// $ANTLR 3.2 Sep 23, 2009 14:05:07 org/deri/xsparql/rewriter/XSPARQLRewriter.g 2012-10-31 11:30:04

  package org.deri.xsparql.rewriter;

  import java.util.logging.Logger;
  import java.util.LinkedList;
  import java.util.UUID;
  import java.net.URL;
  import java.util.Iterator;

  import org.deri.xsparql.rewriter.Pair;
  import org.deri.sql.SQLQuery;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

/**
 *
 * Copyright (C) 2011, NUI Galway.
 * All rights reserved.
 *
 * The software in this package is published under the terms of the BSD style license a copy of which has been included
 * with this distribution in the bsb_license.txt file and/or available on NUI Galway Server at
 * http://xsparql.deri.ie/license/bsd_license.txt
 *
 * Created: 09 February 2011, Reasoning and Querying Unit (URQ), Digital Enterprise Research Institute (DERI) on behalf of
 * NUI Galway.
 */
public class XSPARQLRewriter extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "VAR", "ENDELM", "INTEGER", "LCURLY", "RCURLY", "NCNAME", "QSTRING", "DOT", "AT", "ASSIGN", "CARET", "CARETCARET", "COLON", "COMMA", "SLASH", "LBRACKET", "RBRACKET", "LPAR", "RPAR", "SEMICOLON", "STAR", "DOTDOT", "SLASHSLASH", "LESSTHAN", "GREATERTHAN", "PLUS", "MINUS", "UNIONSYMBOL", "QUESTIONMARK", "LESSTHANLESSTHAN", "GREATERTHANEQUALS", "LESSTHANEQUALS", "HAFENEQUALS", "EQUALS", "COLONCOLON", "BLANK_NODE_LABEL", "BNODE_CONSTRUCT", "IRI_CONSTRUCT", "ASK", "DESCRIBE", "SELECT", "PNAME_NS", "PNAME_LN", "CDATASTART", "CDATAELMEND", "RCURLYGREATERTHAN", "LESSTHANLCURLY", "ORSYMBOL", "ANDSYMBOL", "NOT", "WHITESPACE", "IRIREF", "NCNAMEELM", "ENDTAG", "A", "IS", "EQ", "NE", "LT", "GE", "LE", "GT", "FOR", "FROM", "LIMIT", "OFFSET", "LET", "ORDER", "BY", "ATS", "IN", "AS", "DESCENDING", "ASCENDING", "STABLE", "IF", "THEN", "ELSE", "RETURN", "CONSTRUCT", "WHERE", "GREATEST", "LEAST", "COLLATION", "CHILD", "DESCENDANT", "ATTRIBUTE", "SELF", "DESCENDANTORSELF", "FOLLOWINGSIBLING", "FOLLOWING", "PARENT", "ANCESTOR", "PRECEDINGSIBLING", "PRECEDING", "ANCESTORORSELF", "ORDERED", "UNORDERED", "DECLARE", "NAMESPACE", "DEFAULT", "ELEMENT", "FUNCTION", "BASEURI", "PREFIX", "BASE", "AND", "OR", "TO", "DIV", "IDIV", "MOD", "UNION", "INTERSECT", "EXCEPT", "INSTANCE", "TREAT", "CASTABLE", "CAST", "OF", "EMPTYSEQUENCE", "ITEM", "NODE", "DOCUMENTNODE", "TEXT", "COMMENT", "PROCESSINGINSTRUCTION", "SCHEMAATTRIBUTE", "SCHEMAELEMENT", "DOCUMENT", "NAMED", "OPTIONAL", "FILTER", "STR", "LANG", "LANGMATCHES", "DATATYPE", "BOUND", "ISIRI", "ISURI", "ISBLANK", "ISLITERAL", "REGEX", "TRUE", "FALSE", "GRAPH", "GREATERTHANGREATERTHAN", "DISTINCT", "GROUP", "HAVING", "ENDPOINT", "ROW", "T_NAMESPACE", "T_XML_ELEMENT", "T_XML_CONTENT", "T_XML_ATTRIBUTE", "T_FLWOR", "T_FUNCTION_DECL", "T_PARAMS", "T_FORLET", "T_WHERE", "T_SPARQL_FOR", "T_SPARQL_WHERE", "T_FOR", "T_LET", "T_CONSTRUCT", "T_ORDER", "T_RETURN", "T_UNION", "T_SQL_FOR", "T_SQL_WHERE", "T_SQL_FROM", "T_VAR", "T_TABLE", "T_BLANK", "T_ANON_BLANK", "T_EMPTY_ANON_BLANK", "T_SUBJECT", "T_VERB", "T_OBJECT", "T_MAIN", "T_PAR", "T_INSTANCEOF", "T_TYPE", "T_CASTAS", "T_CASTABLEAS", "T_TREATAS", "T_VARIABLE_DECL", "T_EXTERNAL_VARIABLE_DECL", "T_OPTION_DECL", "T_FUNCTION_CALL", "T_PARAM", "T_ORDER_BY", "T_STABLE_ORDER_BY", "T_GROUP_BY", "T_HAVING", "BOUNDARYSPACE", "STRIP", "VARIABLE", "IMPORT", "EXTERNAL", "NOPRESERVE", "PRESERVE", "CONSTRUCTION", "MODULE", "INHERIT", "NOINHERIT", "SCHEMA", "EMPTY", "ORDERING", "COPYNAMESPACES", "XQUERY", "VERSION", "ENCODING", "OPTION", "LAX", "CASE", "EVERY", "TYPESWITCH", "SATISFIES", "VALIDATE", "SOME", "STRICT", "ASC", "DESC", "T_MODULE_DECL", "T_VERSION", "T_BOUNDARYSPACE_DECL", "T_DEFAULT_DECL", "T_ORDER_DECL", "T_EMPTY_ORDER_DECL", "T_DEFAULT_COLLATION_DECL", "T_BASEURI_DECL", "T_MODULE_IMPORT", "T_SCHEMA_IMPORT", "T_QUERY_BODY", "T_BODY_PART", "XPATH", "T_LITERAL_CONSTRUCT", "T_IRI_CONSTRUCT", "T_EPILOGUE", "DECIMAL", "REWRITEVNODE", "REWRITEVNODE1", "DELETEVNODE", "T_QSTRING", "NOTHING", "T_XML_CONTENTS"
    };
    public static final int FUNCTION=106;
    public static final int ENDTAG=57;
    public static final int STAR=24;
    public static final int ROW=155;
    public static final int GRAPH=149;
    public static final int T_MODULE_DECL=229;
    public static final int MOD=115;
    public static final int T_BLANK=178;
    public static final int BNODE_CONSTRUCT=40;
    public static final int T_INSTANCEOF=186;
    public static final int REGEX=146;
    public static final int PNAME_LN=46;
    public static final int T_FOR=167;
    public static final int CONSTRUCT=83;
    public static final int T_RETURN=171;
    public static final int T_ORDER_BY=196;
    public static final int NOT=53;
    public static final int T_EPILOGUE=244;
    public static final int EXCEPT=118;
    public static final int EOF=-1;
    public static final int T_ORDER_DECL=233;
    public static final int T_XML_CONTENT=158;
    public static final int LBRACKET=19;
    public static final int T_OBJECT=183;
    public static final int ISLITERAL=145;
    public static final int IMPORT=203;
    public static final int IRIREF=55;
    public static final int GREATERTHANEQUALS=34;
    public static final int PRECEDING=98;
    public static final int RETURN=82;
    public static final int ELEMENT=105;
    public static final int COPYNAMESPACES=214;
    public static final int T_PARAMS=162;
    public static final int EQ=60;
    public static final int BOUND=141;
    public static final int GREATERTHANGREATERTHAN=150;
    public static final int CHILD=88;
    public static final int GE=63;
    public static final int A=58;
    public static final int STRICT=226;
    public static final int T_FUNCTION_DECL=161;
    public static final int PRESERVE=206;
    public static final int ASC=227;
    public static final int LESSTHANEQUALS=35;
    public static final int ELSE=81;
    public static final int ASK=42;
    public static final int TYPESWITCH=222;
    public static final int WHITESPACE=54;
    public static final int LCURLY=7;
    public static final int SEMICOLON=23;
    public static final int T_FORLET=163;
    public static final int T_SQL_FROM=175;
    public static final int REWRITEVNODE1=247;
    public static final int EMPTY=212;
    public static final int GROUP=152;
    public static final int INTERSECT=117;
    public static final int NCNAME=9;
    public static final int XPATH=241;
    public static final int T_WHERE=164;
    public static final int DESCRIBE=43;
    public static final int GT=65;
    public static final int DATATYPE=140;
    public static final int T_QSTRING=249;
    public static final int T_FLWOR=160;
    public static final int LANG=138;
    public static final int T_VERSION=230;
    public static final int OPTION=218;
    public static final int T_STABLE_ORDER_BY=197;
    public static final int T_CASTAS=188;
    public static final int T_BOUNDARYSPACE_DECL=231;
    public static final int T_VERB=182;
    public static final int VERSION=216;
    public static final int SATISFIES=223;
    public static final int IDIV=114;
    public static final int DESCENDANTORSELF=92;
    public static final int ATS=73;
    public static final int ASCENDING=77;
    public static final int AT=12;
    public static final int STR=137;
    public static final int AS=75;
    public static final int PARENT=95;
    public static final int CONSTRUCTION=207;
    public static final int SLASH=18;
    public static final int THEN=80;
    public static final int DOCUMENT=133;
    public static final int COLLATION=87;
    public static final int OFFSET=69;
    public static final int T_CONSTRUCT=169;
    public static final int ANCESTOR=96;
    public static final int PLUS=29;
    public static final int QSTRING=10;
    public static final int T_SUBJECT=181;
    public static final int CASTABLE=121;
    public static final int T_GROUP_BY=198;
    public static final int INTEGER=6;
    public static final int BY=72;
    public static final int LESSTHAN=27;
    public static final int EMPTYSEQUENCE=124;
    public static final int PRECEDINGSIBLING=97;
    public static final int ENDPOINT=154;
    public static final int T_SQL_WHERE=174;
    public static final int ITEM=125;
    public static final int TO=112;
    public static final int T_TREATAS=190;
    public static final int INHERIT=209;
    public static final int PNAME_NS=45;
    public static final int HAVING=153;
    public static final int ENDELM=5;
    public static final int MINUS=30;
    public static final int TEXT=128;
    public static final int MODULE=208;
    public static final int ORDERED=100;
    public static final int UNION=116;
    public static final int T_IRI_CONSTRUCT=243;
    public static final int T_DEFAULT_COLLATION_DECL=235;
    public static final int COLON=16;
    public static final int SCHEMA=211;
    public static final int T_CASTABLEAS=189;
    public static final int DECIMAL=245;
    public static final int VALIDATE=224;
    public static final int INSTANCE=119;
    public static final int PROCESSINGINSTRUCTION=130;
    public static final int NOINHERIT=210;
    public static final int LESSTHANLCURLY=50;
    public static final int RCURLY=8;
    public static final int T_PARAM=195;
    public static final int DECLARE=102;
    public static final int T_ANON_BLANK=179;
    public static final int DIV=113;
    public static final int DESCENDING=76;
    public static final int SELF=91;
    public static final int CAST=122;
    public static final int PREFIX=108;
    public static final int EXTERNAL=204;
    public static final int LT=62;
    public static final int UNIONSYMBOL=31;
    public static final int FOLLOWINGSIBLING=93;
    public static final int ORSYMBOL=51;
    public static final int CASE=220;
    public static final int ENCODING=217;
    public static final int EQUALS=37;
    public static final int SCHEMAATTRIBUTE=131;
    public static final int LPAR=21;
    public static final int T_VAR=176;
    public static final int CARET=14;
    public static final int LANGMATCHES=139;
    public static final int BASE=109;
    public static final int T_MODULE_IMPORT=237;
    public static final int VAR=4;
    public static final int T_NAMESPACE=156;
    public static final int T_SPARQL_WHERE=166;
    public static final int COMMENT=129;
    public static final int SELECT=44;
    public static final int ISIRI=142;
    public static final int NE=61;
    public static final int GREATERTHAN=28;
    public static final int BOUNDARYSPACE=200;
    public static final int REWRITEVNODE=246;
    public static final int NODE=126;
    public static final int CDATASTART=47;
    public static final int T_ORDER=170;
    public static final int GREATEST=85;
    public static final int BLANK_NODE_LABEL=39;
    public static final int T_MAIN=184;
    public static final int EVERY=221;
    public static final int T_FUNCTION_CALL=194;
    public static final int CDATAELMEND=48;
    public static final int OF=123;
    public static final int T_VARIABLE_DECL=191;
    public static final int NAMESPACE=103;
    public static final int ISBLANK=144;
    public static final int T_BASEURI_DECL=236;
    public static final int T_PAR=185;
    public static final int COLONCOLON=38;
    public static final int T_XML_ELEMENT=157;
    public static final int VARIABLE=202;
    public static final int SLASHSLASH=26;
    public static final int T_XML_CONTENTS=251;
    public static final int NOPRESERVE=205;
    public static final int T_EXTERNAL_VARIABLE_DECL=192;
    public static final int NAMED=134;
    public static final int OR=111;
    public static final int FILTER=136;
    public static final int RCURLYGREATERTHAN=49;
    public static final int IRI_CONSTRUCT=41;
    public static final int CARETCARET=15;
    public static final int FROM=67;
    public static final int FALSE=148;
    public static final int DISTINCT=151;
    public static final int WHERE=84;
    public static final int LAX=219;
    public static final int HAFENEQUALS=36;
    public static final int ORDER=71;
    public static final int LIMIT=68;
    public static final int T_HAVING=199;
    public static final int ATTRIBUTE=90;
    public static final int FOR=66;
    public static final int DOTDOT=25;
    public static final int AND=110;
    public static final int FOLLOWING=94;
    public static final int T_XML_ATTRIBUTE=159;
    public static final int IF=79;
    public static final int ISURI=143;
    public static final int SCHEMAELEMENT=132;
    public static final int IN=74;
    public static final int COMMA=17;
    public static final int IS=59;
    public static final int SOME=225;
    public static final int QUESTIONMARK=32;
    public static final int T_SCHEMA_IMPORT=238;
    public static final int T_BODY_PART=240;
    public static final int NOTHING=250;
    public static final int T_QUERY_BODY=239;
    public static final int STRIP=201;
    public static final int RBRACKET=20;
    public static final int DOT=11;
    public static final int STABLE=78;
    public static final int T_OPTION_DECL=193;
    public static final int XQUERY=215;
    public static final int DELETEVNODE=248;
    public static final int ANDSYMBOL=52;
    public static final int DEFAULT=104;
    public static final int NCNAMEELM=56;
    public static final int DESCENDANT=89;
    public static final int T_SPARQL_FOR=165;
    public static final int T_LITERAL_CONSTRUCT=242;
    public static final int TRUE=147;
    public static final int BASEURI=107;
    public static final int T_TABLE=177;
    public static final int UNORDERED=101;
    public static final int OPTIONAL=135;
    public static final int T_TYPE=187;
    public static final int T_UNION=172;
    public static final int T_LET=168;
    public static final int T_EMPTY_ORDER_DECL=234;
    public static final int ORDERING=213;
    public static final int ASSIGN=13;
    public static final int T_EMPTY_ANON_BLANK=180;
    public static final int T_SQL_FOR=173;
    public static final int DOCUMENTNODE=127;
    public static final int LESSTHANLESSTHAN=33;
    public static final int LEAST=86;
    public static final int RPAR=22;
    public static final int T_DEFAULT_DECL=232;
    public static final int DESC=228;
    public static final int ANCESTORORSELF=99;
    public static final int TREAT=120;
    public static final int LE=64;
    public static final int LET=70;

    // delegates
    // delegators

    protected static class VariableScope_scope {
        Map<String, Types> variables;
        List<String> positions;
        boolean scopedDataset;
        boolean sparqlClause;
    }
    protected Stack VariableScope_stack = new Stack();


        public XSPARQLRewriter(TreeNodeStream input) {
            this(input, new RecognizerSharedState());
        }
        public XSPARQLRewriter(TreeNodeStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return XSPARQLRewriter.tokenNames; }
    public String getGrammarFileName() { return "org/deri/xsparql/rewriter/XSPARQLRewriter.g"; }


      private static final Logger logger = Logger.getLogger(XSPARQLRewriter.class.getClass().getName());

      /** Types for variables */
      private enum Types {
       XQUERY, SPARQL, SQL, SQL_ROW, RDF_GRAPH 
     }

      /** Handle namespaces */
      private final Map<String, String> namespaces = new HashMap<String, String>();

      /** global stack for scoped datasets */
      private final Stack<ScopedDataset> scopedDataset = new Stack<ScopedDataset>();

      /** final part of the tree, used for postprocesssing, e.g. delete scopedDatasets */
      private final CommonTree epilogue = (CommonTree) adaptor.nil();
      
      /**
       * use validating XQuery engine
       */
      private boolean validatingXQuery = false;
      
      public void setValidatingXQuery(boolean b) {
        this.validatingXQuery = b;
      }
      
      private boolean warnIfNestedConstruct = false;
      
      public void setWarnIfNestedConstruct(boolean warnIfNestedConstruct) {
        this.warnIfNestedConstruct = warnIfNestedConstruct;
      }
      
      private String sparqlmethod;
      
      public void setSPARQLMethod(String sparqlmethod) {
        this.sparqlmethod = sparqlmethod;
      }
      
      private String endpointURI;
      
      public void setEndpointURI(String endpointURI) {
        this.endpointURI = endpointURI;
      }
      
      /*
       * Create a debug version of the rewritten query
       * The debug version will print all the SPARQL queries on the stdout before sending to the SPARQL engine
       */
      private boolean debugVersion = false;
      
      public void setDebugVersion(boolean debugVersion) {
        this.debugVersion = debugVersion;
      }
      
      
      /**
       * XQuery engine to be used for evaluation/code production.
       */
      private String xqueryEngine = "saxon-he";
    	
      public void setXQueryEngine(String xqueryEngine) {
        this.xqueryEngine = xqueryEngine;
      }

      /** Add a namespace prefix and the corresponding IRI */
      private void addNamespace(final String name, final String iri) {
        logger.entering(this.getClass().getCanonicalName(), "addNamespace", new String[]{name, iri});

        namespaces.put(name, iri);
      }

      /** Get a string containing the SPARQL namespace declarations */
      private String getSPARQLNamespaces() {
         final StringBuffer sb = new StringBuffer();
         for(String key : namespaces.keySet()) {
            sb.append("PREFIX ");
            sb.append(key);
            if(!key.equals(":")) {
               sb.append(":");
            }
            sb.append(" <");
            sb.append(namespaces.get(key));
            sb.append("> ");
            sb.append(System.getProperties().getProperty("line.separator"));
         }

         return sb.toString();
      }


      private String getRDFNamespaceDecls() {
         final StringBuffer sb = new StringBuffer();
         for(String key : namespaces.keySet()) {
            sb.append("@prefix ");
            sb.append(key);
            if(!key.equals(":")) {
               sb.append(":");
            }
            sb.append(" <");
            sb.append(namespaces.get(key));
            sb.append("> . ");
            sb.append(System.getProperties().getProperty("line.separator"));
         }

         // if there are any prefixes, put a separator in the output
         if (sb.length() > 0) {
           sb.append(System.getProperties().getProperty("line.separator"));
         }
         
         return sb.toString();
      }

      // Create new temporary variables

      private int auxresultscounter = 0;
      private String getNewAuxResultsVariable() {
        logger.entering(this.getClass().getCanonicalName(), "getNewAuxResultsVariable");
        return "$_aux_results" + auxresultscounter++;
      }

      private int auxresultcounter = 0;
      private String getNewAuxResultVariable() {
        logger.entering(this.getClass().getCanonicalName(), "auxresultcounter");
        return "$_aux_result" + auxresultcounter++;
      }

      private int posvarcnt = 0;
      
      @Deprecated
      private String getNewPosVariableName() {
        logger.entering(this.getClass().getCanonicalName(), "getNewPosVariableName");
        return "$_pos" + posvarcnt++;
      }

      private int rdftermcnt = 0;
      private String getNewTempRdfTermVariable() {
        logger.entering(this.getClass().getCanonicalName(), "getNewTempRdfTermVariable");
        return "$_rdf" + rdftermcnt++;
      }

      // Variable scoping

      private void addVariableToScope(final String name) {
        addVariableToScope(name, Types.XQUERY);
      }

      private void addVariableToScope(final String name, final Types type) {
        logger.info(this.getClass().getCanonicalName() + " addVariableToScope "+ name);

        ((VariableScope_scope)VariableScope_stack.peek()).variables.put(name, type);
      }


      private void addVariablesToScope(final List<?> variables, final Types type) {
        logger.entering(this.getClass().getCanonicalName(), "addVariablesToScope");
        String text;
        for(Object o : variables) {
           final CommonTree tree = (CommonTree) o;
           
           if (type == Types.SQL) {
             int c = tree.getChildCount();
             text = ((CommonTree) tree.getChild(c-1)).getText();
           } else {
             if(tree.getChildCount() > 0 && ((CommonTree) tree.getChild(1)).getType() == T_FUNCTION_CALL)   // function_call
               text = tree.getChild(3).getText();
             else
               text  = tree.getText();
           }

           addVariableToScope(text, type);
        }
      }

      @Deprecated
      private void addVariablesStringToScope(final List<String> variables, final Types type) {
        logger.entering(this.getClass().getCanonicalName(), "addVariablesStringToScope");

        for(String o : variables) {
           addVariableToScope("$"+o, type);
        }
      }


      private void addPositionVariableToScope(final String name) {
        logger.entering(this.getClass().getCanonicalName(), "addPositionVariableToScope", name);
        ((VariableScope_scope)VariableScope_stack.peek()).positions.add(name);
      }

      private boolean isBound(final String name, Types type) {
        logger.info(this.getClass().getCanonicalName() +" isBoundType "+ name+type);
        
        Types t = containsVar(name, 1);
        if (t != null) {
         return t.equals(type);
        } else {
          return false;
        }
      }
      
      private boolean isBoundEarlier(final String name, Types type) {
        logger.info(this.getClass().getCanonicalName()+ "isBoundEarlierType"+ name+type);

        Types t = containsVar(name, 2);
        if (t != null) {
         return t.equals(type);
        } else {
          return false;
        }
      }

      private boolean isBound(final String name) {
        logger.info(this.getClass().getCanonicalName()+ "isBound"+ name);
        return containsVar(name, 1) != null;
      }
      
      private boolean isBoundEarlier(final String name) {
        logger.info(this.getClass().getCanonicalName()+ "isBoundEarlier"+ name);
        return containsVar(name, 2) != null;
      }



      private Types containsVar(final String name, int pos) {
        logger.entering(this.getClass().getCanonicalName(), "isBound", name);
        for(int s=VariableScope_stack.size()-pos; s >= 0; s--) {
          if(((VariableScope_scope)VariableScope_stack.elementAt(s)).variables.containsKey(name)) {
            logger.exiting(this.getClass().getCanonicalName(), "isBound", "true");

           // Iterator iterator = ((VariableScope_scope)VariableScope_stack.elementAt(s)).variables.keySet().iterator();
           // while (iterator.hasNext()) {
           //    String key = iterator.next().toString();
           //    String value = ((VariableScope_scope)VariableScope_stack.elementAt(s)).variables.get(key).toString();
           //    System.out.println("VariableScope["+ s +"]: "+key + " " + value);
           // }

            return ((VariableScope_scope)VariableScope_stack.elementAt(s)).variables.get(name);
          }
        }
        logger.exiting(this.getClass().getCanonicalName(), "isBound", "false");
        return null;
      }

      private CommonTree getPositionVarList() {
        CommonTree ret = (CommonTree) adaptor.nil();
        
        for(int s=0; s < VariableScope_stack.size(); s++) {
          for(String name : ((VariableScope_scope)VariableScope_stack.elementAt(s)).positions) {
            adaptor.addChild(ret, (CommonTree)adaptor.create(QSTRING, "_"));
            adaptor.addChild(ret, (CommonTree)adaptor.create(VAR, name));
          }
        }
        
        return ret;
      }

      // CONSTANTS
      private static final String xsparqlNamespace = "http://xsparql.deri.org/demo/xquery/xsparql.xquery";


      private static final String xsparqlAbbrev = "_xsparql";
      private static final String javaExternalAbbrev = "_java";
      private String javaExternalURL;
      private static final String serializeFunction = xsparqlAbbrev + ":_serialize";
      private static final String rdfTermFunction = xsparqlAbbrev + ":_rdf_term";
      private static final String bindingTermFunction = xsparqlAbbrev+":_binding_term";

      private static String sparqlFunctionScopedCreate = xsparqlAbbrev+":createScopedDataset";
      private static String sparqlFunctionScopedInner = xsparqlAbbrev+":sparqlScopedDataset";
      private static String sparqlFunctionScopedDelete = xsparqlAbbrev+":deleteScopedDataset";
      private static String sparqlFunctionScopedPop = xsparqlAbbrev+":scopedDatasetPopResults";

      private String sparqlResultsFunctionNode;
      private static String storeGraphFunction;

      private static final String schemaAbbrev = "_sparql_result";
      private static final String schemaNamespace = "http://www.w3.org/2005/sparql-results#";
      private static String schemaURL = "http://xsparql.deri.org/demo/xquery/sparql.xsd";

      private static final String validSubjectFunction = xsparqlAbbrev+":_validSubject";
      private static final String validPredicateFunction = xsparqlAbbrev+":_validPredicate";
      private static final String validObjectFunction = xsparqlAbbrev+":_validObject";

      private static final String sparqlNamespaceAbbrev = "xsparql";
      private static final String sparqlFunctionsNamespace = "http://xsparql.deri.org/demo/xquery/sparql-functions.xquery";
      
      /*
      * set the library to be used
      */
      private String xsparqlLibURL = "http://xsparql.deri.org/demo/xquery/xsparql-types.xquery";
      private String sparqlLibURL  = "http://xsparql.deri.org/demo/xquery/sparql-functions.xquery";


      public void setLibraryVersion() {

        URL local = XSPARQLRewriter.class.getResource("/xquery/xsparql-types.xquery");
        if (local != null) {
          xsparqlLibURL = local.toString();
        }

        local = XSPARQLRewriter.class.getResource("/xquery/sparql-functions.xquery");
        if (local != null) {
          sparqlLibURL = local.toString();
        }

        if (!this.validatingXQuery) {
          local = XSPARQLRewriter.class.getResource("/xquery/xsparql.xquery");
          if (local != null) {
            xsparqlLibURL = local.toString();
          } else {
            xsparqlLibURL = "http://xsparql.deri.org/demo/xquery/xsparql.xquery";
          }
        }

    //    if(Configuration.debugVersion()) {
    //      local = XSPARQLRewriter.class.getResource("/xquery/xsparql-types.debug.xquery");
    //      if (local != null) {
    //        xsparqlLibURL = local.toString();
    //      } else {
    //        xsparqlLibURL = "http://xsparql.deri.org/demo/xquery/xsparql-types.debug.xquery";
    //      }
    //    } 

      }
      

      public CommonTree createSchemaImport() {
        CommonTree ret = (CommonTree) adaptor.nil();
        
        //    ^(T_SCHEMA_IMPORT ^(NAMESPACE NCNAME[schemaAbbrev]) QSTRING[schemaNamespace] ^(AT QSTRING[schemaURL]))
        if (this.validatingXQuery) {
          URL local = XSPARQLRewriter.class.getResource("/xquery/sparql.xsd");
          if (local != null) {
            schemaURL = local.toString();
          }

          CommonTree at = (CommonTree) adaptor.create(AT, "AT");
          adaptor.addChild(at, adaptor.create(QSTRING, schemaURL));

          CommonTree ns = (CommonTree) adaptor.create(NAMESPACE, "NAMESPACE");
          adaptor.addChild(ns, adaptor.create(NCNAME, schemaAbbrev));

          ret = (CommonTree) adaptor.create(T_SCHEMA_IMPORT, "T_SCHEMA_IMPORT");
          adaptor.addChild(ret, ns);
          adaptor.addChild(ret, adaptor.create(QSTRING, schemaNamespace));
          adaptor.addChild(ret, at);
        }

        return ret;
      }       

      private SQLQuery sqlQuery = null;

      /**
       * set the database connection
       */
      public void setDBconnection(SQLQuery q) {
        this.sqlQuery = q;
      }

      private String evaluationFunction = "";
      private String iterationFunction = "";

      private String SQLevaluationFunction = "";
      private String SQLiterationFunction = "";


      /**
       * set the evaluation method for SPARQL queries:
       *     arq = using saxon integrated (no need for an endpoint)
       *     joseki =  using a SPARQL endpoint (default)
       */
      public void setEvaluationMethod() {

        String externalFunctionAbbrev = "";

        // defaults, use joseki
        this.iterationFunction = xsparqlAbbrev+":_sparqlResults";
        this.evaluationFunction = xsparqlAbbrev+":_sparql";

        this.SQLevaluationFunction = xsparqlAbbrev+":_sqlQuery";
        this.SQLiterationFunction = xsparqlAbbrev+":_sqlResults";

        // Qexo engine
        if (this.xqueryEngine.equals("qexo")) {
          this.javaExternalURL = "class:org.deri.xquery.qexo.Sparql";

          if (this.sparqlmethod.equals("arq")) {
            this.evaluationFunction = javaExternalAbbrev+":sparqlResultsIterator";
            this.sparqlResultsFunctionNode = xsparqlAbbrev+":_sparqlResultsFromNode";
            this.iterationFunction = "iterator-items";
            externalFunctionAbbrev = javaExternalAbbrev;
          } 
        } 

        // saxon engine
        if (this.xqueryEngine.equals("saxon-he") || this.xqueryEngine.equals("saxon-ee")) {
          this.javaExternalURL = "java:org.deri.xquery.saxon.Sparql";
          externalFunctionAbbrev = xsparqlAbbrev;

          if (this.sparqlmethod.equals("arq")) {
            this.evaluationFunction = externalFunctionAbbrev+":_sparqlQuery";
            this.sparqlResultsFunctionNode = xsparqlAbbrev+":_sparqlResultsFromNode";
            this.iterationFunction = sparqlResultsFunctionNode; 

          }
        }

        sparqlFunctionScopedCreate = externalFunctionAbbrev+":createScopedDataset";
        sparqlFunctionScopedInner = externalFunctionAbbrev+":sparqlScopedDataset";
        sparqlFunctionScopedDelete = externalFunctionAbbrev+":deleteScopedDataset";
        sparqlFunctionScopedPop = externalFunctionAbbrev+":scopedDatasetPopResults";
        storeGraphFunction = externalFunctionAbbrev+":turtleGraphToURI";
      
      }


      // stores the variable as a joinVariable for the scoped Dataset and creates a
      // tree with with text of the variable as a string
      public CommonTree addJoinVar(int tok, String text) {
        ((sparqlForClause_scope)sparqlForClause_stack.peek()).joinVars += text+",";

        return new CommonTree(new CommonToken(tok, text));
      }       

      public CommonTree endpointURI(String endpoint) {
        CommonTree ret = (CommonTree) adaptor.nil();

        if(endpoint != null) {
          ret = new CommonTree(new CommonToken(QSTRING, endpoint));
        } else if(this.endpointURI != null) {
          ret = new CommonTree(new CommonToken(QSTRING, this.endpointURI));
        }

        return ret;
      }       


      public void changeTreeToScopedDataset() {
        logger.info("Entering changeTreeToScopedDataset");

        logger.info(scopedDataset.peek().toString());
        ScopedDataset sd = scopedDataset.peek();

        CommonTree functionTree = sd.getFunctionTree();
        if(!functionTree.isNil()) {
          Token tk1 = functionTree.getToken();
          tk1.setText(sparqlFunctionScopedCreate);
        }
        
        CommonTree resultsTree = sd.getResultsTree();
        if(!resultsTree.isNil()) {
          Token tk2 = resultsTree.getToken();
          tk2.setText(sparqlResultsFunctionNode);
        }

        String id = sd.getId();
        CommonTree idTree = sd.getIdTree();
        if(!idTree.isNil()) {
          Token tk3 = idTree.getToken();
          tk3.setText(id);
          tk3.setType(QSTRING);
        }
        
        // add the delete call to the epilogue
        if(!functionTree.isNil() && !resultsTree.isNil() && !idTree.isNil()) {
          CommonTree part = (CommonTree) adaptor.create(T_BODY_PART, "T_BODY_PART");
          adaptor.addChild(epilogue, part);

          CommonTree del = (CommonTree) adaptor.create(XPATH, "XPATH");
          adaptor.addChild(part, del);

          CommonTree func = (CommonTree) adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL");
          adaptor.addChild(del, func);

          CommonTree params = (CommonTree) adaptor.create(T_PARAMS, "T_PARAMS");
          CommonTree xpath = (CommonTree) adaptor.create(XPATH, "XPATH");
          adaptor.addChild(xpath, adaptor.create(QSTRING, id));
          adaptor.addChild(params, xpath);
          
          adaptor.addChild(func, adaptor.create(NCNAME, sparqlFunctionScopedDelete));
          adaptor.addChild(func, params);
        }
      }


      // returns the tree with the variable and saves the info that there has been
      // at least one unbound variable
      public CommonTree unboundVar(String var) {
        ((sparqlForClause_scope)sparqlForClause_stack.peek()).containsVars = true;

        return new CommonTree(new CommonToken(VAR, var));
      }       


      // If there is at least an unbound var return a tree with the variables, 
      // otherwise return a tree with the string *
      private CommonTree getVarList(final List<?> variables) {
        logger.info("Entering getVarList");

        CommonTree res = (CommonTree) adaptor.nil();
        
         for(Object o : variables) {
            if(((CommonTree) o).getType() == NOTHING) { continue; }
              CommonTree t = (CommonTree) adaptor.create(new CommonToken(REWRITEVNODE1));
              adaptor.addChild(t, (CommonTree) o);
              adaptor.addChild(res, t);
            }

          if(res.getChildCount() == 0) 
          {
            res = (CommonTree) adaptor.create(new CommonToken(REWRITEVNODE1));
            adaptor.addChild(res, adaptor.create(VAR, "*"));
          } 

        return res;
      } 


      // inserts a function call to the pop function if there was a scopeddataset
      private CommonTree generatePop() {
        logger.info("Entering generatePop");

        CommonTree res = (CommonTree) adaptor.nil();
        
        logger.info("generatePop: "+((VariableScope_scope)VariableScope_stack.peek()).scopedDataset+", "+((VariableScope_scope)VariableScope_stack.peek()).sparqlClause);

        if(((VariableScope_scope)VariableScope_stack.peek()).sparqlClause && ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset) 
          {
            res = (CommonTree) adaptor.create(T_FLWOR, "T_FLWOR");
            CommonTree xpath = (CommonTree) adaptor.create(XPATH, "XPATH");
            CommonTree func = (CommonTree) adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL");
            CommonTree params = (CommonTree) adaptor.create(T_PARAMS, "T_PARAMS");
            adaptor.addChild(params, adaptor.create(QSTRING, scopedDataset.peek().getId()));

            adaptor.addChild(func, adaptor.create(NCNAME, sparqlFunctionScopedPop));
            adaptor.addChild(func, params);

            adaptor.addChild(xpath, (CommonTree) adaptor.create(NCNAME, ","));
            adaptor.addChild(xpath, func);
            adaptor.addChild(res, xpath);
          } 

        return res;
      } 


      private CommonTree getVarNodes(final List<String> variables, String auxVariable) {

        CommonTree res = (CommonTree) adaptor.nil();
        
        for(String o : variables) {
          CommonTree v = (CommonTree) adaptor.create(new CommonToken(T_VAR));
          adaptor.addChild(v, adaptor.create(new CommonToken(QSTRING, o)));
          adaptor.addChild(v, adaptor.create(new CommonToken(VAR, o)));

          CommonTree t = (CommonTree) adaptor.create(new CommonToken(REWRITEVNODE, auxVariable));
          adaptor.addChild(t, v);
          adaptor.addChild(res, t);
        }

        return res;
      } 
      
      private CommonTree getVars(final List<String> variables) {

        CommonTree res = (CommonTree) adaptor.nil();
        
        for(String o : variables) {
          adaptor.addChild(res, adaptor.create(new CommonToken(VAR, "$"+o)));
       }

        return res;
      } 

    // format the select line correctly
    protected String concat(List<String> list, String separator) {
        String res = "";
        String sep = "";
        for (String s : list) {
          res += sep + format(s) + " AS \"\"" + s +"\"\"";
          sep = separator;
        }
         
        return res;
      }


    protected String format(String relation) {
      logger.info("format: "+relation);
      if (relation.matches(".*\\..*")) {
        logger.info("format-true");
        String[] split = relation.split("\\.");
        logger.info("format-true: "+split.length);
        return new String("\"\"" + split[0] +"\"\".\"\"" + split[1] +"\"\"") ;
      } else {
        logger.info("format-false");
        return relation;
      }

    }




    public static class root_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "root"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:810:1: root : ( versionDecl )? ( libraryModule | mainModule ) ;
    public final XSPARQLRewriter.root_return root() throws RecognitionException {
        XSPARQLRewriter.root_return retval = new XSPARQLRewriter.root_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.versionDecl_return versionDecl1 = null;

        XSPARQLRewriter.libraryModule_return libraryModule2 = null;

        XSPARQLRewriter.mainModule_return mainModule3 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:811:3: ( ( versionDecl )? ( libraryModule | mainModule ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:811:5: ( versionDecl )? ( libraryModule | mainModule )
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:811:5: ( versionDecl )?
            int alt1=2;
            switch ( input.LA(1) ) {
                case T_VERSION:
                    {
                    alt1=1;
                    }
                    break;
            }

            switch (alt1) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: versionDecl
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_versionDecl_in_root962);
                    versionDecl1=versionDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, versionDecl1.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:811:18: ( libraryModule | mainModule )
            int alt2=2;
            switch ( input.LA(1) ) {
            case T_MODULE_DECL:
                {
                alt2=1;
                }
                break;
            case T_MAIN:
                {
                alt2=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:811:19: libraryModule
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_libraryModule_in_root966);
                    libraryModule2=libraryModule();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, libraryModule2.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:811:35: mainModule
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_mainModule_in_root970);
                    mainModule3=mainModule();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, mainModule3.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "root"

    public static class versionDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "versionDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:814:1: versionDecl : ^( T_VERSION stringliteral ^( ENCODING ( stringliteral )? ) ) ;
    public final XSPARQLRewriter.versionDecl_return versionDecl() throws RecognitionException {
        XSPARQLRewriter.versionDecl_return retval = new XSPARQLRewriter.versionDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_VERSION4=null;
        CommonTree ENCODING6=null;
        XSPARQLRewriter.stringliteral_return stringliteral5 = null;

        XSPARQLRewriter.stringliteral_return stringliteral7 = null;


        CommonTree T_VERSION4_tree=null;
        CommonTree ENCODING6_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:815:3: ( ^( T_VERSION stringliteral ^( ENCODING ( stringliteral )? ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:815:5: ^( T_VERSION stringliteral ^( ENCODING ( stringliteral )? ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_VERSION4=(CommonTree)match(input,T_VERSION,FOLLOW_T_VERSION_in_versionDecl985); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_VERSION4_tree = (CommonTree)adaptor.dupNode(T_VERSION4);

            root_1 = (CommonTree)adaptor.becomeRoot(T_VERSION4_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_stringliteral_in_versionDecl987);
            stringliteral5=stringliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, stringliteral5.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            ENCODING6=(CommonTree)match(input,ENCODING,FOLLOW_ENCODING_in_versionDecl990); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ENCODING6_tree = (CommonTree)adaptor.dupNode(ENCODING6);

            root_2 = (CommonTree)adaptor.becomeRoot(ENCODING6_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:815:42: ( stringliteral )?
                int alt3=2;
                switch ( input.LA(1) ) {
                    case QSTRING:
                        {
                        alt3=1;
                        }
                        break;
                }

                switch (alt3) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: stringliteral
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_stringliteral_in_versionDecl992);
                        stringliteral7=stringliteral();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) 
                        adaptor.addChild(root_2, stringliteral7.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "versionDecl"

    public static class mainModule_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "mainModule"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:818:1: mainModule : ^( T_MAIN prolog queryBody ) ;
    public final XSPARQLRewriter.mainModule_return mainModule() throws RecognitionException {
        VariableScope_stack.push(new VariableScope_scope());

        XSPARQLRewriter.mainModule_return retval = new XSPARQLRewriter.mainModule_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_MAIN8=null;
        XSPARQLRewriter.prolog_return prolog9 = null;

        XSPARQLRewriter.queryBody_return queryBody10 = null;


        CommonTree T_MAIN8_tree=null;


          // initialize global scopes
          ((VariableScope_scope)VariableScope_stack.peek()).variables = new HashMap<String,Types>();
          ((VariableScope_scope)VariableScope_stack.peek()).positions = new LinkedList<String>();
          logger.info("Creating new variable scope: mainModule");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:826:3: ( ^( T_MAIN prolog queryBody ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:826:5: ^( T_MAIN prolog queryBody )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_MAIN8=(CommonTree)match(input,T_MAIN,FOLLOW_T_MAIN_in_mainModule1020); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_MAIN8_tree = (CommonTree)adaptor.dupNode(T_MAIN8);

            root_1 = (CommonTree)adaptor.becomeRoot(T_MAIN8_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_prolog_in_mainModule1022);
            prolog9=prolog();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, prolog9.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_queryBody_in_mainModule1024);
            queryBody10=queryBody();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, queryBody10.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            VariableScope_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "mainModule"

    public static class libraryModule_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "libraryModule"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:829:1: libraryModule : moduleDecl prolog ;
    public final XSPARQLRewriter.libraryModule_return libraryModule() throws RecognitionException {
        XSPARQLRewriter.libraryModule_return retval = new XSPARQLRewriter.libraryModule_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.moduleDecl_return moduleDecl11 = null;

        XSPARQLRewriter.prolog_return prolog12 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:830:3: ( moduleDecl prolog )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:830:6: moduleDecl prolog
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_moduleDecl_in_libraryModule1039);
            moduleDecl11=moduleDecl();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, moduleDecl11.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_prolog_in_libraryModule1041);
            prolog12=prolog();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, prolog12.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "libraryModule"

    public static class moduleDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "moduleDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:833:1: moduleDecl : ^( T_MODULE_DECL NCNAME uriliteral ) ;
    public final XSPARQLRewriter.moduleDecl_return moduleDecl() throws RecognitionException {
        XSPARQLRewriter.moduleDecl_return retval = new XSPARQLRewriter.moduleDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_MODULE_DECL13=null;
        CommonTree NCNAME14=null;
        XSPARQLRewriter.uriliteral_return uriliteral15 = null;


        CommonTree T_MODULE_DECL13_tree=null;
        CommonTree NCNAME14_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:834:3: ( ^( T_MODULE_DECL NCNAME uriliteral ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:834:5: ^( T_MODULE_DECL NCNAME uriliteral )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_MODULE_DECL13=(CommonTree)match(input,T_MODULE_DECL,FOLLOW_T_MODULE_DECL_in_moduleDecl1055); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_MODULE_DECL13_tree = (CommonTree)adaptor.dupNode(T_MODULE_DECL13);

            root_1 = (CommonTree)adaptor.becomeRoot(T_MODULE_DECL13_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            NCNAME14=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_moduleDecl1057); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            NCNAME14_tree = (CommonTree)adaptor.dupNode(NCNAME14);

            adaptor.addChild(root_1, NCNAME14_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_uriliteral_in_moduleDecl1059);
            uriliteral15=uriliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, uriliteral15.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "moduleDecl"

    public static class prolog_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prolog"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:837:1: prolog : ( baseDecl )? ( prolog1 )* ( prolog2 )* -> ( baseDecl )? COMMENT[\"modules imported by default\"] ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[xsparqlAbbrev] ) QSTRING[xsparqlNamespace] ^( AT QSTRING[xsparqlLibURL] ) ) ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[sparqlNamespaceAbbrev] ) QSTRING[sparqlFunctionsNamespace] ^( AT QSTRING[sparqlLibURL] ) ) ( prolog1 )* COMMENT[\"SPARQL prefix namespaces\"] ^( T_VARIABLE_DECL VAR[\"\\$_sparql_prefixes\"] ^( T_TYPE ) QSTRING[getSPARQLNamespaces()] ) ( prolog2 )* ;
    public final XSPARQLRewriter.prolog_return prolog() throws RecognitionException {
        XSPARQLRewriter.prolog_return retval = new XSPARQLRewriter.prolog_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.baseDecl_return baseDecl16 = null;

        XSPARQLRewriter.prolog1_return prolog117 = null;

        XSPARQLRewriter.prolog2_return prolog218 = null;


        RewriteRuleSubtreeStream stream_baseDecl=new RewriteRuleSubtreeStream(adaptor,"rule baseDecl");
        RewriteRuleSubtreeStream stream_prolog2=new RewriteRuleSubtreeStream(adaptor,"rule prolog2");
        RewriteRuleSubtreeStream stream_prolog1=new RewriteRuleSubtreeStream(adaptor,"rule prolog1");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:838:3: ( ( baseDecl )? ( prolog1 )* ( prolog2 )* -> ( baseDecl )? COMMENT[\"modules imported by default\"] ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[xsparqlAbbrev] ) QSTRING[xsparqlNamespace] ^( AT QSTRING[xsparqlLibURL] ) ) ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[sparqlNamespaceAbbrev] ) QSTRING[sparqlFunctionsNamespace] ^( AT QSTRING[sparqlLibURL] ) ) ( prolog1 )* COMMENT[\"SPARQL prefix namespaces\"] ^( T_VARIABLE_DECL VAR[\"\\$_sparql_prefixes\"] ^( T_TYPE ) QSTRING[getSPARQLNamespaces()] ) ( prolog2 )* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:838:5: ( baseDecl )? ( prolog1 )* ( prolog2 )*
            {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:838:5: ( baseDecl )?
            int alt4=2;
            switch ( input.LA(1) ) {
                case T_NAMESPACE:
                    {
                    switch ( input.LA(2) ) {
                        case DOWN:
                            {
                            switch ( input.LA(3) ) {
                                case DEFAULT:
                                    {
                                    switch ( input.LA(4) ) {
                                        case IRIREF:
                                            {
                                            alt4=1;
                                            }
                                            break;
                                    }

                                    }
                                    break;
                            }

                            }
                            break;
                    }

                    }
                    break;
            }

            switch (alt4) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: baseDecl
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_baseDecl_in_prolog1073);
                    baseDecl16=baseDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_baseDecl.add(baseDecl16.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:839:5: ( prolog1 )*
            loop5:
            do {
                int alt5=2;
                switch ( input.LA(1) ) {
                case DECLARE:
                case T_NAMESPACE:
                case COPYNAMESPACES:
                case T_BOUNDARYSPACE_DECL:
                case T_DEFAULT_DECL:
                case T_ORDER_DECL:
                case T_EMPTY_ORDER_DECL:
                case T_DEFAULT_COLLATION_DECL:
                case T_BASEURI_DECL:
                case T_MODULE_IMPORT:
                case T_SCHEMA_IMPORT:
                    {
                    alt5=1;
                    }
                    break;

                }

                switch (alt5) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: prolog1
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_prolog1_in_prolog1080);
            	    prolog117=prolog1();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_prolog1.add(prolog117.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:840:5: ( prolog2 )*
            loop6:
            do {
                int alt6=2;
                switch ( input.LA(1) ) {
                case T_FUNCTION_DECL:
                case T_VARIABLE_DECL:
                case T_EXTERNAL_VARIABLE_DECL:
                case T_OPTION_DECL:
                    {
                    alt6=1;
                    }
                    break;

                }

                switch (alt6) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: prolog2
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_prolog2_in_prolog1087);
            	    prolog218=prolog2();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_prolog2.add(prolog218.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);



            // AST REWRITE
            // elements: baseDecl, prolog1, prolog2
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 841:3: -> ( baseDecl )? COMMENT[\"modules imported by default\"] ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[xsparqlAbbrev] ) QSTRING[xsparqlNamespace] ^( AT QSTRING[xsparqlLibURL] ) ) ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[sparqlNamespaceAbbrev] ) QSTRING[sparqlFunctionsNamespace] ^( AT QSTRING[sparqlLibURL] ) ) ( prolog1 )* COMMENT[\"SPARQL prefix namespaces\"] ^( T_VARIABLE_DECL VAR[\"\\$_sparql_prefixes\"] ^( T_TYPE ) QSTRING[getSPARQLNamespaces()] ) ( prolog2 )*
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:842:5: ( baseDecl )?
                if ( stream_baseDecl.hasNext() ) {
                    adaptor.addChild(root_0, stream_baseDecl.nextTree());

                }
                stream_baseDecl.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, "modules imported by default"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:844:5: ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[xsparqlAbbrev] ) QSTRING[xsparqlNamespace] ^( AT QSTRING[xsparqlLibURL] ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_MODULE_IMPORT, "T_MODULE_IMPORT"), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:844:23: ^( NAMESPACE NCNAME[xsparqlAbbrev] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(NAMESPACE, "NAMESPACE"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, xsparqlAbbrev));

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, xsparqlNamespace));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:844:84: ^( AT QSTRING[xsparqlLibURL] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, xsparqlLibURL));

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:845:5: ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[sparqlNamespaceAbbrev] ) QSTRING[sparqlFunctionsNamespace] ^( AT QSTRING[sparqlLibURL] ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_MODULE_IMPORT, "T_MODULE_IMPORT"), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:845:23: ^( NAMESPACE NCNAME[sparqlNamespaceAbbrev] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(NAMESPACE, "NAMESPACE"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, sparqlNamespaceAbbrev));

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, sparqlFunctionsNamespace));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:845:100: ^( AT QSTRING[sparqlLibURL] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, sparqlLibURL));

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                adaptor.addChild(root_0,  createSchemaImport() );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:847:5: ( prolog1 )*
                while ( stream_prolog1.hasNext() ) {
                    adaptor.addChild(root_0, stream_prolog1.nextTree());

                }
                stream_prolog1.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, "SPARQL prefix namespaces"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:850:5: ^( T_VARIABLE_DECL VAR[\"\\$_sparql_prefixes\"] ^( T_TYPE ) QSTRING[getSPARQLNamespaces()] )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_VARIABLE_DECL, "T_VARIABLE_DECL"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, "$_sparql_prefixes"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:850:49: ^( T_TYPE )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_TYPE, "T_TYPE"), root_2);

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, getSPARQLNamespaces()));

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:851:5: ( prolog2 )*
                while ( stream_prolog2.hasNext() ) {
                    adaptor.addChild(root_0, stream_prolog2.nextTree());

                }
                stream_prolog2.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prolog"

    public static class prolog1_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prolog1"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:854:1: prolog1 : ( defaultNamespaceDecl | namespaceDecl | setter | importa | prefixDecl );
    public final XSPARQLRewriter.prolog1_return prolog1() throws RecognitionException {
        XSPARQLRewriter.prolog1_return retval = new XSPARQLRewriter.prolog1_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.defaultNamespaceDecl_return defaultNamespaceDecl19 = null;

        XSPARQLRewriter.namespaceDecl_return namespaceDecl20 = null;

        XSPARQLRewriter.setter_return setter21 = null;

        XSPARQLRewriter.importa_return importa22 = null;

        XSPARQLRewriter.prefixDecl_return prefixDecl23 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:855:3: ( defaultNamespaceDecl | namespaceDecl | setter | importa | prefixDecl )
            int alt7=5;
            switch ( input.LA(1) ) {
            case T_DEFAULT_DECL:
                {
                alt7=1;
                }
                break;
            case T_NAMESPACE:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case NCNAME:
                        {
                        alt7=2;
                        }
                        break;
                    case PNAME_NS:
                    case DEFAULT:
                        {
                        alt7=5;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 7, 5, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 7, 2, input);

                    throw nvae;
                }

                }
                break;
            case DECLARE:
            case COPYNAMESPACES:
            case T_BOUNDARYSPACE_DECL:
            case T_ORDER_DECL:
            case T_EMPTY_ORDER_DECL:
            case T_DEFAULT_COLLATION_DECL:
            case T_BASEURI_DECL:
                {
                alt7=3;
                }
                break;
            case T_MODULE_IMPORT:
            case T_SCHEMA_IMPORT:
                {
                alt7=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }

            switch (alt7) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:855:5: defaultNamespaceDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_defaultNamespaceDecl_in_prolog11215);
                    defaultNamespaceDecl19=defaultNamespaceDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, defaultNamespaceDecl19.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:856:5: namespaceDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_namespaceDecl_in_prolog11221);
                    namespaceDecl20=namespaceDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, namespaceDecl20.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:857:5: setter
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_setter_in_prolog11227);
                    setter21=setter();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, setter21.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:858:5: importa
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_importa_in_prolog11233);
                    importa22=importa();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, importa22.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:859:5: prefixDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_prefixDecl_in_prolog11239);
                    prefixDecl23=prefixDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, prefixDecl23.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prolog1"

    public static class prolog2_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prolog2"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:862:1: prolog2 : ( varDecl | functionDecl | optionDecl );
    public final XSPARQLRewriter.prolog2_return prolog2() throws RecognitionException {
        XSPARQLRewriter.prolog2_return retval = new XSPARQLRewriter.prolog2_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.varDecl_return varDecl24 = null;

        XSPARQLRewriter.functionDecl_return functionDecl25 = null;

        XSPARQLRewriter.optionDecl_return optionDecl26 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:863:3: ( varDecl | functionDecl | optionDecl )
            int alt8=3;
            switch ( input.LA(1) ) {
            case T_VARIABLE_DECL:
            case T_EXTERNAL_VARIABLE_DECL:
                {
                alt8=1;
                }
                break;
            case T_FUNCTION_DECL:
                {
                alt8=2;
                }
                break;
            case T_OPTION_DECL:
                {
                alt8=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }

            switch (alt8) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:863:5: varDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_varDecl_in_prolog21252);
                    varDecl24=varDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, varDecl24.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:864:5: functionDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_functionDecl_in_prolog21258);
                    functionDecl25=functionDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, functionDecl25.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:865:5: optionDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_optionDecl_in_prolog21264);
                    optionDecl26=optionDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, optionDecl26.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prolog2"

    public static class setter_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "setter"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:868:1: setter : ( boundarySpaceDecl | defaultCollationDecl | baseURIDecl | constructionDecl | orderingModeDecl | emptyOrderDecl | copyNamespacesDecl );
    public final XSPARQLRewriter.setter_return setter() throws RecognitionException {
        XSPARQLRewriter.setter_return retval = new XSPARQLRewriter.setter_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.boundarySpaceDecl_return boundarySpaceDecl27 = null;

        XSPARQLRewriter.defaultCollationDecl_return defaultCollationDecl28 = null;

        XSPARQLRewriter.baseURIDecl_return baseURIDecl29 = null;

        XSPARQLRewriter.constructionDecl_return constructionDecl30 = null;

        XSPARQLRewriter.orderingModeDecl_return orderingModeDecl31 = null;

        XSPARQLRewriter.emptyOrderDecl_return emptyOrderDecl32 = null;

        XSPARQLRewriter.copyNamespacesDecl_return copyNamespacesDecl33 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:869:3: ( boundarySpaceDecl | defaultCollationDecl | baseURIDecl | constructionDecl | orderingModeDecl | emptyOrderDecl | copyNamespacesDecl )
            int alt9=7;
            switch ( input.LA(1) ) {
            case T_BOUNDARYSPACE_DECL:
                {
                alt9=1;
                }
                break;
            case T_DEFAULT_COLLATION_DECL:
                {
                alt9=2;
                }
                break;
            case T_BASEURI_DECL:
                {
                alt9=3;
                }
                break;
            case DECLARE:
                {
                alt9=4;
                }
                break;
            case T_ORDER_DECL:
                {
                alt9=5;
                }
                break;
            case T_EMPTY_ORDER_DECL:
                {
                alt9=6;
                }
                break;
            case COPYNAMESPACES:
                {
                alt9=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }

            switch (alt9) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:869:5: boundarySpaceDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_boundarySpaceDecl_in_setter1277);
                    boundarySpaceDecl27=boundarySpaceDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, boundarySpaceDecl27.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:870:5: defaultCollationDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_defaultCollationDecl_in_setter1283);
                    defaultCollationDecl28=defaultCollationDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, defaultCollationDecl28.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:871:5: baseURIDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_baseURIDecl_in_setter1289);
                    baseURIDecl29=baseURIDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, baseURIDecl29.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:872:5: constructionDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructionDecl_in_setter1295);
                    constructionDecl30=constructionDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, constructionDecl30.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:873:5: orderingModeDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orderingModeDecl_in_setter1301);
                    orderingModeDecl31=orderingModeDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, orderingModeDecl31.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:874:5: emptyOrderDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_emptyOrderDecl_in_setter1307);
                    emptyOrderDecl32=emptyOrderDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, emptyOrderDecl32.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:875:5: copyNamespacesDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_copyNamespacesDecl_in_setter1313);
                    copyNamespacesDecl33=copyNamespacesDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, copyNamespacesDecl33.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "setter"

    public static class importa_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "importa"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:878:1: importa : ( schemaImport | moduleImport );
    public final XSPARQLRewriter.importa_return importa() throws RecognitionException {
        XSPARQLRewriter.importa_return retval = new XSPARQLRewriter.importa_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.schemaImport_return schemaImport34 = null;

        XSPARQLRewriter.moduleImport_return moduleImport35 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:879:3: ( schemaImport | moduleImport )
            int alt10=2;
            switch ( input.LA(1) ) {
            case T_SCHEMA_IMPORT:
                {
                alt10=1;
                }
                break;
            case T_MODULE_IMPORT:
                {
                alt10=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 10, 0, input);

                throw nvae;
            }

            switch (alt10) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:879:5: schemaImport
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_schemaImport_in_importa1326);
                    schemaImport34=schemaImport();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, schemaImport34.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:879:20: moduleImport
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_moduleImport_in_importa1330);
                    moduleImport35=moduleImport();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, moduleImport35.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "importa"

    public static class namespaceDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "namespaceDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:882:1: namespaceDecl : ^( T_NAMESPACE name= NCNAME irix= QSTRING ) ;
    public final XSPARQLRewriter.namespaceDecl_return namespaceDecl() throws RecognitionException {
        XSPARQLRewriter.namespaceDecl_return retval = new XSPARQLRewriter.namespaceDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree name=null;
        CommonTree irix=null;
        CommonTree T_NAMESPACE36=null;

        CommonTree name_tree=null;
        CommonTree irix_tree=null;
        CommonTree T_NAMESPACE36_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:883:3: ( ^( T_NAMESPACE name= NCNAME irix= QSTRING ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:883:5: ^( T_NAMESPACE name= NCNAME irix= QSTRING )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_NAMESPACE36=(CommonTree)match(input,T_NAMESPACE,FOLLOW_T_NAMESPACE_in_namespaceDecl1344); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_NAMESPACE36_tree = (CommonTree)adaptor.dupNode(T_NAMESPACE36);

            root_1 = (CommonTree)adaptor.becomeRoot(T_NAMESPACE36_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            name=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_namespaceDecl1348); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            name_tree = (CommonTree)adaptor.dupNode(name);

            adaptor.addChild(root_1, name_tree);
            }
            _last = (CommonTree)input.LT(1);
            irix=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_namespaceDecl1352); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            irix_tree = (CommonTree)adaptor.dupNode(irix);

            adaptor.addChild(root_1, irix_tree);
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
              addNamespace((name!=null?name.getText():null), (irix!=null?irix.getText():null));
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "namespaceDecl"

    public static class boundarySpaceDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "boundarySpaceDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:886:1: boundarySpaceDecl : ^( T_BOUNDARYSPACE_DECL ( PRESERVE | STRIP ) ) ;
    public final XSPARQLRewriter.boundarySpaceDecl_return boundarySpaceDecl() throws RecognitionException {
        XSPARQLRewriter.boundarySpaceDecl_return retval = new XSPARQLRewriter.boundarySpaceDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_BOUNDARYSPACE_DECL37=null;
        CommonTree set38=null;

        CommonTree T_BOUNDARYSPACE_DECL37_tree=null;
        CommonTree set38_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:887:3: ( ^( T_BOUNDARYSPACE_DECL ( PRESERVE | STRIP ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:887:5: ^( T_BOUNDARYSPACE_DECL ( PRESERVE | STRIP ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_BOUNDARYSPACE_DECL37=(CommonTree)match(input,T_BOUNDARYSPACE_DECL,FOLLOW_T_BOUNDARYSPACE_DECL_in_boundarySpaceDecl1369); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_BOUNDARYSPACE_DECL37_tree = (CommonTree)adaptor.dupNode(T_BOUNDARYSPACE_DECL37);

            root_1 = (CommonTree)adaptor.becomeRoot(T_BOUNDARYSPACE_DECL37_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            set38=(CommonTree)input.LT(1);
            if ( input.LA(1)==STRIP||input.LA(1)==PRESERVE ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set38_tree = (CommonTree)adaptor.dupNode(set38);

                adaptor.addChild(root_1, set38_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "boundarySpaceDecl"

    public static class defaultNamespaceDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "defaultNamespaceDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:890:1: defaultNamespaceDecl : ^( T_DEFAULT_DECL ( ELEMENT | FUNCTION ) NAMESPACE irix= QSTRING ) ;
    public final XSPARQLRewriter.defaultNamespaceDecl_return defaultNamespaceDecl() throws RecognitionException {
        XSPARQLRewriter.defaultNamespaceDecl_return retval = new XSPARQLRewriter.defaultNamespaceDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree irix=null;
        CommonTree T_DEFAULT_DECL39=null;
        CommonTree set40=null;
        CommonTree NAMESPACE41=null;

        CommonTree irix_tree=null;
        CommonTree T_DEFAULT_DECL39_tree=null;
        CommonTree set40_tree=null;
        CommonTree NAMESPACE41_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:891:3: ( ^( T_DEFAULT_DECL ( ELEMENT | FUNCTION ) NAMESPACE irix= QSTRING ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:891:5: ^( T_DEFAULT_DECL ( ELEMENT | FUNCTION ) NAMESPACE irix= QSTRING )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_DEFAULT_DECL39=(CommonTree)match(input,T_DEFAULT_DECL,FOLLOW_T_DEFAULT_DECL_in_defaultNamespaceDecl1390); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_DEFAULT_DECL39_tree = (CommonTree)adaptor.dupNode(T_DEFAULT_DECL39);

            root_1 = (CommonTree)adaptor.becomeRoot(T_DEFAULT_DECL39_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            set40=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=ELEMENT && input.LA(1)<=FUNCTION) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set40_tree = (CommonTree)adaptor.dupNode(set40);

                adaptor.addChild(root_1, set40_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            _last = (CommonTree)input.LT(1);
            NAMESPACE41=(CommonTree)match(input,NAMESPACE,FOLLOW_NAMESPACE_in_defaultNamespaceDecl1398); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            NAMESPACE41_tree = (CommonTree)adaptor.dupNode(NAMESPACE41);

            adaptor.addChild(root_1, NAMESPACE41_tree);
            }
            _last = (CommonTree)input.LT(1);
            irix=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_defaultNamespaceDecl1402); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            irix_tree = (CommonTree)adaptor.dupNode(irix);

            adaptor.addChild(root_1, irix_tree);
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
              addNamespace(":", (irix!=null?irix.getText():null));
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "defaultNamespaceDecl"

    public static class optionDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "optionDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:894:1: optionDecl : ^( T_OPTION_DECL qname stringliteral ) ;
    public final XSPARQLRewriter.optionDecl_return optionDecl() throws RecognitionException {
        XSPARQLRewriter.optionDecl_return retval = new XSPARQLRewriter.optionDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_OPTION_DECL42=null;
        XSPARQLRewriter.qname_return qname43 = null;

        XSPARQLRewriter.stringliteral_return stringliteral44 = null;


        CommonTree T_OPTION_DECL42_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:895:3: ( ^( T_OPTION_DECL qname stringliteral ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:895:5: ^( T_OPTION_DECL qname stringliteral )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_OPTION_DECL42=(CommonTree)match(input,T_OPTION_DECL,FOLLOW_T_OPTION_DECL_in_optionDecl1419); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_OPTION_DECL42_tree = (CommonTree)adaptor.dupNode(T_OPTION_DECL42);

            root_1 = (CommonTree)adaptor.becomeRoot(T_OPTION_DECL42_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_optionDecl1421);
            qname43=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, qname43.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_stringliteral_in_optionDecl1423);
            stringliteral44=stringliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, stringliteral44.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "optionDecl"

    public static class orderingModeDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderingModeDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:898:1: orderingModeDecl : ^( T_ORDER_DECL ( ORDERED | UNORDERED ) ) ;
    public final XSPARQLRewriter.orderingModeDecl_return orderingModeDecl() throws RecognitionException {
        XSPARQLRewriter.orderingModeDecl_return retval = new XSPARQLRewriter.orderingModeDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_ORDER_DECL45=null;
        CommonTree set46=null;

        CommonTree T_ORDER_DECL45_tree=null;
        CommonTree set46_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:899:3: ( ^( T_ORDER_DECL ( ORDERED | UNORDERED ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:899:5: ^( T_ORDER_DECL ( ORDERED | UNORDERED ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_ORDER_DECL45=(CommonTree)match(input,T_ORDER_DECL,FOLLOW_T_ORDER_DECL_in_orderingModeDecl1438); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_ORDER_DECL45_tree = (CommonTree)adaptor.dupNode(T_ORDER_DECL45);

            root_1 = (CommonTree)adaptor.becomeRoot(T_ORDER_DECL45_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            set46=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=ORDERED && input.LA(1)<=UNORDERED) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set46_tree = (CommonTree)adaptor.dupNode(set46);

                adaptor.addChild(root_1, set46_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderingModeDecl"

    public static class emptyOrderDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "emptyOrderDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:902:1: emptyOrderDecl : ^( T_EMPTY_ORDER_DECL ( GREATEST | LEAST ) ) ;
    public final XSPARQLRewriter.emptyOrderDecl_return emptyOrderDecl() throws RecognitionException {
        XSPARQLRewriter.emptyOrderDecl_return retval = new XSPARQLRewriter.emptyOrderDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_EMPTY_ORDER_DECL47=null;
        CommonTree set48=null;

        CommonTree T_EMPTY_ORDER_DECL47_tree=null;
        CommonTree set48_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:903:3: ( ^( T_EMPTY_ORDER_DECL ( GREATEST | LEAST ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:903:5: ^( T_EMPTY_ORDER_DECL ( GREATEST | LEAST ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_EMPTY_ORDER_DECL47=(CommonTree)match(input,T_EMPTY_ORDER_DECL,FOLLOW_T_EMPTY_ORDER_DECL_in_emptyOrderDecl1459); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_EMPTY_ORDER_DECL47_tree = (CommonTree)adaptor.dupNode(T_EMPTY_ORDER_DECL47);

            root_1 = (CommonTree)adaptor.becomeRoot(T_EMPTY_ORDER_DECL47_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            set48=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=GREATEST && input.LA(1)<=LEAST) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set48_tree = (CommonTree)adaptor.dupNode(set48);

                adaptor.addChild(root_1, set48_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "emptyOrderDecl"

    public static class copyNamespacesDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "copyNamespacesDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:906:1: copyNamespacesDecl : ^( COPYNAMESPACES preserveMode inheritMode ) ;
    public final XSPARQLRewriter.copyNamespacesDecl_return copyNamespacesDecl() throws RecognitionException {
        XSPARQLRewriter.copyNamespacesDecl_return retval = new XSPARQLRewriter.copyNamespacesDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree COPYNAMESPACES49=null;
        XSPARQLRewriter.preserveMode_return preserveMode50 = null;

        XSPARQLRewriter.inheritMode_return inheritMode51 = null;


        CommonTree COPYNAMESPACES49_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:907:3: ( ^( COPYNAMESPACES preserveMode inheritMode ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:907:5: ^( COPYNAMESPACES preserveMode inheritMode )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            COPYNAMESPACES49=(CommonTree)match(input,COPYNAMESPACES,FOLLOW_COPYNAMESPACES_in_copyNamespacesDecl1480); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            COPYNAMESPACES49_tree = (CommonTree)adaptor.dupNode(COPYNAMESPACES49);

            root_1 = (CommonTree)adaptor.becomeRoot(COPYNAMESPACES49_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_preserveMode_in_copyNamespacesDecl1482);
            preserveMode50=preserveMode();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, preserveMode50.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_inheritMode_in_copyNamespacesDecl1484);
            inheritMode51=inheritMode();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, inheritMode51.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "copyNamespacesDecl"

    public static class preserveMode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "preserveMode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:910:1: preserveMode : ( PRESERVE | NOPRESERVE );
    public final XSPARQLRewriter.preserveMode_return preserveMode() throws RecognitionException {
        XSPARQLRewriter.preserveMode_return retval = new XSPARQLRewriter.preserveMode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set52=null;

        CommonTree set52_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:911:3: ( PRESERVE | NOPRESERVE )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set52=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=NOPRESERVE && input.LA(1)<=PRESERVE) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set52_tree = (CommonTree)adaptor.dupNode(set52);

                adaptor.addChild(root_0, set52_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "preserveMode"

    public static class inheritMode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "inheritMode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:915:1: inheritMode : ( INHERIT | NOINHERIT );
    public final XSPARQLRewriter.inheritMode_return inheritMode() throws RecognitionException {
        XSPARQLRewriter.inheritMode_return retval = new XSPARQLRewriter.inheritMode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set53=null;

        CommonTree set53_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:916:3: ( INHERIT | NOINHERIT )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set53=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=INHERIT && input.LA(1)<=NOINHERIT) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set53_tree = (CommonTree)adaptor.dupNode(set53);

                adaptor.addChild(root_0, set53_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "inheritMode"

    public static class defaultCollationDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "defaultCollationDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:920:1: defaultCollationDecl : ^( T_DEFAULT_COLLATION_DECL uriliteral ) ;
    public final XSPARQLRewriter.defaultCollationDecl_return defaultCollationDecl() throws RecognitionException {
        XSPARQLRewriter.defaultCollationDecl_return retval = new XSPARQLRewriter.defaultCollationDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_DEFAULT_COLLATION_DECL54=null;
        XSPARQLRewriter.uriliteral_return uriliteral55 = null;


        CommonTree T_DEFAULT_COLLATION_DECL54_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:921:3: ( ^( T_DEFAULT_COLLATION_DECL uriliteral ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:921:5: ^( T_DEFAULT_COLLATION_DECL uriliteral )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_DEFAULT_COLLATION_DECL54=(CommonTree)match(input,T_DEFAULT_COLLATION_DECL,FOLLOW_T_DEFAULT_COLLATION_DECL_in_defaultCollationDecl1537); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_DEFAULT_COLLATION_DECL54_tree = (CommonTree)adaptor.dupNode(T_DEFAULT_COLLATION_DECL54);

            root_1 = (CommonTree)adaptor.becomeRoot(T_DEFAULT_COLLATION_DECL54_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_uriliteral_in_defaultCollationDecl1539);
            uriliteral55=uriliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, uriliteral55.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "defaultCollationDecl"

    public static class baseURIDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "baseURIDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:924:1: baseURIDecl : ^( T_BASEURI_DECL QSTRING ) ;
    public final XSPARQLRewriter.baseURIDecl_return baseURIDecl() throws RecognitionException {
        XSPARQLRewriter.baseURIDecl_return retval = new XSPARQLRewriter.baseURIDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_BASEURI_DECL56=null;
        CommonTree QSTRING57=null;

        CommonTree T_BASEURI_DECL56_tree=null;
        CommonTree QSTRING57_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:925:3: ( ^( T_BASEURI_DECL QSTRING ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:925:5: ^( T_BASEURI_DECL QSTRING )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_BASEURI_DECL56=(CommonTree)match(input,T_BASEURI_DECL,FOLLOW_T_BASEURI_DECL_in_baseURIDecl1554); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_BASEURI_DECL56_tree = (CommonTree)adaptor.dupNode(T_BASEURI_DECL56);

            root_1 = (CommonTree)adaptor.becomeRoot(T_BASEURI_DECL56_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            QSTRING57=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_baseURIDecl1556); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            QSTRING57_tree = (CommonTree)adaptor.dupNode(QSTRING57);

            adaptor.addChild(root_1, QSTRING57_tree);
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "baseURIDecl"

    public static class schemaImport_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "schemaImport"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:928:1: schemaImport : ^( T_SCHEMA_IMPORT ^( SCHEMA ( schemaPrefix )? ) uriliteral ^( AT ( uriliteral )* ) ) ;
    public final XSPARQLRewriter.schemaImport_return schemaImport() throws RecognitionException {
        XSPARQLRewriter.schemaImport_return retval = new XSPARQLRewriter.schemaImport_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_SCHEMA_IMPORT58=null;
        CommonTree SCHEMA59=null;
        CommonTree AT62=null;
        XSPARQLRewriter.schemaPrefix_return schemaPrefix60 = null;

        XSPARQLRewriter.uriliteral_return uriliteral61 = null;

        XSPARQLRewriter.uriliteral_return uriliteral63 = null;


        CommonTree T_SCHEMA_IMPORT58_tree=null;
        CommonTree SCHEMA59_tree=null;
        CommonTree AT62_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:929:3: ( ^( T_SCHEMA_IMPORT ^( SCHEMA ( schemaPrefix )? ) uriliteral ^( AT ( uriliteral )* ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:929:5: ^( T_SCHEMA_IMPORT ^( SCHEMA ( schemaPrefix )? ) uriliteral ^( AT ( uriliteral )* ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_SCHEMA_IMPORT58=(CommonTree)match(input,T_SCHEMA_IMPORT,FOLLOW_T_SCHEMA_IMPORT_in_schemaImport1571); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_SCHEMA_IMPORT58_tree = (CommonTree)adaptor.dupNode(T_SCHEMA_IMPORT58);

            root_1 = (CommonTree)adaptor.becomeRoot(T_SCHEMA_IMPORT58_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            SCHEMA59=(CommonTree)match(input,SCHEMA,FOLLOW_SCHEMA_in_schemaImport1574); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            SCHEMA59_tree = (CommonTree)adaptor.dupNode(SCHEMA59);

            root_2 = (CommonTree)adaptor.becomeRoot(SCHEMA59_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:929:32: ( schemaPrefix )?
                int alt11=2;
                switch ( input.LA(1) ) {
                    case NCNAME:
                    case DEFAULT:
                        {
                        alt11=1;
                        }
                        break;
                }

                switch (alt11) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: schemaPrefix
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_schemaPrefix_in_schemaImport1576);
                        schemaPrefix60=schemaPrefix();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) 
                        adaptor.addChild(root_2, schemaPrefix60.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_uriliteral_in_schemaImport1580);
            uriliteral61=uriliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, uriliteral61.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            AT62=(CommonTree)match(input,AT,FOLLOW_AT_in_schemaImport1583); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            AT62_tree = (CommonTree)adaptor.dupNode(AT62);

            root_2 = (CommonTree)adaptor.becomeRoot(AT62_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:929:63: ( uriliteral )*
                loop12:
                do {
                    int alt12=2;
                    switch ( input.LA(1) ) {
                    case QSTRING:
                        {
                        alt12=1;
                        }
                        break;

                    }

                    switch (alt12) {
                	case 1 :
                	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: uriliteral
                	    {
                	    _last = (CommonTree)input.LT(1);
                	    pushFollow(FOLLOW_uriliteral_in_schemaImport1585);
                	    uriliteral63=uriliteral();

                	    state._fsp--;
                	    if (state.failed) return retval;
                	    if ( state.backtracking==0 ) 
                	    adaptor.addChild(root_2, uriliteral63.getTree());

                	    if ( state.backtracking==0 ) {
                	    }
                	    }
                	    break;

                	default :
                	    break loop12;
                    }
                } while (true);


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "schemaImport"

    public static class schemaPrefix_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "schemaPrefix"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:932:1: schemaPrefix : ( NCNAME | DEFAULT );
    public final XSPARQLRewriter.schemaPrefix_return schemaPrefix() throws RecognitionException {
        XSPARQLRewriter.schemaPrefix_return retval = new XSPARQLRewriter.schemaPrefix_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set64=null;

        CommonTree set64_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:933:3: ( NCNAME | DEFAULT )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set64=(CommonTree)input.LT(1);
            if ( input.LA(1)==NCNAME||input.LA(1)==DEFAULT ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set64_tree = (CommonTree)adaptor.dupNode(set64);

                adaptor.addChild(root_0, set64_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "schemaPrefix"

    public static class moduleImport_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "moduleImport"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:937:1: moduleImport : ^( T_MODULE_IMPORT ^( NAMESPACE ( NCNAME )? ) uriliteral ^( AT ( uriliteral )* ) ) ;
    public final XSPARQLRewriter.moduleImport_return moduleImport() throws RecognitionException {
        XSPARQLRewriter.moduleImport_return retval = new XSPARQLRewriter.moduleImport_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_MODULE_IMPORT65=null;
        CommonTree NAMESPACE66=null;
        CommonTree NCNAME67=null;
        CommonTree AT69=null;
        XSPARQLRewriter.uriliteral_return uriliteral68 = null;

        XSPARQLRewriter.uriliteral_return uriliteral70 = null;


        CommonTree T_MODULE_IMPORT65_tree=null;
        CommonTree NAMESPACE66_tree=null;
        CommonTree NCNAME67_tree=null;
        CommonTree AT69_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:938:3: ( ^( T_MODULE_IMPORT ^( NAMESPACE ( NCNAME )? ) uriliteral ^( AT ( uriliteral )* ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:938:5: ^( T_MODULE_IMPORT ^( NAMESPACE ( NCNAME )? ) uriliteral ^( AT ( uriliteral )* ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_MODULE_IMPORT65=(CommonTree)match(input,T_MODULE_IMPORT,FOLLOW_T_MODULE_IMPORT_in_moduleImport1621); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_MODULE_IMPORT65_tree = (CommonTree)adaptor.dupNode(T_MODULE_IMPORT65);

            root_1 = (CommonTree)adaptor.becomeRoot(T_MODULE_IMPORT65_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            NAMESPACE66=(CommonTree)match(input,NAMESPACE,FOLLOW_NAMESPACE_in_moduleImport1624); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            NAMESPACE66_tree = (CommonTree)adaptor.dupNode(NAMESPACE66);

            root_2 = (CommonTree)adaptor.becomeRoot(NAMESPACE66_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:938:35: ( NCNAME )?
                int alt13=2;
                switch ( input.LA(1) ) {
                    case NCNAME:
                        {
                        alt13=1;
                        }
                        break;
                }

                switch (alt13) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: NCNAME
                        {
                        _last = (CommonTree)input.LT(1);
                        NCNAME67=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_moduleImport1626); if (state.failed) return retval;
                        if ( state.backtracking==0 ) {
                        NCNAME67_tree = (CommonTree)adaptor.dupNode(NCNAME67);

                        adaptor.addChild(root_2, NCNAME67_tree);
                        }

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_uriliteral_in_moduleImport1630);
            uriliteral68=uriliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, uriliteral68.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            AT69=(CommonTree)match(input,AT,FOLLOW_AT_in_moduleImport1633); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            AT69_tree = (CommonTree)adaptor.dupNode(AT69);

            root_2 = (CommonTree)adaptor.becomeRoot(AT69_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:938:60: ( uriliteral )*
                loop14:
                do {
                    int alt14=2;
                    switch ( input.LA(1) ) {
                    case QSTRING:
                        {
                        alt14=1;
                        }
                        break;

                    }

                    switch (alt14) {
                	case 1 :
                	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: uriliteral
                	    {
                	    _last = (CommonTree)input.LT(1);
                	    pushFollow(FOLLOW_uriliteral_in_moduleImport1635);
                	    uriliteral70=uriliteral();

                	    state._fsp--;
                	    if (state.failed) return retval;
                	    if ( state.backtracking==0 ) 
                	    adaptor.addChild(root_2, uriliteral70.getTree());

                	    if ( state.backtracking==0 ) {
                	    }
                	    }
                	    break;

                	default :
                	    break loop14;
                    }
                } while (true);


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "moduleImport"

    public static class varDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:941:1: varDecl : ( ^( T_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) exprSingle ) | ^( T_EXTERNAL_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) ) );
    public final XSPARQLRewriter.varDecl_return varDecl() throws RecognitionException {
        XSPARQLRewriter.varDecl_return retval = new XSPARQLRewriter.varDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        CommonTree T_VARIABLE_DECL71=null;
        CommonTree T_TYPE72=null;
        CommonTree T_EXTERNAL_VARIABLE_DECL75=null;
        CommonTree T_TYPE76=null;
        XSPARQLRewriter.typeDeclaration_return typeDeclaration73 = null;

        XSPARQLRewriter.exprSingle_return exprSingle74 = null;

        XSPARQLRewriter.typeDeclaration_return typeDeclaration77 = null;


        CommonTree var_tree=null;
        CommonTree T_VARIABLE_DECL71_tree=null;
        CommonTree T_TYPE72_tree=null;
        CommonTree T_EXTERNAL_VARIABLE_DECL75_tree=null;
        CommonTree T_TYPE76_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:942:3: ( ^( T_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) exprSingle ) | ^( T_EXTERNAL_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) ) )
            int alt17=2;
            switch ( input.LA(1) ) {
            case T_VARIABLE_DECL:
                {
                alt17=1;
                }
                break;
            case T_EXTERNAL_VARIABLE_DECL:
                {
                alt17=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 17, 0, input);

                throw nvae;
            }

            switch (alt17) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:942:5: ^( T_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) exprSingle )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VARIABLE_DECL71=(CommonTree)match(input,T_VARIABLE_DECL,FOLLOW_T_VARIABLE_DECL_in_varDecl1652); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_VARIABLE_DECL71_tree = (CommonTree)adaptor.dupNode(T_VARIABLE_DECL71);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_VARIABLE_DECL71_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varDecl1656); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    var_tree = (CommonTree)adaptor.dupNode(var);

                    adaptor.addChild(root_1, var_tree);
                    }
                    if ( state.backtracking==0 ) {
                      addVariableToScope((var!=null?var.getText():null));
                    }
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_TYPE72=(CommonTree)match(input,T_TYPE,FOLLOW_T_TYPE_in_varDecl1661); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_TYPE72_tree = (CommonTree)adaptor.dupNode(T_TYPE72);

                    root_2 = (CommonTree)adaptor.becomeRoot(T_TYPE72_tree, root_2);
                    }


                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); if (state.failed) return retval;
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:942:73: ( typeDeclaration )?
                        int alt15=2;
                        switch ( input.LA(1) ) {
                            case NCNAME:
                            case PNAME_NS:
                            case PNAME_LN:
                            case A:
                            case FROM:
                            case ATTRIBUTE:
                            case ELEMENT:
                            case TO:
                            case EMPTYSEQUENCE:
                            case ITEM:
                            case NODE:
                            case DOCUMENTNODE:
                            case TEXT:
                            case COMMENT:
                            case PROCESSINGINSTRUCTION:
                            case SCHEMAATTRIBUTE:
                            case SCHEMAELEMENT:
                            case ROW:
                                {
                                alt15=1;
                                }
                                break;
                        }

                        switch (alt15) {
                            case 1 :
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: typeDeclaration
                                {
                                _last = (CommonTree)input.LT(1);
                                pushFollow(FOLLOW_typeDeclaration_in_varDecl1663);
                                typeDeclaration73=typeDeclaration();

                                state._fsp--;
                                if (state.failed) return retval;
                                if ( state.backtracking==0 ) 
                                adaptor.addChild(root_2, typeDeclaration73.getTree());

                                if ( state.backtracking==0 ) {
                                }
                                }
                                break;

                        }


                        match(input, Token.UP, null); if (state.failed) return retval;
                    }adaptor.addChild(root_1, root_2);_last = _save_last_2;
                    }

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_exprSingle_in_varDecl1667);
                    exprSingle74=exprSingle();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, exprSingle74.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:943:5: ^( T_EXTERNAL_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_EXTERNAL_VARIABLE_DECL75=(CommonTree)match(input,T_EXTERNAL_VARIABLE_DECL,FOLLOW_T_EXTERNAL_VARIABLE_DECL_in_varDecl1675); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_EXTERNAL_VARIABLE_DECL75_tree = (CommonTree)adaptor.dupNode(T_EXTERNAL_VARIABLE_DECL75);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_EXTERNAL_VARIABLE_DECL75_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varDecl1679); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    var_tree = (CommonTree)adaptor.dupNode(var);

                    adaptor.addChild(root_1, var_tree);
                    }
                    if ( state.backtracking==0 ) {
                      addVariableToScope((var!=null?var.getText():null));
                    }
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_TYPE76=(CommonTree)match(input,T_TYPE,FOLLOW_T_TYPE_in_varDecl1684); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_TYPE76_tree = (CommonTree)adaptor.dupNode(T_TYPE76);

                    root_2 = (CommonTree)adaptor.becomeRoot(T_TYPE76_tree, root_2);
                    }


                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); if (state.failed) return retval;
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:943:82: ( typeDeclaration )?
                        int alt16=2;
                        switch ( input.LA(1) ) {
                            case NCNAME:
                            case PNAME_NS:
                            case PNAME_LN:
                            case A:
                            case FROM:
                            case ATTRIBUTE:
                            case ELEMENT:
                            case TO:
                            case EMPTYSEQUENCE:
                            case ITEM:
                            case NODE:
                            case DOCUMENTNODE:
                            case TEXT:
                            case COMMENT:
                            case PROCESSINGINSTRUCTION:
                            case SCHEMAATTRIBUTE:
                            case SCHEMAELEMENT:
                            case ROW:
                                {
                                alt16=1;
                                }
                                break;
                        }

                        switch (alt16) {
                            case 1 :
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: typeDeclaration
                                {
                                _last = (CommonTree)input.LT(1);
                                pushFollow(FOLLOW_typeDeclaration_in_varDecl1686);
                                typeDeclaration77=typeDeclaration();

                                state._fsp--;
                                if (state.failed) return retval;
                                if ( state.backtracking==0 ) 
                                adaptor.addChild(root_2, typeDeclaration77.getTree());

                                if ( state.backtracking==0 ) {
                                }
                                }
                                break;

                        }


                        match(input, Token.UP, null); if (state.failed) return retval;
                    }adaptor.addChild(root_1, root_2);_last = _save_last_2;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varDecl"

    public static class constructionDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructionDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:946:1: constructionDecl : DECLARE CONSTRUCTION ( STRIP | PRESERVE ) ;
    public final XSPARQLRewriter.constructionDecl_return constructionDecl() throws RecognitionException {
        XSPARQLRewriter.constructionDecl_return retval = new XSPARQLRewriter.constructionDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DECLARE78=null;
        CommonTree CONSTRUCTION79=null;
        CommonTree set80=null;

        CommonTree DECLARE78_tree=null;
        CommonTree CONSTRUCTION79_tree=null;
        CommonTree set80_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:947:3: ( DECLARE CONSTRUCTION ( STRIP | PRESERVE ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:947:5: DECLARE CONSTRUCTION ( STRIP | PRESERVE )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DECLARE78=(CommonTree)match(input,DECLARE,FOLLOW_DECLARE_in_constructionDecl1702); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DECLARE78_tree = (CommonTree)adaptor.dupNode(DECLARE78);

            adaptor.addChild(root_0, DECLARE78_tree);
            }
            _last = (CommonTree)input.LT(1);
            CONSTRUCTION79=(CommonTree)match(input,CONSTRUCTION,FOLLOW_CONSTRUCTION_in_constructionDecl1704); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            CONSTRUCTION79_tree = (CommonTree)adaptor.dupNode(CONSTRUCTION79);

            adaptor.addChild(root_0, CONSTRUCTION79_tree);
            }
            _last = (CommonTree)input.LT(1);
            set80=(CommonTree)input.LT(1);
            if ( input.LA(1)==STRIP||input.LA(1)==PRESERVE ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set80_tree = (CommonTree)adaptor.dupNode(set80);

                adaptor.addChild(root_0, set80_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constructionDecl"

    public static class functionDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "functionDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:950:1: functionDecl : ^( T_FUNCTION_DECL qname ^( T_PARAMS ( paramList )? ) ( ^( AS sequenceType ) )? ( enclosedExpr | EXTERNAL ) ) ;
    public final XSPARQLRewriter.functionDecl_return functionDecl() throws RecognitionException {
        VariableScope_stack.push(new VariableScope_scope());

        XSPARQLRewriter.functionDecl_return retval = new XSPARQLRewriter.functionDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_FUNCTION_DECL81=null;
        CommonTree T_PARAMS83=null;
        CommonTree AS85=null;
        CommonTree EXTERNAL88=null;
        XSPARQLRewriter.qname_return qname82 = null;

        XSPARQLRewriter.paramList_return paramList84 = null;

        XSPARQLRewriter.sequenceType_return sequenceType86 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr87 = null;


        CommonTree T_FUNCTION_DECL81_tree=null;
        CommonTree T_PARAMS83_tree=null;
        CommonTree AS85_tree=null;
        CommonTree EXTERNAL88_tree=null;


          ((VariableScope_scope)VariableScope_stack.peek()).variables = new HashMap<String,Types>();
          logger.info("Creating new variable scope: functionDecl");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:956:3: ( ^( T_FUNCTION_DECL qname ^( T_PARAMS ( paramList )? ) ( ^( AS sequenceType ) )? ( enclosedExpr | EXTERNAL ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:956:5: ^( T_FUNCTION_DECL qname ^( T_PARAMS ( paramList )? ) ( ^( AS sequenceType ) )? ( enclosedExpr | EXTERNAL ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_FUNCTION_DECL81=(CommonTree)match(input,T_FUNCTION_DECL,FOLLOW_T_FUNCTION_DECL_in_functionDecl1737); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_FUNCTION_DECL81_tree = (CommonTree)adaptor.dupNode(T_FUNCTION_DECL81);

            root_1 = (CommonTree)adaptor.becomeRoot(T_FUNCTION_DECL81_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_functionDecl1739);
            qname82=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, qname82.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_PARAMS83=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_functionDecl1742); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_PARAMS83_tree = (CommonTree)adaptor.dupNode(T_PARAMS83);

            root_2 = (CommonTree)adaptor.becomeRoot(T_PARAMS83_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:956:40: ( paramList )?
                int alt18=2;
                switch ( input.LA(1) ) {
                    case T_PARAM:
                        {
                        alt18=1;
                        }
                        break;
                }

                switch (alt18) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: paramList
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_paramList_in_functionDecl1744);
                        paramList84=paramList();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) 
                        adaptor.addChild(root_2, paramList84.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:956:52: ( ^( AS sequenceType ) )?
            int alt19=2;
            switch ( input.LA(1) ) {
                case AS:
                    {
                    alt19=1;
                    }
                    break;
            }

            switch (alt19) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:956:53: ^( AS sequenceType )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    AS85=(CommonTree)match(input,AS,FOLLOW_AS_in_functionDecl1750); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AS85_tree = (CommonTree)adaptor.dupNode(AS85);

                    root_2 = (CommonTree)adaptor.becomeRoot(AS85_tree, root_2);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sequenceType_in_functionDecl1752);
                    sequenceType86=sequenceType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_2, sequenceType86.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:956:74: ( enclosedExpr | EXTERNAL )
            int alt20=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt20=1;
                }
                break;
            case EXTERNAL:
                {
                alt20=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;
            }

            switch (alt20) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:956:75: enclosedExpr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_functionDecl1758);
                    enclosedExpr87=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, enclosedExpr87.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:956:90: EXTERNAL
                    {
                    _last = (CommonTree)input.LT(1);
                    EXTERNAL88=(CommonTree)match(input,EXTERNAL,FOLLOW_EXTERNAL_in_functionDecl1762); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    EXTERNAL88_tree = (CommonTree)adaptor.dupNode(EXTERNAL88);

                    adaptor.addChild(root_1, EXTERNAL88_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            VariableScope_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "functionDecl"

    public static class paramList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "paramList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:959:1: paramList : ( param )+ ;
    public final XSPARQLRewriter.paramList_return paramList() throws RecognitionException {
        XSPARQLRewriter.paramList_return retval = new XSPARQLRewriter.paramList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.param_return param89 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:960:3: ( ( param )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:960:5: ( param )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:960:5: ( param )+
            int cnt21=0;
            loop21:
            do {
                int alt21=2;
                switch ( input.LA(1) ) {
                case T_PARAM:
                    {
                    alt21=1;
                    }
                    break;

                }

                switch (alt21) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: param
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_param_in_paramList1777);
            	    param89=param();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, param89.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt21 >= 1 ) break loop21;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(21, input);
                        throw eee;
                }
                cnt21++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "paramList"

    public static class param_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "param"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:963:1: param : ^( T_PARAM var= VAR ^( T_TYPE ( typeDeclaration )? ) ) ;
    public final XSPARQLRewriter.param_return param() throws RecognitionException {
        XSPARQLRewriter.param_return retval = new XSPARQLRewriter.param_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        CommonTree T_PARAM90=null;
        CommonTree T_TYPE91=null;
        XSPARQLRewriter.typeDeclaration_return typeDeclaration92 = null;


        CommonTree var_tree=null;
        CommonTree T_PARAM90_tree=null;
        CommonTree T_TYPE91_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:964:3: ( ^( T_PARAM var= VAR ^( T_TYPE ( typeDeclaration )? ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:964:5: ^( T_PARAM var= VAR ^( T_TYPE ( typeDeclaration )? ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_PARAM90=(CommonTree)match(input,T_PARAM,FOLLOW_T_PARAM_in_param1792); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_PARAM90_tree = (CommonTree)adaptor.dupNode(T_PARAM90);

            root_1 = (CommonTree)adaptor.becomeRoot(T_PARAM90_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_param1796); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            var_tree = (CommonTree)adaptor.dupNode(var);

            adaptor.addChild(root_1, var_tree);
            }
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_TYPE91=(CommonTree)match(input,T_TYPE,FOLLOW_T_TYPE_in_param1799); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_TYPE91_tree = (CommonTree)adaptor.dupNode(T_TYPE91);

            root_2 = (CommonTree)adaptor.becomeRoot(T_TYPE91_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:964:32: ( typeDeclaration )?
                int alt22=2;
                switch ( input.LA(1) ) {
                    case NCNAME:
                    case PNAME_NS:
                    case PNAME_LN:
                    case A:
                    case FROM:
                    case ATTRIBUTE:
                    case ELEMENT:
                    case TO:
                    case EMPTYSEQUENCE:
                    case ITEM:
                    case NODE:
                    case DOCUMENTNODE:
                    case TEXT:
                    case COMMENT:
                    case PROCESSINGINSTRUCTION:
                    case SCHEMAATTRIBUTE:
                    case SCHEMAELEMENT:
                    case ROW:
                        {
                        alt22=1;
                        }
                        break;
                }

                switch (alt22) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: typeDeclaration
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_typeDeclaration_in_param1801);
                        typeDeclaration92=typeDeclaration();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) 
                        adaptor.addChild(root_2, typeDeclaration92.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
              addVariableToScope((var!=null?var.getText():null));
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "param"

    public static class enclosedExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enclosedExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:967:1: enclosedExpr : expr ;
    public final XSPARQLRewriter.enclosedExpr_return enclosedExpr() throws RecognitionException {
        XSPARQLRewriter.enclosedExpr_return retval = new XSPARQLRewriter.enclosedExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.expr_return expr93 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:968:3: ( expr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:968:5: expr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_enclosedExpr1819);
            expr93=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr93.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "enclosedExpr"

    public static class enclosedExpr__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enclosedExpr_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:971:1: enclosedExpr_ : LCURLY expr RCURLY ;
    public final XSPARQLRewriter.enclosedExpr__return enclosedExpr_() throws RecognitionException {
        XSPARQLRewriter.enclosedExpr__return retval = new XSPARQLRewriter.enclosedExpr__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree LCURLY94=null;
        CommonTree RCURLY96=null;
        XSPARQLRewriter.expr_return expr95 = null;


        CommonTree LCURLY94_tree=null;
        CommonTree RCURLY96_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:972:3: ( LCURLY expr RCURLY )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:972:5: LCURLY expr RCURLY
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            LCURLY94=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_enclosedExpr_1832); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LCURLY94_tree = (CommonTree)adaptor.dupNode(LCURLY94);

            adaptor.addChild(root_0, LCURLY94_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_enclosedExpr_1834);
            expr95=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr95.getTree());
            _last = (CommonTree)input.LT(1);
            RCURLY96=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_enclosedExpr_1836); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RCURLY96_tree = (CommonTree)adaptor.dupNode(RCURLY96);

            adaptor.addChild(root_0, RCURLY96_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "enclosedExpr_"

    public static class queryBody_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "queryBody"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:975:1: queryBody : ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue ) -> {XSPARQL.graphoutput}? ^( T_QUERY_BODY ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ ) ) ) ) -> ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue ) ;
    public final XSPARQLRewriter.queryBody_return queryBody() throws RecognitionException {
        XSPARQLRewriter.queryBody_return retval = new XSPARQLRewriter.queryBody_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_QUERY_BODY97=null;
        CommonTree T_BODY_PART98=null;
        XSPARQLRewriter.exprSingle_return exprSingle99 = null;

        XSPARQLRewriter.epilogue_return epilogue100 = null;


        CommonTree T_QUERY_BODY97_tree=null;
        CommonTree T_BODY_PART98_tree=null;
        RewriteRuleNodeStream stream_T_QUERY_BODY=new RewriteRuleNodeStream(adaptor,"token T_QUERY_BODY");
        RewriteRuleNodeStream stream_T_BODY_PART=new RewriteRuleNodeStream(adaptor,"token T_BODY_PART");
        RewriteRuleSubtreeStream stream_epilogue=new RewriteRuleSubtreeStream(adaptor,"rule epilogue");
        RewriteRuleSubtreeStream stream_exprSingle=new RewriteRuleSubtreeStream(adaptor,"rule exprSingle");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:976:3: ( ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue ) -> {XSPARQL.graphoutput}? ^( T_QUERY_BODY ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ ) ) ) ) -> ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:976:5: ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_QUERY_BODY97=(CommonTree)match(input,T_QUERY_BODY,FOLLOW_T_QUERY_BODY_in_queryBody1850); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_QUERY_BODY.add(T_QUERY_BODY97);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:976:20: ( ^( T_BODY_PART exprSingle ) )+
            int cnt23=0;
            loop23:
            do {
                int alt23=2;
                switch ( input.LA(1) ) {
                case T_BODY_PART:
                    {
                    alt23=1;
                    }
                    break;

                }

                switch (alt23) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:976:21: ^( T_BODY_PART exprSingle )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_2 = _last;
            	    CommonTree _first_2 = null;
            	    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_BODY_PART98=(CommonTree)match(input,T_BODY_PART,FOLLOW_T_BODY_PART_in_queryBody1854); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_T_BODY_PART.add(T_BODY_PART98);



            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_exprSingle_in_queryBody1856);
            	    exprSingle99=exprSingle();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle99.getTree());

            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt23 >= 1 ) break loop23;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(23, input);
                        throw eee;
                }
                cnt23++;
            } while (true);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_epilogue_in_queryBody1861);
            epilogue100=epilogue();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_epilogue.add(epilogue100.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: T_BODY_PART, epilogue, exprSingle, T_BODY_PART, exprSingle, T_QUERY_BODY, T_BODY_PART, T_QUERY_BODY
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 977:3: -> {XSPARQL.graphoutput}? ^( T_QUERY_BODY ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ ) ) ) )
            if (XSPARQL.graphoutput) {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:978:6: ^( T_QUERY_BODY ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_T_QUERY_BODY.nextNode(), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:979:9: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:981:11: ^( T_PARAMS ^( T_PAR ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:981:22: ^( T_PAR ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:982:13: ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] )
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot(stream_T_BODY_PART.nextNode(), root_5);

                adaptor.addChild(root_5, (CommonTree)adaptor.create(COMMENT, "N3 namespace declaration"));
                adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, getRDFNamespaceDecls()));

                adaptor.addChild(root_4, root_5);
                }
                if ( !(stream_T_BODY_PART.hasNext()||stream_exprSingle.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_T_BODY_PART.hasNext()||stream_exprSingle.hasNext() ) {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:986:11: ^( T_BODY_PART exprSingle )
                    {
                    CommonTree root_5 = (CommonTree)adaptor.nil();
                    root_5 = (CommonTree)adaptor.becomeRoot(stream_T_BODY_PART.nextNode(), root_5);

                    adaptor.addChild(root_5, stream_exprSingle.nextTree());

                    adaptor.addChild(root_4, root_5);
                    }

                }
                stream_T_BODY_PART.reset();
                stream_exprSingle.reset();

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }
            else // 991:3: -> ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue )
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:991:7: ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_T_QUERY_BODY.nextNode(), root_1);

                if ( !(stream_exprSingle.hasNext()||stream_T_BODY_PART.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_exprSingle.hasNext()||stream_T_BODY_PART.hasNext() ) {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:991:23: ^( T_BODY_PART exprSingle )
                    {
                    CommonTree root_2 = (CommonTree)adaptor.nil();
                    root_2 = (CommonTree)adaptor.becomeRoot(stream_T_BODY_PART.nextNode(), root_2);

                    adaptor.addChild(root_2, stream_exprSingle.nextTree());

                    adaptor.addChild(root_1, root_2);
                    }

                }
                stream_exprSingle.reset();
                stream_T_BODY_PART.reset();
                adaptor.addChild(root_1, stream_epilogue.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "queryBody"

    public static class epilogue_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "epilogue"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:995:1: epilogue : T_EPILOGUE -> { epilogue.getChildCount() > 0 }? -> DELETEVNODE[\"epilogue\"] ;
    public final XSPARQLRewriter.epilogue_return epilogue() throws RecognitionException {
        XSPARQLRewriter.epilogue_return retval = new XSPARQLRewriter.epilogue_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_EPILOGUE101=null;

        CommonTree T_EPILOGUE101_tree=null;
        RewriteRuleNodeStream stream_T_EPILOGUE=new RewriteRuleNodeStream(adaptor,"token T_EPILOGUE");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:996:3: ( T_EPILOGUE -> { epilogue.getChildCount() > 0 }? -> DELETEVNODE[\"epilogue\"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:996:5: T_EPILOGUE
            {
            _last = (CommonTree)input.LT(1);
            T_EPILOGUE101=(CommonTree)match(input,T_EPILOGUE,FOLLOW_T_EPILOGUE_in_epilogue2070); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_EPILOGUE.add(T_EPILOGUE101);



            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 997:3: -> { epilogue.getChildCount() > 0 }?
            if ( epilogue.getChildCount() > 0 ) {
                adaptor.addChild(root_0,  epilogue );

            }
            else // 998:3: -> DELETEVNODE[\"epilogue\"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(DELETEVNODE, "epilogue"));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "epilogue"

    public static class expr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1002:1: expr options {backtrack=false; } : ( exprSingle )+ ;
    public final XSPARQLRewriter.expr_return expr() throws RecognitionException {
        XSPARQLRewriter.expr_return retval = new XSPARQLRewriter.expr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.exprSingle_return exprSingle102 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1007:3: ( ( exprSingle )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1007:5: ( exprSingle )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1007:5: ( exprSingle )+
            int cnt24=0;
            loop24:
            do {
                int alt24=2;
                alt24 = dfa24.predict(input);
                switch (alt24) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: exprSingle
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_exprSingle_in_expr2109);
            	    exprSingle102=exprSingle();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, exprSingle102.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt24 >= 1 ) break loop24;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(24, input);
                        throw eee;
                }
                cnt24++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "expr"

    protected static class exprSingle_scope {
        boolean isConstruct;
    }
    protected Stack exprSingle_stack = new Stack();

    public static class exprSingle_return extends TreeRuleReturnScope {
        public Types type;
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "exprSingle"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1010:1: exprSingle returns [Types type] : ( flworExpr | quantifiedExpr | typeSwitchExpr | orExpr | ifExpr );
    public final XSPARQLRewriter.exprSingle_return exprSingle() throws RecognitionException {
        exprSingle_stack.push(new exprSingle_scope());
        XSPARQLRewriter.exprSingle_return retval = new XSPARQLRewriter.exprSingle_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.flworExpr_return flworExpr103 = null;

        XSPARQLRewriter.quantifiedExpr_return quantifiedExpr104 = null;

        XSPARQLRewriter.typeSwitchExpr_return typeSwitchExpr105 = null;

        XSPARQLRewriter.orExpr_return orExpr106 = null;

        XSPARQLRewriter.ifExpr_return ifExpr107 = null;




            logger.info("exprSingle");
            ((exprSingle_scope)exprSingle_stack.peek()).isConstruct = false;
            retval.type = Types.XQUERY;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1020:3: ( flworExpr | quantifiedExpr | typeSwitchExpr | orExpr | ifExpr )
            int alt25=5;
            switch ( input.LA(1) ) {
            case T_FLWOR:
                {
                alt25=1;
                }
                break;
            case EVERY:
            case SOME:
                {
                alt25=2;
                }
                break;
            case TYPESWITCH:
                {
                alt25=3;
                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt25=4;
                }
                break;
            case IF:
                {
                alt25=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }

            switch (alt25) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1020:5: flworExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_flworExpr_in_exprSingle2140);
                    flworExpr103=flworExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, flworExpr103.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1021:5: quantifiedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_quantifiedExpr_in_exprSingle2146);
                    quantifiedExpr104=quantifiedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, quantifiedExpr104.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1022:5: typeSwitchExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_typeSwitchExpr_in_exprSingle2152);
                    typeSwitchExpr105=typeSwitchExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, typeSwitchExpr105.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1023:5: orExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orExpr_in_exprSingle2158);
                    orExpr106=orExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, orExpr106.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1024:5: ifExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_ifExpr_in_exprSingle2164);
                    ifExpr107=ifExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, ifExpr107.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
            if ( state.backtracking==0 ) {
               if (((exprSingle_scope)exprSingle_stack.peek()).isConstruct) { retval.type = Types.RDF_GRAPH; }  
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            exprSingle_stack.pop();
        }
        return retval;
    }
    // $ANTLR end "exprSingle"

    public static class flworExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "flworExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1027:1: flworExpr : ^( T_FLWOR forletClause ( returnClause )? ) ;
    public final XSPARQLRewriter.flworExpr_return flworExpr() throws RecognitionException {
        VariableScope_stack.push(new VariableScope_scope());

        XSPARQLRewriter.flworExpr_return retval = new XSPARQLRewriter.flworExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_FLWOR108=null;
        XSPARQLRewriter.forletClause_return forletClause109 = null;

        XSPARQLRewriter.returnClause_return returnClause110 = null;


        CommonTree T_FLWOR108_tree=null;


          ((VariableScope_scope)VariableScope_stack.peek()).variables = new HashMap<String,Types>();
          ((VariableScope_scope)VariableScope_stack.peek()).positions = new LinkedList<String>();
          ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset = true;
          ((VariableScope_scope)VariableScope_stack.peek()).sparqlClause = false;
          logger.info("Creating new variable scope: flworExpr");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1036:3: ( ^( T_FLWOR forletClause ( returnClause )? ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1036:5: ^( T_FLWOR forletClause ( returnClause )? )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_FLWOR108=(CommonTree)match(input,T_FLWOR,FOLLOW_T_FLWOR_in_flworExpr2188); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_FLWOR108_tree = (CommonTree)adaptor.dupNode(T_FLWOR108);

            root_1 = (CommonTree)adaptor.becomeRoot(T_FLWOR108_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_forletClause_in_flworExpr2190);
            forletClause109=forletClause();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, forletClause109.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1037:7: ( returnClause )?
            int alt26=2;
            switch ( input.LA(1) ) {
                case T_CONSTRUCT:
                case T_RETURN:
                    {
                    alt26=1;
                    }
                    break;
            }

            switch (alt26) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: returnClause
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_returnClause_in_flworExpr2199);
                    returnClause110=returnClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, returnClause110.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            VariableScope_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "flworExpr"

    public static class returnClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "returnClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1041:1: returnClause : ( ^( T_RETURN exprSingle ) -> ^( T_RETURN exprSingle ) | ^(c= T_CONSTRUCT constructTemplate ) -> COMMENT[\"SPARQL CONSTRUCT \" + $c.text + \" from \" + $c.line + \":\" + $c.pos] ^( T_RETURN[$c.token, \"return\"] ^( T_FUNCTION_CALL[$c.token, \"T_FUNCTION_CALL\"] NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR constructTemplate ) ) ) ) );
    public final XSPARQLRewriter.returnClause_return returnClause() throws RecognitionException {
        XSPARQLRewriter.returnClause_return retval = new XSPARQLRewriter.returnClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree c=null;
        CommonTree T_RETURN111=null;
        XSPARQLRewriter.exprSingle_return exprSingle112 = null;

        XSPARQLRewriter.constructTemplate_return constructTemplate113 = null;


        CommonTree c_tree=null;
        CommonTree T_RETURN111_tree=null;
        RewriteRuleNodeStream stream_T_RETURN=new RewriteRuleNodeStream(adaptor,"token T_RETURN");
        RewriteRuleNodeStream stream_T_CONSTRUCT=new RewriteRuleNodeStream(adaptor,"token T_CONSTRUCT");
        RewriteRuleSubtreeStream stream_constructTemplate=new RewriteRuleSubtreeStream(adaptor,"rule constructTemplate");
        RewriteRuleSubtreeStream stream_exprSingle=new RewriteRuleSubtreeStream(adaptor,"rule exprSingle");

          logger.info("returnClause");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1046:3: ( ^( T_RETURN exprSingle ) -> ^( T_RETURN exprSingle ) | ^(c= T_CONSTRUCT constructTemplate ) -> COMMENT[\"SPARQL CONSTRUCT \" + $c.text + \" from \" + $c.line + \":\" + $c.pos] ^( T_RETURN[$c.token, \"return\"] ^( T_FUNCTION_CALL[$c.token, \"T_FUNCTION_CALL\"] NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR constructTemplate ) ) ) ) )
            int alt27=2;
            switch ( input.LA(1) ) {
            case T_RETURN:
                {
                alt27=1;
                }
                break;
            case T_CONSTRUCT:
                {
                alt27=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 27, 0, input);

                throw nvae;
            }

            switch (alt27) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1046:5: ^( T_RETURN exprSingle )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_RETURN111=(CommonTree)match(input,T_RETURN,FOLLOW_T_RETURN_in_returnClause2231); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_RETURN.add(T_RETURN111);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_exprSingle_in_returnClause2233);
                    exprSingle112=exprSingle();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle112.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: T_RETURN, exprSingle
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1046:28: -> ^( T_RETURN exprSingle )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1046:31: ^( T_RETURN exprSingle )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_T_RETURN.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_exprSingle.nextTree());
                        adaptor.addChild(root_1,  generatePop() );

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1047:5: ^(c= T_CONSTRUCT constructTemplate )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    c=(CommonTree)match(input,T_CONSTRUCT,FOLLOW_T_CONSTRUCT_in_returnClause2253); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_CONSTRUCT.add(c);



                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); if (state.failed) return retval;
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_constructTemplate_in_returnClause2256);
                        constructTemplate113=constructTemplate();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) stream_constructTemplate.add(constructTemplate113.getTree());
                        if ( state.backtracking==0 ) {
                           ((exprSingle_scope)exprSingle_stack.peek()).isConstruct = true; 
                        }

                        match(input, Token.UP, null); if (state.failed) return retval;
                    }adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: constructTemplate
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1048:3: -> COMMENT[\"SPARQL CONSTRUCT \" + $c.text + \" from \" + $c.line + \":\" + $c.pos] ^( T_RETURN[$c.token, \"return\"] ^( T_FUNCTION_CALL[$c.token, \"T_FUNCTION_CALL\"] NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR constructTemplate ) ) ) )
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, "SPARQL CONSTRUCT " + (c!=null?c.getText():null) + " from " + (c!=null?c.getLine():0) + ":" + (c!=null?c.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1049:6: ^( T_RETURN[$c.token, \"return\"] ^( T_FUNCTION_CALL[$c.token, \"T_FUNCTION_CALL\"] NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR constructTemplate ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, c.token, "return"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1050:8: ^( T_FUNCTION_CALL[$c.token, \"T_FUNCTION_CALL\"] NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR constructTemplate ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, c.token, "T_FUNCTION_CALL"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1051:10: ^( T_PARAMS ^( T_PAR constructTemplate ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1051:21: ^( T_PAR constructTemplate )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, stream_constructTemplate.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, generatePop());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
            if ( state.backtracking==0 ) {
               if(((VariableScope_scope)VariableScope_stack.peek()).sparqlClause) { scopedDataset.pop(); }
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "returnClause"

    public static class forletClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forletClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1057:1: forletClause : ( forClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )? | sparqlForClause | sqlForClause | letClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )? );
    public final XSPARQLRewriter.forletClause_return forletClause() throws RecognitionException {
        XSPARQLRewriter.forletClause_return retval = new XSPARQLRewriter.forletClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_WHERE115=null;
        CommonTree T_ORDER117=null;
        CommonTree T_WHERE122=null;
        CommonTree T_ORDER124=null;
        XSPARQLRewriter.forClause_return forClause114 = null;

        XSPARQLRewriter.whereClause_return whereClause116 = null;

        XSPARQLRewriter.orderByClause_return orderByClause118 = null;

        XSPARQLRewriter.sparqlForClause_return sparqlForClause119 = null;

        XSPARQLRewriter.sqlForClause_return sqlForClause120 = null;

        XSPARQLRewriter.letClause_return letClause121 = null;

        XSPARQLRewriter.whereClause_return whereClause123 = null;

        XSPARQLRewriter.orderByClause_return orderByClause125 = null;


        CommonTree T_WHERE115_tree=null;
        CommonTree T_ORDER117_tree=null;
        CommonTree T_WHERE122_tree=null;
        CommonTree T_ORDER124_tree=null;

         logger.info("forletClause"); 
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1059:3: ( forClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )? | sparqlForClause | sqlForClause | letClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )? )
            int alt32=4;
            switch ( input.LA(1) ) {
            case T_FOR:
                {
                alt32=1;
                }
                break;
            case T_SPARQL_FOR:
                {
                alt32=2;
                }
                break;
            case T_SQL_FOR:
                {
                alt32=3;
                }
                break;
            case T_LET:
                {
                alt32=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 32, 0, input);

                throw nvae;
            }

            switch (alt32) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1059:5: forClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_forClause_in_forletClause2356);
                    forClause114=forClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, forClause114.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1059:15: ( ^( T_WHERE whereClause ) )?
                    int alt28=2;
                    switch ( input.LA(1) ) {
                        case T_WHERE:
                            {
                            alt28=1;
                            }
                            break;
                    }

                    switch (alt28) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1059:16: ^( T_WHERE whereClause )
                            {
                            _last = (CommonTree)input.LT(1);
                            {
                            CommonTree _save_last_1 = _last;
                            CommonTree _first_1 = null;
                            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                            T_WHERE115=(CommonTree)match(input,T_WHERE,FOLLOW_T_WHERE_in_forletClause2360); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            T_WHERE115_tree = (CommonTree)adaptor.dupNode(T_WHERE115);

                            root_1 = (CommonTree)adaptor.becomeRoot(T_WHERE115_tree, root_1);
                            }


                            match(input, Token.DOWN, null); if (state.failed) return retval;
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_whereClause_in_forletClause2362);
                            whereClause116=whereClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_1, whereClause116.getTree());

                            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1059:41: ( ^( T_ORDER orderByClause ) )?
                    int alt29=2;
                    switch ( input.LA(1) ) {
                        case T_ORDER:
                            {
                            alt29=1;
                            }
                            break;
                    }

                    switch (alt29) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1059:42: ^( T_ORDER orderByClause )
                            {
                            _last = (CommonTree)input.LT(1);
                            {
                            CommonTree _save_last_1 = _last;
                            CommonTree _first_1 = null;
                            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                            T_ORDER117=(CommonTree)match(input,T_ORDER,FOLLOW_T_ORDER_in_forletClause2369); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            T_ORDER117_tree = (CommonTree)adaptor.dupNode(T_ORDER117);

                            root_1 = (CommonTree)adaptor.becomeRoot(T_ORDER117_tree, root_1);
                            }


                            match(input, Token.DOWN, null); if (state.failed) return retval;
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_orderByClause_in_forletClause2371);
                            orderByClause118=orderByClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_1, orderByClause118.getTree());

                            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1060:5: sparqlForClause
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sparqlForClause_in_forletClause2380);
                    sparqlForClause119=sparqlForClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sparqlForClause119.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1061:5: sqlForClause
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sqlForClause_in_forletClause2386);
                    sqlForClause120=sqlForClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sqlForClause120.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1062:5: letClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_letClause_in_forletClause2392);
                    letClause121=letClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, letClause121.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1062:15: ( ^( T_WHERE whereClause ) )?
                    int alt30=2;
                    switch ( input.LA(1) ) {
                        case T_WHERE:
                            {
                            alt30=1;
                            }
                            break;
                    }

                    switch (alt30) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1062:16: ^( T_WHERE whereClause )
                            {
                            _last = (CommonTree)input.LT(1);
                            {
                            CommonTree _save_last_1 = _last;
                            CommonTree _first_1 = null;
                            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                            T_WHERE122=(CommonTree)match(input,T_WHERE,FOLLOW_T_WHERE_in_forletClause2396); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            T_WHERE122_tree = (CommonTree)adaptor.dupNode(T_WHERE122);

                            root_1 = (CommonTree)adaptor.becomeRoot(T_WHERE122_tree, root_1);
                            }


                            match(input, Token.DOWN, null); if (state.failed) return retval;
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_whereClause_in_forletClause2398);
                            whereClause123=whereClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_1, whereClause123.getTree());

                            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1062:41: ( ^( T_ORDER orderByClause ) )?
                    int alt31=2;
                    switch ( input.LA(1) ) {
                        case T_ORDER:
                            {
                            alt31=1;
                            }
                            break;
                    }

                    switch (alt31) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1062:42: ^( T_ORDER orderByClause )
                            {
                            _last = (CommonTree)input.LT(1);
                            {
                            CommonTree _save_last_1 = _last;
                            CommonTree _first_1 = null;
                            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                            T_ORDER124=(CommonTree)match(input,T_ORDER,FOLLOW_T_ORDER_in_forletClause2405); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            T_ORDER124_tree = (CommonTree)adaptor.dupNode(T_ORDER124);

                            root_1 = (CommonTree)adaptor.becomeRoot(T_ORDER124_tree, root_1);
                            }


                            match(input, Token.DOWN, null); if (state.failed) return retval;
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_orderByClause_in_forletClause2407);
                            orderByClause125=orderByClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_1, orderByClause125.getTree());

                            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forletClause"

    public static class distinct_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "distinct"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1065:1: distinct : DISTINCT -> QSTRING[ \" DISTINCT \" ] ;
    public final XSPARQLRewriter.distinct_return distinct() throws RecognitionException {
        XSPARQLRewriter.distinct_return retval = new XSPARQLRewriter.distinct_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DISTINCT126=null;

        CommonTree DISTINCT126_tree=null;
        RewriteRuleNodeStream stream_DISTINCT=new RewriteRuleNodeStream(adaptor,"token DISTINCT");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1065:9: ( DISTINCT -> QSTRING[ \" DISTINCT \" ] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1066:3: DISTINCT
            {
            _last = (CommonTree)input.LT(1);
            DISTINCT126=(CommonTree)match(input,DISTINCT,FOLLOW_DISTINCT_in_distinct2423); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_DISTINCT.add(DISTINCT126);



            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1066:12: -> QSTRING[ \" DISTINCT \" ]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " DISTINCT "));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "distinct"

    protected static class sqlForClause_scope {
        List<Pair<String,String>> relationsAlias;
        List<String> relations;
    }
    protected Stack sqlForClause_stack = new Stack();

    public static class sqlForClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlForClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1078:1: sqlForClause : ( ^(fo= T_SQL_FOR ( distinct )? (var+= sqlVarOrFunction )+ ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ | ^(fo= T_SQL_FOR ( distinct )? s= STAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) ^( T_SQL_FROM ^( T_FUNCTION_CALL qname ^( T_PARAMS sqlVarOrString ) ) ) -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) );
    public final XSPARQLRewriter.sqlForClause_return sqlForClause() throws RecognitionException {
        sqlForClause_stack.push(new sqlForClause_scope());
        XSPARQLRewriter.sqlForClause_return retval = new XSPARQLRewriter.sqlForClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree fo=null;
        CommonTree s=null;
        CommonTree v=null;
        CommonTree ROW134=null;
        CommonTree T_SQL_FROM135=null;
        CommonTree T_FUNCTION_CALL136=null;
        CommonTree T_PARAMS138=null;
        CommonTree ROW141=null;
        List list_var=null;
        XSPARQLRewriter.distinct_return distinct127 = null;

        XSPARQLRewriter.relationClause_return relationClause128 = null;

        XSPARQLRewriter.sqlWhereClause_return sqlWhereClause129 = null;

        XSPARQLRewriter.distinct_return distinct130 = null;

        XSPARQLRewriter.relationClause_return relationClause131 = null;

        XSPARQLRewriter.sqlWhereClause_return sqlWhereClause132 = null;

        XSPARQLRewriter.distinct_return distinct133 = null;

        XSPARQLRewriter.qname_return qname137 = null;

        XSPARQLRewriter.sqlVarOrString_return sqlVarOrString139 = null;

        XSPARQLRewriter.distinct_return distinct140 = null;

        XSPARQLRewriter.relationClause_return relationClause142 = null;

        XSPARQLRewriter.sqlWhereClause_return sqlWhereClause143 = null;

        RuleReturnScope var = null;
        CommonTree fo_tree=null;
        CommonTree s_tree=null;
        CommonTree v_tree=null;
        CommonTree ROW134_tree=null;
        CommonTree T_SQL_FROM135_tree=null;
        CommonTree T_FUNCTION_CALL136_tree=null;
        CommonTree T_PARAMS138_tree=null;
        CommonTree ROW141_tree=null;
        RewriteRuleNodeStream stream_T_SQL_FOR=new RewriteRuleNodeStream(adaptor,"token T_SQL_FOR");
        RewriteRuleNodeStream stream_T_FUNCTION_CALL=new RewriteRuleNodeStream(adaptor,"token T_FUNCTION_CALL");
        RewriteRuleNodeStream stream_T_PARAMS=new RewriteRuleNodeStream(adaptor,"token T_PARAMS");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_STAR=new RewriteRuleNodeStream(adaptor,"token STAR");
        RewriteRuleNodeStream stream_ROW=new RewriteRuleNodeStream(adaptor,"token ROW");
        RewriteRuleNodeStream stream_T_SQL_FROM=new RewriteRuleNodeStream(adaptor,"token T_SQL_FROM");
        RewriteRuleSubtreeStream stream_sqlVarOrFunction=new RewriteRuleSubtreeStream(adaptor,"rule sqlVarOrFunction");
        RewriteRuleSubtreeStream stream_sqlWhereClause=new RewriteRuleSubtreeStream(adaptor,"rule sqlWhereClause");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        RewriteRuleSubtreeStream stream_relationClause=new RewriteRuleSubtreeStream(adaptor,"rule relationClause");
        RewriteRuleSubtreeStream stream_sqlVarOrString=new RewriteRuleSubtreeStream(adaptor,"rule sqlVarOrString");
        RewriteRuleSubtreeStream stream_distinct=new RewriteRuleSubtreeStream(adaptor,"rule distinct");

          String auxResults = getNewAuxResultsVariable();
          String auxResult = getNewAuxResultVariable();
          String auxResultPos = auxResult + "_pos";
          
          ((sqlForClause_scope)sqlForClause_stack.peek()).relationsAlias = new LinkedList<Pair<String,String>>();
          ((sqlForClause_scope)sqlForClause_stack.peek()).relations = new LinkedList<String>();
         
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1091:3: ( ^(fo= T_SQL_FOR ( distinct )? (var+= sqlVarOrFunction )+ ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ | ^(fo= T_SQL_FOR ( distinct )? s= STAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) ^( T_SQL_FROM ^( T_FUNCTION_CALL qname ^( T_PARAMS sqlVarOrString ) ) ) -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) )
            int alt41=4;
            alt41 = dfa41.predict(input);
            switch (alt41) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1091:5: ^(fo= T_SQL_FOR ( distinct )? (var+= sqlVarOrFunction )+ ) relationClause ( sqlWhereClause )?
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    fo=(CommonTree)match(input,T_SQL_FOR,FOLLOW_T_SQL_FOR_in_sqlForClause2460); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SQL_FOR.add(fo);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1091:20: ( distinct )?
                    int alt33=2;
                    switch ( input.LA(1) ) {
                        case DISTINCT:
                            {
                            alt33=1;
                            }
                            break;
                    }

                    switch (alt33) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: distinct
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_distinct_in_sqlForClause2462);
                            distinct127=distinct();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_distinct.add(distinct127.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1091:33: (var+= sqlVarOrFunction )+
                    int cnt34=0;
                    loop34:
                    do {
                        int alt34=2;
                        switch ( input.LA(1) ) {
                        case COMMA:
                        case LPAR:
                        case T_VAR:
                            {
                            alt34=1;
                            }
                            break;

                        }

                        switch (alt34) {
                    	case 1 :
                    	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: var+= sqlVarOrFunction
                    	    {
                    	    _last = (CommonTree)input.LT(1);
                    	    _last = (CommonTree)input.LT(1);
                    	    pushFollow(FOLLOW_sqlVarOrFunction_in_sqlForClause2467);
                    	    var=sqlVarOrFunction();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_sqlVarOrFunction.add(var.getTree());
                    	    if (list_var==null) list_var=new ArrayList();
                    	    list_var.add(var.getTree());


                    	    if ( state.backtracking==0 ) {
                    	    }
                    	    }
                    	    break;

                    	default :
                    	    if ( cnt34 >= 1 ) break loop34;
                    	    if (state.backtracking>0) {state.failed=true; return retval;}
                                EarlyExitException eee =
                                    new EarlyExitException(34, input);
                                throw eee;
                        }
                        cnt34++;
                    } while (true);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                       addVariablesToScope(list_var, Types.SQL); 
                                                                              addPositionVariableToScope(auxResultPos); 
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationClause_in_sqlForClause2481);
                    relationClause128=relationClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationClause.add(relationClause128.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1093:23: ( sqlWhereClause )?
                    int alt35=2;
                    switch ( input.LA(1) ) {
                        case WHERE:
                            {
                            alt35=1;
                            }
                            break;
                    }

                    switch (alt35) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: sqlWhereClause
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_sqlWhereClause_in_sqlForClause2483);
                            sqlWhereClause129=sqlWhereClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_sqlWhereClause.add(sqlWhereClause129.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: var, sqlWhereClause, relationClause, var, distinct
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: var
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_var=new RewriteRuleSubtreeStream(adaptor,"token var",list_var);
                    root_0 = (CommonTree)adaptor.nil();
                    // 1094:5: -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "SQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1095:5: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1096:7: ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, SQLevaluationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1098:9: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1099:11: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1101:13: ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1103:15: ( distinct )?
                        if ( stream_distinct.hasNext() ) {
                            adaptor.addChild(root_5, stream_distinct.nextTree());

                        }
                        stream_distinct.reset();
                        if ( !(stream_var.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_var.hasNext() ) {
                            adaptor.addChild(root_5, stream_var.nextTree());

                        }
                        stream_var.reset();
                        adaptor.addChild(root_5, stream_relationClause.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1106:15: ( sqlWhereClause )?
                        if ( stream_sqlWhereClause.hasNext() ) {
                            adaptor.addChild(root_5, stream_sqlWhereClause.nextTree());

                        }
                        stream_sqlWhereClause.reset();

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1113:5: ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResult));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1115:7: ^( AT VAR[auxResultPos] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1118:7: ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1119:9: ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, SQLiterationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1121:11: ^( T_PARAMS VAR[auxResults] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        if ( !(stream_var.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_var.hasNext() ) {
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1127:5: ^( REWRITEVNODE[$fo.token, auxResult] $var)
                            {
                            CommonTree root_1 = (CommonTree)adaptor.nil();
                            root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(REWRITEVNODE, fo.token, auxResult), root_1);

                            adaptor.addChild(root_1, stream_var.nextTree());

                            adaptor.addChild(root_0, root_1);
                            }

                        }
                        stream_var.reset();

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1129:5: ^(fo= T_SQL_FOR ( distinct )? s= STAR ) relationClause ( sqlWhereClause )?
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    fo=(CommonTree)match(input,T_SQL_FOR,FOLLOW_T_SQL_FOR_in_sqlForClause2915); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SQL_FOR.add(fo);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1129:20: ( distinct )?
                    int alt36=2;
                    switch ( input.LA(1) ) {
                        case DISTINCT:
                            {
                            alt36=1;
                            }
                            break;
                    }

                    switch (alt36) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: distinct
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_distinct_in_sqlForClause2917);
                            distinct130=distinct();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_distinct.add(distinct130.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    s=(CommonTree)match(input,STAR,FOLLOW_STAR_in_sqlForClause2922); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_STAR.add(s);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationClause_in_sqlForClause2926);
                    relationClause131=relationClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationClause.add(relationClause131.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1129:54: ( sqlWhereClause )?
                    int alt37=2;
                    switch ( input.LA(1) ) {
                        case WHERE:
                            {
                            alt37=1;
                            }
                            break;
                    }

                    switch (alt37) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: sqlWhereClause
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_sqlWhereClause_in_sqlForClause2928);
                            sqlWhereClause132=sqlWhereClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_sqlWhereClause.add(sqlWhereClause132.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                       if (sqlQuery != null) {
                              ((sqlForClause_scope)sqlForClause_stack.peek()).relations = sqlQuery.getRelationAttributes(((sqlForClause_scope)sqlForClause_stack.peek()).relationsAlias); 
                              addVariablesStringToScope(((sqlForClause_scope)sqlForClause_stack.peek()).relations, Types.SQL); 
                              addPositionVariableToScope(auxResultPos); 
                            } else {
                              logger.severe("Unable to connect to the database!");
                              System.exit(1);
                            }

                          
                    }


                    // AST REWRITE
                    // elements: distinct, relationClause, sqlWhereClause
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1140:3: -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "SQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1141:5: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1142:7: ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, SQLevaluationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1144:9: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1145:11: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1147:13: ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1149:15: ( distinct )?
                        if ( stream_distinct.hasNext() ) {
                            adaptor.addChild(root_5, stream_distinct.nextTree());

                        }
                        stream_distinct.reset();
                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, concat(((sqlForClause_scope)sqlForClause_stack.peek()).relations, ", ")+" "));
                        adaptor.addChild(root_5, stream_relationClause.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1152:15: ( sqlWhereClause )?
                        if ( stream_sqlWhereClause.hasNext() ) {
                            adaptor.addChild(root_5, stream_sqlWhereClause.nextTree());

                        }
                        stream_sqlWhereClause.reset();

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1159:5: ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResult));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1161:7: ^( AT VAR[auxResultPos] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1164:7: ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1165:9: ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, SQLiterationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1167:11: ^( T_PARAMS VAR[auxResults] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        adaptor.addChild(root_0, getVarNodes(((sqlForClause_scope)sqlForClause_stack.peek()).relations, auxResult));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1177:5: ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) ^( T_SQL_FROM ^( T_FUNCTION_CALL qname ^( T_PARAMS sqlVarOrString ) ) )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    fo=(CommonTree)match(input,T_SQL_FOR,FOLLOW_T_SQL_FOR_in_sqlForClause3354); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SQL_FOR.add(fo);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1177:20: ( distinct )?
                    int alt38=2;
                    switch ( input.LA(1) ) {
                        case DISTINCT:
                            {
                            alt38=1;
                            }
                            break;
                    }

                    switch (alt38) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: distinct
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_distinct_in_sqlForClause3356);
                            distinct133=distinct();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_distinct.add(distinct133.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    ROW134=(CommonTree)match(input,ROW,FOLLOW_ROW_in_sqlForClause3359); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ROW.add(ROW134);

                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlForClause3363); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                       addVariableToScope((v!=null?v.getText():null), Types.SQL_ROW); addPositionVariableToScope(auxResultPos); 
                    }
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_SQL_FROM135=(CommonTree)match(input,T_SQL_FROM,FOLLOW_T_SQL_FROM_in_sqlForClause3377); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SQL_FROM.add(T_SQL_FROM135);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_FUNCTION_CALL136=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_sqlForClause3380); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_FUNCTION_CALL.add(T_FUNCTION_CALL136);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_sqlForClause3382);
                    qname137=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(qname137.getTree());
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_3 = _last;
                    CommonTree _first_3 = null;
                    CommonTree root_3 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_PARAMS138=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_sqlForClause3385); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_PARAMS.add(T_PARAMS138);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sqlVarOrString_in_sqlForClause3387);
                    sqlVarOrString139=sqlVarOrString();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_sqlVarOrString.add(sqlVarOrString139.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_2, root_3);_last = _save_last_3;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: VAR, T_PARAMS, sqlVarOrString, T_FUNCTION_CALL, VAR, VAR, v, T_FUNCTION_CALL, T_PARAMS
                    // token labels: v
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_v=new RewriteRuleNodeStream(adaptor,"token v",v);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1179:3: -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "SQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1180:5: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1181:7: ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot(stream_T_FUNCTION_CALL.nextNode(), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, SQLevaluationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1183:9: ^( T_PARAMS sqlVarOrString )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot(stream_T_PARAMS.nextNode(), root_3);

                        adaptor.addChild(root_3, stream_sqlVarOrString.nextTree());

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1188:5: ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                        adaptor.addChild(root_1, stream_v.nextNode());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1190:7: ^( AT VAR[auxResultPos] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1193:7: ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1194:9: ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot(stream_T_FUNCTION_CALL.nextNode(), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, SQLiterationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1196:11: ^( T_PARAMS VAR[auxResults] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot(stream_T_PARAMS.nextNode(), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1204:5: ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) relationClause ( sqlWhereClause )?
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    fo=(CommonTree)match(input,T_SQL_FOR,FOLLOW_T_SQL_FOR_in_sqlForClause3648); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SQL_FOR.add(fo);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1204:20: ( distinct )?
                    int alt39=2;
                    switch ( input.LA(1) ) {
                        case DISTINCT:
                            {
                            alt39=1;
                            }
                            break;
                    }

                    switch (alt39) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: distinct
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_distinct_in_sqlForClause3650);
                            distinct140=distinct();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_distinct.add(distinct140.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    ROW141=(CommonTree)match(input,ROW,FOLLOW_ROW_in_sqlForClause3653); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ROW.add(ROW141);

                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlForClause3657); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                      addVariableToScope((v!=null?v.getText():null), Types.SQL_ROW); addPositionVariableToScope(auxResultPos);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationClause_in_sqlForClause3672);
                    relationClause142=relationClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationClause.add(relationClause142.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1205:26: ( sqlWhereClause )?
                    int alt40=2;
                    switch ( input.LA(1) ) {
                        case WHERE:
                            {
                            alt40=1;
                            }
                            break;
                    }

                    switch (alt40) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: sqlWhereClause
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_sqlWhereClause_in_sqlForClause3674);
                            sqlWhereClause143=sqlWhereClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_sqlWhereClause.add(sqlWhereClause143.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: relationClause, VAR, distinct, v, VAR, VAR, sqlWhereClause
                    // token labels: v
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_v=new RewriteRuleNodeStream(adaptor,"token v",v);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1206:3: -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "SQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1207:5: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1208:7: ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, SQLevaluationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1210:9: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1211:11: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1213:13: ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1215:15: ( distinct )?
                        if ( stream_distinct.hasNext() ) {
                            adaptor.addChild(root_5, stream_distinct.nextTree());

                        }
                        stream_distinct.reset();
                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " * "));
                        adaptor.addChild(root_5, stream_relationClause.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1218:15: ( sqlWhereClause )?
                        if ( stream_sqlWhereClause.hasNext() ) {
                            adaptor.addChild(root_5, stream_sqlWhereClause.nextTree());

                        }
                        stream_sqlWhereClause.reset();

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1225:5: ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                        adaptor.addChild(root_1, stream_v.nextNode());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1227:7: ^( AT VAR[auxResultPos] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1230:7: ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1231:9: ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, SQLiterationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1233:11: ^( T_PARAMS VAR[auxResults] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            sqlForClause_stack.pop();
        }
        return retval;
    }
    // $ANTLR end "sqlForClause"

    public static class sqlVarOrString_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlVarOrString"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1243:1: sqlVarOrString : ^( T_TABLE v= sqlQuerySpec ) -> $v;
    public final XSPARQLRewriter.sqlVarOrString_return sqlVarOrString() throws RecognitionException {
        XSPARQLRewriter.sqlVarOrString_return retval = new XSPARQLRewriter.sqlVarOrString_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_TABLE144=null;
        XSPARQLRewriter.sqlQuerySpec_return v = null;


        CommonTree T_TABLE144_tree=null;
        RewriteRuleNodeStream stream_T_TABLE=new RewriteRuleNodeStream(adaptor,"token T_TABLE");
        RewriteRuleSubtreeStream stream_sqlQuerySpec=new RewriteRuleSubtreeStream(adaptor,"rule sqlQuerySpec");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1244:3: ( ^( T_TABLE v= sqlQuerySpec ) -> $v)
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1244:5: ^( T_TABLE v= sqlQuerySpec )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_TABLE144=(CommonTree)match(input,T_TABLE,FOLLOW_T_TABLE_in_sqlVarOrString4090); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_TABLE.add(T_TABLE144);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sqlQuerySpec_in_sqlVarOrString4094);
            v=sqlQuerySpec();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_sqlQuerySpec.add(v.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: v
            // token labels: 
            // rule labels: v, retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_v=new RewriteRuleSubtreeStream(adaptor,"rule v",v!=null?v.tree:null);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1245:3: -> $v
            {
                adaptor.addChild(root_0, stream_v.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlVarOrString"

    public static class sqlQuerySpec_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlQuerySpec"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1249:1: sqlQuerySpec : (v= qname -> QSTRING[$v.text] | VAR );
    public final XSPARQLRewriter.sqlQuerySpec_return sqlQuerySpec() throws RecognitionException {
        XSPARQLRewriter.sqlQuerySpec_return retval = new XSPARQLRewriter.sqlQuerySpec_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR145=null;
        XSPARQLRewriter.qname_return v = null;


        CommonTree VAR145_tree=null;
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1250:3: (v= qname -> QSTRING[$v.text] | VAR )
            int alt42=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt42=1;
                }
                break;
            case VAR:
                {
                alt42=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 42, 0, input);

                throw nvae;
            }

            switch (alt42) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1250:5: v= qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_sqlQuerySpec4120);
                    v=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(v.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1250:13: -> QSTRING[$v.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (v!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(v.start),
                          input.getTreeAdaptor().getTokenStopIndex(v.start))):null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1251:5: VAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    VAR145=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlQuerySpec4131); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR145_tree = (CommonTree)adaptor.dupNode(VAR145);

                    adaptor.addChild(root_0, VAR145_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlQuerySpec"

    public static class sqlVarOrFunction_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlVarOrFunction"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1258:1: sqlVarOrFunction : ( ^( T_VAR ( COMMA )? q= qname ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR[\"\\$\"+$q.text] ) | ^( T_VAR ( COMMA )? q= qname VAR ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR ) | ( COMMA )? LPAR functionCall AS v3= VAR RPAR );
    public final XSPARQLRewriter.sqlVarOrFunction_return sqlVarOrFunction() throws RecognitionException {
        XSPARQLRewriter.sqlVarOrFunction_return retval = new XSPARQLRewriter.sqlVarOrFunction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree v3=null;
        CommonTree T_VAR146=null;
        CommonTree COMMA147=null;
        CommonTree T_VAR148=null;
        CommonTree COMMA149=null;
        CommonTree VAR150=null;
        CommonTree COMMA151=null;
        CommonTree LPAR152=null;
        CommonTree AS154=null;
        CommonTree RPAR155=null;
        XSPARQLRewriter.qname_return q = null;

        XSPARQLRewriter.functionCall_return functionCall153 = null;


        CommonTree v3_tree=null;
        CommonTree T_VAR146_tree=null;
        CommonTree COMMA147_tree=null;
        CommonTree T_VAR148_tree=null;
        CommonTree COMMA149_tree=null;
        CommonTree VAR150_tree=null;
        CommonTree COMMA151_tree=null;
        CommonTree LPAR152_tree=null;
        CommonTree AS154_tree=null;
        CommonTree RPAR155_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_COMMA=new RewriteRuleNodeStream(adaptor,"token COMMA");
        RewriteRuleNodeStream stream_T_VAR=new RewriteRuleNodeStream(adaptor,"token T_VAR");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1259:3: ( ^( T_VAR ( COMMA )? q= qname ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR[\"\\$\"+$q.text] ) | ^( T_VAR ( COMMA )? q= qname VAR ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR ) | ( COMMA )? LPAR functionCall AS v3= VAR RPAR )
            int alt46=3;
            alt46 = dfa46.predict(input);
            switch (alt46) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1259:5: ^( T_VAR ( COMMA )? q= qname )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VAR146=(CommonTree)match(input,T_VAR,FOLLOW_T_VAR_in_sqlVarOrFunction4153); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_VAR.add(T_VAR146);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1259:13: ( COMMA )?
                    int alt43=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt43=1;
                            }
                            break;
                    }

                    switch (alt43) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: COMMA
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA147=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_sqlVarOrFunction4155); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_COMMA.add(COMMA147);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_sqlVarOrFunction4160);
                    q=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(q.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: COMMA, T_VAR
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1260:5: -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR[\"\\$\"+$q.text] )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1260:8: ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR[\"\\$\"+$q.text] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_T_VAR.nextNode(), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1260:16: ( COMMA )?
                        if ( stream_COMMA.hasNext() ) {
                            adaptor.addChild(root_1, stream_COMMA.nextNode());

                        }
                        stream_COMMA.reset();
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, (q!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(q.start),
                          input.getTreeAdaptor().getTokenStopIndex(q.start))):null)));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, "$"+(q!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(q.start),
                          input.getTreeAdaptor().getTokenStopIndex(q.start))):null)));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1261:5: ^( T_VAR ( COMMA )? q= qname VAR )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VAR148=(CommonTree)match(input,T_VAR,FOLLOW_T_VAR_in_sqlVarOrFunction4188); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_VAR.add(T_VAR148);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1261:13: ( COMMA )?
                    int alt44=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt44=1;
                            }
                            break;
                    }

                    switch (alt44) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: COMMA
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA149=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_sqlVarOrFunction4190); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_COMMA.add(COMMA149);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_sqlVarOrFunction4195);
                    q=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(q.getTree());
                    _last = (CommonTree)input.LT(1);
                    VAR150=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlVarOrFunction4197); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(VAR150);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: VAR, T_VAR, COMMA
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1262:5: -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1262:8: ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_T_VAR.nextNode(), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1262:16: ( COMMA )?
                        if ( stream_COMMA.hasNext() ) {
                            adaptor.addChild(root_1, stream_COMMA.nextNode());

                        }
                        stream_COMMA.reset();
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, (q!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(q.start),
                          input.getTreeAdaptor().getTokenStopIndex(q.start))):null)));
                        adaptor.addChild(root_1, stream_VAR.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1263:5: ( COMMA )? LPAR functionCall AS v3= VAR RPAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1263:5: ( COMMA )?
                    int alt45=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt45=1;
                            }
                            break;
                    }

                    switch (alt45) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: COMMA
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA151=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_sqlVarOrFunction4223); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            COMMA151_tree = (CommonTree)adaptor.dupNode(COMMA151);

                            adaptor.addChild(root_0, COMMA151_tree);
                            }

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    LPAR152=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_sqlVarOrFunction4226); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    LPAR152_tree = (CommonTree)adaptor.dupNode(LPAR152);

                    adaptor.addChild(root_0, LPAR152_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_functionCall_in_sqlVarOrFunction4228);
                    functionCall153=functionCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, functionCall153.getTree());
                    _last = (CommonTree)input.LT(1);
                    AS154=(CommonTree)match(input,AS,FOLLOW_AS_in_sqlVarOrFunction4230); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AS154_tree = (CommonTree)adaptor.dupNode(AS154);

                    adaptor.addChild(root_0, AS154_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    v3=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlVarOrFunction4234); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    v3_tree = (CommonTree)adaptor.dupNode(v3);

                    adaptor.addChild(root_0, v3_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    RPAR155=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_sqlVarOrFunction4236); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    RPAR155_tree = (CommonTree)adaptor.dupNode(RPAR155);

                    adaptor.addChild(root_0, RPAR155_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlVarOrFunction"

    public static class relationClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relationClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1267:1: relationClause : ^( T_SQL_FROM rdbSourceSelector ( COMMA rdbSourceSelector )* ) -> QSTRING[\"from \"] rdbSourceSelector ( QSTRING[\", \"] rdbSourceSelector )* ;
    public final XSPARQLRewriter.relationClause_return relationClause() throws RecognitionException {
        XSPARQLRewriter.relationClause_return retval = new XSPARQLRewriter.relationClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_SQL_FROM156=null;
        CommonTree COMMA158=null;
        XSPARQLRewriter.rdbSourceSelector_return rdbSourceSelector157 = null;

        XSPARQLRewriter.rdbSourceSelector_return rdbSourceSelector159 = null;


        CommonTree T_SQL_FROM156_tree=null;
        CommonTree COMMA158_tree=null;
        RewriteRuleNodeStream stream_COMMA=new RewriteRuleNodeStream(adaptor,"token COMMA");
        RewriteRuleNodeStream stream_T_SQL_FROM=new RewriteRuleNodeStream(adaptor,"token T_SQL_FROM");
        RewriteRuleSubtreeStream stream_rdbSourceSelector=new RewriteRuleSubtreeStream(adaptor,"rule rdbSourceSelector");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1268:3: ( ^( T_SQL_FROM rdbSourceSelector ( COMMA rdbSourceSelector )* ) -> QSTRING[\"from \"] rdbSourceSelector ( QSTRING[\", \"] rdbSourceSelector )* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1268:5: ^( T_SQL_FROM rdbSourceSelector ( COMMA rdbSourceSelector )* )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_SQL_FROM156=(CommonTree)match(input,T_SQL_FROM,FOLLOW_T_SQL_FROM_in_relationClause4249); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_SQL_FROM.add(T_SQL_FROM156);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_rdbSourceSelector_in_relationClause4251);
            rdbSourceSelector157=rdbSourceSelector();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_rdbSourceSelector.add(rdbSourceSelector157.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1268:36: ( COMMA rdbSourceSelector )*
            loop47:
            do {
                int alt47=2;
                switch ( input.LA(1) ) {
                case COMMA:
                    {
                    alt47=1;
                    }
                    break;

                }

                switch (alt47) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1268:37: COMMA rdbSourceSelector
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    COMMA158=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_relationClause4254); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_COMMA.add(COMMA158);

            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_rdbSourceSelector_in_relationClause4256);
            	    rdbSourceSelector159=rdbSourceSelector();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_rdbSourceSelector.add(rdbSourceSelector159.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop47;
                }
            } while (true);


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: rdbSourceSelector, rdbSourceSelector
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1269:5: -> QSTRING[\"from \"] rdbSourceSelector ( QSTRING[\", \"] rdbSourceSelector )*
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "from "));
                adaptor.addChild(root_0, stream_rdbSourceSelector.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1269:43: ( QSTRING[\", \"] rdbSourceSelector )*
                while ( stream_rdbSourceSelector.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, ", "));
                    adaptor.addChild(root_0, stream_rdbSourceSelector.nextTree());

                }
                stream_rdbSourceSelector.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "relationClause"

    public static class rdbSourceSelector_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "rdbSourceSelector"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1272:1: rdbSourceSelector : ^( T_TABLE v= relationSchemaName (alias= relationAlias )? ) -> $v ( QSTRING[\" \"] $alias)? ;
    public final XSPARQLRewriter.rdbSourceSelector_return rdbSourceSelector() throws RecognitionException {
        XSPARQLRewriter.rdbSourceSelector_return retval = new XSPARQLRewriter.rdbSourceSelector_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_TABLE160=null;
        XSPARQLRewriter.relationSchemaName_return v = null;

        XSPARQLRewriter.relationAlias_return alias = null;


        CommonTree T_TABLE160_tree=null;
        RewriteRuleNodeStream stream_T_TABLE=new RewriteRuleNodeStream(adaptor,"token T_TABLE");
        RewriteRuleSubtreeStream stream_relationSchemaName=new RewriteRuleSubtreeStream(adaptor,"rule relationSchemaName");
        RewriteRuleSubtreeStream stream_relationAlias=new RewriteRuleSubtreeStream(adaptor,"rule relationAlias");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1273:3: ( ^( T_TABLE v= relationSchemaName (alias= relationAlias )? ) -> $v ( QSTRING[\" \"] $alias)? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1273:5: ^( T_TABLE v= relationSchemaName (alias= relationAlias )? )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_TABLE160=(CommonTree)match(input,T_TABLE,FOLLOW_T_TABLE_in_rdbSourceSelector4293); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_TABLE.add(T_TABLE160);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_relationSchemaName_in_rdbSourceSelector4297);
            v=relationSchemaName();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_relationSchemaName.add(v.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1273:41: (alias= relationAlias )?
            int alt48=2;
            switch ( input.LA(1) ) {
                case VAR:
                case NCNAME:
                case PNAME_NS:
                case PNAME_LN:
                case A:
                case FROM:
                case TO:
                case ITEM:
                case NODE:
                case COMMENT:
                case ROW:
                    {
                    alt48=1;
                    }
                    break;
            }

            switch (alt48) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: alias= relationAlias
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationAlias_in_rdbSourceSelector4301);
                    alias=relationAlias();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationAlias.add(alias.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
               ((sqlForClause_scope)sqlForClause_stack.peek()).relationsAlias.add(new Pair<String,String>((v!=null?(input.getTokenStream().toString(
                input.getTreeAdaptor().getTokenStartIndex(v.start),
                input.getTreeAdaptor().getTokenStopIndex(v.start))):null), (alias!=null?(input.getTokenStream().toString(
                input.getTreeAdaptor().getTokenStartIndex(alias.start),
                input.getTreeAdaptor().getTokenStopIndex(alias.start))):null))); 
            }


            // AST REWRITE
            // elements: v, alias
            // token labels: 
            // rule labels: v, retval, alias
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_v=new RewriteRuleSubtreeStream(adaptor,"rule v",v!=null?v.tree:null);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_alias=new RewriteRuleSubtreeStream(adaptor,"rule alias",alias!=null?alias.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1275:3: -> $v ( QSTRING[\" \"] $alias)?
            {
                adaptor.addChild(root_0, stream_v.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1275:9: ( QSTRING[\" \"] $alias)?
                if ( stream_alias.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                    adaptor.addChild(root_0, stream_alias.nextTree());

                }
                stream_alias.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "rdbSourceSelector"

    public static class relationSchemaName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relationSchemaName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1279:1: relationSchemaName : (p1= qname DOT q1= qname -> QSTRING[\"\\\"\\\"\"+$p1.text+\"\\\"\\\".\\\"\\\"\"+$q1.text+\"\\\"\\\"\"] | relationAlias | p2= relationAlias DOT q2= relationAlias -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS $p2 QSTRING[\".\"] $q2) ) );
    public final XSPARQLRewriter.relationSchemaName_return relationSchemaName() throws RecognitionException {
        XSPARQLRewriter.relationSchemaName_return retval = new XSPARQLRewriter.relationSchemaName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DOT161=null;
        CommonTree DOT163=null;
        XSPARQLRewriter.qname_return p1 = null;

        XSPARQLRewriter.qname_return q1 = null;

        XSPARQLRewriter.relationAlias_return p2 = null;

        XSPARQLRewriter.relationAlias_return q2 = null;

        XSPARQLRewriter.relationAlias_return relationAlias162 = null;


        CommonTree DOT161_tree=null;
        CommonTree DOT163_tree=null;
        RewriteRuleNodeStream stream_DOT=new RewriteRuleNodeStream(adaptor,"token DOT");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        RewriteRuleSubtreeStream stream_relationAlias=new RewriteRuleSubtreeStream(adaptor,"rule relationAlias");
         logger.info("relationSchemaName"); 
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1281:3: (p1= qname DOT q1= qname -> QSTRING[\"\\\"\\\"\"+$p1.text+\"\\\"\\\".\\\"\\\"\"+$q1.text+\"\\\"\\\"\"] | relationAlias | p2= relationAlias DOT q2= relationAlias -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS $p2 QSTRING[\".\"] $q2) ) )
            int alt49=3;
            alt49 = dfa49.predict(input);
            switch (alt49) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1281:5: p1= qname DOT q1= qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_relationSchemaName4349);
                    p1=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(p1.getTree());
                    _last = (CommonTree)input.LT(1);
                    DOT161=(CommonTree)match(input,DOT,FOLLOW_DOT_in_relationSchemaName4351); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DOT.add(DOT161);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_relationSchemaName4355);
                    q1=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(q1.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1281:27: -> QSTRING[\"\\\"\\\"\"+$p1.text+\"\\\"\\\".\\\"\\\"\"+$q1.text+\"\\\"\\\"\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "\"\""+(p1!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(p1.start),
                          input.getTreeAdaptor().getTokenStopIndex(p1.start))):null)+"\"\".\"\""+(q1!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(q1.start),
                          input.getTreeAdaptor().getTokenStopIndex(q1.start))):null)+"\"\""));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1282:5: relationAlias
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationAlias_in_relationSchemaName4366);
                    relationAlias162=relationAlias();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, relationAlias162.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1283:5: p2= relationAlias DOT q2= relationAlias
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationAlias_in_relationSchemaName4377);
                    p2=relationAlias();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationAlias.add(p2.getTree());
                    _last = (CommonTree)input.LT(1);
                    DOT163=(CommonTree)match(input,DOT,FOLLOW_DOT_in_relationSchemaName4379); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DOT.add(DOT163);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationAlias_in_relationSchemaName4383);
                    q2=relationAlias();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationAlias.add(q2.getTree());


                    // AST REWRITE
                    // elements: q2, p2
                    // token labels: 
                    // rule labels: retval, q2, p2
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_q2=new RewriteRuleSubtreeStream(adaptor,"rule q2",q2!=null?q2.tree:null);
                    RewriteRuleSubtreeStream stream_p2=new RewriteRuleSubtreeStream(adaptor,"rule p2",p2!=null?p2.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1283:43: -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS $p2 QSTRING[\".\"] $q2) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1284:5: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS $p2 QSTRING[\".\"] $q2) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1284:43: ^( T_PARAMS $p2 QSTRING[\".\"] $q2)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, stream_p2.nextTree());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, "."));
                        adaptor.addChild(root_2, stream_q2.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "relationSchemaName"

    public static class relationAlias_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relationAlias"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1288:1: relationAlias : (v= qname -> QSTRING[$v.text] | var= VAR );
    public final XSPARQLRewriter.relationAlias_return relationAlias() throws RecognitionException {
        XSPARQLRewriter.relationAlias_return retval = new XSPARQLRewriter.relationAlias_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        XSPARQLRewriter.qname_return v = null;


        CommonTree var_tree=null;
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1291:3: (v= qname -> QSTRING[$v.text] | var= VAR )
            int alt50=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt50=1;
                }
                break;
            case VAR:
                {
                alt50=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 50, 0, input);

                throw nvae;
            }

            switch (alt50) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1291:5: v= qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_relationAlias4429);
                    v=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(v.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1291:13: -> QSTRING[$v.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (v!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(v.start),
                          input.getTreeAdaptor().getTokenStopIndex(v.start))):null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1292:5: var= VAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_relationAlias4442); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    var_tree = (CommonTree)adaptor.dupNode(var);

                    adaptor.addChild(root_0, var_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "relationAlias"

    public static class sqlWhereClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlWhereClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1295:1: sqlWhereClause : ^( WHERE sqlWhereSpecList ) -> QSTRING[\" where \"] sqlWhereSpecList ;
    public final XSPARQLRewriter.sqlWhereClause_return sqlWhereClause() throws RecognitionException {
        XSPARQLRewriter.sqlWhereClause_return retval = new XSPARQLRewriter.sqlWhereClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree WHERE164=null;
        XSPARQLRewriter.sqlWhereSpecList_return sqlWhereSpecList165 = null;


        CommonTree WHERE164_tree=null;
        RewriteRuleNodeStream stream_WHERE=new RewriteRuleNodeStream(adaptor,"token WHERE");
        RewriteRuleSubtreeStream stream_sqlWhereSpecList=new RewriteRuleSubtreeStream(adaptor,"rule sqlWhereSpecList");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1296:3: ( ^( WHERE sqlWhereSpecList ) -> QSTRING[\" where \"] sqlWhereSpecList )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1296:5: ^( WHERE sqlWhereSpecList )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            WHERE164=(CommonTree)match(input,WHERE,FOLLOW_WHERE_in_sqlWhereClause4458); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_WHERE.add(WHERE164);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sqlWhereSpecList_in_sqlWhereClause4460);
            sqlWhereSpecList165=sqlWhereSpecList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_sqlWhereSpecList.add(sqlWhereSpecList165.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: sqlWhereSpecList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1297:3: -> QSTRING[\" where \"] sqlWhereSpecList
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " where "));
                adaptor.addChild(root_0, stream_sqlWhereSpecList.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlWhereClause"

    public static class sqlWhereSpecList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlWhereSpecList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1300:1: sqlWhereSpecList : sqlAttrSpecList (b= sqlBooleanOp sqlWhereSpecList )* -> sqlAttrSpecList ( QSTRING[\" \"] QSTRING[$b.text] QSTRING[\" \"] sqlWhereSpecList )* ;
    public final XSPARQLRewriter.sqlWhereSpecList_return sqlWhereSpecList() throws RecognitionException {
        XSPARQLRewriter.sqlWhereSpecList_return retval = new XSPARQLRewriter.sqlWhereSpecList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.sqlBooleanOp_return b = null;

        XSPARQLRewriter.sqlAttrSpecList_return sqlAttrSpecList166 = null;

        XSPARQLRewriter.sqlWhereSpecList_return sqlWhereSpecList167 = null;


        RewriteRuleSubtreeStream stream_sqlWhereSpecList=new RewriteRuleSubtreeStream(adaptor,"rule sqlWhereSpecList");
        RewriteRuleSubtreeStream stream_sqlAttrSpecList=new RewriteRuleSubtreeStream(adaptor,"rule sqlAttrSpecList");
        RewriteRuleSubtreeStream stream_sqlBooleanOp=new RewriteRuleSubtreeStream(adaptor,"rule sqlBooleanOp");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1301:2: ( sqlAttrSpecList (b= sqlBooleanOp sqlWhereSpecList )* -> sqlAttrSpecList ( QSTRING[\" \"] QSTRING[$b.text] QSTRING[\" \"] sqlWhereSpecList )* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1301:4: sqlAttrSpecList (b= sqlBooleanOp sqlWhereSpecList )*
            {
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sqlAttrSpecList_in_sqlWhereSpecList4485);
            sqlAttrSpecList166=sqlAttrSpecList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_sqlAttrSpecList.add(sqlAttrSpecList166.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1301:20: (b= sqlBooleanOp sqlWhereSpecList )*
            loop51:
            do {
                int alt51=2;
                switch ( input.LA(1) ) {
                case AND:
                case OR:
                    {
                    int LA51_2 = input.LA(2);

                    if ( (synpred77_XSPARQLRewriter()) ) {
                        alt51=1;
                    }


                    }
                    break;

                }

                switch (alt51) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1301:21: b= sqlBooleanOp sqlWhereSpecList
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_sqlBooleanOp_in_sqlWhereSpecList4490);
            	    b=sqlBooleanOp();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_sqlBooleanOp.add(b.getTree());
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_sqlWhereSpecList_in_sqlWhereSpecList4492);
            	    sqlWhereSpecList167=sqlWhereSpecList();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_sqlWhereSpecList.add(sqlWhereSpecList167.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop51;
                }
            } while (true);



            // AST REWRITE
            // elements: sqlAttrSpecList, sqlWhereSpecList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1302:2: -> sqlAttrSpecList ( QSTRING[\" \"] QSTRING[$b.text] QSTRING[\" \"] sqlWhereSpecList )*
            {
                adaptor.addChild(root_0, stream_sqlAttrSpecList.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1302:21: ( QSTRING[\" \"] QSTRING[$b.text] QSTRING[\" \"] sqlWhereSpecList )*
                while ( stream_sqlWhereSpecList.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (b!=null?(input.getTokenStream().toString(
                      input.getTreeAdaptor().getTokenStartIndex(b.start),
                      input.getTreeAdaptor().getTokenStopIndex(b.start))):null)));
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                    adaptor.addChild(root_0, stream_sqlWhereSpecList.nextTree());

                }
                stream_sqlWhereSpecList.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlWhereSpecList"

    public static class sqlAttrSpecList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlAttrSpecList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1306:1: sqlAttrSpecList : ( sqlAttrSpec g= generalComp sqlAttrSpec -> sqlAttrSpec QSTRING[\" \"] QSTRING[$g.text] QSTRING[\" \"] sqlAttrSpec | l= LPAR sqlWhereSpecList r= RPAR -> QSTRING[$l.text] sqlWhereSpecList QSTRING[$r.text] );
    public final XSPARQLRewriter.sqlAttrSpecList_return sqlAttrSpecList() throws RecognitionException {
        XSPARQLRewriter.sqlAttrSpecList_return retval = new XSPARQLRewriter.sqlAttrSpecList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree l=null;
        CommonTree r=null;
        XSPARQLRewriter.generalComp_return g = null;

        XSPARQLRewriter.sqlAttrSpec_return sqlAttrSpec168 = null;

        XSPARQLRewriter.sqlAttrSpec_return sqlAttrSpec169 = null;

        XSPARQLRewriter.sqlWhereSpecList_return sqlWhereSpecList170 = null;


        CommonTree l_tree=null;
        CommonTree r_tree=null;
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleSubtreeStream stream_generalComp=new RewriteRuleSubtreeStream(adaptor,"rule generalComp");
        RewriteRuleSubtreeStream stream_sqlWhereSpecList=new RewriteRuleSubtreeStream(adaptor,"rule sqlWhereSpecList");
        RewriteRuleSubtreeStream stream_sqlAttrSpec=new RewriteRuleSubtreeStream(adaptor,"rule sqlAttrSpec");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1307:3: ( sqlAttrSpec g= generalComp sqlAttrSpec -> sqlAttrSpec QSTRING[\" \"] QSTRING[$g.text] QSTRING[\" \"] sqlAttrSpec | l= LPAR sqlWhereSpecList r= RPAR -> QSTRING[$l.text] sqlWhereSpecList QSTRING[$r.text] )
            int alt52=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case LCURLY:
            case NCNAME:
            case QSTRING:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case FROM:
            case IF:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case ITEM:
            case NODE:
            case COMMENT:
            case GREATERTHANGREATERTHAN:
            case ROW:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
            case DECIMAL:
                {
                alt52=1;
                }
                break;
            case LPAR:
                {
                alt52=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 52, 0, input);

                throw nvae;
            }

            switch (alt52) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1307:5: sqlAttrSpec g= generalComp sqlAttrSpec
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sqlAttrSpec_in_sqlAttrSpecList4530);
                    sqlAttrSpec168=sqlAttrSpec();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_sqlAttrSpec.add(sqlAttrSpec168.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_generalComp_in_sqlAttrSpecList4534);
                    g=generalComp();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_generalComp.add(g.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sqlAttrSpec_in_sqlAttrSpecList4536);
                    sqlAttrSpec169=sqlAttrSpec();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_sqlAttrSpec.add(sqlAttrSpec169.getTree());


                    // AST REWRITE
                    // elements: sqlAttrSpec, sqlAttrSpec
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1308:2: -> sqlAttrSpec QSTRING[\" \"] QSTRING[$g.text] QSTRING[\" \"] sqlAttrSpec
                    {
                        adaptor.addChild(root_0, stream_sqlAttrSpec.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (g!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(g.start),
                          input.getTreeAdaptor().getTokenStopIndex(g.start))):null)));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_0, stream_sqlAttrSpec.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1309:5: l= LPAR sqlWhereSpecList r= RPAR
                    {
                    _last = (CommonTree)input.LT(1);
                    l=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_sqlAttrSpecList4561); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LPAR.add(l);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sqlWhereSpecList_in_sqlAttrSpecList4563);
                    sqlWhereSpecList170=sqlWhereSpecList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_sqlWhereSpecList.add(sqlWhereSpecList170.getTree());
                    _last = (CommonTree)input.LT(1);
                    r=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_sqlAttrSpecList4567); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RPAR.add(r);



                    // AST REWRITE
                    // elements: sqlWhereSpecList
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1310:3: -> QSTRING[$l.text] sqlWhereSpecList QSTRING[$r.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (l!=null?l.getText():null)));
                        adaptor.addChild(root_0, stream_sqlWhereSpecList.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (r!=null?r.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlAttrSpecList"

    public static class sqlBooleanOp_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlBooleanOp"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1313:1: sqlBooleanOp : ( AND | OR );
    public final XSPARQLRewriter.sqlBooleanOp_return sqlBooleanOp() throws RecognitionException {
        XSPARQLRewriter.sqlBooleanOp_return retval = new XSPARQLRewriter.sqlBooleanOp_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set171=null;

        CommonTree set171_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1314:3: ( AND | OR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set171=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=AND && input.LA(1)<=OR) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set171_tree = (CommonTree)adaptor.dupNode(set171);

                adaptor.addChild(root_0, set171_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlBooleanOp"

    public static class sqlAttrSpec_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlAttrSpec"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1317:1: sqlAttrSpec : (v= qname -> QSTRING[format($v.text)] | VAR -> ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sql_binding_term\"] ^( T_PARAMS VAR ) ) | nl= numericliteral -> QSTRING[$nl.text] | sl= stringliteral -> QSTRING[\"'\"+$sl.text+\"'\"] | enclosedExpr );
    public final XSPARQLRewriter.sqlAttrSpec_return sqlAttrSpec() throws RecognitionException {
        XSPARQLRewriter.sqlAttrSpec_return retval = new XSPARQLRewriter.sqlAttrSpec_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR172=null;
        XSPARQLRewriter.qname_return v = null;

        XSPARQLRewriter.numericliteral_return nl = null;

        XSPARQLRewriter.stringliteral_return sl = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr173 = null;


        CommonTree VAR172_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        RewriteRuleSubtreeStream stream_stringliteral=new RewriteRuleSubtreeStream(adaptor,"rule stringliteral");
        RewriteRuleSubtreeStream stream_numericliteral=new RewriteRuleSubtreeStream(adaptor,"rule numericliteral");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1318:3: (v= qname -> QSTRING[format($v.text)] | VAR -> ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sql_binding_term\"] ^( T_PARAMS VAR ) ) | nl= numericliteral -> QSTRING[$nl.text] | sl= stringliteral -> QSTRING[\"'\"+$sl.text+\"'\"] | enclosedExpr )
            int alt53=5;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt53=1;
                }
                break;
            case TO:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt53=5;
                    }
                    break;
                case EOF:
                case UP:
                case RPAR:
                case LESSTHAN:
                case GREATERTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case AND:
                case OR:
                    {
                    alt53=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 53, 2, input);

                    throw nvae;
                }

                }
                break;
            case VAR:
                {
                alt53=2;
                }
                break;
            case INTEGER:
            case DECIMAL:
                {
                alt53=3;
                }
                break;
            case QSTRING:
                {
                alt53=4;
                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt53=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 53, 0, input);

                throw nvae;
            }

            switch (alt53) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1318:5: v= qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_sqlAttrSpec4612);
                    v=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(v.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1318:13: -> QSTRING[format($v.text)]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, format((v!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(v.start),
                          input.getTreeAdaptor().getTokenStopIndex(v.start))):null))));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1319:5: VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    VAR172=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlAttrSpec4623); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(VAR172);



                    // AST REWRITE
                    // elements: VAR
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1319:9: -> ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sql_binding_term\"] ^( T_PARAMS VAR ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1319:12: ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sql_binding_term\"] ^( T_PARAMS VAR ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, "_xsparql:_sql_binding_term"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1321:15: ^( T_PARAMS VAR )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, stream_VAR.nextNode());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1323:5: nl= numericliteral
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_numericliteral_in_sqlAttrSpec4688);
                    nl=numericliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_numericliteral.add(nl.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1323:23: -> QSTRING[$nl.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (nl!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(nl.start),
                          input.getTreeAdaptor().getTokenStopIndex(nl.start))):null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1324:5: sl= stringliteral
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_stringliteral_in_sqlAttrSpec4701);
                    sl=stringliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_stringliteral.add(sl.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1324:22: -> QSTRING[\"'\"+$sl.text+\"'\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "'"+(sl!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(sl.start),
                          input.getTreeAdaptor().getTokenStopIndex(sl.start))):null)+"'"));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1325:5: enclosedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_sqlAttrSpec4712);
                    enclosedExpr173=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, enclosedExpr173.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlAttrSpec"

    public static class generalComp_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "generalComp"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1328:1: generalComp : ( EQUALS | LESSTHAN | GREATERTHAN | LESSTHANEQUALS | GREATERTHANEQUALS | HAFENEQUALS );
    public final XSPARQLRewriter.generalComp_return generalComp() throws RecognitionException {
        XSPARQLRewriter.generalComp_return retval = new XSPARQLRewriter.generalComp_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set174=null;

        CommonTree set174_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1329:3: ( EQUALS | LESSTHAN | GREATERTHAN | LESSTHANEQUALS | GREATERTHANEQUALS | HAFENEQUALS )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set174=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=LESSTHAN && input.LA(1)<=GREATERTHAN)||(input.LA(1)>=GREATERTHANEQUALS && input.LA(1)<=EQUALS) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set174_tree = (CommonTree)adaptor.dupNode(set174);

                adaptor.addChild(root_0, set174_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "generalComp"

    protected static class sparqlForClause_scope {
        String joinVars;
        boolean containsVars;
        String evaluationFunction;
        String iterationFunction;
        String endpointURI;
    }
    protected Stack sparqlForClause_stack = new Stack();

    public static class sparqlForClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sparqlForClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1340:1: sparqlForClause : ^(fo= T_SPARQL_FOR ( distinct )? (var+= varOrFunction )+ ) ( datasetClause )* (e= endpointClause )? sWhereClause ( solutionmodifier )? -> { $VariableScope::scopedDataset }? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[sparqlFunctionScopedInner] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ -> {this.debugVersion}? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ -> COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ ;
    public final XSPARQLRewriter.sparqlForClause_return sparqlForClause() throws RecognitionException {
        sparqlForClause_stack.push(new sparqlForClause_scope());
        XSPARQLRewriter.sparqlForClause_return retval = new XSPARQLRewriter.sparqlForClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree fo=null;
        List list_var=null;
        XSPARQLRewriter.endpointClause_return e = null;

        XSPARQLRewriter.distinct_return distinct175 = null;

        XSPARQLRewriter.datasetClause_return datasetClause176 = null;

        XSPARQLRewriter.sWhereClause_return sWhereClause177 = null;

        XSPARQLRewriter.solutionmodifier_return solutionmodifier178 = null;

        RuleReturnScope var = null;
        CommonTree fo_tree=null;
        RewriteRuleNodeStream stream_T_SPARQL_FOR=new RewriteRuleNodeStream(adaptor,"token T_SPARQL_FOR");
        RewriteRuleSubtreeStream stream_endpointClause=new RewriteRuleSubtreeStream(adaptor,"rule endpointClause");
        RewriteRuleSubtreeStream stream_datasetClause=new RewriteRuleSubtreeStream(adaptor,"rule datasetClause");
        RewriteRuleSubtreeStream stream_varOrFunction=new RewriteRuleSubtreeStream(adaptor,"rule varOrFunction");
        RewriteRuleSubtreeStream stream_sWhereClause=new RewriteRuleSubtreeStream(adaptor,"rule sWhereClause");
        RewriteRuleSubtreeStream stream_solutionmodifier=new RewriteRuleSubtreeStream(adaptor,"rule solutionmodifier");
        RewriteRuleSubtreeStream stream_distinct=new RewriteRuleSubtreeStream(adaptor,"rule distinct");

          String auxResults = getNewAuxResultsVariable();
          String auxResult = getNewAuxResultVariable();
          String auxResultPos = auxResult + "_pos";
          
          CommonTree sparqlFunctionTree = (CommonTree) adaptor.nil();
          CommonTree sparqlResultsFunctionTree = (CommonTree) adaptor.nil();
          CommonTree sparqlResultsIdTree = (CommonTree) adaptor.nil();
          
          ((VariableScope_scope)VariableScope_stack.peek()).sparqlClause = true; 
          ((sparqlForClause_scope)sparqlForClause_stack.peek()).joinVars = "";
          ((sparqlForClause_scope)sparqlForClause_stack.peek()).containsVars = false;

          ((sparqlForClause_scope)sparqlForClause_stack.peek()).iterationFunction = iterationFunction;
          ((sparqlForClause_scope)sparqlForClause_stack.peek()).evaluationFunction = evaluationFunction;
          logger.info("sparqlForClause");



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1383:3: ( ^(fo= T_SPARQL_FOR ( distinct )? (var+= varOrFunction )+ ) ( datasetClause )* (e= endpointClause )? sWhereClause ( solutionmodifier )? -> { $VariableScope::scopedDataset }? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[sparqlFunctionScopedInner] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ -> {this.debugVersion}? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ -> COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1383:5: ^(fo= T_SPARQL_FOR ( distinct )? (var+= varOrFunction )+ ) ( datasetClause )* (e= endpointClause )? sWhereClause ( solutionmodifier )?
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            fo=(CommonTree)match(input,T_SPARQL_FOR,FOLLOW_T_SPARQL_FOR_in_sparqlForClause4788); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_SPARQL_FOR.add(fo);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1383:23: ( distinct )?
            int alt54=2;
            switch ( input.LA(1) ) {
                case DISTINCT:
                    {
                    alt54=1;
                    }
                    break;
            }

            switch (alt54) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: distinct
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_distinct_in_sparqlForClause4790);
                    distinct175=distinct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_distinct.add(distinct175.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1383:36: (var+= varOrFunction )+
            int cnt55=0;
            loop55:
            do {
                int alt55=2;
                switch ( input.LA(1) ) {
                case VAR:
                case LPAR:
                    {
                    alt55=1;
                    }
                    break;

                }

                switch (alt55) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: var+= varOrFunction
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_varOrFunction_in_sparqlForClause4795);
            	    var=varOrFunction();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_varOrFunction.add(var.getTree());
            	    if (list_var==null) list_var=new ArrayList();
            	    list_var.add(var.getTree());


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt55 >= 1 ) break loop55;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(55, input);
                        throw eee;
                }
                cnt55++;
            } while (true);

            if ( state.backtracking==0 ) {
               addVariablesToScope(list_var, Types.SPARQL); 
              //                                                      addGeneratedVariablesToScope(list_var); 
                                                                    addPositionVariableToScope(auxResultPos); 
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1386:8: ( datasetClause )*
            loop56:
            do {
                int alt56=2;
                switch ( input.LA(1) ) {
                case FROM:
                    {
                    alt56=1;
                    }
                    break;

                }

                switch (alt56) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: datasetClause
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_datasetClause_in_sparqlForClause4807);
            	    datasetClause176=datasetClause();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_datasetClause.add(datasetClause176.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop56;
                }
            } while (true);

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1386:24: (e= endpointClause )?
            int alt57=2;
            switch ( input.LA(1) ) {
                case ENDPOINT:
                    {
                    alt57=1;
                    }
                    break;
            }

            switch (alt57) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: e= endpointClause
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_endpointClause_in_sparqlForClause4812);
                    e=endpointClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_endpointClause.add(e.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sWhereClause_in_sparqlForClause4815);
            sWhereClause177=sWhereClause();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_sWhereClause.add(sWhereClause177.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1386:54: ( solutionmodifier )?
            int alt58=2;
            switch ( input.LA(1) ) {
                case LIMIT:
                case OFFSET:
                case ORDER:
                case T_GROUP_BY:
                case T_HAVING:
                    {
                    alt58=1;
                    }
                    break;
                case T_RETURN:
                    {
                    int LA58_2 = input.LA(2);

                    if ( (synpred93_XSPARQLRewriter()) ) {
                        alt58=1;
                    }
                    }
                    break;
                case T_CONSTRUCT:
                    {
                    int LA58_3 = input.LA(2);

                    if ( (synpred93_XSPARQLRewriter()) ) {
                        alt58=1;
                    }
                    }
                    break;
                case UP:
                    {
                    int LA58_4 = input.LA(2);

                    if ( (synpred93_XSPARQLRewriter()) ) {
                        alt58=1;
                    }
                    }
                    break;
                case EOF:
                    {
                    int LA58_5 = input.LA(2);

                    if ( (synpred93_XSPARQLRewriter()) ) {
                        alt58=1;
                    }
                    }
                    break;
            }

            switch (alt58) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: solutionmodifier
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_solutionmodifier_in_sparqlForClause4817);
                    solutionmodifier178=solutionmodifier();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_solutionmodifier.add(solutionmodifier178.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }



            // AST REWRITE
            // elements: solutionmodifier, solutionmodifier, distinct, var, sWhereClause, solutionmodifier, sWhereClause, distinct, distinct, var, var, sWhereClause, datasetClause, datasetClause, datasetClause
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: var
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_var=new RewriteRuleSubtreeStream(adaptor,"token var",list_var);
            root_0 = (CommonTree)adaptor.nil();
            // 1389:3: -> { $VariableScope::scopedDataset }? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[sparqlFunctionScopedInner] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+
            if ( ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset ) {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "XSPARQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1391:6: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[sparqlFunctionScopedInner] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1392:13: ^( T_FUNCTION_CALL NCNAME[sparqlFunctionScopedInner] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, sparqlFunctionScopedInner));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1394:15: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1395:16: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1397:15: ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? )
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, "$_sparql_prefixes"));
                adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1401:18: ( distinct )?
                if ( stream_distinct.hasNext() ) {
                    adaptor.addChild(root_5, stream_distinct.nextTree());

                }
                stream_distinct.reset();
                adaptor.addChild(root_5, getVarList(list_var));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1403:18: ( datasetClause )*
                while ( stream_datasetClause.hasNext() ) {
                    adaptor.addChild(root_5, stream_datasetClause.nextTree());

                }
                stream_datasetClause.reset();
                adaptor.addChild(root_5, stream_sWhereClause.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1405:18: ( solutionmodifier )?
                if ( stream_solutionmodifier.hasNext() ) {
                    adaptor.addChild(root_5, stream_solutionmodifier.nextTree());

                }
                stream_solutionmodifier.reset();

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }
                adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, scopedDataset.peek().getId()));
                adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ((sparqlForClause_scope)sparqlForClause_stack.peek()).joinVars.replaceAll(",$", "")));
                adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, scopedDataset.peek().getVar()));

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1414:5: ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResult));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1416:7: ^( AT VAR[auxResultPos] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                adaptor.addChild(root_1, root_2);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1419:7: ^( IN ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1420:9: ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, sparqlResultsFunctionNode));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1422:11: ^( T_PARAMS VAR[auxResults] )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                if ( !(stream_var.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_var.hasNext() ) {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1428:5: ^( REWRITEVNODE[$fo.token, auxResult] $var)
                    {
                    CommonTree root_1 = (CommonTree)adaptor.nil();
                    root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(REWRITEVNODE, fo.token, auxResult), root_1);

                    adaptor.addChild(root_1, stream_var.nextTree());

                    adaptor.addChild(root_0, root_1);
                    }

                }
                stream_var.reset();

            }
            else // 1431:3: -> {this.debugVersion}? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+
            if (this.debugVersion) {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "XSPARQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1433:6: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1434:8: ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2,  sparqlFunctionTree = new CommonTree(new CommonToken(NCNAME, ((sparqlForClause_scope)sparqlForClause_stack.peek()).evaluationFunction)) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1436:10: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                adaptor.addChild(root_3,  endpointURI(((sparqlForClause_scope)sparqlForClause_stack.peek()).endpointURI) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1437:12: ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:trace"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1439:14: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] )
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1440:16: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) )
                {
                CommonTree root_6 = (CommonTree)adaptor.nil();
                root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_6);

                adaptor.addChild(root_6, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1442:18: ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? )
                {
                CommonTree root_7 = (CommonTree)adaptor.nil();
                root_7 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_7);

                adaptor.addChild(root_7, (CommonTree)adaptor.create(VAR, "$_sparql_prefixes"));
                adaptor.addChild(root_7, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1446:20: ( distinct )?
                if ( stream_distinct.hasNext() ) {
                    adaptor.addChild(root_7, stream_distinct.nextTree());

                }
                stream_distinct.reset();
                adaptor.addChild(root_7, getVarList(list_var));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1447:20: ( datasetClause )*
                while ( stream_datasetClause.hasNext() ) {
                    adaptor.addChild(root_7, stream_datasetClause.nextTree());

                }
                stream_datasetClause.reset();
                adaptor.addChild(root_7, stream_sWhereClause.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1449:20: ( solutionmodifier )?
                if ( stream_solutionmodifier.hasNext() ) {
                    adaptor.addChild(root_7, stream_solutionmodifier.nextTree());

                }
                stream_solutionmodifier.reset();

                adaptor.addChild(root_6, root_7);
                }

                adaptor.addChild(root_5, root_6);
                }
                adaptor.addChild(root_5,  sparqlResultsIdTree = new CommonTree(new CommonToken(DELETEVNODE, "deleteNode")) );
                adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, "XSPARQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1459:6: ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResult));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1461:8: ^( AT VAR[auxResultPos] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                adaptor.addChild(root_1, root_2);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1464:8: ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1465:10: ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                adaptor.addChild(root_3,  sparqlResultsFunctionTree = new CommonTree(new CommonToken(NCNAME, ((sparqlForClause_scope)sparqlForClause_stack.peek()).iterationFunction)) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1467:12: ^( T_PARAMS VAR[auxResults] )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                if ( !(stream_var.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_var.hasNext() ) {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1473:6: ^( REWRITEVNODE[$fo.token, auxResult] $var)
                    {
                    CommonTree root_1 = (CommonTree)adaptor.nil();
                    root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(REWRITEVNODE, fo.token, auxResult), root_1);

                    adaptor.addChild(root_1, stream_var.nextTree());

                    adaptor.addChild(root_0, root_1);
                    }

                }
                stream_var.reset();

            }
            else // 1475:3: -> COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "XSPARQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1476:6: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1477:8: ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2,  sparqlFunctionTree = new CommonTree(new CommonToken(NCNAME, ((sparqlForClause_scope)sparqlForClause_stack.peek()).evaluationFunction)) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1479:10: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                adaptor.addChild(root_3,  endpointURI(((sparqlForClause_scope)sparqlForClause_stack.peek()).endpointURI) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1480:12: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1482:14: ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? )
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, "$_sparql_prefixes"));
                adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1486:16: ( distinct )?
                if ( stream_distinct.hasNext() ) {
                    adaptor.addChild(root_5, stream_distinct.nextTree());

                }
                stream_distinct.reset();
                adaptor.addChild(root_5, getVarList(list_var));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1487:16: ( datasetClause )*
                while ( stream_datasetClause.hasNext() ) {
                    adaptor.addChild(root_5, stream_datasetClause.nextTree());

                }
                stream_datasetClause.reset();
                adaptor.addChild(root_5, stream_sWhereClause.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1489:16: ( solutionmodifier )?
                if ( stream_solutionmodifier.hasNext() ) {
                    adaptor.addChild(root_5, stream_solutionmodifier.nextTree());

                }
                stream_solutionmodifier.reset();

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }
                adaptor.addChild(root_3,  sparqlResultsIdTree = new CommonTree(new CommonToken(DELETEVNODE, "deleteNode")) );

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1496:6: ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResult));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1498:8: ^( AT VAR[auxResultPos] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                adaptor.addChild(root_1, root_2);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1501:8: ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1502:10: ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                adaptor.addChild(root_3,  sparqlResultsFunctionTree = new CommonTree(new CommonToken(NCNAME, ((sparqlForClause_scope)sparqlForClause_stack.peek()).iterationFunction)) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1504:12: ^( T_PARAMS VAR[auxResults] )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                if ( !(stream_var.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_var.hasNext() ) {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1510:6: ^( REWRITEVNODE[$fo.token, auxResult] $var)
                    {
                    CommonTree root_1 = (CommonTree)adaptor.nil();
                    root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(REWRITEVNODE, fo.token, auxResult), root_1);

                    adaptor.addChild(root_1, stream_var.nextTree());

                    adaptor.addChild(root_0, root_1);
                    }

                }
                stream_var.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
            if ( state.backtracking==0 ) {

                logger.info("Creating new variable scope: sparqlForClause-1");

                if(((VariableScope_scope)VariableScope_stack.peek()).scopedDataset) {
                  changeTreeToScopedDataset();
                } 

                ScopedDataset sd = new ScopedDataset (((VariableScope_scope)VariableScope_stack.peek()).scopedDataset, 
                                                      ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset?scopedDataset.peek().getId():UUID.randomUUID().toString(), 
                                                      sparqlFunctionTree, 
                                                      sparqlResultsFunctionTree, 
                                                      sparqlResultsIdTree, 
                                                      auxResultPos); 
                scopedDataset.add(sd); 

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            sparqlForClause_stack.pop();
        }
        return retval;
    }
    // $ANTLR end "sparqlForClause"

    public static class endpointClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "endpointClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1513:1: endpointClause : ENDPOINT e= sourceSelector ;
    public final XSPARQLRewriter.endpointClause_return endpointClause() throws RecognitionException {
        XSPARQLRewriter.endpointClause_return retval = new XSPARQLRewriter.endpointClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ENDPOINT179=null;
        XSPARQLRewriter.sourceSelector_return e = null;


        CommonTree ENDPOINT179_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1514:3: ( ENDPOINT e= sourceSelector )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1514:5: ENDPOINT e= sourceSelector
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ENDPOINT179=(CommonTree)match(input,ENDPOINT,FOLLOW_ENDPOINT_in_endpointClause6467); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ENDPOINT179_tree = (CommonTree)adaptor.dupNode(ENDPOINT179);

            adaptor.addChild(root_0, ENDPOINT179_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sourceSelector_in_endpointClause6471);
            e=sourceSelector();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, e.getTree());
            if ( state.backtracking==0 ) {
               ((sparqlForClause_scope)sparqlForClause_stack.peek()).iterationFunction = xsparqlAbbrev+":_sparqlResults";
                                              ((sparqlForClause_scope)sparqlForClause_stack.peek()).evaluationFunction = xsparqlAbbrev+":_sparql";
                                              ((sparqlForClause_scope)sparqlForClause_stack.peek()).endpointURI = (e!=null?(input.getTokenStream().toString(
                input.getTreeAdaptor().getTokenStartIndex(e.start),
                input.getTreeAdaptor().getTokenStopIndex(e.start))):null);
                
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "endpointClause"

    public static class varOrFunction_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varOrFunction"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1520:1: varOrFunction : (v= VAR -> {isBoundEarlier($v.text)}? NOTHING[$v.text] -> | LPAR functionCall AS v= VAR RPAR -> LPAR functionCall AS RPAR );
    public final XSPARQLRewriter.varOrFunction_return varOrFunction() throws RecognitionException {
        XSPARQLRewriter.varOrFunction_return retval = new XSPARQLRewriter.varOrFunction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree v=null;
        CommonTree LPAR180=null;
        CommonTree AS182=null;
        CommonTree RPAR183=null;
        XSPARQLRewriter.functionCall_return functionCall181 = null;


        CommonTree v_tree=null;
        CommonTree LPAR180_tree=null;
        CommonTree AS182_tree=null;
        CommonTree RPAR183_tree=null;
        RewriteRuleNodeStream stream_AS=new RewriteRuleNodeStream(adaptor,"token AS");
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleSubtreeStream stream_functionCall=new RewriteRuleSubtreeStream(adaptor,"rule functionCall");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1521:3: (v= VAR -> {isBoundEarlier($v.text)}? NOTHING[$v.text] -> | LPAR functionCall AS v= VAR RPAR -> LPAR functionCall AS RPAR )
            int alt59=2;
            switch ( input.LA(1) ) {
            case VAR:
                {
                alt59=1;
                }
                break;
            case LPAR:
                {
                alt59=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 59, 0, input);

                throw nvae;
            }

            switch (alt59) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1521:5: v= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varOrFunction6488); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1522:3: -> {isBoundEarlier($v.text)}? NOTHING[$v.text]
                    if (isBoundEarlier((v!=null?v.getText():null))) {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NOTHING, (v!=null?v.getText():null)));

                    }
                    else // 1523:3: ->
                    {
                        adaptor.addChild(root_0,  unboundVar((v!=null?v.getText():null)) );

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1524:5: LPAR functionCall AS v= VAR RPAR
                    {
                    _last = (CommonTree)input.LT(1);
                    LPAR180=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_varOrFunction6511); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LPAR.add(LPAR180);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_functionCall_in_varOrFunction6513);
                    functionCall181=functionCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_functionCall.add(functionCall181.getTree());
                    _last = (CommonTree)input.LT(1);
                    AS182=(CommonTree)match(input,AS,FOLLOW_AS_in_varOrFunction6515); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AS.add(AS182);

                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varOrFunction6519); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);

                    _last = (CommonTree)input.LT(1);
                    RPAR183=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_varOrFunction6521); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RPAR.add(RPAR183);



                    // AST REWRITE
                    // elements: functionCall, AS, RPAR, LPAR
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1525:3: -> LPAR functionCall AS RPAR
                    {
                        adaptor.addChild(root_0, stream_LPAR.nextNode());
                        adaptor.addChild(root_0, stream_functionCall.nextTree());
                        adaptor.addChild(root_0, stream_AS.nextNode());
                        adaptor.addChild(root_0,  unboundVar((v!=null?v.getText():null)) );
                        adaptor.addChild(root_0, stream_RPAR.nextNode());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varOrFunction"

    public static class forClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1528:1: forClause : ( singleForClause )+ ;
    public final XSPARQLRewriter.forClause_return forClause() throws RecognitionException {
        XSPARQLRewriter.forClause_return retval = new XSPARQLRewriter.forClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.singleForClause_return singleForClause184 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1529:3: ( ( singleForClause )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1529:5: ( singleForClause )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1529:5: ( singleForClause )+
            int cnt60=0;
            loop60:
            do {
                int alt60=2;
                switch ( input.LA(1) ) {
                case T_FOR:
                    {
                    alt60=1;
                    }
                    break;

                }

                switch (alt60) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: singleForClause
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_singleForClause_in_forClause6547);
            	    singleForClause184=singleForClause();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, singleForClause184.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt60 >= 1 ) break loop60;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(60, input);
                        throw eee;
                }
                cnt60++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forClause"

    public static class singleForClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleForClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1532:1: singleForClause : ^( T_FOR var= VAR ( ^( T_TYPE typeDeclaration ) )? optionalPosClause[$var.text] ) ;
    public final XSPARQLRewriter.singleForClause_return singleForClause() throws RecognitionException {
        XSPARQLRewriter.singleForClause_return retval = new XSPARQLRewriter.singleForClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        CommonTree T_FOR185=null;
        CommonTree T_TYPE186=null;
        XSPARQLRewriter.typeDeclaration_return typeDeclaration187 = null;

        XSPARQLRewriter.optionalPosClause_return optionalPosClause188 = null;


        CommonTree var_tree=null;
        CommonTree T_FOR185_tree=null;
        CommonTree T_TYPE186_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1533:3: ( ^( T_FOR var= VAR ( ^( T_TYPE typeDeclaration ) )? optionalPosClause[$var.text] ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1533:5: ^( T_FOR var= VAR ( ^( T_TYPE typeDeclaration ) )? optionalPosClause[$var.text] )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_FOR185=(CommonTree)match(input,T_FOR,FOLLOW_T_FOR_in_singleForClause6562); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_FOR185_tree = (CommonTree)adaptor.dupNode(T_FOR185);

            root_1 = (CommonTree)adaptor.becomeRoot(T_FOR185_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_singleForClause6566); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            var_tree = (CommonTree)adaptor.dupNode(var);

            adaptor.addChild(root_1, var_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1533:21: ( ^( T_TYPE typeDeclaration ) )?
            int alt61=2;
            switch ( input.LA(1) ) {
                case T_TYPE:
                    {
                    alt61=1;
                    }
                    break;
            }

            switch (alt61) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1533:22: ^( T_TYPE typeDeclaration )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_TYPE186=(CommonTree)match(input,T_TYPE,FOLLOW_T_TYPE_in_singleForClause6570); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_TYPE186_tree = (CommonTree)adaptor.dupNode(T_TYPE186);

                    root_2 = (CommonTree)adaptor.becomeRoot(T_TYPE186_tree, root_2);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_typeDeclaration_in_singleForClause6572);
                    typeDeclaration187=typeDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_2, typeDeclaration187.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_optionalPosClause_in_singleForClause6577);
            optionalPosClause188=optionalPosClause((var!=null?var.getText():null));

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, optionalPosClause188.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleForClause"

    public static class optionalPosClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "optionalPosClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1537:1: optionalPosClause[String var] : ( ^( IN exprSingle ) -> ^( AT VAR[$var + \"_pos\"] ) ^( IN exprSingle ) | ^(a= AT p= positionalVar ) ^( IN exprSingle ) -> ^( $a $p) ^( IN exprSingle ) );
    public final XSPARQLRewriter.optionalPosClause_return optionalPosClause(String var) throws RecognitionException {
        XSPARQLRewriter.optionalPosClause_return retval = new XSPARQLRewriter.optionalPosClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree a=null;
        CommonTree IN189=null;
        CommonTree IN191=null;
        XSPARQLRewriter.positionalVar_return p = null;

        XSPARQLRewriter.exprSingle_return exprSingle190 = null;

        XSPARQLRewriter.exprSingle_return exprSingle192 = null;


        CommonTree a_tree=null;
        CommonTree IN189_tree=null;
        CommonTree IN191_tree=null;
        RewriteRuleNodeStream stream_AT=new RewriteRuleNodeStream(adaptor,"token AT");
        RewriteRuleNodeStream stream_IN=new RewriteRuleNodeStream(adaptor,"token IN");
        RewriteRuleSubtreeStream stream_positionalVar=new RewriteRuleSubtreeStream(adaptor,"rule positionalVar");
        RewriteRuleSubtreeStream stream_exprSingle=new RewriteRuleSubtreeStream(adaptor,"rule exprSingle");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1538:3: ( ^( IN exprSingle ) -> ^( AT VAR[$var + \"_pos\"] ) ^( IN exprSingle ) | ^(a= AT p= positionalVar ) ^( IN exprSingle ) -> ^( $a $p) ^( IN exprSingle ) )
            int alt62=2;
            switch ( input.LA(1) ) {
            case IN:
                {
                alt62=1;
                }
                break;
            case AT:
                {
                alt62=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 62, 0, input);

                throw nvae;
            }

            switch (alt62) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1538:5: ^( IN exprSingle )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    IN189=(CommonTree)match(input,IN,FOLLOW_IN_in_optionalPosClause6596); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IN.add(IN189);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_exprSingle_in_optionalPosClause6598);
                    exprSingle190=exprSingle();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle190.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                      addPositionVariableToScope(var + "_pos");
                    }


                    // AST REWRITE
                    // elements: exprSingle, IN
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1539:3: -> ^( AT VAR[$var + \"_pos\"] ) ^( IN exprSingle )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1539:6: ^( AT VAR[$var + \"_pos\"] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, var + "_pos"));

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1539:31: ^( IN exprSingle )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_IN.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_exprSingle.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1540:5: ^(a= AT p= positionalVar ) ^( IN exprSingle )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    a=(CommonTree)match(input,AT,FOLLOW_AT_in_optionalPosClause6627); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT.add(a);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_positionalVar_in_optionalPosClause6631);
                    p=positionalVar();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_positionalVar.add(p.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    IN191=(CommonTree)match(input,IN,FOLLOW_IN_in_optionalPosClause6635); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IN.add(IN191);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_exprSingle_in_optionalPosClause6637);
                    exprSingle192=exprSingle();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle192.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                      addPositionVariableToScope((p!=null?(input.getTokenStream().toString(
                        input.getTreeAdaptor().getTokenStartIndex(p.start),
                        input.getTreeAdaptor().getTokenStopIndex(p.start))):null));
                    }


                    // AST REWRITE
                    // elements: a, IN, exprSingle, p
                    // token labels: a
                    // rule labels: retval, p
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_a=new RewriteRuleNodeStream(adaptor,"token a",a);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_p=new RewriteRuleSubtreeStream(adaptor,"rule p",p!=null?p.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1541:3: -> ^( $a $p) ^( IN exprSingle )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1541:6: ^( $a $p)
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_a.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_p.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1541:15: ^( IN exprSingle )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_IN.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_exprSingle.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "optionalPosClause"

    public static class positionalVar_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "positionalVar"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1544:1: positionalVar : VAR ;
    public final XSPARQLRewriter.positionalVar_return positionalVar() throws RecognitionException {
        XSPARQLRewriter.positionalVar_return retval = new XSPARQLRewriter.positionalVar_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR193=null;

        CommonTree VAR193_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1545:3: ( VAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1545:5: VAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            VAR193=(CommonTree)match(input,VAR,FOLLOW_VAR_in_positionalVar6671); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            VAR193_tree = (CommonTree)adaptor.dupNode(VAR193);

            adaptor.addChild(root_0, VAR193_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "positionalVar"

    public static class letClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "letClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1548:1: letClause : ( singleLetClause )+ ;
    public final XSPARQLRewriter.letClause_return letClause() throws RecognitionException {
        XSPARQLRewriter.letClause_return retval = new XSPARQLRewriter.letClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.singleLetClause_return singleLetClause194 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1549:3: ( ( singleLetClause )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1549:5: ( singleLetClause )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1549:5: ( singleLetClause )+
            int cnt63=0;
            loop63:
            do {
                int alt63=2;
                switch ( input.LA(1) ) {
                case T_LET:
                    {
                    alt63=1;
                    }
                    break;

                }

                switch (alt63) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1549:6: singleLetClause
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_singleLetClause_in_letClause6685);
            	    singleLetClause194=singleLetClause();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, singleLetClause194.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt63 >= 1 ) break loop63;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(63, input);
                        throw eee;
                }
                cnt63++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "letClause"

    public static class singleLetClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleLetClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1552:1: singleLetClause : ^( T_LET ^(var= VAR ( typeDeclaration )? ) exprSingle ) -> { $exprSingle.type.equals(Types.RDF_GRAPH) }? ^( T_LET ^( $var ( typeDeclaration )? ) ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS exprSingle ) ) ) ^( T_RETURN ^( T_FLWOR ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) ) ) ) -> ^( T_LET ^( $var ( typeDeclaration )? ) exprSingle ) ;
    public final XSPARQLRewriter.singleLetClause_return singleLetClause() throws RecognitionException {
        XSPARQLRewriter.singleLetClause_return retval = new XSPARQLRewriter.singleLetClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        CommonTree T_LET195=null;
        XSPARQLRewriter.typeDeclaration_return typeDeclaration196 = null;

        XSPARQLRewriter.exprSingle_return exprSingle197 = null;


        CommonTree var_tree=null;
        CommonTree T_LET195_tree=null;
        RewriteRuleNodeStream stream_T_LET=new RewriteRuleNodeStream(adaptor,"token T_LET");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleSubtreeStream stream_exprSingle=new RewriteRuleSubtreeStream(adaptor,"rule exprSingle");
        RewriteRuleSubtreeStream stream_typeDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule typeDeclaration");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1553:3: ( ^( T_LET ^(var= VAR ( typeDeclaration )? ) exprSingle ) -> { $exprSingle.type.equals(Types.RDF_GRAPH) }? ^( T_LET ^( $var ( typeDeclaration )? ) ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS exprSingle ) ) ) ^( T_RETURN ^( T_FLWOR ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) ) ) ) -> ^( T_LET ^( $var ( typeDeclaration )? ) exprSingle ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1553:5: ^( T_LET ^(var= VAR ( typeDeclaration )? ) exprSingle )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_LET195=(CommonTree)match(input,T_LET,FOLLOW_T_LET_in_singleLetClause6701); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_LET.add(T_LET195);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_singleLetClause6713); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_VAR.add(var);



            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1554:17: ( typeDeclaration )?
                int alt64=2;
                switch ( input.LA(1) ) {
                    case NCNAME:
                    case PNAME_NS:
                    case PNAME_LN:
                    case A:
                    case FROM:
                    case ATTRIBUTE:
                    case ELEMENT:
                    case TO:
                    case EMPTYSEQUENCE:
                    case ITEM:
                    case NODE:
                    case DOCUMENTNODE:
                    case TEXT:
                    case COMMENT:
                    case PROCESSINGINSTRUCTION:
                    case SCHEMAATTRIBUTE:
                    case SCHEMAELEMENT:
                    case ROW:
                        {
                        alt64=1;
                        }
                        break;
                }

                switch (alt64) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: typeDeclaration
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_typeDeclaration_in_singleLetClause6715);
                        typeDeclaration196=typeDeclaration();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) stream_typeDeclaration.add(typeDeclaration196.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_singleLetClause6725);
            exprSingle197=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle197.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
               addVariableToScope((var!=null?var.getText():null)); 
                      if ( (exprSingle197!=null?exprSingle197.type:null).equals(Types.RDF_GRAPH) ) {
                        addVariableToScope("$_" + Helper.removeLeading((var!=null?var.getText():null),"$")+"_graph");
                      } 
                      if(this.warnIfNestedConstruct) {
                        logger.severe("The evaluation will probably NOT work because you are using a nested construct and want to evaluate that on a SPARQL endpoint which is not located on your host. That doesn't work! If you want to evaluate a nested constuct, then the XQuery engine and the SPARQL engine have to be running on the same host.");
                      }
                    
            }


            // AST REWRITE
            // elements: var, exprSingle, exprSingle, T_LET, typeDeclaration, T_LET, typeDeclaration, VAR, var, var, T_LET
            // token labels: var
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleNodeStream stream_var=new RewriteRuleNodeStream(adaptor,"token var",var);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1564:3: -> { $exprSingle.type.equals(Types.RDF_GRAPH) }? ^( T_LET ^( $var ( typeDeclaration )? ) ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS exprSingle ) ) ) ^( T_RETURN ^( T_FLWOR ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) ) ) )
            if ( (exprSingle197!=null?exprSingle197.type:null).equals(Types.RDF_GRAPH) ) {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:52: ^( T_LET ^( $var ( typeDeclaration )? ) ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS exprSingle ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_T_LET.nextNode(), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:60: ^( $var ( typeDeclaration )? )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot(stream_var.nextNode(), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:67: ( typeDeclaration )?
                if ( stream_typeDeclaration.hasNext() ) {
                    adaptor.addChild(root_2, stream_typeDeclaration.nextTree());

                }
                stream_typeDeclaration.reset();

                adaptor.addChild(root_1, root_2);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:85: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS exprSingle ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:129: ^( T_PARAMS exprSingle )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                adaptor.addChild(root_3, stream_exprSingle.nextTree());

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:154: ^( T_RETURN ^( T_FLWOR ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:165: ^( T_FLWOR ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:175: ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot(stream_T_LET.nextNode(), root_3);

                adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, "$_" + Helper.removeLeading((var!=null?var.getText():null),"$")+"_graph"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:242: ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, storeGraphFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:287: ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var)
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, getRDFNamespaceDecls()));
                adaptor.addChild(root_5, stream_var.nextNode());

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }
            else // 1565:3: -> ^( T_LET ^( $var ( typeDeclaration )? ) exprSingle )
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1565:6: ^( T_LET ^( $var ( typeDeclaration )? ) exprSingle )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_T_LET.nextNode(), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1565:14: ^( $var ( typeDeclaration )? )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot(stream_var.nextNode(), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1565:21: ( typeDeclaration )?
                if ( stream_typeDeclaration.hasNext() ) {
                    adaptor.addChild(root_2, stream_typeDeclaration.nextTree());

                }
                stream_typeDeclaration.reset();

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, stream_exprSingle.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleLetClause"

    public static class whereClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "whereClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1568:1: whereClause : ^( WHERE exprSingle ) -> exprSingle ;
    public final XSPARQLRewriter.whereClause_return whereClause() throws RecognitionException {
        XSPARQLRewriter.whereClause_return retval = new XSPARQLRewriter.whereClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree WHERE198=null;
        XSPARQLRewriter.exprSingle_return exprSingle199 = null;


        CommonTree WHERE198_tree=null;
        RewriteRuleNodeStream stream_WHERE=new RewriteRuleNodeStream(adaptor,"token WHERE");
        RewriteRuleSubtreeStream stream_exprSingle=new RewriteRuleSubtreeStream(adaptor,"rule exprSingle");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1569:3: ( ^( WHERE exprSingle ) -> exprSingle )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1569:5: ^( WHERE exprSingle )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            WHERE198=(CommonTree)match(input,WHERE,FOLLOW_WHERE_in_whereClause6829); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_WHERE.add(WHERE198);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_whereClause6831);
            exprSingle199=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle199.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: exprSingle
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1569:25: -> exprSingle
            {
                adaptor.addChild(root_0, stream_exprSingle.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "whereClause"

    public static class orderByClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderByClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1572:1: orderByClause : ( ^( T_ORDER_BY orderSpecList ) | ^( T_STABLE_ORDER_BY orderSpecList ) );
    public final XSPARQLRewriter.orderByClause_return orderByClause() throws RecognitionException {
        XSPARQLRewriter.orderByClause_return retval = new XSPARQLRewriter.orderByClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_ORDER_BY200=null;
        CommonTree T_STABLE_ORDER_BY202=null;
        XSPARQLRewriter.orderSpecList_return orderSpecList201 = null;

        XSPARQLRewriter.orderSpecList_return orderSpecList203 = null;


        CommonTree T_ORDER_BY200_tree=null;
        CommonTree T_STABLE_ORDER_BY202_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1573:3: ( ^( T_ORDER_BY orderSpecList ) | ^( T_STABLE_ORDER_BY orderSpecList ) )
            int alt65=2;
            switch ( input.LA(1) ) {
            case T_ORDER_BY:
                {
                alt65=1;
                }
                break;
            case T_STABLE_ORDER_BY:
                {
                alt65=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 65, 0, input);

                throw nvae;
            }

            switch (alt65) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1573:5: ^( T_ORDER_BY orderSpecList )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_ORDER_BY200=(CommonTree)match(input,T_ORDER_BY,FOLLOW_T_ORDER_BY_in_orderByClause6850); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_ORDER_BY200_tree = (CommonTree)adaptor.dupNode(T_ORDER_BY200);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_ORDER_BY200_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orderSpecList_in_orderByClause6852);
                    orderSpecList201=orderSpecList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, orderSpecList201.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1574:5: ^( T_STABLE_ORDER_BY orderSpecList )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_STABLE_ORDER_BY202=(CommonTree)match(input,T_STABLE_ORDER_BY,FOLLOW_T_STABLE_ORDER_BY_in_orderByClause6860); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_STABLE_ORDER_BY202_tree = (CommonTree)adaptor.dupNode(T_STABLE_ORDER_BY202);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_STABLE_ORDER_BY202_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orderSpecList_in_orderByClause6862);
                    orderSpecList203=orderSpecList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, orderSpecList203.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderByClause"

    public static class orderSpecList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderSpecList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1577:1: orderSpecList : ( orderSpec )+ ;
    public final XSPARQLRewriter.orderSpecList_return orderSpecList() throws RecognitionException {
        XSPARQLRewriter.orderSpecList_return retval = new XSPARQLRewriter.orderSpecList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.orderSpec_return orderSpec204 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1578:3: ( ( orderSpec )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1578:5: ( orderSpec )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1578:5: ( orderSpec )+
            int cnt66=0;
            loop66:
            do {
                int alt66=2;
                switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt66=1;
                    }
                    break;

                }

                switch (alt66) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: orderSpec
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_orderSpec_in_orderSpecList6876);
            	    orderSpec204=orderSpec();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, orderSpec204.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt66 >= 1 ) break loop66;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(66, input);
                        throw eee;
                }
                cnt66++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderSpecList"

    public static class orderSpec_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderSpec"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1581:1: orderSpec : exprSingle orderModifier ;
    public final XSPARQLRewriter.orderSpec_return orderSpec() throws RecognitionException {
        XSPARQLRewriter.orderSpec_return retval = new XSPARQLRewriter.orderSpec_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.exprSingle_return exprSingle205 = null;

        XSPARQLRewriter.orderModifier_return orderModifier206 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1582:3: ( exprSingle orderModifier )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1582:6: exprSingle orderModifier
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_orderSpec6891);
            exprSingle205=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, exprSingle205.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_orderModifier_in_orderSpec6893);
            orderModifier206=orderModifier();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, orderModifier206.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderSpec"

    public static class orderModifier_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderModifier"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1585:1: orderModifier : ( ASCENDING | DESCENDING )? ( EMPTY ( GREATEST | LEAST ) )? ( COLLATION uriliteral )? ;
    public final XSPARQLRewriter.orderModifier_return orderModifier() throws RecognitionException {
        XSPARQLRewriter.orderModifier_return retval = new XSPARQLRewriter.orderModifier_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set207=null;
        CommonTree EMPTY208=null;
        CommonTree set209=null;
        CommonTree COLLATION210=null;
        XSPARQLRewriter.uriliteral_return uriliteral211 = null;


        CommonTree set207_tree=null;
        CommonTree EMPTY208_tree=null;
        CommonTree set209_tree=null;
        CommonTree COLLATION210_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1586:3: ( ( ASCENDING | DESCENDING )? ( EMPTY ( GREATEST | LEAST ) )? ( COLLATION uriliteral )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1586:5: ( ASCENDING | DESCENDING )? ( EMPTY ( GREATEST | LEAST ) )? ( COLLATION uriliteral )?
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1586:5: ( ASCENDING | DESCENDING )?
            int alt67=2;
            switch ( input.LA(1) ) {
                case DESCENDING:
                case ASCENDING:
                    {
                    alt67=1;
                    }
                    break;
            }

            switch (alt67) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
                    {
                    _last = (CommonTree)input.LT(1);
                    set207=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=DESCENDING && input.LA(1)<=ASCENDING) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set207_tree = (CommonTree)adaptor.dupNode(set207);

                        adaptor.addChild(root_0, set207_tree);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }


                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1586:31: ( EMPTY ( GREATEST | LEAST ) )?
            int alt68=2;
            switch ( input.LA(1) ) {
                case EMPTY:
                    {
                    alt68=1;
                    }
                    break;
            }

            switch (alt68) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1586:32: EMPTY ( GREATEST | LEAST )
                    {
                    _last = (CommonTree)input.LT(1);
                    EMPTY208=(CommonTree)match(input,EMPTY,FOLLOW_EMPTY_in_orderModifier6916); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    EMPTY208_tree = (CommonTree)adaptor.dupNode(EMPTY208);

                    adaptor.addChild(root_0, EMPTY208_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    set209=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=GREATEST && input.LA(1)<=LEAST) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set209_tree = (CommonTree)adaptor.dupNode(set209);

                        adaptor.addChild(root_0, set209_tree);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1586:59: ( COLLATION uriliteral )?
            int alt69=2;
            switch ( input.LA(1) ) {
                case COLLATION:
                    {
                    alt69=1;
                    }
                    break;
            }

            switch (alt69) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1586:60: COLLATION uriliteral
                    {
                    _last = (CommonTree)input.LT(1);
                    COLLATION210=(CommonTree)match(input,COLLATION,FOLLOW_COLLATION_in_orderModifier6929); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLLATION210_tree = (CommonTree)adaptor.dupNode(COLLATION210);

                    adaptor.addChild(root_0, COLLATION210_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_uriliteral_in_orderModifier6931);
                    uriliteral211=uriliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, uriliteral211.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderModifier"

    public static class quantifiedExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "quantifiedExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1589:1: quantifiedExpr : ^( ( SOME | EVERY ) ( ^( T_VAR VAR ( ^( T_TYPE typeDeclaration ) )? ^( IN exprSingle ) ) )+ ^( SATISFIES exprSingle ) ) ;
    public final XSPARQLRewriter.quantifiedExpr_return quantifiedExpr() throws RecognitionException {
        XSPARQLRewriter.quantifiedExpr_return retval = new XSPARQLRewriter.quantifiedExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set212=null;
        CommonTree T_VAR213=null;
        CommonTree VAR214=null;
        CommonTree T_TYPE215=null;
        CommonTree IN217=null;
        CommonTree SATISFIES219=null;
        XSPARQLRewriter.typeDeclaration_return typeDeclaration216 = null;

        XSPARQLRewriter.exprSingle_return exprSingle218 = null;

        XSPARQLRewriter.exprSingle_return exprSingle220 = null;


        CommonTree set212_tree=null;
        CommonTree T_VAR213_tree=null;
        CommonTree VAR214_tree=null;
        CommonTree T_TYPE215_tree=null;
        CommonTree IN217_tree=null;
        CommonTree SATISFIES219_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1590:3: ( ^( ( SOME | EVERY ) ( ^( T_VAR VAR ( ^( T_TYPE typeDeclaration ) )? ^( IN exprSingle ) ) )+ ^( SATISFIES exprSingle ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1590:5: ^( ( SOME | EVERY ) ( ^( T_VAR VAR ( ^( T_TYPE typeDeclaration ) )? ^( IN exprSingle ) ) )+ ^( SATISFIES exprSingle ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();set212=(CommonTree)input.LT(1);
            if ( input.LA(1)==EVERY||input.LA(1)==SOME ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set212_tree = (CommonTree)adaptor.dupNode(set212);

                root_1 = (CommonTree)adaptor.becomeRoot(set212_tree, root_1);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }



            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1590:20: ( ^( T_VAR VAR ( ^( T_TYPE typeDeclaration ) )? ^( IN exprSingle ) ) )+
            int cnt71=0;
            loop71:
            do {
                int alt71=2;
                switch ( input.LA(1) ) {
                case T_VAR:
                    {
                    alt71=1;
                    }
                    break;

                }

                switch (alt71) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1590:21: ^( T_VAR VAR ( ^( T_TYPE typeDeclaration ) )? ^( IN exprSingle ) )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_2 = _last;
            	    CommonTree _first_2 = null;
            	    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_VAR213=(CommonTree)match(input,T_VAR,FOLLOW_T_VAR_in_quantifiedExpr6955); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    T_VAR213_tree = (CommonTree)adaptor.dupNode(T_VAR213);

            	    root_2 = (CommonTree)adaptor.becomeRoot(T_VAR213_tree, root_2);
            	    }


            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    VAR214=(CommonTree)match(input,VAR,FOLLOW_VAR_in_quantifiedExpr6957); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    VAR214_tree = (CommonTree)adaptor.dupNode(VAR214);

            	    adaptor.addChild(root_2, VAR214_tree);
            	    }
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1590:33: ( ^( T_TYPE typeDeclaration ) )?
            	    int alt70=2;
            	    switch ( input.LA(1) ) {
            	        case T_TYPE:
            	            {
            	            alt70=1;
            	            }
            	            break;
            	    }

            	    switch (alt70) {
            	        case 1 :
            	            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1590:34: ^( T_TYPE typeDeclaration )
            	            {
            	            _last = (CommonTree)input.LT(1);
            	            {
            	            CommonTree _save_last_3 = _last;
            	            CommonTree _first_3 = null;
            	            CommonTree root_3 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	            T_TYPE215=(CommonTree)match(input,T_TYPE,FOLLOW_T_TYPE_in_quantifiedExpr6961); if (state.failed) return retval;
            	            if ( state.backtracking==0 ) {
            	            T_TYPE215_tree = (CommonTree)adaptor.dupNode(T_TYPE215);

            	            root_3 = (CommonTree)adaptor.becomeRoot(T_TYPE215_tree, root_3);
            	            }


            	            match(input, Token.DOWN, null); if (state.failed) return retval;
            	            _last = (CommonTree)input.LT(1);
            	            pushFollow(FOLLOW_typeDeclaration_in_quantifiedExpr6963);
            	            typeDeclaration216=typeDeclaration();

            	            state._fsp--;
            	            if (state.failed) return retval;
            	            if ( state.backtracking==0 ) 
            	            adaptor.addChild(root_3, typeDeclaration216.getTree());

            	            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_2, root_3);_last = _save_last_3;
            	            }


            	            if ( state.backtracking==0 ) {
            	            }
            	            }
            	            break;

            	    }

            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_3 = _last;
            	    CommonTree _first_3 = null;
            	    CommonTree root_3 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    IN217=(CommonTree)match(input,IN,FOLLOW_IN_in_quantifiedExpr6969); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    IN217_tree = (CommonTree)adaptor.dupNode(IN217);

            	    root_3 = (CommonTree)adaptor.becomeRoot(IN217_tree, root_3);
            	    }


            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_exprSingle_in_quantifiedExpr6971);
            	    exprSingle218=exprSingle();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_3, exprSingle218.getTree());

            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_2, root_3);_last = _save_last_3;
            	    }


            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt71 >= 1 ) break loop71;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(71, input);
                        throw eee;
                }
                cnt71++;
            } while (true);

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            SATISFIES219=(CommonTree)match(input,SATISFIES,FOLLOW_SATISFIES_in_quantifiedExpr6978); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            SATISFIES219_tree = (CommonTree)adaptor.dupNode(SATISFIES219);

            root_2 = (CommonTree)adaptor.becomeRoot(SATISFIES219_tree, root_2);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_quantifiedExpr6980);
            exprSingle220=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_2, exprSingle220.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "quantifiedExpr"

    public static class typeSwitchExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeSwitchExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1593:1: typeSwitchExpr : ^( TYPESWITCH expr ( caseClause )+ ( VAR )? exprSingle ) ;
    public final XSPARQLRewriter.typeSwitchExpr_return typeSwitchExpr() throws RecognitionException {
        XSPARQLRewriter.typeSwitchExpr_return retval = new XSPARQLRewriter.typeSwitchExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree TYPESWITCH221=null;
        CommonTree VAR224=null;
        XSPARQLRewriter.expr_return expr222 = null;

        XSPARQLRewriter.caseClause_return caseClause223 = null;

        XSPARQLRewriter.exprSingle_return exprSingle225 = null;


        CommonTree TYPESWITCH221_tree=null;
        CommonTree VAR224_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1594:3: ( ^( TYPESWITCH expr ( caseClause )+ ( VAR )? exprSingle ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1594:5: ^( TYPESWITCH expr ( caseClause )+ ( VAR )? exprSingle )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            TYPESWITCH221=(CommonTree)match(input,TYPESWITCH,FOLLOW_TYPESWITCH_in_typeSwitchExpr6996); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            TYPESWITCH221_tree = (CommonTree)adaptor.dupNode(TYPESWITCH221);

            root_1 = (CommonTree)adaptor.becomeRoot(TYPESWITCH221_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_typeSwitchExpr6998);
            expr222=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, expr222.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1594:23: ( caseClause )+
            int cnt72=0;
            loop72:
            do {
                int alt72=2;
                switch ( input.LA(1) ) {
                case CASE:
                    {
                    alt72=1;
                    }
                    break;

                }

                switch (alt72) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: caseClause
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_caseClause_in_typeSwitchExpr7000);
            	    caseClause223=caseClause();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_1, caseClause223.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt72 >= 1 ) break loop72;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(72, input);
                        throw eee;
                }
                cnt72++;
            } while (true);

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1594:35: ( VAR )?
            int alt73=2;
            switch ( input.LA(1) ) {
                case VAR:
                    {
                    alt73=1;
                    }
                    break;
            }

            switch (alt73) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    VAR224=(CommonTree)match(input,VAR,FOLLOW_VAR_in_typeSwitchExpr7003); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR224_tree = (CommonTree)adaptor.dupNode(VAR224);

                    adaptor.addChild(root_1, VAR224_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_typeSwitchExpr7006);
            exprSingle225=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, exprSingle225.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "typeSwitchExpr"

    public static class caseClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "caseClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1597:1: caseClause : CASE ( VAR AS )? sequenceType RETURN exprSingle ;
    public final XSPARQLRewriter.caseClause_return caseClause() throws RecognitionException {
        XSPARQLRewriter.caseClause_return retval = new XSPARQLRewriter.caseClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree CASE226=null;
        CommonTree VAR227=null;
        CommonTree AS228=null;
        CommonTree RETURN230=null;
        XSPARQLRewriter.sequenceType_return sequenceType229 = null;

        XSPARQLRewriter.exprSingle_return exprSingle231 = null;


        CommonTree CASE226_tree=null;
        CommonTree VAR227_tree=null;
        CommonTree AS228_tree=null;
        CommonTree RETURN230_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1598:3: ( CASE ( VAR AS )? sequenceType RETURN exprSingle )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1598:5: CASE ( VAR AS )? sequenceType RETURN exprSingle
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            CASE226=(CommonTree)match(input,CASE,FOLLOW_CASE_in_caseClause7020); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            CASE226_tree = (CommonTree)adaptor.dupNode(CASE226);

            adaptor.addChild(root_0, CASE226_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1598:10: ( VAR AS )?
            int alt74=2;
            switch ( input.LA(1) ) {
                case VAR:
                    {
                    alt74=1;
                    }
                    break;
            }

            switch (alt74) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1598:11: VAR AS
                    {
                    _last = (CommonTree)input.LT(1);
                    VAR227=(CommonTree)match(input,VAR,FOLLOW_VAR_in_caseClause7023); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR227_tree = (CommonTree)adaptor.dupNode(VAR227);

                    adaptor.addChild(root_0, VAR227_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    AS228=(CommonTree)match(input,AS,FOLLOW_AS_in_caseClause7025); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AS228_tree = (CommonTree)adaptor.dupNode(AS228);

                    adaptor.addChild(root_0, AS228_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sequenceType_in_caseClause7029);
            sequenceType229=sequenceType();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, sequenceType229.getTree());
            _last = (CommonTree)input.LT(1);
            RETURN230=(CommonTree)match(input,RETURN,FOLLOW_RETURN_in_caseClause7031); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RETURN230_tree = (CommonTree)adaptor.dupNode(RETURN230);

            adaptor.addChild(root_0, RETURN230_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_caseClause7033);
            exprSingle231=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, exprSingle231.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "caseClause"

    public static class ifExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "ifExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1601:1: ifExpr : ^( IF exprSingle exprSingle exprSingle ) ;
    public final XSPARQLRewriter.ifExpr_return ifExpr() throws RecognitionException {
        XSPARQLRewriter.ifExpr_return retval = new XSPARQLRewriter.ifExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree IF232=null;
        XSPARQLRewriter.exprSingle_return exprSingle233 = null;

        XSPARQLRewriter.exprSingle_return exprSingle234 = null;

        XSPARQLRewriter.exprSingle_return exprSingle235 = null;


        CommonTree IF232_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1603:3: ( ^( IF exprSingle exprSingle exprSingle ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1603:5: ^( IF exprSingle exprSingle exprSingle )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            IF232=(CommonTree)match(input,IF,FOLLOW_IF_in_ifExpr7048); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            IF232_tree = (CommonTree)adaptor.dupNode(IF232);

            root_1 = (CommonTree)adaptor.becomeRoot(IF232_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_ifExpr7050);
            exprSingle233=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, exprSingle233.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_ifExpr7052);
            exprSingle234=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, exprSingle234.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_ifExpr7054);
            exprSingle235=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, exprSingle235.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "ifExpr"

    public static class orExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1606:1: orExpr : ( andExpr | ^( OR orExpr andExpr ) );
    public final XSPARQLRewriter.orExpr_return orExpr() throws RecognitionException {
        XSPARQLRewriter.orExpr_return retval = new XSPARQLRewriter.orExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree OR237=null;
        XSPARQLRewriter.andExpr_return andExpr236 = null;

        XSPARQLRewriter.orExpr_return orExpr238 = null;

        XSPARQLRewriter.andExpr_return andExpr239 = null;


        CommonTree OR237_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1607:3: ( andExpr | ^( OR orExpr andExpr ) )
            int alt75=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case AND:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt75=1;
                }
                break;
            case OR:
                {
                alt75=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 75, 0, input);

                throw nvae;
            }

            switch (alt75) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1607:5: andExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_andExpr_in_orExpr7068);
                    andExpr236=andExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, andExpr236.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1608:5: ^( OR orExpr andExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    OR237=(CommonTree)match(input,OR,FOLLOW_OR_in_orExpr7075); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    OR237_tree = (CommonTree)adaptor.dupNode(OR237);

                    root_1 = (CommonTree)adaptor.becomeRoot(OR237_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orExpr_in_orExpr7077);
                    orExpr238=orExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, orExpr238.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_andExpr_in_orExpr7079);
                    andExpr239=andExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, andExpr239.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orExpr"

    public static class andExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "andExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1611:1: andExpr : ( comparisonExpr | ^( AND andExpr comparisonExpr ) );
    public final XSPARQLRewriter.andExpr_return andExpr() throws RecognitionException {
        XSPARQLRewriter.andExpr_return retval = new XSPARQLRewriter.andExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree AND241=null;
        XSPARQLRewriter.comparisonExpr_return comparisonExpr240 = null;

        XSPARQLRewriter.andExpr_return andExpr242 = null;

        XSPARQLRewriter.comparisonExpr_return comparisonExpr243 = null;


        CommonTree AND241_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1612:3: ( comparisonExpr | ^( AND andExpr comparisonExpr ) )
            int alt76=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt76=1;
                }
                break;
            case AND:
                {
                alt76=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 76, 0, input);

                throw nvae;
            }

            switch (alt76) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1612:5: comparisonExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_comparisonExpr_in_andExpr7093);
                    comparisonExpr240=comparisonExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, comparisonExpr240.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1613:5: ^( AND andExpr comparisonExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    AND241=(CommonTree)match(input,AND,FOLLOW_AND_in_andExpr7100); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AND241_tree = (CommonTree)adaptor.dupNode(AND241);

                    root_1 = (CommonTree)adaptor.becomeRoot(AND241_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_andExpr_in_andExpr7102);
                    andExpr242=andExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, andExpr242.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_comparisonExpr_in_andExpr7104);
                    comparisonExpr243=comparisonExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, comparisonExpr243.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "andExpr"

    public static class comparisonExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "comparisonExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1616:1: comparisonExpr : ( rangeExpr | ^( ( EQ | NE | LT | LE | GT | GE | EQUALS | LESSTHAN | GREATERTHAN | LESSTHANEQUALS | GREATERTHANEQUALS | HAFENEQUALS | LESSTHANLESSTHAN | GREATERTHANGREATERTHAN | IS ) rangeExpr rangeExpr ) );
    public final XSPARQLRewriter.comparisonExpr_return comparisonExpr() throws RecognitionException {
        XSPARQLRewriter.comparisonExpr_return retval = new XSPARQLRewriter.comparisonExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set245=null;
        XSPARQLRewriter.rangeExpr_return rangeExpr244 = null;

        XSPARQLRewriter.rangeExpr_return rangeExpr246 = null;

        XSPARQLRewriter.rangeExpr_return rangeExpr247 = null;


        CommonTree set245_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1617:3: ( rangeExpr | ^( ( EQ | NE | LT | LE | GT | GE | EQUALS | LESSTHAN | GREATERTHAN | LESSTHANEQUALS | GREATERTHANEQUALS | HAFENEQUALS | LESSTHANLESSTHAN | GREATERTHANGREATERTHAN | IS ) rangeExpr rangeExpr ) )
            int alt77=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt77=1;
                }
                break;
            case LESSTHAN:
            case GREATERTHAN:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case GREATERTHANGREATERTHAN:
                {
                alt77=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 77, 0, input);

                throw nvae;
            }

            switch (alt77) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1617:5: rangeExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rangeExpr_in_comparisonExpr7118);
                    rangeExpr244=rangeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, rangeExpr244.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1618:5: ^( ( EQ | NE | LT | LE | GT | GE | EQUALS | LESSTHAN | GREATERTHAN | LESSTHANEQUALS | GREATERTHANEQUALS | HAFENEQUALS | LESSTHANLESSTHAN | GREATERTHANGREATERTHAN | IS ) rangeExpr rangeExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();set245=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=LESSTHAN && input.LA(1)<=GREATERTHAN)||(input.LA(1)>=LESSTHANLESSTHAN && input.LA(1)<=EQUALS)||(input.LA(1)>=IS && input.LA(1)<=GT)||input.LA(1)==GREATERTHANGREATERTHAN ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set245_tree = (CommonTree)adaptor.dupNode(set245);

                        root_1 = (CommonTree)adaptor.becomeRoot(set245_tree, root_1);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rangeExpr_in_comparisonExpr7290);
                    rangeExpr246=rangeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, rangeExpr246.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rangeExpr_in_comparisonExpr7292);
                    rangeExpr247=rangeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, rangeExpr247.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "comparisonExpr"

    public static class rangeExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "rangeExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1639:1: rangeExpr : ( additiveExpr | ^( TO rangeExpr additiveExpr ) );
    public final XSPARQLRewriter.rangeExpr_return rangeExpr() throws RecognitionException {
        XSPARQLRewriter.rangeExpr_return retval = new XSPARQLRewriter.rangeExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree TO249=null;
        XSPARQLRewriter.additiveExpr_return additiveExpr248 = null;

        XSPARQLRewriter.rangeExpr_return rangeExpr250 = null;

        XSPARQLRewriter.additiveExpr_return additiveExpr251 = null;


        CommonTree TO249_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1640:3: ( additiveExpr | ^( TO rangeExpr additiveExpr ) )
            int alt78=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt78=1;
                }
                break;
            case TO:
                {
                alt78=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 78, 0, input);

                throw nvae;
            }

            switch (alt78) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1640:5: additiveExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_additiveExpr_in_rangeExpr7311);
                    additiveExpr248=additiveExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, additiveExpr248.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1641:5: ^( TO rangeExpr additiveExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    TO249=(CommonTree)match(input,TO,FOLLOW_TO_in_rangeExpr7318); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    TO249_tree = (CommonTree)adaptor.dupNode(TO249);

                    root_1 = (CommonTree)adaptor.becomeRoot(TO249_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rangeExpr_in_rangeExpr7320);
                    rangeExpr250=rangeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, rangeExpr250.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_additiveExpr_in_rangeExpr7322);
                    additiveExpr251=additiveExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, additiveExpr251.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "rangeExpr"

    public static class additiveExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "additiveExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1644:1: additiveExpr : ( multiplicativeExpr | ^( ( PLUS | MINUS ) additiveExpr multiplicativeExpr ) );
    public final XSPARQLRewriter.additiveExpr_return additiveExpr() throws RecognitionException {
        XSPARQLRewriter.additiveExpr_return retval = new XSPARQLRewriter.additiveExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set253=null;
        XSPARQLRewriter.multiplicativeExpr_return multiplicativeExpr252 = null;

        XSPARQLRewriter.additiveExpr_return additiveExpr254 = null;

        XSPARQLRewriter.multiplicativeExpr_return multiplicativeExpr255 = null;


        CommonTree set253_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1645:3: ( multiplicativeExpr | ^( ( PLUS | MINUS ) additiveExpr multiplicativeExpr ) )
            int alt79=2;
            switch ( input.LA(1) ) {
            case PLUS:
            case MINUS:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt79=2;
                    }
                    break;
                case LCURLY:
                case PLUS:
                case MINUS:
                case VALIDATE:
                case XPATH:
                    {
                    alt79=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 79, 1, input);

                    throw nvae;
                }

                }
                break;
            case LCURLY:
            case STAR:
            case UNIONSYMBOL:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt79=1;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 79, 0, input);

                throw nvae;
            }

            switch (alt79) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1645:5: multiplicativeExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpr_in_additiveExpr7336);
                    multiplicativeExpr252=multiplicativeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, multiplicativeExpr252.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1646:5: ^( ( PLUS | MINUS ) additiveExpr multiplicativeExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();set253=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=PLUS && input.LA(1)<=MINUS) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set253_tree = (CommonTree)adaptor.dupNode(set253);

                        root_1 = (CommonTree)adaptor.becomeRoot(set253_tree, root_1);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_additiveExpr_in_additiveExpr7349);
                    additiveExpr254=additiveExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, additiveExpr254.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpr_in_additiveExpr7351);
                    multiplicativeExpr255=multiplicativeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, multiplicativeExpr255.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "additiveExpr"

    public static class multiplicativeExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multiplicativeExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1648:1: multiplicativeExpr : ( unionExpr | ^( ( STAR | DIV | IDIV | MOD ) multiplicativeExpr unionExpr ) );
    public final XSPARQLRewriter.multiplicativeExpr_return multiplicativeExpr() throws RecognitionException {
        XSPARQLRewriter.multiplicativeExpr_return retval = new XSPARQLRewriter.multiplicativeExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set257=null;
        XSPARQLRewriter.unionExpr_return unionExpr256 = null;

        XSPARQLRewriter.multiplicativeExpr_return multiplicativeExpr258 = null;

        XSPARQLRewriter.unionExpr_return unionExpr259 = null;


        CommonTree set257_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1649:3: ( unionExpr | ^( ( STAR | DIV | IDIV | MOD ) multiplicativeExpr unionExpr ) )
            int alt80=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt80=1;
                }
                break;
            case STAR:
            case DIV:
            case IDIV:
            case MOD:
                {
                alt80=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 80, 0, input);

                throw nvae;
            }

            switch (alt80) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1649:5: unionExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unionExpr_in_multiplicativeExpr7362);
                    unionExpr256=unionExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, unionExpr256.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1650:5: ^( ( STAR | DIV | IDIV | MOD ) multiplicativeExpr unionExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();set257=(CommonTree)input.LT(1);
                    if ( input.LA(1)==STAR||(input.LA(1)>=DIV && input.LA(1)<=MOD) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set257_tree = (CommonTree)adaptor.dupNode(set257);

                        root_1 = (CommonTree)adaptor.becomeRoot(set257_tree, root_1);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpr_in_multiplicativeExpr7385);
                    multiplicativeExpr258=multiplicativeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, multiplicativeExpr258.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unionExpr_in_multiplicativeExpr7387);
                    unionExpr259=unionExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, unionExpr259.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multiplicativeExpr"

    public static class unionExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unionExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1653:1: unionExpr : ( intersectExceptExpr | ^( ( UNION | UNIONSYMBOL ) unionExpr intersectExceptExpr ) );
    public final XSPARQLRewriter.unionExpr_return unionExpr() throws RecognitionException {
        XSPARQLRewriter.unionExpr_return retval = new XSPARQLRewriter.unionExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set261=null;
        XSPARQLRewriter.intersectExceptExpr_return intersectExceptExpr260 = null;

        XSPARQLRewriter.unionExpr_return unionExpr262 = null;

        XSPARQLRewriter.intersectExceptExpr_return intersectExceptExpr263 = null;


        CommonTree set261_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1654:3: ( intersectExceptExpr | ^( ( UNION | UNIONSYMBOL ) unionExpr intersectExceptExpr ) )
            int alt81=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case INTERSECT:
            case EXCEPT:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt81=1;
                }
                break;
            case UNIONSYMBOL:
            case UNION:
                {
                alt81=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 81, 0, input);

                throw nvae;
            }

            switch (alt81) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1654:5: intersectExceptExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_intersectExceptExpr_in_unionExpr7401);
                    intersectExceptExpr260=intersectExceptExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, intersectExceptExpr260.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1655:5: ^( ( UNION | UNIONSYMBOL ) unionExpr intersectExceptExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();set261=(CommonTree)input.LT(1);
                    if ( input.LA(1)==UNIONSYMBOL||input.LA(1)==UNION ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set261_tree = (CommonTree)adaptor.dupNode(set261);

                        root_1 = (CommonTree)adaptor.becomeRoot(set261_tree, root_1);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unionExpr_in_unionExpr7416);
                    unionExpr262=unionExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, unionExpr262.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_intersectExceptExpr_in_unionExpr7418);
                    intersectExceptExpr263=intersectExceptExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, intersectExceptExpr263.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unionExpr"

    public static class intersectExceptExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "intersectExceptExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1658:1: intersectExceptExpr : ( instanceOfExpr | ^( ( INTERSECT | EXCEPT ) intersectExceptExpr instanceOfExpr ) );
    public final XSPARQLRewriter.intersectExceptExpr_return intersectExceptExpr() throws RecognitionException {
        XSPARQLRewriter.intersectExceptExpr_return retval = new XSPARQLRewriter.intersectExceptExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set265=null;
        XSPARQLRewriter.instanceOfExpr_return instanceOfExpr264 = null;

        XSPARQLRewriter.intersectExceptExpr_return intersectExceptExpr266 = null;

        XSPARQLRewriter.instanceOfExpr_return instanceOfExpr267 = null;


        CommonTree set265_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1659:3: ( instanceOfExpr | ^( ( INTERSECT | EXCEPT ) intersectExceptExpr instanceOfExpr ) )
            int alt82=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt82=1;
                }
                break;
            case INTERSECT:
            case EXCEPT:
                {
                alt82=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 82, 0, input);

                throw nvae;
            }

            switch (alt82) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1659:5: instanceOfExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_instanceOfExpr_in_intersectExceptExpr7432);
                    instanceOfExpr264=instanceOfExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, instanceOfExpr264.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1660:5: ^( ( INTERSECT | EXCEPT ) intersectExceptExpr instanceOfExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();set265=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=INTERSECT && input.LA(1)<=EXCEPT) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set265_tree = (CommonTree)adaptor.dupNode(set265);

                        root_1 = (CommonTree)adaptor.becomeRoot(set265_tree, root_1);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_intersectExceptExpr_in_intersectExceptExpr7447);
                    intersectExceptExpr266=intersectExceptExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, intersectExceptExpr266.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_instanceOfExpr_in_intersectExceptExpr7449);
                    instanceOfExpr267=instanceOfExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, instanceOfExpr267.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "intersectExceptExpr"

    public static class instanceOfExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "instanceOfExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1663:1: instanceOfExpr : ( treatExpr | ^( T_INSTANCEOF instanceOfExpr sequenceType ) );
    public final XSPARQLRewriter.instanceOfExpr_return instanceOfExpr() throws RecognitionException {
        XSPARQLRewriter.instanceOfExpr_return retval = new XSPARQLRewriter.instanceOfExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_INSTANCEOF269=null;
        XSPARQLRewriter.treatExpr_return treatExpr268 = null;

        XSPARQLRewriter.instanceOfExpr_return instanceOfExpr270 = null;

        XSPARQLRewriter.sequenceType_return sequenceType271 = null;


        CommonTree T_INSTANCEOF269_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1664:3: ( treatExpr | ^( T_INSTANCEOF instanceOfExpr sequenceType ) )
            int alt83=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt83=1;
                }
                break;
            case T_INSTANCEOF:
                {
                alt83=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 83, 0, input);

                throw nvae;
            }

            switch (alt83) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1664:5: treatExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_treatExpr_in_instanceOfExpr7463);
                    treatExpr268=treatExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, treatExpr268.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1665:5: ^( T_INSTANCEOF instanceOfExpr sequenceType )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_INSTANCEOF269=(CommonTree)match(input,T_INSTANCEOF,FOLLOW_T_INSTANCEOF_in_instanceOfExpr7470); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_INSTANCEOF269_tree = (CommonTree)adaptor.dupNode(T_INSTANCEOF269);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_INSTANCEOF269_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_instanceOfExpr_in_instanceOfExpr7472);
                    instanceOfExpr270=instanceOfExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, instanceOfExpr270.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sequenceType_in_instanceOfExpr7474);
                    sequenceType271=sequenceType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, sequenceType271.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "instanceOfExpr"

    public static class treatExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "treatExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1668:1: treatExpr : ( castableExpr | ^( T_TREATAS treatExpr sequenceType ) );
    public final XSPARQLRewriter.treatExpr_return treatExpr() throws RecognitionException {
        XSPARQLRewriter.treatExpr_return retval = new XSPARQLRewriter.treatExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_TREATAS273=null;
        XSPARQLRewriter.castableExpr_return castableExpr272 = null;

        XSPARQLRewriter.treatExpr_return treatExpr274 = null;

        XSPARQLRewriter.sequenceType_return sequenceType275 = null;


        CommonTree T_TREATAS273_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1669:3: ( castableExpr | ^( T_TREATAS treatExpr sequenceType ) )
            int alt84=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case T_CASTAS:
            case T_CASTABLEAS:
            case VALIDATE:
            case XPATH:
                {
                alt84=1;
                }
                break;
            case T_TREATAS:
                {
                alt84=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 84, 0, input);

                throw nvae;
            }

            switch (alt84) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1669:5: castableExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_castableExpr_in_treatExpr7488);
                    castableExpr272=castableExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, castableExpr272.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1670:5: ^( T_TREATAS treatExpr sequenceType )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_TREATAS273=(CommonTree)match(input,T_TREATAS,FOLLOW_T_TREATAS_in_treatExpr7495); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_TREATAS273_tree = (CommonTree)adaptor.dupNode(T_TREATAS273);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_TREATAS273_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_treatExpr_in_treatExpr7497);
                    treatExpr274=treatExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, treatExpr274.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sequenceType_in_treatExpr7499);
                    sequenceType275=sequenceType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, sequenceType275.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "treatExpr"

    public static class castableExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "castableExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1673:1: castableExpr : ( castExpr | ^( T_CASTABLEAS castableExpr singleType ) );
    public final XSPARQLRewriter.castableExpr_return castableExpr() throws RecognitionException {
        XSPARQLRewriter.castableExpr_return retval = new XSPARQLRewriter.castableExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_CASTABLEAS277=null;
        XSPARQLRewriter.castExpr_return castExpr276 = null;

        XSPARQLRewriter.castableExpr_return castableExpr278 = null;

        XSPARQLRewriter.singleType_return singleType279 = null;


        CommonTree T_CASTABLEAS277_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1674:3: ( castExpr | ^( T_CASTABLEAS castableExpr singleType ) )
            int alt85=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case T_CASTAS:
            case VALIDATE:
            case XPATH:
                {
                alt85=1;
                }
                break;
            case T_CASTABLEAS:
                {
                alt85=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 85, 0, input);

                throw nvae;
            }

            switch (alt85) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1674:5: castExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_castExpr_in_castableExpr7513);
                    castExpr276=castExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, castExpr276.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1675:5: ^( T_CASTABLEAS castableExpr singleType )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_CASTABLEAS277=(CommonTree)match(input,T_CASTABLEAS,FOLLOW_T_CASTABLEAS_in_castableExpr7520); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_CASTABLEAS277_tree = (CommonTree)adaptor.dupNode(T_CASTABLEAS277);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_CASTABLEAS277_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_castableExpr_in_castableExpr7522);
                    castableExpr278=castableExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, castableExpr278.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_singleType_in_castableExpr7524);
                    singleType279=singleType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, singleType279.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "castableExpr"

    public static class castExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "castExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1678:1: castExpr : ( unaryExpr | ^( T_CASTAS castExpr singleType ) );
    public final XSPARQLRewriter.castExpr_return castExpr() throws RecognitionException {
        XSPARQLRewriter.castExpr_return retval = new XSPARQLRewriter.castExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_CASTAS281=null;
        XSPARQLRewriter.unaryExpr_return unaryExpr280 = null;

        XSPARQLRewriter.castExpr_return castExpr282 = null;

        XSPARQLRewriter.singleType_return singleType283 = null;


        CommonTree T_CASTAS281_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1679:3: ( unaryExpr | ^( T_CASTAS castExpr singleType ) )
            int alt86=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case VALIDATE:
            case XPATH:
                {
                alt86=1;
                }
                break;
            case T_CASTAS:
                {
                alt86=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 86, 0, input);

                throw nvae;
            }

            switch (alt86) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1679:5: unaryExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unaryExpr_in_castExpr7538);
                    unaryExpr280=unaryExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, unaryExpr280.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1680:5: ^( T_CASTAS castExpr singleType )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_CASTAS281=(CommonTree)match(input,T_CASTAS,FOLLOW_T_CASTAS_in_castExpr7545); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_CASTAS281_tree = (CommonTree)adaptor.dupNode(T_CASTAS281);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_CASTAS281_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_castExpr_in_castExpr7547);
                    castExpr282=castExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, castExpr282.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_singleType_in_castExpr7549);
                    singleType283=singleType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, singleType283.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "castExpr"

    public static class unaryExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unaryExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1683:1: unaryExpr : ( MINUS | PLUS )* valueExpr ;
    public final XSPARQLRewriter.unaryExpr_return unaryExpr() throws RecognitionException {
        XSPARQLRewriter.unaryExpr_return retval = new XSPARQLRewriter.unaryExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set284=null;
        XSPARQLRewriter.valueExpr_return valueExpr285 = null;


        CommonTree set284_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1684:3: ( ( MINUS | PLUS )* valueExpr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1684:5: ( MINUS | PLUS )* valueExpr
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1684:5: ( MINUS | PLUS )*
            loop87:
            do {
                int alt87=2;
                switch ( input.LA(1) ) {
                case PLUS:
                case MINUS:
                    {
                    alt87=1;
                    }
                    break;

                }

                switch (alt87) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    set284=(CommonTree)input.LT(1);
            	    if ( (input.LA(1)>=PLUS && input.LA(1)<=MINUS) ) {
            	        input.consume();

            	        if ( state.backtracking==0 ) {
            	        set284_tree = (CommonTree)adaptor.dupNode(set284);

            	        adaptor.addChild(root_0, set284_tree);
            	        }
            	        state.errorRecovery=false;state.failed=false;
            	    }
            	    else {
            	        if (state.backtracking>0) {state.failed=true; return retval;}
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop87;
                }
            } while (true);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_valueExpr_in_unaryExpr7572);
            valueExpr285=valueExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, valueExpr285.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unaryExpr"

    public static class valueExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "valueExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1687:1: valueExpr : ( pathExpr | validateExpr | extensionExpr );
    public final XSPARQLRewriter.valueExpr_return valueExpr() throws RecognitionException {
        XSPARQLRewriter.valueExpr_return retval = new XSPARQLRewriter.valueExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.pathExpr_return pathExpr286 = null;

        XSPARQLRewriter.validateExpr_return validateExpr287 = null;

        XSPARQLRewriter.extensionExpr_return extensionExpr288 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1688:3: ( pathExpr | validateExpr | extensionExpr )
            int alt88=3;
            switch ( input.LA(1) ) {
            case XPATH:
                {
                alt88=1;
                }
                break;
            case VALIDATE:
                {
                alt88=2;
                }
                break;
            case LCURLY:
                {
                alt88=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 88, 0, input);

                throw nvae;
            }

            switch (alt88) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1688:5: pathExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_pathExpr_in_valueExpr7585);
                    pathExpr286=pathExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, pathExpr286.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1689:5: validateExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_validateExpr_in_valueExpr7591);
                    validateExpr287=validateExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, validateExpr287.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1690:5: extensionExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_extensionExpr_in_valueExpr7597);
                    extensionExpr288=extensionExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, extensionExpr288.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "valueExpr"

    public static class validateExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "validateExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1693:1: validateExpr : VALIDATE ( validationMode )? expr ;
    public final XSPARQLRewriter.validateExpr_return validateExpr() throws RecognitionException {
        XSPARQLRewriter.validateExpr_return retval = new XSPARQLRewriter.validateExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VALIDATE289=null;
        XSPARQLRewriter.validationMode_return validationMode290 = null;

        XSPARQLRewriter.expr_return expr291 = null;


        CommonTree VALIDATE289_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1694:3: ( VALIDATE ( validationMode )? expr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1694:5: VALIDATE ( validationMode )? expr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            VALIDATE289=(CommonTree)match(input,VALIDATE,FOLLOW_VALIDATE_in_validateExpr7610); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            VALIDATE289_tree = (CommonTree)adaptor.dupNode(VALIDATE289);

            adaptor.addChild(root_0, VALIDATE289_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1694:14: ( validationMode )?
            int alt89=2;
            switch ( input.LA(1) ) {
                case LAX:
                case STRICT:
                    {
                    alt89=1;
                    }
                    break;
            }

            switch (alt89) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: validationMode
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_validationMode_in_validateExpr7612);
                    validationMode290=validationMode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, validationMode290.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_validateExpr7615);
            expr291=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr291.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "validateExpr"

    public static class validationMode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "validationMode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1697:1: validationMode : ( LAX | STRICT );
    public final XSPARQLRewriter.validationMode_return validationMode() throws RecognitionException {
        XSPARQLRewriter.validationMode_return retval = new XSPARQLRewriter.validationMode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set292=null;

        CommonTree set292_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1698:3: ( LAX | STRICT )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set292=(CommonTree)input.LT(1);
            if ( input.LA(1)==LAX||input.LA(1)==STRICT ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set292_tree = (CommonTree)adaptor.dupNode(set292);

                adaptor.addChild(root_0, set292_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "validationMode"

    public static class extensionExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "extensionExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1702:1: extensionExpr : LCURLY ( expr )? RCURLY ;
    public final XSPARQLRewriter.extensionExpr_return extensionExpr() throws RecognitionException {
        XSPARQLRewriter.extensionExpr_return retval = new XSPARQLRewriter.extensionExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree LCURLY293=null;
        CommonTree RCURLY295=null;
        XSPARQLRewriter.expr_return expr294 = null;


        CommonTree LCURLY293_tree=null;
        CommonTree RCURLY295_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1703:3: ( LCURLY ( expr )? RCURLY )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1704:5: LCURLY ( expr )? RCURLY
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            LCURLY293=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_extensionExpr7652); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LCURLY293_tree = (CommonTree)adaptor.dupNode(LCURLY293);

            adaptor.addChild(root_0, LCURLY293_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1704:12: ( expr )?
            int alt90=2;
            switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt90=1;
                    }
                    break;
            }

            switch (alt90) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: expr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expr_in_extensionExpr7654);
                    expr294=expr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, expr294.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RCURLY295=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_extensionExpr7657); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RCURLY295_tree = (CommonTree)adaptor.dupNode(RCURLY295);

            adaptor.addChild(root_0, RCURLY295_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "extensionExpr"

    public static class pathExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "pathExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1707:1: pathExpr : ( ^( XPATH SLASH SLASH relativePathExpr ) | ^( XPATH SLASH relativePathExpr ) | ^( XPATH SLASH ) | ^( XPATH relativePathExpr ) );
    public final XSPARQLRewriter.pathExpr_return pathExpr() throws RecognitionException {
        XSPARQLRewriter.pathExpr_return retval = new XSPARQLRewriter.pathExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree XPATH296=null;
        CommonTree SLASH297=null;
        CommonTree SLASH298=null;
        CommonTree XPATH300=null;
        CommonTree SLASH301=null;
        CommonTree XPATH303=null;
        CommonTree SLASH304=null;
        CommonTree XPATH305=null;
        XSPARQLRewriter.relativePathExpr_return relativePathExpr299 = null;

        XSPARQLRewriter.relativePathExpr_return relativePathExpr302 = null;

        XSPARQLRewriter.relativePathExpr_return relativePathExpr306 = null;


        CommonTree XPATH296_tree=null;
        CommonTree SLASH297_tree=null;
        CommonTree SLASH298_tree=null;
        CommonTree XPATH300_tree=null;
        CommonTree SLASH301_tree=null;
        CommonTree XPATH303_tree=null;
        CommonTree SLASH304_tree=null;
        CommonTree XPATH305_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1708:3: ( ^( XPATH SLASH SLASH relativePathExpr ) | ^( XPATH SLASH relativePathExpr ) | ^( XPATH SLASH ) | ^( XPATH relativePathExpr ) )
            int alt91=4;
            switch ( input.LA(1) ) {
            case XPATH:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case SLASH:
                        {
                        switch ( input.LA(4) ) {
                        case SLASH:
                            {
                            alt91=1;
                            }
                            break;
                        case UP:
                            {
                            alt91=3;
                            }
                            break;
                        case VAR:
                        case INTEGER:
                        case NCNAME:
                        case QSTRING:
                        case DOT:
                        case AT:
                        case STAR:
                        case DOTDOT:
                        case PNAME_NS:
                        case PNAME_LN:
                        case A:
                        case FROM:
                        case CHILD:
                        case DESCENDANT:
                        case ATTRIBUTE:
                        case SELF:
                        case DESCENDANTORSELF:
                        case FOLLOWINGSIBLING:
                        case FOLLOWING:
                        case PARENT:
                        case ANCESTOR:
                        case PRECEDINGSIBLING:
                        case PRECEDING:
                        case ANCESTORORSELF:
                        case ORDERED:
                        case UNORDERED:
                        case ELEMENT:
                        case TO:
                        case ITEM:
                        case NODE:
                        case DOCUMENTNODE:
                        case TEXT:
                        case COMMENT:
                        case PROCESSINGINSTRUCTION:
                        case SCHEMAATTRIBUTE:
                        case SCHEMAELEMENT:
                        case DOCUMENT:
                        case ROW:
                        case T_XML_ELEMENT:
                        case T_PAR:
                        case T_FUNCTION_CALL:
                        case DECIMAL:
                            {
                            alt91=2;
                            }
                            break;
                        default:
                            if (state.backtracking>0) {state.failed=true; return retval;}
                            NoViableAltException nvae =
                                new NoViableAltException("", 91, 3, input);

                            throw nvae;
                        }

                        }
                        break;
                    case VAR:
                    case INTEGER:
                    case NCNAME:
                    case QSTRING:
                    case DOT:
                    case AT:
                    case STAR:
                    case DOTDOT:
                    case PNAME_NS:
                    case PNAME_LN:
                    case A:
                    case FROM:
                    case CHILD:
                    case DESCENDANT:
                    case ATTRIBUTE:
                    case SELF:
                    case DESCENDANTORSELF:
                    case FOLLOWINGSIBLING:
                    case FOLLOWING:
                    case PARENT:
                    case ANCESTOR:
                    case PRECEDINGSIBLING:
                    case PRECEDING:
                    case ANCESTORORSELF:
                    case ORDERED:
                    case UNORDERED:
                    case ELEMENT:
                    case TO:
                    case ITEM:
                    case NODE:
                    case DOCUMENTNODE:
                    case TEXT:
                    case COMMENT:
                    case PROCESSINGINSTRUCTION:
                    case SCHEMAATTRIBUTE:
                    case SCHEMAELEMENT:
                    case DOCUMENT:
                    case ROW:
                    case T_XML_ELEMENT:
                    case T_PAR:
                    case T_FUNCTION_CALL:
                    case DECIMAL:
                        {
                        alt91=4;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 91, 2, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 91, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 91, 0, input);

                throw nvae;
            }

            switch (alt91) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1708:5: ^( XPATH SLASH SLASH relativePathExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    XPATH296=(CommonTree)match(input,XPATH,FOLLOW_XPATH_in_pathExpr7671); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    XPATH296_tree = (CommonTree)adaptor.dupNode(XPATH296);

                    root_1 = (CommonTree)adaptor.becomeRoot(XPATH296_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    SLASH297=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_pathExpr7673); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SLASH297_tree = (CommonTree)adaptor.dupNode(SLASH297);

                    adaptor.addChild(root_1, SLASH297_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    SLASH298=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_pathExpr7675); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SLASH298_tree = (CommonTree)adaptor.dupNode(SLASH298);

                    adaptor.addChild(root_1, SLASH298_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relativePathExpr_in_pathExpr7677);
                    relativePathExpr299=relativePathExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, relativePathExpr299.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1709:5: ^( XPATH SLASH relativePathExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    XPATH300=(CommonTree)match(input,XPATH,FOLLOW_XPATH_in_pathExpr7685); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    XPATH300_tree = (CommonTree)adaptor.dupNode(XPATH300);

                    root_1 = (CommonTree)adaptor.becomeRoot(XPATH300_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    SLASH301=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_pathExpr7687); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SLASH301_tree = (CommonTree)adaptor.dupNode(SLASH301);

                    adaptor.addChild(root_1, SLASH301_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relativePathExpr_in_pathExpr7689);
                    relativePathExpr302=relativePathExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, relativePathExpr302.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1710:5: ^( XPATH SLASH )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    XPATH303=(CommonTree)match(input,XPATH,FOLLOW_XPATH_in_pathExpr7697); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    XPATH303_tree = (CommonTree)adaptor.dupNode(XPATH303);

                    root_1 = (CommonTree)adaptor.becomeRoot(XPATH303_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    SLASH304=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_pathExpr7699); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SLASH304_tree = (CommonTree)adaptor.dupNode(SLASH304);

                    adaptor.addChild(root_1, SLASH304_tree);
                    }

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1711:5: ^( XPATH relativePathExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    XPATH305=(CommonTree)match(input,XPATH,FOLLOW_XPATH_in_pathExpr7707); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    XPATH305_tree = (CommonTree)adaptor.dupNode(XPATH305);

                    root_1 = (CommonTree)adaptor.becomeRoot(XPATH305_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relativePathExpr_in_pathExpr7709);
                    relativePathExpr306=relativePathExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, relativePathExpr306.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "pathExpr"

    protected static class relativePathExpr_scope {
        boolean rdbVar;
    }
    protected Stack relativePathExpr_stack = new Stack();

    public static class relativePathExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relativePathExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1714:1: relativePathExpr : stepExpr ( SLASH ( SLASH )? stepExpr )* ;
    public final XSPARQLRewriter.relativePathExpr_return relativePathExpr() throws RecognitionException {
        relativePathExpr_stack.push(new relativePathExpr_scope());
        XSPARQLRewriter.relativePathExpr_return retval = new XSPARQLRewriter.relativePathExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree SLASH308=null;
        CommonTree SLASH309=null;
        XSPARQLRewriter.stepExpr_return stepExpr307 = null;

        XSPARQLRewriter.stepExpr_return stepExpr310 = null;


        CommonTree SLASH308_tree=null;
        CommonTree SLASH309_tree=null;


          ((relativePathExpr_scope)relativePathExpr_stack.peek()).rdbVar = false;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1721:3: ( stepExpr ( SLASH ( SLASH )? stepExpr )* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1721:5: stepExpr ( SLASH ( SLASH )? stepExpr )*
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_stepExpr_in_relativePathExpr7732);
            stepExpr307=stepExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, stepExpr307.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1721:14: ( SLASH ( SLASH )? stepExpr )*
            loop93:
            do {
                int alt93=2;
                switch ( input.LA(1) ) {
                case SLASH:
                    {
                    alt93=1;
                    }
                    break;

                }

                switch (alt93) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1721:15: SLASH ( SLASH )? stepExpr
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    SLASH308=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_relativePathExpr7735); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    SLASH308_tree = (CommonTree)adaptor.dupNode(SLASH308);

            	    adaptor.addChild(root_0, SLASH308_tree);
            	    }
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1721:21: ( SLASH )?
            	    int alt92=2;
            	    switch ( input.LA(1) ) {
            	        case SLASH:
            	            {
            	            alt92=1;
            	            }
            	            break;
            	    }

            	    switch (alt92) {
            	        case 1 :
            	            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: SLASH
            	            {
            	            _last = (CommonTree)input.LT(1);
            	            SLASH309=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_relativePathExpr7737); if (state.failed) return retval;
            	            if ( state.backtracking==0 ) {
            	            SLASH309_tree = (CommonTree)adaptor.dupNode(SLASH309);

            	            adaptor.addChild(root_0, SLASH309_tree);
            	            }

            	            if ( state.backtracking==0 ) {
            	            }
            	            }
            	            break;

            	    }

            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_stepExpr_in_relativePathExpr7740);
            	    stepExpr310=stepExpr();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, stepExpr310.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop93;
                }
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            relativePathExpr_stack.pop();
        }
        return retval;
    }
    // $ANTLR end "relativePathExpr"

    public static class stepExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "stepExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1727:1: stepExpr : ( filterExpr | axisStep );
    public final XSPARQLRewriter.stepExpr_return stepExpr() throws RecognitionException {
        XSPARQLRewriter.stepExpr_return retval = new XSPARQLRewriter.stepExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.filterExpr_return filterExpr311 = null;

        XSPARQLRewriter.axisStep_return axisStep312 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1728:3: ( filterExpr | axisStep )
            int alt94=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case DOT:
            case ORDERED:
            case UNORDERED:
            case DOCUMENT:
            case T_XML_ELEMENT:
            case T_PAR:
            case T_FUNCTION_CALL:
            case DECIMAL:
                {
                alt94=1;
                }
                break;
            case ELEMENT:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt94=2;
                    }
                    break;
                case LCURLY:
                case NCNAME:
                case PNAME_NS:
                case PNAME_LN:
                case A:
                case FROM:
                case TO:
                case ITEM:
                case NODE:
                case COMMENT:
                case ROW:
                    {
                    alt94=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 94, 2, input);

                    throw nvae;
                }

                }
                break;
            case ATTRIBUTE:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                case COLONCOLON:
                    {
                    alt94=2;
                    }
                    break;
                case LCURLY:
                case NCNAME:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case PNAME_NS:
                case PNAME_LN:
                case A:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case FROM:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case ITEM:
                case NODE:
                case COMMENT:
                case GREATERTHANGREATERTHAN:
                case ROW:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt94=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 94, 3, input);

                    throw nvae;
                }

                }
                break;
            case TEXT:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt94=2;
                    }
                    break;
                case LCURLY:
                    {
                    alt94=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 94, 4, input);

                    throw nvae;
                }

                }
                break;
            case COMMENT:
                {
                switch ( input.LA(2) ) {
                case EOF:
                case UP:
                case SLASH:
                case LBRACKET:
                case LPAR:
                    {
                    alt94=2;
                    }
                    break;
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt94=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 94, 5, input);

                    throw nvae;
                }

                }
                break;
            case PROCESSINGINSTRUCTION:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt94=2;
                    }
                    break;
                case LCURLY:
                case NCNAME:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt94=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 94, 6, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
            case AT:
            case STAR:
            case DOTDOT:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case CHILD:
            case DESCENDANT:
            case SELF:
            case DESCENDANTORSELF:
            case FOLLOWINGSIBLING:
            case FOLLOWING:
            case PARENT:
            case ANCESTOR:
            case PRECEDINGSIBLING:
            case PRECEDING:
            case ANCESTORORSELF:
            case TO:
            case ITEM:
            case NODE:
            case DOCUMENTNODE:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
            case ROW:
                {
                alt94=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 94, 0, input);

                throw nvae;
            }

            switch (alt94) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1728:5: filterExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_filterExpr_in_stepExpr7758);
                    filterExpr311=filterExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, filterExpr311.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1729:5: axisStep
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_axisStep_in_stepExpr7764);
                    axisStep312=axisStep();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, axisStep312.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "stepExpr"

    public static class axisStep_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "axisStep"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1732:1: axisStep : ( reverseStep | forwardStep ) predicateList ;
    public final XSPARQLRewriter.axisStep_return axisStep() throws RecognitionException {
        XSPARQLRewriter.axisStep_return retval = new XSPARQLRewriter.axisStep_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.reverseStep_return reverseStep313 = null;

        XSPARQLRewriter.forwardStep_return forwardStep314 = null;

        XSPARQLRewriter.predicateList_return predicateList315 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1733:3: ( ( reverseStep | forwardStep ) predicateList )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1733:5: ( reverseStep | forwardStep ) predicateList
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1733:5: ( reverseStep | forwardStep )
            int alt95=2;
            switch ( input.LA(1) ) {
            case DOTDOT:
            case PARENT:
            case ANCESTOR:
            case PRECEDINGSIBLING:
            case PRECEDING:
            case ANCESTORORSELF:
                {
                alt95=1;
                }
                break;
            case NCNAME:
            case AT:
            case STAR:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case CHILD:
            case DESCENDANT:
            case ATTRIBUTE:
            case SELF:
            case DESCENDANTORSELF:
            case FOLLOWINGSIBLING:
            case FOLLOWING:
            case ELEMENT:
            case TO:
            case ITEM:
            case NODE:
            case DOCUMENTNODE:
            case TEXT:
            case COMMENT:
            case PROCESSINGINSTRUCTION:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
            case ROW:
                {
                alt95=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 95, 0, input);

                throw nvae;
            }

            switch (alt95) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1733:6: reverseStep
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_reverseStep_in_axisStep7778);
                    reverseStep313=reverseStep();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, reverseStep313.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1733:20: forwardStep
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_forwardStep_in_axisStep7782);
                    forwardStep314=forwardStep();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, forwardStep314.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_predicateList_in_axisStep7785);
            predicateList315=predicateList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, predicateList315.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "axisStep"

    public static class forwardStep_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forwardStep"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1736:1: forwardStep : ( forwardAxis nodeTest | abbrevForwardStep );
    public final XSPARQLRewriter.forwardStep_return forwardStep() throws RecognitionException {
        XSPARQLRewriter.forwardStep_return retval = new XSPARQLRewriter.forwardStep_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.forwardAxis_return forwardAxis316 = null;

        XSPARQLRewriter.nodeTest_return nodeTest317 = null;

        XSPARQLRewriter.abbrevForwardStep_return abbrevForwardStep318 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1737:3: ( forwardAxis nodeTest | abbrevForwardStep )
            int alt96=2;
            switch ( input.LA(1) ) {
            case CHILD:
            case DESCENDANT:
            case SELF:
            case DESCENDANTORSELF:
            case FOLLOWINGSIBLING:
            case FOLLOWING:
                {
                alt96=1;
                }
                break;
            case ATTRIBUTE:
                {
                switch ( input.LA(2) ) {
                case COLONCOLON:
                    {
                    alt96=1;
                    }
                    break;
                case LPAR:
                    {
                    alt96=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 96, 2, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
            case AT:
            case STAR:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case ELEMENT:
            case TO:
            case ITEM:
            case NODE:
            case DOCUMENTNODE:
            case TEXT:
            case COMMENT:
            case PROCESSINGINSTRUCTION:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
            case ROW:
                {
                alt96=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 96, 0, input);

                throw nvae;
            }

            switch (alt96) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1737:5: forwardAxis nodeTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_forwardAxis_in_forwardStep7798);
                    forwardAxis316=forwardAxis();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, forwardAxis316.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_nodeTest_in_forwardStep7800);
                    nodeTest317=nodeTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, nodeTest317.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1738:5: abbrevForwardStep
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_abbrevForwardStep_in_forwardStep7806);
                    abbrevForwardStep318=abbrevForwardStep();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, abbrevForwardStep318.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forwardStep"

    public static class forwardAxis_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forwardAxis"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1741:1: forwardAxis : ( CHILD COLONCOLON | DESCENDANT COLONCOLON | ATTRIBUTE COLONCOLON | SELF COLONCOLON | DESCENDANTORSELF COLONCOLON | FOLLOWINGSIBLING COLONCOLON | FOLLOWING COLONCOLON );
    public final XSPARQLRewriter.forwardAxis_return forwardAxis() throws RecognitionException {
        XSPARQLRewriter.forwardAxis_return retval = new XSPARQLRewriter.forwardAxis_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree CHILD319=null;
        CommonTree COLONCOLON320=null;
        CommonTree DESCENDANT321=null;
        CommonTree COLONCOLON322=null;
        CommonTree ATTRIBUTE323=null;
        CommonTree COLONCOLON324=null;
        CommonTree SELF325=null;
        CommonTree COLONCOLON326=null;
        CommonTree DESCENDANTORSELF327=null;
        CommonTree COLONCOLON328=null;
        CommonTree FOLLOWINGSIBLING329=null;
        CommonTree COLONCOLON330=null;
        CommonTree FOLLOWING331=null;
        CommonTree COLONCOLON332=null;

        CommonTree CHILD319_tree=null;
        CommonTree COLONCOLON320_tree=null;
        CommonTree DESCENDANT321_tree=null;
        CommonTree COLONCOLON322_tree=null;
        CommonTree ATTRIBUTE323_tree=null;
        CommonTree COLONCOLON324_tree=null;
        CommonTree SELF325_tree=null;
        CommonTree COLONCOLON326_tree=null;
        CommonTree DESCENDANTORSELF327_tree=null;
        CommonTree COLONCOLON328_tree=null;
        CommonTree FOLLOWINGSIBLING329_tree=null;
        CommonTree COLONCOLON330_tree=null;
        CommonTree FOLLOWING331_tree=null;
        CommonTree COLONCOLON332_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1742:3: ( CHILD COLONCOLON | DESCENDANT COLONCOLON | ATTRIBUTE COLONCOLON | SELF COLONCOLON | DESCENDANTORSELF COLONCOLON | FOLLOWINGSIBLING COLONCOLON | FOLLOWING COLONCOLON )
            int alt97=7;
            switch ( input.LA(1) ) {
            case CHILD:
                {
                alt97=1;
                }
                break;
            case DESCENDANT:
                {
                alt97=2;
                }
                break;
            case ATTRIBUTE:
                {
                alt97=3;
                }
                break;
            case SELF:
                {
                alt97=4;
                }
                break;
            case DESCENDANTORSELF:
                {
                alt97=5;
                }
                break;
            case FOLLOWINGSIBLING:
                {
                alt97=6;
                }
                break;
            case FOLLOWING:
                {
                alt97=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 97, 0, input);

                throw nvae;
            }

            switch (alt97) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1742:5: CHILD COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    CHILD319=(CommonTree)match(input,CHILD,FOLLOW_CHILD_in_forwardAxis7819); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    CHILD319_tree = (CommonTree)adaptor.dupNode(CHILD319);

                    adaptor.addChild(root_0, CHILD319_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON320=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7821); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON320_tree = (CommonTree)adaptor.dupNode(COLONCOLON320);

                    adaptor.addChild(root_0, COLONCOLON320_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1743:5: DESCENDANT COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    DESCENDANT321=(CommonTree)match(input,DESCENDANT,FOLLOW_DESCENDANT_in_forwardAxis7827); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    DESCENDANT321_tree = (CommonTree)adaptor.dupNode(DESCENDANT321);

                    adaptor.addChild(root_0, DESCENDANT321_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON322=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7829); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON322_tree = (CommonTree)adaptor.dupNode(COLONCOLON322);

                    adaptor.addChild(root_0, COLONCOLON322_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1744:5: ATTRIBUTE COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    ATTRIBUTE323=(CommonTree)match(input,ATTRIBUTE,FOLLOW_ATTRIBUTE_in_forwardAxis7835); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ATTRIBUTE323_tree = (CommonTree)adaptor.dupNode(ATTRIBUTE323);

                    adaptor.addChild(root_0, ATTRIBUTE323_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON324=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7837); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON324_tree = (CommonTree)adaptor.dupNode(COLONCOLON324);

                    adaptor.addChild(root_0, COLONCOLON324_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1745:5: SELF COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    SELF325=(CommonTree)match(input,SELF,FOLLOW_SELF_in_forwardAxis7843); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SELF325_tree = (CommonTree)adaptor.dupNode(SELF325);

                    adaptor.addChild(root_0, SELF325_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON326=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7845); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON326_tree = (CommonTree)adaptor.dupNode(COLONCOLON326);

                    adaptor.addChild(root_0, COLONCOLON326_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1746:5: DESCENDANTORSELF COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    DESCENDANTORSELF327=(CommonTree)match(input,DESCENDANTORSELF,FOLLOW_DESCENDANTORSELF_in_forwardAxis7851); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    DESCENDANTORSELF327_tree = (CommonTree)adaptor.dupNode(DESCENDANTORSELF327);

                    adaptor.addChild(root_0, DESCENDANTORSELF327_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON328=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7853); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON328_tree = (CommonTree)adaptor.dupNode(COLONCOLON328);

                    adaptor.addChild(root_0, COLONCOLON328_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1747:5: FOLLOWINGSIBLING COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    FOLLOWINGSIBLING329=(CommonTree)match(input,FOLLOWINGSIBLING,FOLLOW_FOLLOWINGSIBLING_in_forwardAxis7859); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    FOLLOWINGSIBLING329_tree = (CommonTree)adaptor.dupNode(FOLLOWINGSIBLING329);

                    adaptor.addChild(root_0, FOLLOWINGSIBLING329_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON330=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7861); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON330_tree = (CommonTree)adaptor.dupNode(COLONCOLON330);

                    adaptor.addChild(root_0, COLONCOLON330_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1748:5: FOLLOWING COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    FOLLOWING331=(CommonTree)match(input,FOLLOWING,FOLLOW_FOLLOWING_in_forwardAxis7867); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    FOLLOWING331_tree = (CommonTree)adaptor.dupNode(FOLLOWING331);

                    adaptor.addChild(root_0, FOLLOWING331_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON332=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7869); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON332_tree = (CommonTree)adaptor.dupNode(COLONCOLON332);

                    adaptor.addChild(root_0, COLONCOLON332_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forwardAxis"

    public static class abbrevForwardStep_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "abbrevForwardStep"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1751:1: abbrevForwardStep : ( AT )? nodeTest ;
    public final XSPARQLRewriter.abbrevForwardStep_return abbrevForwardStep() throws RecognitionException {
        XSPARQLRewriter.abbrevForwardStep_return retval = new XSPARQLRewriter.abbrevForwardStep_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree AT333=null;
        XSPARQLRewriter.nodeTest_return nodeTest334 = null;


        CommonTree AT333_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1752:3: ( ( AT )? nodeTest )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1752:5: ( AT )? nodeTest
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1752:5: ( AT )?
            int alt98=2;
            switch ( input.LA(1) ) {
                case AT:
                    {
                    alt98=1;
                    }
                    break;
            }

            switch (alt98) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: AT
                    {
                    _last = (CommonTree)input.LT(1);
                    AT333=(CommonTree)match(input,AT,FOLLOW_AT_in_abbrevForwardStep7882); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AT333_tree = (CommonTree)adaptor.dupNode(AT333);

                    adaptor.addChild(root_0, AT333_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_nodeTest_in_abbrevForwardStep7885);
            nodeTest334=nodeTest();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, nodeTest334.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "abbrevForwardStep"

    public static class reverseStep_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "reverseStep"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1755:1: reverseStep : ( reverseAxis nodeTest | abbrevReverseStep );
    public final XSPARQLRewriter.reverseStep_return reverseStep() throws RecognitionException {
        XSPARQLRewriter.reverseStep_return retval = new XSPARQLRewriter.reverseStep_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.reverseAxis_return reverseAxis335 = null;

        XSPARQLRewriter.nodeTest_return nodeTest336 = null;

        XSPARQLRewriter.abbrevReverseStep_return abbrevReverseStep337 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1756:3: ( reverseAxis nodeTest | abbrevReverseStep )
            int alt99=2;
            switch ( input.LA(1) ) {
            case PARENT:
            case ANCESTOR:
            case PRECEDINGSIBLING:
            case PRECEDING:
            case ANCESTORORSELF:
                {
                alt99=1;
                }
                break;
            case DOTDOT:
                {
                alt99=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 99, 0, input);

                throw nvae;
            }

            switch (alt99) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1756:5: reverseAxis nodeTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_reverseAxis_in_reverseStep7898);
                    reverseAxis335=reverseAxis();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, reverseAxis335.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_nodeTest_in_reverseStep7900);
                    nodeTest336=nodeTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, nodeTest336.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1757:5: abbrevReverseStep
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_abbrevReverseStep_in_reverseStep7906);
                    abbrevReverseStep337=abbrevReverseStep();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, abbrevReverseStep337.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "reverseStep"

    public static class reverseAxis_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "reverseAxis"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1760:1: reverseAxis : ( PARENT COLONCOLON | ANCESTOR COLONCOLON | PRECEDINGSIBLING COLONCOLON | PRECEDING COLONCOLON | ANCESTORORSELF COLONCOLON );
    public final XSPARQLRewriter.reverseAxis_return reverseAxis() throws RecognitionException {
        XSPARQLRewriter.reverseAxis_return retval = new XSPARQLRewriter.reverseAxis_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree PARENT338=null;
        CommonTree COLONCOLON339=null;
        CommonTree ANCESTOR340=null;
        CommonTree COLONCOLON341=null;
        CommonTree PRECEDINGSIBLING342=null;
        CommonTree COLONCOLON343=null;
        CommonTree PRECEDING344=null;
        CommonTree COLONCOLON345=null;
        CommonTree ANCESTORORSELF346=null;
        CommonTree COLONCOLON347=null;

        CommonTree PARENT338_tree=null;
        CommonTree COLONCOLON339_tree=null;
        CommonTree ANCESTOR340_tree=null;
        CommonTree COLONCOLON341_tree=null;
        CommonTree PRECEDINGSIBLING342_tree=null;
        CommonTree COLONCOLON343_tree=null;
        CommonTree PRECEDING344_tree=null;
        CommonTree COLONCOLON345_tree=null;
        CommonTree ANCESTORORSELF346_tree=null;
        CommonTree COLONCOLON347_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1761:3: ( PARENT COLONCOLON | ANCESTOR COLONCOLON | PRECEDINGSIBLING COLONCOLON | PRECEDING COLONCOLON | ANCESTORORSELF COLONCOLON )
            int alt100=5;
            switch ( input.LA(1) ) {
            case PARENT:
                {
                alt100=1;
                }
                break;
            case ANCESTOR:
                {
                alt100=2;
                }
                break;
            case PRECEDINGSIBLING:
                {
                alt100=3;
                }
                break;
            case PRECEDING:
                {
                alt100=4;
                }
                break;
            case ANCESTORORSELF:
                {
                alt100=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 100, 0, input);

                throw nvae;
            }

            switch (alt100) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1761:5: PARENT COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    PARENT338=(CommonTree)match(input,PARENT,FOLLOW_PARENT_in_reverseAxis7919); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    PARENT338_tree = (CommonTree)adaptor.dupNode(PARENT338);

                    adaptor.addChild(root_0, PARENT338_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON339=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_reverseAxis7921); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON339_tree = (CommonTree)adaptor.dupNode(COLONCOLON339);

                    adaptor.addChild(root_0, COLONCOLON339_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1762:5: ANCESTOR COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    ANCESTOR340=(CommonTree)match(input,ANCESTOR,FOLLOW_ANCESTOR_in_reverseAxis7927); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ANCESTOR340_tree = (CommonTree)adaptor.dupNode(ANCESTOR340);

                    adaptor.addChild(root_0, ANCESTOR340_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON341=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_reverseAxis7929); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON341_tree = (CommonTree)adaptor.dupNode(COLONCOLON341);

                    adaptor.addChild(root_0, COLONCOLON341_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1763:5: PRECEDINGSIBLING COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    PRECEDINGSIBLING342=(CommonTree)match(input,PRECEDINGSIBLING,FOLLOW_PRECEDINGSIBLING_in_reverseAxis7935); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    PRECEDINGSIBLING342_tree = (CommonTree)adaptor.dupNode(PRECEDINGSIBLING342);

                    adaptor.addChild(root_0, PRECEDINGSIBLING342_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON343=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_reverseAxis7937); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON343_tree = (CommonTree)adaptor.dupNode(COLONCOLON343);

                    adaptor.addChild(root_0, COLONCOLON343_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1764:5: PRECEDING COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    PRECEDING344=(CommonTree)match(input,PRECEDING,FOLLOW_PRECEDING_in_reverseAxis7943); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    PRECEDING344_tree = (CommonTree)adaptor.dupNode(PRECEDING344);

                    adaptor.addChild(root_0, PRECEDING344_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON345=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_reverseAxis7945); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON345_tree = (CommonTree)adaptor.dupNode(COLONCOLON345);

                    adaptor.addChild(root_0, COLONCOLON345_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1765:5: ANCESTORORSELF COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    ANCESTORORSELF346=(CommonTree)match(input,ANCESTORORSELF,FOLLOW_ANCESTORORSELF_in_reverseAxis7951); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ANCESTORORSELF346_tree = (CommonTree)adaptor.dupNode(ANCESTORORSELF346);

                    adaptor.addChild(root_0, ANCESTORORSELF346_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON347=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_reverseAxis7953); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON347_tree = (CommonTree)adaptor.dupNode(COLONCOLON347);

                    adaptor.addChild(root_0, COLONCOLON347_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "reverseAxis"

    public static class abbrevReverseStep_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "abbrevReverseStep"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1768:1: abbrevReverseStep : DOTDOT ;
    public final XSPARQLRewriter.abbrevReverseStep_return abbrevReverseStep() throws RecognitionException {
        XSPARQLRewriter.abbrevReverseStep_return retval = new XSPARQLRewriter.abbrevReverseStep_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DOTDOT348=null;

        CommonTree DOTDOT348_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1769:3: ( DOTDOT )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1769:5: DOTDOT
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DOTDOT348=(CommonTree)match(input,DOTDOT,FOLLOW_DOTDOT_in_abbrevReverseStep7966); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOTDOT348_tree = (CommonTree)adaptor.dupNode(DOTDOT348);

            adaptor.addChild(root_0, DOTDOT348_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "abbrevReverseStep"

    public static class nodeTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "nodeTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1772:1: nodeTest : ( kindTest | nameTest );
    public final XSPARQLRewriter.nodeTest_return nodeTest() throws RecognitionException {
        XSPARQLRewriter.nodeTest_return retval = new XSPARQLRewriter.nodeTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.kindTest_return kindTest349 = null;

        XSPARQLRewriter.nameTest_return nameTest350 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1773:3: ( kindTest | nameTest )
            int alt101=2;
            switch ( input.LA(1) ) {
            case ATTRIBUTE:
            case ELEMENT:
            case DOCUMENTNODE:
            case TEXT:
            case PROCESSINGINSTRUCTION:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
                {
                alt101=1;
                }
                break;
            case COMMENT:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt101=1;
                    }
                    break;
                case EOF:
                case UP:
                case SLASH:
                case LBRACKET:
                    {
                    alt101=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 101, 2, input);

                    throw nvae;
                }

                }
                break;
            case NODE:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt101=1;
                    }
                    break;
                case EOF:
                case UP:
                case SLASH:
                case LBRACKET:
                    {
                    alt101=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 101, 3, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
            case STAR:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case ROW:
                {
                alt101=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 101, 0, input);

                throw nvae;
            }

            switch (alt101) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1773:5: kindTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_kindTest_in_nodeTest7979);
                    kindTest349=kindTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, kindTest349.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1774:5: nameTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_nameTest_in_nodeTest7985);
                    nameTest350=nameTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, nameTest350.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "nodeTest"

    public static class nameTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "nameTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1777:1: nameTest : ( qname | wildCard );
    public final XSPARQLRewriter.nameTest_return nameTest() throws RecognitionException {
        XSPARQLRewriter.nameTest_return retval = new XSPARQLRewriter.nameTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname351 = null;

        XSPARQLRewriter.wildCard_return wildCard352 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1778:3: ( qname | wildCard )
            int alt102=2;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt102=1;
                }
                break;
            case NCNAME:
                {
                switch ( input.LA(2) ) {
                case COLON:
                    {
                    alt102=2;
                    }
                    break;
                case EOF:
                case UP:
                case SLASH:
                case LBRACKET:
                    {
                    alt102=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 102, 2, input);

                    throw nvae;
                }

                }
                break;
            case STAR:
                {
                alt102=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 102, 0, input);

                throw nvae;
            }

            switch (alt102) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1778:5: qname
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_nameTest7998);
                    qname351=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, qname351.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1779:5: wildCard
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_wildCard_in_nameTest8004);
                    wildCard352=wildCard();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, wildCard352.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "nameTest"

    public static class wildCard_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "wildCard"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1782:1: wildCard : ( STAR | STAR COLON NCNAME | NCNAME COLON STAR );
    public final XSPARQLRewriter.wildCard_return wildCard() throws RecognitionException {
        XSPARQLRewriter.wildCard_return retval = new XSPARQLRewriter.wildCard_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree STAR353=null;
        CommonTree STAR354=null;
        CommonTree COLON355=null;
        CommonTree NCNAME356=null;
        CommonTree NCNAME357=null;
        CommonTree COLON358=null;
        CommonTree STAR359=null;

        CommonTree STAR353_tree=null;
        CommonTree STAR354_tree=null;
        CommonTree COLON355_tree=null;
        CommonTree NCNAME356_tree=null;
        CommonTree NCNAME357_tree=null;
        CommonTree COLON358_tree=null;
        CommonTree STAR359_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1783:3: ( STAR | STAR COLON NCNAME | NCNAME COLON STAR )
            int alt103=3;
            switch ( input.LA(1) ) {
            case STAR:
                {
                switch ( input.LA(2) ) {
                case COLON:
                    {
                    alt103=2;
                    }
                    break;
                case EOF:
                case UP:
                case SLASH:
                case LBRACKET:
                    {
                    alt103=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 103, 1, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
                {
                alt103=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 103, 0, input);

                throw nvae;
            }

            switch (alt103) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1783:5: STAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    STAR353=(CommonTree)match(input,STAR,FOLLOW_STAR_in_wildCard8017); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    STAR353_tree = (CommonTree)adaptor.dupNode(STAR353);

                    adaptor.addChild(root_0, STAR353_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1784:5: STAR COLON NCNAME
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    STAR354=(CommonTree)match(input,STAR,FOLLOW_STAR_in_wildCard8023); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    STAR354_tree = (CommonTree)adaptor.dupNode(STAR354);

                    adaptor.addChild(root_0, STAR354_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLON355=(CommonTree)match(input,COLON,FOLLOW_COLON_in_wildCard8025); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLON355_tree = (CommonTree)adaptor.dupNode(COLON355);

                    adaptor.addChild(root_0, COLON355_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    NCNAME356=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_wildCard8027); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAME356_tree = (CommonTree)adaptor.dupNode(NCNAME356);

                    adaptor.addChild(root_0, NCNAME356_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1785:5: NCNAME COLON STAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    NCNAME357=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_wildCard8033); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAME357_tree = (CommonTree)adaptor.dupNode(NCNAME357);

                    adaptor.addChild(root_0, NCNAME357_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLON358=(CommonTree)match(input,COLON,FOLLOW_COLON_in_wildCard8035); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLON358_tree = (CommonTree)adaptor.dupNode(COLON358);

                    adaptor.addChild(root_0, COLON358_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    STAR359=(CommonTree)match(input,STAR,FOLLOW_STAR_in_wildCard8037); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    STAR359_tree = (CommonTree)adaptor.dupNode(STAR359);

                    adaptor.addChild(root_0, STAR359_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "wildCard"

    public static class filterExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "filterExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1788:1: filterExpr : primaryExpr predicateList ;
    public final XSPARQLRewriter.filterExpr_return filterExpr() throws RecognitionException {
        XSPARQLRewriter.filterExpr_return retval = new XSPARQLRewriter.filterExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.primaryExpr_return primaryExpr360 = null;

        XSPARQLRewriter.predicateList_return predicateList361 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1789:3: ( primaryExpr predicateList )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1789:5: primaryExpr predicateList
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_primaryExpr_in_filterExpr8050);
            primaryExpr360=primaryExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, primaryExpr360.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_predicateList_in_filterExpr8052);
            predicateList361=predicateList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, predicateList361.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "filterExpr"

    public static class predicateList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "predicateList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1792:1: predicateList : ( predicate )* ;
    public final XSPARQLRewriter.predicateList_return predicateList() throws RecognitionException {
        XSPARQLRewriter.predicateList_return retval = new XSPARQLRewriter.predicateList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.predicate_return predicate362 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1793:3: ( ( predicate )* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1793:5: ( predicate )*
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1793:5: ( predicate )*
            loop104:
            do {
                int alt104=2;
                switch ( input.LA(1) ) {
                case LBRACKET:
                    {
                    alt104=1;
                    }
                    break;

                }

                switch (alt104) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: predicate
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_predicate_in_predicateList8065);
            	    predicate362=predicate();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, predicate362.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop104;
                }
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "predicateList"

    public static class predicate_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "predicate"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1796:1: predicate : LBRACKET expr RBRACKET ;
    public final XSPARQLRewriter.predicate_return predicate() throws RecognitionException {
        XSPARQLRewriter.predicate_return retval = new XSPARQLRewriter.predicate_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree LBRACKET363=null;
        CommonTree RBRACKET365=null;
        XSPARQLRewriter.expr_return expr364 = null;


        CommonTree LBRACKET363_tree=null;
        CommonTree RBRACKET365_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1797:3: ( LBRACKET expr RBRACKET )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1797:5: LBRACKET expr RBRACKET
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            LBRACKET363=(CommonTree)match(input,LBRACKET,FOLLOW_LBRACKET_in_predicate8079); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LBRACKET363_tree = (CommonTree)adaptor.dupNode(LBRACKET363);

            adaptor.addChild(root_0, LBRACKET363_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_predicate8081);
            expr364=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr364.getTree());
            _last = (CommonTree)input.LT(1);
            RBRACKET365=(CommonTree)match(input,RBRACKET,FOLLOW_RBRACKET_in_predicate8083); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RBRACKET365_tree = (CommonTree)adaptor.dupNode(RBRACKET365);

            adaptor.addChild(root_0, RBRACKET365_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "predicate"

    public static class primaryExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "primaryExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1800:1: primaryExpr : ( varRef | literal | parenthesizedExpr | contextItemExpr | functionCall | orderedExpr | unorderedExpr | constructor );
    public final XSPARQLRewriter.primaryExpr_return primaryExpr() throws RecognitionException {
        XSPARQLRewriter.primaryExpr_return retval = new XSPARQLRewriter.primaryExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.varRef_return varRef366 = null;

        XSPARQLRewriter.literal_return literal367 = null;

        XSPARQLRewriter.parenthesizedExpr_return parenthesizedExpr368 = null;

        XSPARQLRewriter.contextItemExpr_return contextItemExpr369 = null;

        XSPARQLRewriter.functionCall_return functionCall370 = null;

        XSPARQLRewriter.orderedExpr_return orderedExpr371 = null;

        XSPARQLRewriter.unorderedExpr_return unorderedExpr372 = null;

        XSPARQLRewriter.constructor_return constructor373 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1801:3: ( varRef | literal | parenthesizedExpr | contextItemExpr | functionCall | orderedExpr | unorderedExpr | constructor )
            int alt105=8;
            switch ( input.LA(1) ) {
            case VAR:
                {
                alt105=1;
                }
                break;
            case INTEGER:
            case QSTRING:
            case DECIMAL:
                {
                alt105=2;
                }
                break;
            case T_PAR:
                {
                alt105=3;
                }
                break;
            case DOT:
                {
                alt105=4;
                }
                break;
            case T_FUNCTION_CALL:
                {
                alt105=5;
                }
                break;
            case ORDERED:
                {
                alt105=6;
                }
                break;
            case UNORDERED:
                {
                alt105=7;
                }
                break;
            case ATTRIBUTE:
            case ELEMENT:
            case TEXT:
            case COMMENT:
            case PROCESSINGINSTRUCTION:
            case DOCUMENT:
            case T_XML_ELEMENT:
                {
                alt105=8;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 105, 0, input);

                throw nvae;
            }

            switch (alt105) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1801:5: varRef
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_varRef_in_primaryExpr8096);
                    varRef366=varRef();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, varRef366.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1802:5: literal
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_literal_in_primaryExpr8102);
                    literal367=literal();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, literal367.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1803:5: parenthesizedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_parenthesizedExpr_in_primaryExpr8108);
                    parenthesizedExpr368=parenthesizedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, parenthesizedExpr368.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1804:5: contextItemExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_contextItemExpr_in_primaryExpr8114);
                    contextItemExpr369=contextItemExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, contextItemExpr369.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1805:5: functionCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_functionCall_in_primaryExpr8120);
                    functionCall370=functionCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, functionCall370.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1806:5: orderedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orderedExpr_in_primaryExpr8126);
                    orderedExpr371=orderedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, orderedExpr371.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1807:5: unorderedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unorderedExpr_in_primaryExpr8132);
                    unorderedExpr372=unorderedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, unorderedExpr372.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1808:5: constructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructor_in_primaryExpr8138);
                    constructor373=constructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, constructor373.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "primaryExpr"

    public static class literal_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "literal"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1811:1: literal : ( numericliteral | stringliteral );
    public final XSPARQLRewriter.literal_return literal() throws RecognitionException {
        XSPARQLRewriter.literal_return retval = new XSPARQLRewriter.literal_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.numericliteral_return numericliteral374 = null;

        XSPARQLRewriter.stringliteral_return stringliteral375 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1812:3: ( numericliteral | stringliteral )
            int alt106=2;
            switch ( input.LA(1) ) {
            case INTEGER:
            case DECIMAL:
                {
                alt106=1;
                }
                break;
            case QSTRING:
                {
                alt106=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 106, 0, input);

                throw nvae;
            }

            switch (alt106) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1812:5: numericliteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_numericliteral_in_literal8151);
                    numericliteral374=numericliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, numericliteral374.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1813:5: stringliteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_stringliteral_in_literal8157);
                    stringliteral375=stringliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, stringliteral375.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "literal"

    public static class numericliteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "numericliteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1816:1: numericliteral : ( integerLiteral | decimalLiteral );
    public final XSPARQLRewriter.numericliteral_return numericliteral() throws RecognitionException {
        XSPARQLRewriter.numericliteral_return retval = new XSPARQLRewriter.numericliteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.integerLiteral_return integerLiteral376 = null;

        XSPARQLRewriter.decimalLiteral_return decimalLiteral377 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1817:3: ( integerLiteral | decimalLiteral )
            int alt107=2;
            switch ( input.LA(1) ) {
            case INTEGER:
                {
                alt107=1;
                }
                break;
            case DECIMAL:
                {
                alt107=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 107, 0, input);

                throw nvae;
            }

            switch (alt107) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1817:5: integerLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_integerLiteral_in_numericliteral8170);
                    integerLiteral376=integerLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, integerLiteral376.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1818:5: decimalLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_decimalLiteral_in_numericliteral8176);
                    decimalLiteral377=decimalLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, decimalLiteral377.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "numericliteral"

    public static class varRef_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varRef"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1822:1: varRef : v= VAR -> { isBound($v.text, Types.SPARQL) || $relativePathExpr::rdbVar }? ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_typeData\"] ^( T_PARAMS $v) ) -> $v;
    public final XSPARQLRewriter.varRef_return varRef() throws RecognitionException {
        XSPARQLRewriter.varRef_return retval = new XSPARQLRewriter.varRef_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree v=null;

        CommonTree v_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1823:3: (v= VAR -> { isBound($v.text, Types.SPARQL) || $relativePathExpr::rdbVar }? ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_typeData\"] ^( T_PARAMS $v) ) -> $v)
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1823:5: v= VAR
            {
            _last = (CommonTree)input.LT(1);
            v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varRef8195); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_VAR.add(v);

            if ( state.backtracking==0 ) {
               ((relativePathExpr_scope)relativePathExpr_stack.peek()).rdbVar = isBound((v!=null?v.getText():null), Types.SQL); 
            }


            // AST REWRITE
            // elements: v, v
            // token labels: v
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleNodeStream stream_v=new RewriteRuleNodeStream(adaptor,"token v",v);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1824:5: -> { isBound($v.text, Types.SPARQL) || $relativePathExpr::rdbVar }? ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_typeData\"] ^( T_PARAMS $v) )
            if ( isBound((v!=null?v.getText():null), Types.SPARQL) || ((relativePathExpr_scope)relativePathExpr_stack.peek()).rdbVar ) {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1824:73: ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_typeData\"] ^( T_PARAMS $v) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, "_xsparql:_typeData"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1824:120: ^( T_PARAMS $v)
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                adaptor.addChild(root_2, stream_v.nextNode());

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }
            else // 1825:5: -> $v
            {
                adaptor.addChild(root_0, stream_v.nextNode());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varRef"

    public static class varName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1828:1: varName : qname ;
    public final XSPARQLRewriter.varName_return varName() throws RecognitionException {
        XSPARQLRewriter.varName_return retval = new XSPARQLRewriter.varName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname378 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1829:3: ( qname )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1829:5: qname
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_varName8242);
            qname378=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, qname378.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varName"

    public static class parenthesizedExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "parenthesizedExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1832:1: parenthesizedExpr : ^( T_PAR ( expr )? ) ;
    public final XSPARQLRewriter.parenthesizedExpr_return parenthesizedExpr() throws RecognitionException {
        XSPARQLRewriter.parenthesizedExpr_return retval = new XSPARQLRewriter.parenthesizedExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_PAR379=null;
        XSPARQLRewriter.expr_return expr380 = null;


        CommonTree T_PAR379_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1833:3: ( ^( T_PAR ( expr )? ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1833:5: ^( T_PAR ( expr )? )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_PAR379=(CommonTree)match(input,T_PAR,FOLLOW_T_PAR_in_parenthesizedExpr8256); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_PAR379_tree = (CommonTree)adaptor.dupNode(T_PAR379);

            root_1 = (CommonTree)adaptor.becomeRoot(T_PAR379_tree, root_1);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1833:13: ( expr )?
                int alt108=2;
                switch ( input.LA(1) ) {
                    case LCURLY:
                    case STAR:
                    case LESSTHAN:
                    case GREATERTHAN:
                    case PLUS:
                    case MINUS:
                    case UNIONSYMBOL:
                    case LESSTHANLESSTHAN:
                    case GREATERTHANEQUALS:
                    case LESSTHANEQUALS:
                    case HAFENEQUALS:
                    case EQUALS:
                    case IS:
                    case EQ:
                    case NE:
                    case LT:
                    case GE:
                    case LE:
                    case GT:
                    case IF:
                    case AND:
                    case OR:
                    case TO:
                    case DIV:
                    case IDIV:
                    case MOD:
                    case UNION:
                    case INTERSECT:
                    case EXCEPT:
                    case GREATERTHANGREATERTHAN:
                    case T_FLWOR:
                    case T_INSTANCEOF:
                    case T_CASTAS:
                    case T_CASTABLEAS:
                    case T_TREATAS:
                    case EVERY:
                    case TYPESWITCH:
                    case VALIDATE:
                    case SOME:
                    case XPATH:
                        {
                        alt108=1;
                        }
                        break;
                }

                switch (alt108) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: expr
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_expr_in_parenthesizedExpr8258);
                        expr380=expr();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) 
                        adaptor.addChild(root_1, expr380.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "parenthesizedExpr"

    public static class contextItemExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "contextItemExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1836:1: contextItemExpr : DOT ;
    public final XSPARQLRewriter.contextItemExpr_return contextItemExpr() throws RecognitionException {
        XSPARQLRewriter.contextItemExpr_return retval = new XSPARQLRewriter.contextItemExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DOT381=null;

        CommonTree DOT381_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1837:3: ( DOT )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1837:5: DOT
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DOT381=(CommonTree)match(input,DOT,FOLLOW_DOT_in_contextItemExpr8273); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOT381_tree = (CommonTree)adaptor.dupNode(DOT381);

            adaptor.addChild(root_0, DOT381_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "contextItemExpr"

    public static class orderedExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderedExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1840:1: orderedExpr : ORDERED expr ;
    public final XSPARQLRewriter.orderedExpr_return orderedExpr() throws RecognitionException {
        XSPARQLRewriter.orderedExpr_return retval = new XSPARQLRewriter.orderedExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ORDERED382=null;
        XSPARQLRewriter.expr_return expr383 = null;


        CommonTree ORDERED382_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1841:3: ( ORDERED expr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1841:5: ORDERED expr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ORDERED382=(CommonTree)match(input,ORDERED,FOLLOW_ORDERED_in_orderedExpr8286); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ORDERED382_tree = (CommonTree)adaptor.dupNode(ORDERED382);

            adaptor.addChild(root_0, ORDERED382_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_orderedExpr8288);
            expr383=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr383.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderedExpr"

    public static class unorderedExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unorderedExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1844:1: unorderedExpr : UNORDERED expr ;
    public final XSPARQLRewriter.unorderedExpr_return unorderedExpr() throws RecognitionException {
        XSPARQLRewriter.unorderedExpr_return retval = new XSPARQLRewriter.unorderedExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree UNORDERED384=null;
        XSPARQLRewriter.expr_return expr385 = null;


        CommonTree UNORDERED384_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1845:3: ( UNORDERED expr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1845:5: UNORDERED expr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            UNORDERED384=(CommonTree)match(input,UNORDERED,FOLLOW_UNORDERED_in_unorderedExpr8301); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            UNORDERED384_tree = (CommonTree)adaptor.dupNode(UNORDERED384);

            adaptor.addChild(root_0, UNORDERED384_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_unorderedExpr8303);
            expr385=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr385.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unorderedExpr"

    public static class functionCall_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "functionCall"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1848:1: functionCall : ^( T_FUNCTION_CALL qname ^( T_PARAMS ( exprSingle )* ) ) ;
    public final XSPARQLRewriter.functionCall_return functionCall() throws RecognitionException {
        XSPARQLRewriter.functionCall_return retval = new XSPARQLRewriter.functionCall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_FUNCTION_CALL386=null;
        CommonTree T_PARAMS388=null;
        XSPARQLRewriter.qname_return qname387 = null;

        XSPARQLRewriter.exprSingle_return exprSingle389 = null;


        CommonTree T_FUNCTION_CALL386_tree=null;
        CommonTree T_PARAMS388_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1849:3: ( ^( T_FUNCTION_CALL qname ^( T_PARAMS ( exprSingle )* ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1849:6: ^( T_FUNCTION_CALL qname ^( T_PARAMS ( exprSingle )* ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_FUNCTION_CALL386=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_functionCall8318); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_FUNCTION_CALL386_tree = (CommonTree)adaptor.dupNode(T_FUNCTION_CALL386);

            root_1 = (CommonTree)adaptor.becomeRoot(T_FUNCTION_CALL386_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_functionCall8320);
            qname387=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, qname387.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_PARAMS388=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_functionCall8323); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_PARAMS388_tree = (CommonTree)adaptor.dupNode(T_PARAMS388);

            root_2 = (CommonTree)adaptor.becomeRoot(T_PARAMS388_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1849:41: ( exprSingle )*
                loop109:
                do {
                    int alt109=2;
                    switch ( input.LA(1) ) {
                    case LCURLY:
                    case STAR:
                    case LESSTHAN:
                    case GREATERTHAN:
                    case PLUS:
                    case MINUS:
                    case UNIONSYMBOL:
                    case LESSTHANLESSTHAN:
                    case GREATERTHANEQUALS:
                    case LESSTHANEQUALS:
                    case HAFENEQUALS:
                    case EQUALS:
                    case IS:
                    case EQ:
                    case NE:
                    case LT:
                    case GE:
                    case LE:
                    case GT:
                    case IF:
                    case AND:
                    case OR:
                    case TO:
                    case DIV:
                    case IDIV:
                    case MOD:
                    case UNION:
                    case INTERSECT:
                    case EXCEPT:
                    case GREATERTHANGREATERTHAN:
                    case T_FLWOR:
                    case T_INSTANCEOF:
                    case T_CASTAS:
                    case T_CASTABLEAS:
                    case T_TREATAS:
                    case EVERY:
                    case TYPESWITCH:
                    case VALIDATE:
                    case SOME:
                    case XPATH:
                        {
                        alt109=1;
                        }
                        break;

                    }

                    switch (alt109) {
                	case 1 :
                	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: exprSingle
                	    {
                	    _last = (CommonTree)input.LT(1);
                	    pushFollow(FOLLOW_exprSingle_in_functionCall8325);
                	    exprSingle389=exprSingle();

                	    state._fsp--;
                	    if (state.failed) return retval;
                	    if ( state.backtracking==0 ) 
                	    adaptor.addChild(root_2, exprSingle389.getTree());

                	    if ( state.backtracking==0 ) {
                	    }
                	    }
                	    break;

                	default :
                	    break loop109;
                    }
                } while (true);


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "functionCall"

    public static class constructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1852:1: constructor : ( directConstructor | computedConstructor );
    public final XSPARQLRewriter.constructor_return constructor() throws RecognitionException {
        XSPARQLRewriter.constructor_return retval = new XSPARQLRewriter.constructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.directConstructor_return directConstructor390 = null;

        XSPARQLRewriter.computedConstructor_return computedConstructor391 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1853:3: ( directConstructor | computedConstructor )
            int alt110=2;
            switch ( input.LA(1) ) {
            case T_XML_ELEMENT:
                {
                alt110=1;
                }
                break;
            case ATTRIBUTE:
            case ELEMENT:
            case TEXT:
            case COMMENT:
            case PROCESSINGINSTRUCTION:
            case DOCUMENT:
                {
                alt110=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 110, 0, input);

                throw nvae;
            }

            switch (alt110) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1853:5: directConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_directConstructor_in_constructor8341);
                    directConstructor390=directConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, directConstructor390.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1854:5: computedConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_computedConstructor_in_constructor8347);
                    computedConstructor391=computedConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, computedConstructor391.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constructor"

    public static class directConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "directConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1857:1: directConstructor : dirElemConstructor ;
    public final XSPARQLRewriter.directConstructor_return directConstructor() throws RecognitionException {
        XSPARQLRewriter.directConstructor_return retval = new XSPARQLRewriter.directConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.dirElemConstructor_return dirElemConstructor392 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1858:3: ( dirElemConstructor )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1858:5: dirElemConstructor
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_dirElemConstructor_in_directConstructor8360);
            dirElemConstructor392=dirElemConstructor();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, dirElemConstructor392.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "directConstructor"

    public static class dirElemConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dirElemConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1863:1: dirElemConstructor : ^( T_XML_ELEMENT qname ( dirAttributeList )? ( ^( T_XML_CONTENT dirElemContent ) )* ) ;
    public final XSPARQLRewriter.dirElemConstructor_return dirElemConstructor() throws RecognitionException {
        XSPARQLRewriter.dirElemConstructor_return retval = new XSPARQLRewriter.dirElemConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_XML_ELEMENT393=null;
        CommonTree T_XML_CONTENT396=null;
        XSPARQLRewriter.qname_return qname394 = null;

        XSPARQLRewriter.dirAttributeList_return dirAttributeList395 = null;

        XSPARQLRewriter.dirElemContent_return dirElemContent397 = null;


        CommonTree T_XML_ELEMENT393_tree=null;
        CommonTree T_XML_CONTENT396_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1864:3: ( ^( T_XML_ELEMENT qname ( dirAttributeList )? ( ^( T_XML_CONTENT dirElemContent ) )* ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1864:5: ^( T_XML_ELEMENT qname ( dirAttributeList )? ( ^( T_XML_CONTENT dirElemContent ) )* )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_XML_ELEMENT393=(CommonTree)match(input,T_XML_ELEMENT,FOLLOW_T_XML_ELEMENT_in_dirElemConstructor8376); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_XML_ELEMENT393_tree = (CommonTree)adaptor.dupNode(T_XML_ELEMENT393);

            root_1 = (CommonTree)adaptor.becomeRoot(T_XML_ELEMENT393_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_dirElemConstructor8378);
            qname394=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, qname394.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1864:27: ( dirAttributeList )?
            int alt111=2;
            switch ( input.LA(1) ) {
                case T_XML_ATTRIBUTE:
                    {
                    alt111=1;
                    }
                    break;
            }

            switch (alt111) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: dirAttributeList
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_dirAttributeList_in_dirElemConstructor8380);
                    dirAttributeList395=dirAttributeList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, dirAttributeList395.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1864:45: ( ^( T_XML_CONTENT dirElemContent ) )*
            loop112:
            do {
                int alt112=2;
                switch ( input.LA(1) ) {
                case T_XML_CONTENT:
                    {
                    alt112=1;
                    }
                    break;

                }

                switch (alt112) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1864:46: ^( T_XML_CONTENT dirElemContent )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_2 = _last;
            	    CommonTree _first_2 = null;
            	    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_XML_CONTENT396=(CommonTree)match(input,T_XML_CONTENT,FOLLOW_T_XML_CONTENT_in_dirElemConstructor8385); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    T_XML_CONTENT396_tree = (CommonTree)adaptor.dupNode(T_XML_CONTENT396);

            	    root_2 = (CommonTree)adaptor.becomeRoot(T_XML_CONTENT396_tree, root_2);
            	    }


            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_dirElemContent_in_dirElemConstructor8387);
            	    dirElemContent397=dirElemContent();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_2, dirElemContent397.getTree());

            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop112;
                }
            } while (true);


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dirElemConstructor"

    public static class dirAttributeList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dirAttributeList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1867:1: dirAttributeList : ( dirAttribute )+ ;
    public final XSPARQLRewriter.dirAttributeList_return dirAttributeList() throws RecognitionException {
        XSPARQLRewriter.dirAttributeList_return retval = new XSPARQLRewriter.dirAttributeList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.dirAttribute_return dirAttribute398 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1868:3: ( ( dirAttribute )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1868:6: ( dirAttribute )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1868:6: ( dirAttribute )+
            int cnt113=0;
            loop113:
            do {
                int alt113=2;
                switch ( input.LA(1) ) {
                case T_XML_ATTRIBUTE:
                    {
                    alt113=1;
                    }
                    break;

                }

                switch (alt113) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: dirAttribute
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_dirAttribute_in_dirAttributeList8406);
            	    dirAttribute398=dirAttribute();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, dirAttribute398.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt113 >= 1 ) break loop113;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(113, input);
                        throw eee;
                }
                cnt113++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dirAttributeList"

    public static class dirAttribute_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dirAttribute"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1871:1: dirAttribute : ^( T_XML_ATTRIBUTE qname dirAttributeValue ) ;
    public final XSPARQLRewriter.dirAttribute_return dirAttribute() throws RecognitionException {
        XSPARQLRewriter.dirAttribute_return retval = new XSPARQLRewriter.dirAttribute_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_XML_ATTRIBUTE399=null;
        XSPARQLRewriter.qname_return qname400 = null;

        XSPARQLRewriter.dirAttributeValue_return dirAttributeValue401 = null;


        CommonTree T_XML_ATTRIBUTE399_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1872:3: ( ^( T_XML_ATTRIBUTE qname dirAttributeValue ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1872:5: ^( T_XML_ATTRIBUTE qname dirAttributeValue )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_XML_ATTRIBUTE399=(CommonTree)match(input,T_XML_ATTRIBUTE,FOLLOW_T_XML_ATTRIBUTE_in_dirAttribute8421); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_XML_ATTRIBUTE399_tree = (CommonTree)adaptor.dupNode(T_XML_ATTRIBUTE399);

            root_1 = (CommonTree)adaptor.becomeRoot(T_XML_ATTRIBUTE399_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_dirAttribute8423);
            qname400=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, qname400.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_dirAttributeValue_in_dirAttribute8425);
            dirAttributeValue401=dirAttributeValue();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, dirAttributeValue401.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dirAttribute"

    public static class dirAttributeValue_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dirAttributeValue"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1875:1: dirAttributeValue : ( enclosedExpr | QSTRING );
    public final XSPARQLRewriter.dirAttributeValue_return dirAttributeValue() throws RecognitionException {
        XSPARQLRewriter.dirAttributeValue_return retval = new XSPARQLRewriter.dirAttributeValue_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree QSTRING403=null;
        XSPARQLRewriter.enclosedExpr_return enclosedExpr402 = null;


        CommonTree QSTRING403_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1876:3: ( enclosedExpr | QSTRING )
            int alt114=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt114=1;
                }
                break;
            case QSTRING:
                {
                alt114=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 114, 0, input);

                throw nvae;
            }

            switch (alt114) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1876:5: enclosedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_dirAttributeValue8439);
                    enclosedExpr402=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, enclosedExpr402.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1877:5: QSTRING
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    QSTRING403=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_dirAttributeValue8445); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    QSTRING403_tree = (CommonTree)adaptor.dupNode(QSTRING403);

                    adaptor.addChild(root_0, QSTRING403_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dirAttributeValue"

    public static class dirElemContent_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dirElemContent"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1880:1: dirElemContent : ( directConstructor | commonContent | WHITESPACE | NCNAMEELM | cDataSection );
    public final XSPARQLRewriter.dirElemContent_return dirElemContent() throws RecognitionException {
        XSPARQLRewriter.dirElemContent_return retval = new XSPARQLRewriter.dirElemContent_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree WHITESPACE406=null;
        CommonTree NCNAMEELM407=null;
        XSPARQLRewriter.directConstructor_return directConstructor404 = null;

        XSPARQLRewriter.commonContent_return commonContent405 = null;

        XSPARQLRewriter.cDataSection_return cDataSection408 = null;


        CommonTree WHITESPACE406_tree=null;
        CommonTree NCNAMEELM407_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1881:3: ( directConstructor | commonContent | WHITESPACE | NCNAMEELM | cDataSection )
            int alt115=5;
            switch ( input.LA(1) ) {
            case T_XML_ELEMENT:
                {
                alt115=1;
                }
                break;
            case LCURLY:
            case RCURLY:
                {
                alt115=2;
                }
                break;
            case WHITESPACE:
                {
                alt115=3;
                }
                break;
            case NCNAMEELM:
                {
                alt115=4;
                }
                break;
            case CDATASTART:
                {
                alt115=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 115, 0, input);

                throw nvae;
            }

            switch (alt115) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1881:5: directConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_directConstructor_in_dirElemContent8458);
                    directConstructor404=directConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, directConstructor404.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1882:5: commonContent
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_commonContent_in_dirElemContent8464);
                    commonContent405=commonContent();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, commonContent405.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1883:5: WHITESPACE
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    WHITESPACE406=(CommonTree)match(input,WHITESPACE,FOLLOW_WHITESPACE_in_dirElemContent8470); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    WHITESPACE406_tree = (CommonTree)adaptor.dupNode(WHITESPACE406);

                    adaptor.addChild(root_0, WHITESPACE406_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1884:5: NCNAMEELM
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    NCNAMEELM407=(CommonTree)match(input,NCNAMEELM,FOLLOW_NCNAMEELM_in_dirElemContent8477); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAMEELM407_tree = (CommonTree)adaptor.dupNode(NCNAMEELM407);

                    adaptor.addChild(root_0, NCNAMEELM407_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1885:5: cDataSection
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_cDataSection_in_dirElemContent8484);
                    cDataSection408=cDataSection();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, cDataSection408.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dirElemContent"

    public static class commonContent_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "commonContent"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1888:1: commonContent : ( LCURLY expr RCURLY -> ^( T_XML_CONTENTS expr ) | LCURLY LCURLY | RCURLY RCURLY );
    public final XSPARQLRewriter.commonContent_return commonContent() throws RecognitionException {
        XSPARQLRewriter.commonContent_return retval = new XSPARQLRewriter.commonContent_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree LCURLY409=null;
        CommonTree RCURLY411=null;
        CommonTree LCURLY412=null;
        CommonTree LCURLY413=null;
        CommonTree RCURLY414=null;
        CommonTree RCURLY415=null;
        XSPARQLRewriter.expr_return expr410 = null;


        CommonTree LCURLY409_tree=null;
        CommonTree RCURLY411_tree=null;
        CommonTree LCURLY412_tree=null;
        CommonTree LCURLY413_tree=null;
        CommonTree RCURLY414_tree=null;
        CommonTree RCURLY415_tree=null;
        RewriteRuleNodeStream stream_LCURLY=new RewriteRuleNodeStream(adaptor,"token LCURLY");
        RewriteRuleNodeStream stream_RCURLY=new RewriteRuleNodeStream(adaptor,"token RCURLY");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1889:3: ( LCURLY expr RCURLY -> ^( T_XML_CONTENTS expr ) | LCURLY LCURLY | RCURLY RCURLY )
            int alt116=3;
            switch ( input.LA(1) ) {
            case LCURLY:
                {
                switch ( input.LA(2) ) {
                case LCURLY:
                    {
                    switch ( input.LA(3) ) {
                    case EOF:
                    case UP:
                        {
                        alt116=2;
                        }
                        break;
                    case LCURLY:
                    case RCURLY:
                    case STAR:
                    case LESSTHAN:
                    case GREATERTHAN:
                    case PLUS:
                    case MINUS:
                    case UNIONSYMBOL:
                    case LESSTHANLESSTHAN:
                    case GREATERTHANEQUALS:
                    case LESSTHANEQUALS:
                    case HAFENEQUALS:
                    case EQUALS:
                    case IS:
                    case EQ:
                    case NE:
                    case LT:
                    case GE:
                    case LE:
                    case GT:
                    case IF:
                    case AND:
                    case OR:
                    case TO:
                    case DIV:
                    case IDIV:
                    case MOD:
                    case UNION:
                    case INTERSECT:
                    case EXCEPT:
                    case GREATERTHANGREATERTHAN:
                    case T_FLWOR:
                    case T_INSTANCEOF:
                    case T_CASTAS:
                    case T_CASTABLEAS:
                    case T_TREATAS:
                    case EVERY:
                    case TYPESWITCH:
                    case VALIDATE:
                    case SOME:
                    case XPATH:
                        {
                        alt116=1;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 116, 3, input);

                        throw nvae;
                    }

                    }
                    break;
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt116=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 116, 1, input);

                    throw nvae;
                }

                }
                break;
            case RCURLY:
                {
                alt116=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 116, 0, input);

                throw nvae;
            }

            switch (alt116) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1889:5: LCURLY expr RCURLY
                    {
                    _last = (CommonTree)input.LT(1);
                    LCURLY409=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_commonContent8497); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LCURLY.add(LCURLY409);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expr_in_commonContent8499);
                    expr410=expr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expr.add(expr410.getTree());
                    _last = (CommonTree)input.LT(1);
                    RCURLY411=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_commonContent8501); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RCURLY.add(RCURLY411);



                    // AST REWRITE
                    // elements: expr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1889:24: -> ^( T_XML_CONTENTS expr )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1889:27: ^( T_XML_CONTENTS expr )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_XML_CONTENTS, "T_XML_CONTENTS"), root_1);

                        adaptor.addChild(root_1, stream_expr.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1890:5: LCURLY LCURLY
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    LCURLY412=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_commonContent8515); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    LCURLY412_tree = (CommonTree)adaptor.dupNode(LCURLY412);

                    adaptor.addChild(root_0, LCURLY412_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    LCURLY413=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_commonContent8517); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    LCURLY413_tree = (CommonTree)adaptor.dupNode(LCURLY413);

                    adaptor.addChild(root_0, LCURLY413_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1891:5: RCURLY RCURLY
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    RCURLY414=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_commonContent8523); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    RCURLY414_tree = (CommonTree)adaptor.dupNode(RCURLY414);

                    adaptor.addChild(root_0, RCURLY414_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    RCURLY415=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_commonContent8525); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    RCURLY415_tree = (CommonTree)adaptor.dupNode(RCURLY415);

                    adaptor.addChild(root_0, RCURLY415_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "commonContent"

    public static class cDataSection_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "cDataSection"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1894:1: cDataSection : CDATASTART CDATAELMEND ;
    public final XSPARQLRewriter.cDataSection_return cDataSection() throws RecognitionException {
        XSPARQLRewriter.cDataSection_return retval = new XSPARQLRewriter.cDataSection_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree CDATASTART416=null;
        CommonTree CDATAELMEND417=null;

        CommonTree CDATASTART416_tree=null;
        CommonTree CDATAELMEND417_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1895:3: ( CDATASTART CDATAELMEND )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1895:5: CDATASTART CDATAELMEND
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            CDATASTART416=(CommonTree)match(input,CDATASTART,FOLLOW_CDATASTART_in_cDataSection8538); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            CDATASTART416_tree = (CommonTree)adaptor.dupNode(CDATASTART416);

            adaptor.addChild(root_0, CDATASTART416_tree);
            }
            _last = (CommonTree)input.LT(1);
            CDATAELMEND417=(CommonTree)match(input,CDATAELMEND,FOLLOW_CDATAELMEND_in_cDataSection8540); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            CDATAELMEND417_tree = (CommonTree)adaptor.dupNode(CDATAELMEND417);

            adaptor.addChild(root_0, CDATAELMEND417_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "cDataSection"

    public static class computedConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "computedConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1898:1: computedConstructor : ( compDocConstructor | compElemConstructor | compAttrConstructor | compTextConstructor | compCommentConstructor | compPIConstructor );
    public final XSPARQLRewriter.computedConstructor_return computedConstructor() throws RecognitionException {
        XSPARQLRewriter.computedConstructor_return retval = new XSPARQLRewriter.computedConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.compDocConstructor_return compDocConstructor418 = null;

        XSPARQLRewriter.compElemConstructor_return compElemConstructor419 = null;

        XSPARQLRewriter.compAttrConstructor_return compAttrConstructor420 = null;

        XSPARQLRewriter.compTextConstructor_return compTextConstructor421 = null;

        XSPARQLRewriter.compCommentConstructor_return compCommentConstructor422 = null;

        XSPARQLRewriter.compPIConstructor_return compPIConstructor423 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1899:3: ( compDocConstructor | compElemConstructor | compAttrConstructor | compTextConstructor | compCommentConstructor | compPIConstructor )
            int alt117=6;
            switch ( input.LA(1) ) {
            case DOCUMENT:
                {
                alt117=1;
                }
                break;
            case ELEMENT:
                {
                alt117=2;
                }
                break;
            case ATTRIBUTE:
                {
                alt117=3;
                }
                break;
            case TEXT:
                {
                alt117=4;
                }
                break;
            case COMMENT:
                {
                alt117=5;
                }
                break;
            case PROCESSINGINSTRUCTION:
                {
                alt117=6;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 117, 0, input);

                throw nvae;
            }

            switch (alt117) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1899:5: compDocConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compDocConstructor_in_computedConstructor8553);
                    compDocConstructor418=compDocConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compDocConstructor418.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1900:5: compElemConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compElemConstructor_in_computedConstructor8559);
                    compElemConstructor419=compElemConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compElemConstructor419.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1901:5: compAttrConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compAttrConstructor_in_computedConstructor8565);
                    compAttrConstructor420=compAttrConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compAttrConstructor420.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1902:5: compTextConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compTextConstructor_in_computedConstructor8571);
                    compTextConstructor421=compTextConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compTextConstructor421.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1903:5: compCommentConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compCommentConstructor_in_computedConstructor8577);
                    compCommentConstructor422=compCommentConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compCommentConstructor422.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1904:5: compPIConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compPIConstructor_in_computedConstructor8583);
                    compPIConstructor423=compPIConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compPIConstructor423.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "computedConstructor"

    public static class compDocConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compDocConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1907:1: compDocConstructor : DOCUMENT enclosedExpr ;
    public final XSPARQLRewriter.compDocConstructor_return compDocConstructor() throws RecognitionException {
        XSPARQLRewriter.compDocConstructor_return retval = new XSPARQLRewriter.compDocConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DOCUMENT424=null;
        XSPARQLRewriter.enclosedExpr_return enclosedExpr425 = null;


        CommonTree DOCUMENT424_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1908:3: ( DOCUMENT enclosedExpr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1908:5: DOCUMENT enclosedExpr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DOCUMENT424=(CommonTree)match(input,DOCUMENT,FOLLOW_DOCUMENT_in_compDocConstructor8596); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOCUMENT424_tree = (CommonTree)adaptor.dupNode(DOCUMENT424);

            adaptor.addChild(root_0, DOCUMENT424_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_enclosedExpr_in_compDocConstructor8598);
            enclosedExpr425=enclosedExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, enclosedExpr425.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compDocConstructor"

    public static class compElemConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compElemConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1911:1: compElemConstructor : ELEMENT ( qname | enclosedExpr_ ) LCURLY ( contentExpr )? RCURLY ;
    public final XSPARQLRewriter.compElemConstructor_return compElemConstructor() throws RecognitionException {
        XSPARQLRewriter.compElemConstructor_return retval = new XSPARQLRewriter.compElemConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ELEMENT426=null;
        CommonTree LCURLY429=null;
        CommonTree RCURLY431=null;
        XSPARQLRewriter.qname_return qname427 = null;

        XSPARQLRewriter.enclosedExpr__return enclosedExpr_428 = null;

        XSPARQLRewriter.contentExpr_return contentExpr430 = null;


        CommonTree ELEMENT426_tree=null;
        CommonTree LCURLY429_tree=null;
        CommonTree RCURLY431_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1912:3: ( ELEMENT ( qname | enclosedExpr_ ) LCURLY ( contentExpr )? RCURLY )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1912:5: ELEMENT ( qname | enclosedExpr_ ) LCURLY ( contentExpr )? RCURLY
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ELEMENT426=(CommonTree)match(input,ELEMENT,FOLLOW_ELEMENT_in_compElemConstructor8611); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ELEMENT426_tree = (CommonTree)adaptor.dupNode(ELEMENT426);

            adaptor.addChild(root_0, ELEMENT426_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1912:13: ( qname | enclosedExpr_ )
            int alt118=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt118=1;
                }
                break;
            case LCURLY:
                {
                alt118=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 118, 0, input);

                throw nvae;
            }

            switch (alt118) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1912:15: qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_compElemConstructor8615);
                    qname427=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, qname427.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1912:23: enclosedExpr_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr__in_compElemConstructor8619);
                    enclosedExpr_428=enclosedExpr_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, enclosedExpr_428.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            LCURLY429=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_compElemConstructor8622); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LCURLY429_tree = (CommonTree)adaptor.dupNode(LCURLY429);

            adaptor.addChild(root_0, LCURLY429_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1912:45: ( contentExpr )?
            int alt119=2;
            switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt119=1;
                    }
                    break;
            }

            switch (alt119) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: contentExpr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_contentExpr_in_compElemConstructor8624);
                    contentExpr430=contentExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, contentExpr430.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RCURLY431=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_compElemConstructor8627); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RCURLY431_tree = (CommonTree)adaptor.dupNode(RCURLY431);

            adaptor.addChild(root_0, RCURLY431_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compElemConstructor"

    public static class contentExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "contentExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1915:1: contentExpr : expr ;
    public final XSPARQLRewriter.contentExpr_return contentExpr() throws RecognitionException {
        XSPARQLRewriter.contentExpr_return retval = new XSPARQLRewriter.contentExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.expr_return expr432 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1916:3: ( expr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1916:5: expr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_contentExpr8640);
            expr432=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr432.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "contentExpr"

    public static class compAttrConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compAttrConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1919:1: compAttrConstructor : ATTRIBUTE ( qname | enclosedExpr ) LCURLY ( expr )? RCURLY ;
    public final XSPARQLRewriter.compAttrConstructor_return compAttrConstructor() throws RecognitionException {
        XSPARQLRewriter.compAttrConstructor_return retval = new XSPARQLRewriter.compAttrConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ATTRIBUTE433=null;
        CommonTree LCURLY436=null;
        CommonTree RCURLY438=null;
        XSPARQLRewriter.qname_return qname434 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr435 = null;

        XSPARQLRewriter.expr_return expr437 = null;


        CommonTree ATTRIBUTE433_tree=null;
        CommonTree LCURLY436_tree=null;
        CommonTree RCURLY438_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1920:3: ( ATTRIBUTE ( qname | enclosedExpr ) LCURLY ( expr )? RCURLY )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1920:5: ATTRIBUTE ( qname | enclosedExpr ) LCURLY ( expr )? RCURLY
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ATTRIBUTE433=(CommonTree)match(input,ATTRIBUTE,FOLLOW_ATTRIBUTE_in_compAttrConstructor8653); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ATTRIBUTE433_tree = (CommonTree)adaptor.dupNode(ATTRIBUTE433);

            adaptor.addChild(root_0, ATTRIBUTE433_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1920:15: ( qname | enclosedExpr )
            int alt120=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt120=1;
                }
                break;
            case TO:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt120=2;
                    }
                    break;
                case LCURLY:
                    {
                    alt120=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 120, 2, input);

                    throw nvae;
                }

                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt120=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 120, 0, input);

                throw nvae;
            }

            switch (alt120) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1920:16: qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_compAttrConstructor8656);
                    qname434=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, qname434.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1920:24: enclosedExpr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_compAttrConstructor8660);
                    enclosedExpr435=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, enclosedExpr435.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            LCURLY436=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_compAttrConstructor8663); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LCURLY436_tree = (CommonTree)adaptor.dupNode(LCURLY436);

            adaptor.addChild(root_0, LCURLY436_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1920:45: ( expr )?
            int alt121=2;
            switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt121=1;
                    }
                    break;
            }

            switch (alt121) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: expr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expr_in_compAttrConstructor8665);
                    expr437=expr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, expr437.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RCURLY438=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_compAttrConstructor8668); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RCURLY438_tree = (CommonTree)adaptor.dupNode(RCURLY438);

            adaptor.addChild(root_0, RCURLY438_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compAttrConstructor"

    public static class compTextConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compTextConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1923:1: compTextConstructor : TEXT enclosedExpr_ ;
    public final XSPARQLRewriter.compTextConstructor_return compTextConstructor() throws RecognitionException {
        XSPARQLRewriter.compTextConstructor_return retval = new XSPARQLRewriter.compTextConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree TEXT439=null;
        XSPARQLRewriter.enclosedExpr__return enclosedExpr_440 = null;


        CommonTree TEXT439_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1924:3: ( TEXT enclosedExpr_ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1924:5: TEXT enclosedExpr_
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            TEXT439=(CommonTree)match(input,TEXT,FOLLOW_TEXT_in_compTextConstructor8681); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            TEXT439_tree = (CommonTree)adaptor.dupNode(TEXT439);

            adaptor.addChild(root_0, TEXT439_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_enclosedExpr__in_compTextConstructor8683);
            enclosedExpr_440=enclosedExpr_();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, enclosedExpr_440.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compTextConstructor"

    public static class compCommentConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compCommentConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1927:1: compCommentConstructor : COMMENT enclosedExpr ;
    public final XSPARQLRewriter.compCommentConstructor_return compCommentConstructor() throws RecognitionException {
        XSPARQLRewriter.compCommentConstructor_return retval = new XSPARQLRewriter.compCommentConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree COMMENT441=null;
        XSPARQLRewriter.enclosedExpr_return enclosedExpr442 = null;


        CommonTree COMMENT441_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1928:3: ( COMMENT enclosedExpr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1928:5: COMMENT enclosedExpr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            COMMENT441=(CommonTree)match(input,COMMENT,FOLLOW_COMMENT_in_compCommentConstructor8696); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            COMMENT441_tree = (CommonTree)adaptor.dupNode(COMMENT441);

            adaptor.addChild(root_0, COMMENT441_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_enclosedExpr_in_compCommentConstructor8698);
            enclosedExpr442=enclosedExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, enclosedExpr442.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compCommentConstructor"

    public static class compPIConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compPIConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1931:1: compPIConstructor : PROCESSINGINSTRUCTION ( NCNAME | enclosedExpr ) LCURLY ( expr )? RCURLY ;
    public final XSPARQLRewriter.compPIConstructor_return compPIConstructor() throws RecognitionException {
        XSPARQLRewriter.compPIConstructor_return retval = new XSPARQLRewriter.compPIConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree PROCESSINGINSTRUCTION443=null;
        CommonTree NCNAME444=null;
        CommonTree LCURLY446=null;
        CommonTree RCURLY448=null;
        XSPARQLRewriter.enclosedExpr_return enclosedExpr445 = null;

        XSPARQLRewriter.expr_return expr447 = null;


        CommonTree PROCESSINGINSTRUCTION443_tree=null;
        CommonTree NCNAME444_tree=null;
        CommonTree LCURLY446_tree=null;
        CommonTree RCURLY448_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1932:3: ( PROCESSINGINSTRUCTION ( NCNAME | enclosedExpr ) LCURLY ( expr )? RCURLY )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1932:5: PROCESSINGINSTRUCTION ( NCNAME | enclosedExpr ) LCURLY ( expr )? RCURLY
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            PROCESSINGINSTRUCTION443=(CommonTree)match(input,PROCESSINGINSTRUCTION,FOLLOW_PROCESSINGINSTRUCTION_in_compPIConstructor8711); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            PROCESSINGINSTRUCTION443_tree = (CommonTree)adaptor.dupNode(PROCESSINGINSTRUCTION443);

            adaptor.addChild(root_0, PROCESSINGINSTRUCTION443_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1932:27: ( NCNAME | enclosedExpr )
            int alt122=2;
            switch ( input.LA(1) ) {
            case NCNAME:
                {
                alt122=1;
                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt122=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 122, 0, input);

                throw nvae;
            }

            switch (alt122) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1932:29: NCNAME
                    {
                    _last = (CommonTree)input.LT(1);
                    NCNAME444=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_compPIConstructor8715); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAME444_tree = (CommonTree)adaptor.dupNode(NCNAME444);

                    adaptor.addChild(root_0, NCNAME444_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1932:38: enclosedExpr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_compPIConstructor8719);
                    enclosedExpr445=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, enclosedExpr445.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            LCURLY446=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_compPIConstructor8722); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LCURLY446_tree = (CommonTree)adaptor.dupNode(LCURLY446);

            adaptor.addChild(root_0, LCURLY446_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1932:59: ( expr )?
            int alt123=2;
            switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt123=1;
                    }
                    break;
            }

            switch (alt123) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: expr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expr_in_compPIConstructor8724);
                    expr447=expr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, expr447.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RCURLY448=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_compPIConstructor8727); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RCURLY448_tree = (CommonTree)adaptor.dupNode(RCURLY448);

            adaptor.addChild(root_0, RCURLY448_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compPIConstructor"

    public static class singleType_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleType"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1935:1: singleType : atomicType ( QUESTIONMARK )? ;
    public final XSPARQLRewriter.singleType_return singleType() throws RecognitionException {
        XSPARQLRewriter.singleType_return retval = new XSPARQLRewriter.singleType_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree QUESTIONMARK450=null;
        XSPARQLRewriter.atomicType_return atomicType449 = null;


        CommonTree QUESTIONMARK450_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1936:3: ( atomicType ( QUESTIONMARK )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1936:5: atomicType ( QUESTIONMARK )?
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_atomicType_in_singleType8740);
            atomicType449=atomicType();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, atomicType449.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1936:16: ( QUESTIONMARK )?
            int alt124=2;
            switch ( input.LA(1) ) {
                case QUESTIONMARK:
                    {
                    alt124=1;
                    }
                    break;
            }

            switch (alt124) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: QUESTIONMARK
                    {
                    _last = (CommonTree)input.LT(1);
                    QUESTIONMARK450=(CommonTree)match(input,QUESTIONMARK,FOLLOW_QUESTIONMARK_in_singleType8742); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    QUESTIONMARK450_tree = (CommonTree)adaptor.dupNode(QUESTIONMARK450);

                    adaptor.addChild(root_0, QUESTIONMARK450_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleType"

    public static class typeDeclaration_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeDeclaration"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1939:1: typeDeclaration : sequenceType ;
    public final XSPARQLRewriter.typeDeclaration_return typeDeclaration() throws RecognitionException {
        XSPARQLRewriter.typeDeclaration_return retval = new XSPARQLRewriter.typeDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.sequenceType_return sequenceType451 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1940:3: ( sequenceType )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1940:5: sequenceType
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sequenceType_in_typeDeclaration8756);
            sequenceType451=sequenceType();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, sequenceType451.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "typeDeclaration"

    public static class sequenceType_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sequenceType"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1943:1: sequenceType : ( EMPTYSEQUENCE LPAR RPAR | itemType ( occurrenceIndicator )? );
    public final XSPARQLRewriter.sequenceType_return sequenceType() throws RecognitionException {
        XSPARQLRewriter.sequenceType_return retval = new XSPARQLRewriter.sequenceType_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree EMPTYSEQUENCE452=null;
        CommonTree LPAR453=null;
        CommonTree RPAR454=null;
        XSPARQLRewriter.itemType_return itemType455 = null;

        XSPARQLRewriter.occurrenceIndicator_return occurrenceIndicator456 = null;


        CommonTree EMPTYSEQUENCE452_tree=null;
        CommonTree LPAR453_tree=null;
        CommonTree RPAR454_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1944:3: ( EMPTYSEQUENCE LPAR RPAR | itemType ( occurrenceIndicator )? )
            int alt126=2;
            switch ( input.LA(1) ) {
            case EMPTYSEQUENCE:
                {
                alt126=1;
                }
                break;
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case ATTRIBUTE:
            case ELEMENT:
            case TO:
            case ITEM:
            case NODE:
            case DOCUMENTNODE:
            case TEXT:
            case COMMENT:
            case PROCESSINGINSTRUCTION:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
            case ROW:
                {
                alt126=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 126, 0, input);

                throw nvae;
            }

            switch (alt126) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1944:5: EMPTYSEQUENCE LPAR RPAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    EMPTYSEQUENCE452=(CommonTree)match(input,EMPTYSEQUENCE,FOLLOW_EMPTYSEQUENCE_in_sequenceType8769); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    EMPTYSEQUENCE452_tree = (CommonTree)adaptor.dupNode(EMPTYSEQUENCE452);

                    adaptor.addChild(root_0, EMPTYSEQUENCE452_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    LPAR453=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_sequenceType8771); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    LPAR453_tree = (CommonTree)adaptor.dupNode(LPAR453);

                    adaptor.addChild(root_0, LPAR453_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    RPAR454=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_sequenceType8773); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    RPAR454_tree = (CommonTree)adaptor.dupNode(RPAR454);

                    adaptor.addChild(root_0, RPAR454_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1945:5: itemType ( occurrenceIndicator )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_itemType_in_sequenceType8779);
                    itemType455=itemType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, itemType455.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1945:14: ( occurrenceIndicator )?
                    int alt125=2;
                    switch ( input.LA(1) ) {
                        case STAR:
                        case PLUS:
                        case QUESTIONMARK:
                            {
                            alt125=1;
                            }
                            break;
                    }

                    switch (alt125) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: occurrenceIndicator
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_occurrenceIndicator_in_sequenceType8781);
                            occurrenceIndicator456=occurrenceIndicator();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, occurrenceIndicator456.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sequenceType"

    public static class occurrenceIndicator_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "occurrenceIndicator"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1948:1: occurrenceIndicator : ( QUESTIONMARK | STAR | PLUS );
    public final XSPARQLRewriter.occurrenceIndicator_return occurrenceIndicator() throws RecognitionException {
        XSPARQLRewriter.occurrenceIndicator_return retval = new XSPARQLRewriter.occurrenceIndicator_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set457=null;

        CommonTree set457_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1949:3: ( QUESTIONMARK | STAR | PLUS )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set457=(CommonTree)input.LT(1);
            if ( input.LA(1)==STAR||input.LA(1)==PLUS||input.LA(1)==QUESTIONMARK ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set457_tree = (CommonTree)adaptor.dupNode(set457);

                adaptor.addChild(root_0, set457_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "occurrenceIndicator"

    public static class itemType_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "itemType"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1952:1: itemType : ( ITEM LPAR RPAR | atomicType | kindTest );
    public final XSPARQLRewriter.itemType_return itemType() throws RecognitionException {
        XSPARQLRewriter.itemType_return retval = new XSPARQLRewriter.itemType_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ITEM458=null;
        CommonTree LPAR459=null;
        CommonTree RPAR460=null;
        XSPARQLRewriter.atomicType_return atomicType461 = null;

        XSPARQLRewriter.kindTest_return kindTest462 = null;


        CommonTree ITEM458_tree=null;
        CommonTree LPAR459_tree=null;
        CommonTree RPAR460_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1953:3: ( ITEM LPAR RPAR | atomicType | kindTest )
            int alt127=3;
            switch ( input.LA(1) ) {
            case ITEM:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt127=1;
                    }
                    break;
                case EOF:
                case UP:
                case STAR:
                case PLUS:
                case QUESTIONMARK:
                case RETURN:
                    {
                    alt127=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 127, 1, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ROW:
                {
                alt127=2;
                }
                break;
            case COMMENT:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt127=3;
                    }
                    break;
                case EOF:
                case UP:
                case STAR:
                case PLUS:
                case QUESTIONMARK:
                case RETURN:
                    {
                    alt127=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 127, 3, input);

                    throw nvae;
                }

                }
                break;
            case NODE:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt127=3;
                    }
                    break;
                case EOF:
                case UP:
                case STAR:
                case PLUS:
                case QUESTIONMARK:
                case RETURN:
                    {
                    alt127=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 127, 4, input);

                    throw nvae;
                }

                }
                break;
            case ATTRIBUTE:
            case ELEMENT:
            case DOCUMENTNODE:
            case TEXT:
            case PROCESSINGINSTRUCTION:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
                {
                alt127=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 127, 0, input);

                throw nvae;
            }

            switch (alt127) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1953:5: ITEM LPAR RPAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    ITEM458=(CommonTree)match(input,ITEM,FOLLOW_ITEM_in_itemType8816); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ITEM458_tree = (CommonTree)adaptor.dupNode(ITEM458);

                    adaptor.addChild(root_0, ITEM458_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    LPAR459=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_itemType8818); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    LPAR459_tree = (CommonTree)adaptor.dupNode(LPAR459);

                    adaptor.addChild(root_0, LPAR459_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    RPAR460=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_itemType8820); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    RPAR460_tree = (CommonTree)adaptor.dupNode(RPAR460);

                    adaptor.addChild(root_0, RPAR460_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1954:5: atomicType
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_atomicType_in_itemType8826);
                    atomicType461=atomicType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, atomicType461.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1955:5: kindTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_kindTest_in_itemType8832);
                    kindTest462=kindTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, kindTest462.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "itemType"

    public static class atomicType_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "atomicType"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1958:1: atomicType : qname ;
    public final XSPARQLRewriter.atomicType_return atomicType() throws RecognitionException {
        XSPARQLRewriter.atomicType_return retval = new XSPARQLRewriter.atomicType_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname463 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1959:3: ( qname )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1959:5: qname
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_atomicType8845);
            qname463=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, qname463.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "atomicType"

    public static class kindTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "kindTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1962:1: kindTest : ( documentTest | elementTest | attributeTest | schemaElementTest | schemaAttributeTest | piTest | commentTest | textTest | anyKindTest );
    public final XSPARQLRewriter.kindTest_return kindTest() throws RecognitionException {
        XSPARQLRewriter.kindTest_return retval = new XSPARQLRewriter.kindTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.documentTest_return documentTest464 = null;

        XSPARQLRewriter.elementTest_return elementTest465 = null;

        XSPARQLRewriter.attributeTest_return attributeTest466 = null;

        XSPARQLRewriter.schemaElementTest_return schemaElementTest467 = null;

        XSPARQLRewriter.schemaAttributeTest_return schemaAttributeTest468 = null;

        XSPARQLRewriter.piTest_return piTest469 = null;

        XSPARQLRewriter.commentTest_return commentTest470 = null;

        XSPARQLRewriter.textTest_return textTest471 = null;

        XSPARQLRewriter.anyKindTest_return anyKindTest472 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1963:3: ( documentTest | elementTest | attributeTest | schemaElementTest | schemaAttributeTest | piTest | commentTest | textTest | anyKindTest )
            int alt128=9;
            switch ( input.LA(1) ) {
            case DOCUMENTNODE:
                {
                alt128=1;
                }
                break;
            case ELEMENT:
                {
                alt128=2;
                }
                break;
            case ATTRIBUTE:
                {
                alt128=3;
                }
                break;
            case SCHEMAELEMENT:
                {
                alt128=4;
                }
                break;
            case SCHEMAATTRIBUTE:
                {
                alt128=5;
                }
                break;
            case PROCESSINGINSTRUCTION:
                {
                alt128=6;
                }
                break;
            case COMMENT:
                {
                alt128=7;
                }
                break;
            case TEXT:
                {
                alt128=8;
                }
                break;
            case NODE:
                {
                alt128=9;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 128, 0, input);

                throw nvae;
            }

            switch (alt128) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1963:5: documentTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_documentTest_in_kindTest8858);
                    documentTest464=documentTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, documentTest464.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1964:5: elementTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_elementTest_in_kindTest8864);
                    elementTest465=elementTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, elementTest465.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1965:5: attributeTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_attributeTest_in_kindTest8870);
                    attributeTest466=attributeTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, attributeTest466.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1966:5: schemaElementTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_schemaElementTest_in_kindTest8876);
                    schemaElementTest467=schemaElementTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, schemaElementTest467.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1967:5: schemaAttributeTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_schemaAttributeTest_in_kindTest8882);
                    schemaAttributeTest468=schemaAttributeTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, schemaAttributeTest468.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1968:5: piTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_piTest_in_kindTest8888);
                    piTest469=piTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, piTest469.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1969:5: commentTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_commentTest_in_kindTest8894);
                    commentTest470=commentTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, commentTest470.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1970:5: textTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_textTest_in_kindTest8900);
                    textTest471=textTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, textTest471.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 9 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1971:5: anyKindTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_anyKindTest_in_kindTest8906);
                    anyKindTest472=anyKindTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, anyKindTest472.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "kindTest"

    public static class anyKindTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "anyKindTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1974:1: anyKindTest : NODE LPAR RPAR ;
    public final XSPARQLRewriter.anyKindTest_return anyKindTest() throws RecognitionException {
        XSPARQLRewriter.anyKindTest_return retval = new XSPARQLRewriter.anyKindTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree NODE473=null;
        CommonTree LPAR474=null;
        CommonTree RPAR475=null;

        CommonTree NODE473_tree=null;
        CommonTree LPAR474_tree=null;
        CommonTree RPAR475_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1975:3: ( NODE LPAR RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1975:5: NODE LPAR RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            NODE473=(CommonTree)match(input,NODE,FOLLOW_NODE_in_anyKindTest8919); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            NODE473_tree = (CommonTree)adaptor.dupNode(NODE473);

            adaptor.addChild(root_0, NODE473_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR474=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_anyKindTest8921); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR474_tree = (CommonTree)adaptor.dupNode(LPAR474);

            adaptor.addChild(root_0, LPAR474_tree);
            }
            _last = (CommonTree)input.LT(1);
            RPAR475=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_anyKindTest8923); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR475_tree = (CommonTree)adaptor.dupNode(RPAR475);

            adaptor.addChild(root_0, RPAR475_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "anyKindTest"

    public static class documentTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "documentTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1978:1: documentTest : DOCUMENTNODE LPAR ( elementTest | schemaElementTest )? RPAR ;
    public final XSPARQLRewriter.documentTest_return documentTest() throws RecognitionException {
        XSPARQLRewriter.documentTest_return retval = new XSPARQLRewriter.documentTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DOCUMENTNODE476=null;
        CommonTree LPAR477=null;
        CommonTree RPAR480=null;
        XSPARQLRewriter.elementTest_return elementTest478 = null;

        XSPARQLRewriter.schemaElementTest_return schemaElementTest479 = null;


        CommonTree DOCUMENTNODE476_tree=null;
        CommonTree LPAR477_tree=null;
        CommonTree RPAR480_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1979:3: ( DOCUMENTNODE LPAR ( elementTest | schemaElementTest )? RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1979:5: DOCUMENTNODE LPAR ( elementTest | schemaElementTest )? RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DOCUMENTNODE476=(CommonTree)match(input,DOCUMENTNODE,FOLLOW_DOCUMENTNODE_in_documentTest8936); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOCUMENTNODE476_tree = (CommonTree)adaptor.dupNode(DOCUMENTNODE476);

            adaptor.addChild(root_0, DOCUMENTNODE476_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR477=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_documentTest8938); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR477_tree = (CommonTree)adaptor.dupNode(LPAR477);

            adaptor.addChild(root_0, LPAR477_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1979:23: ( elementTest | schemaElementTest )?
            int alt129=3;
            switch ( input.LA(1) ) {
                case ELEMENT:
                    {
                    alt129=1;
                    }
                    break;
                case SCHEMAELEMENT:
                    {
                    alt129=2;
                    }
                    break;
            }

            switch (alt129) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1979:24: elementTest
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_elementTest_in_documentTest8941);
                    elementTest478=elementTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, elementTest478.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1979:38: schemaElementTest
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_schemaElementTest_in_documentTest8945);
                    schemaElementTest479=schemaElementTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, schemaElementTest479.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RPAR480=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_documentTest8949); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR480_tree = (CommonTree)adaptor.dupNode(RPAR480);

            adaptor.addChild(root_0, RPAR480_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "documentTest"

    public static class textTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "textTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1982:1: textTest : TEXT LPAR RPAR ;
    public final XSPARQLRewriter.textTest_return textTest() throws RecognitionException {
        XSPARQLRewriter.textTest_return retval = new XSPARQLRewriter.textTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree TEXT481=null;
        CommonTree LPAR482=null;
        CommonTree RPAR483=null;

        CommonTree TEXT481_tree=null;
        CommonTree LPAR482_tree=null;
        CommonTree RPAR483_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1983:3: ( TEXT LPAR RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1983:5: TEXT LPAR RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            TEXT481=(CommonTree)match(input,TEXT,FOLLOW_TEXT_in_textTest8962); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            TEXT481_tree = (CommonTree)adaptor.dupNode(TEXT481);

            adaptor.addChild(root_0, TEXT481_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR482=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_textTest8964); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR482_tree = (CommonTree)adaptor.dupNode(LPAR482);

            adaptor.addChild(root_0, LPAR482_tree);
            }
            _last = (CommonTree)input.LT(1);
            RPAR483=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_textTest8966); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR483_tree = (CommonTree)adaptor.dupNode(RPAR483);

            adaptor.addChild(root_0, RPAR483_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "textTest"

    public static class commentTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "commentTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1986:1: commentTest : COMMENT LPAR RPAR ;
    public final XSPARQLRewriter.commentTest_return commentTest() throws RecognitionException {
        XSPARQLRewriter.commentTest_return retval = new XSPARQLRewriter.commentTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree COMMENT484=null;
        CommonTree LPAR485=null;
        CommonTree RPAR486=null;

        CommonTree COMMENT484_tree=null;
        CommonTree LPAR485_tree=null;
        CommonTree RPAR486_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1987:3: ( COMMENT LPAR RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1987:5: COMMENT LPAR RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            COMMENT484=(CommonTree)match(input,COMMENT,FOLLOW_COMMENT_in_commentTest8979); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            COMMENT484_tree = (CommonTree)adaptor.dupNode(COMMENT484);

            adaptor.addChild(root_0, COMMENT484_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR485=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_commentTest8981); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR485_tree = (CommonTree)adaptor.dupNode(LPAR485);

            adaptor.addChild(root_0, LPAR485_tree);
            }
            _last = (CommonTree)input.LT(1);
            RPAR486=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_commentTest8983); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR486_tree = (CommonTree)adaptor.dupNode(RPAR486);

            adaptor.addChild(root_0, RPAR486_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "commentTest"

    public static class piTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "piTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1990:1: piTest : PROCESSINGINSTRUCTION LPAR ( NCNAME | stringliteral )? RPAR ;
    public final XSPARQLRewriter.piTest_return piTest() throws RecognitionException {
        XSPARQLRewriter.piTest_return retval = new XSPARQLRewriter.piTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree PROCESSINGINSTRUCTION487=null;
        CommonTree LPAR488=null;
        CommonTree NCNAME489=null;
        CommonTree RPAR491=null;
        XSPARQLRewriter.stringliteral_return stringliteral490 = null;


        CommonTree PROCESSINGINSTRUCTION487_tree=null;
        CommonTree LPAR488_tree=null;
        CommonTree NCNAME489_tree=null;
        CommonTree RPAR491_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1991:3: ( PROCESSINGINSTRUCTION LPAR ( NCNAME | stringliteral )? RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1991:5: PROCESSINGINSTRUCTION LPAR ( NCNAME | stringliteral )? RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            PROCESSINGINSTRUCTION487=(CommonTree)match(input,PROCESSINGINSTRUCTION,FOLLOW_PROCESSINGINSTRUCTION_in_piTest8996); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            PROCESSINGINSTRUCTION487_tree = (CommonTree)adaptor.dupNode(PROCESSINGINSTRUCTION487);

            adaptor.addChild(root_0, PROCESSINGINSTRUCTION487_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR488=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_piTest8998); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR488_tree = (CommonTree)adaptor.dupNode(LPAR488);

            adaptor.addChild(root_0, LPAR488_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1991:32: ( NCNAME | stringliteral )?
            int alt130=3;
            switch ( input.LA(1) ) {
                case NCNAME:
                    {
                    alt130=1;
                    }
                    break;
                case QSTRING:
                    {
                    alt130=2;
                    }
                    break;
            }

            switch (alt130) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1991:33: NCNAME
                    {
                    _last = (CommonTree)input.LT(1);
                    NCNAME489=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_piTest9001); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAME489_tree = (CommonTree)adaptor.dupNode(NCNAME489);

                    adaptor.addChild(root_0, NCNAME489_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1991:42: stringliteral
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_stringliteral_in_piTest9005);
                    stringliteral490=stringliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, stringliteral490.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RPAR491=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_piTest9009); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR491_tree = (CommonTree)adaptor.dupNode(RPAR491);

            adaptor.addChild(root_0, RPAR491_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "piTest"

    public static class attributeTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "attributeTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1994:1: attributeTest : ATTRIBUTE LPAR ( attributeNameOrWildcard ( COMMA typeName )? )? RPAR ;
    public final XSPARQLRewriter.attributeTest_return attributeTest() throws RecognitionException {
        XSPARQLRewriter.attributeTest_return retval = new XSPARQLRewriter.attributeTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ATTRIBUTE492=null;
        CommonTree LPAR493=null;
        CommonTree COMMA495=null;
        CommonTree RPAR497=null;
        XSPARQLRewriter.attributeNameOrWildcard_return attributeNameOrWildcard494 = null;

        XSPARQLRewriter.typeName_return typeName496 = null;


        CommonTree ATTRIBUTE492_tree=null;
        CommonTree LPAR493_tree=null;
        CommonTree COMMA495_tree=null;
        CommonTree RPAR497_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1995:3: ( ATTRIBUTE LPAR ( attributeNameOrWildcard ( COMMA typeName )? )? RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1995:5: ATTRIBUTE LPAR ( attributeNameOrWildcard ( COMMA typeName )? )? RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ATTRIBUTE492=(CommonTree)match(input,ATTRIBUTE,FOLLOW_ATTRIBUTE_in_attributeTest9022); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ATTRIBUTE492_tree = (CommonTree)adaptor.dupNode(ATTRIBUTE492);

            adaptor.addChild(root_0, ATTRIBUTE492_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR493=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_attributeTest9024); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR493_tree = (CommonTree)adaptor.dupNode(LPAR493);

            adaptor.addChild(root_0, LPAR493_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1995:20: ( attributeNameOrWildcard ( COMMA typeName )? )?
            int alt132=2;
            switch ( input.LA(1) ) {
                case NCNAME:
                case STAR:
                case PNAME_NS:
                case PNAME_LN:
                case A:
                case FROM:
                case TO:
                case ITEM:
                case NODE:
                case COMMENT:
                case ROW:
                    {
                    alt132=1;
                    }
                    break;
            }

            switch (alt132) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1995:21: attributeNameOrWildcard ( COMMA typeName )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_attributeNameOrWildcard_in_attributeTest9027);
                    attributeNameOrWildcard494=attributeNameOrWildcard();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, attributeNameOrWildcard494.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1995:45: ( COMMA typeName )?
                    int alt131=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt131=1;
                            }
                            break;
                    }

                    switch (alt131) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1995:46: COMMA typeName
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA495=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_attributeTest9030); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            COMMA495_tree = (CommonTree)adaptor.dupNode(COMMA495);

                            adaptor.addChild(root_0, COMMA495_tree);
                            }
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_typeName_in_attributeTest9032);
                            typeName496=typeName();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, typeName496.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RPAR497=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_attributeTest9038); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR497_tree = (CommonTree)adaptor.dupNode(RPAR497);

            adaptor.addChild(root_0, RPAR497_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "attributeTest"

    public static class attributeNameOrWildcard_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "attributeNameOrWildcard"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1998:1: attributeNameOrWildcard : ( attributeName | STAR );
    public final XSPARQLRewriter.attributeNameOrWildcard_return attributeNameOrWildcard() throws RecognitionException {
        XSPARQLRewriter.attributeNameOrWildcard_return retval = new XSPARQLRewriter.attributeNameOrWildcard_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree STAR499=null;
        XSPARQLRewriter.attributeName_return attributeName498 = null;


        CommonTree STAR499_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1999:3: ( attributeName | STAR )
            int alt133=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt133=1;
                }
                break;
            case STAR:
                {
                alt133=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 133, 0, input);

                throw nvae;
            }

            switch (alt133) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1999:5: attributeName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_attributeName_in_attributeNameOrWildcard9051);
                    attributeName498=attributeName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, attributeName498.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1999:21: STAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    STAR499=(CommonTree)match(input,STAR,FOLLOW_STAR_in_attributeNameOrWildcard9055); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    STAR499_tree = (CommonTree)adaptor.dupNode(STAR499);

                    adaptor.addChild(root_0, STAR499_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "attributeNameOrWildcard"

    public static class schemaAttributeTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "schemaAttributeTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2002:1: schemaAttributeTest : SCHEMAATTRIBUTE LPAR attributeDeclaration RPAR ;
    public final XSPARQLRewriter.schemaAttributeTest_return schemaAttributeTest() throws RecognitionException {
        XSPARQLRewriter.schemaAttributeTest_return retval = new XSPARQLRewriter.schemaAttributeTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree SCHEMAATTRIBUTE500=null;
        CommonTree LPAR501=null;
        CommonTree RPAR503=null;
        XSPARQLRewriter.attributeDeclaration_return attributeDeclaration502 = null;


        CommonTree SCHEMAATTRIBUTE500_tree=null;
        CommonTree LPAR501_tree=null;
        CommonTree RPAR503_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2003:3: ( SCHEMAATTRIBUTE LPAR attributeDeclaration RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2003:5: SCHEMAATTRIBUTE LPAR attributeDeclaration RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            SCHEMAATTRIBUTE500=(CommonTree)match(input,SCHEMAATTRIBUTE,FOLLOW_SCHEMAATTRIBUTE_in_schemaAttributeTest9068); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            SCHEMAATTRIBUTE500_tree = (CommonTree)adaptor.dupNode(SCHEMAATTRIBUTE500);

            adaptor.addChild(root_0, SCHEMAATTRIBUTE500_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR501=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_schemaAttributeTest9070); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR501_tree = (CommonTree)adaptor.dupNode(LPAR501);

            adaptor.addChild(root_0, LPAR501_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_attributeDeclaration_in_schemaAttributeTest9072);
            attributeDeclaration502=attributeDeclaration();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, attributeDeclaration502.getTree());
            _last = (CommonTree)input.LT(1);
            RPAR503=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_schemaAttributeTest9074); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR503_tree = (CommonTree)adaptor.dupNode(RPAR503);

            adaptor.addChild(root_0, RPAR503_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "schemaAttributeTest"

    public static class attributeDeclaration_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "attributeDeclaration"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2006:1: attributeDeclaration : attributeName ;
    public final XSPARQLRewriter.attributeDeclaration_return attributeDeclaration() throws RecognitionException {
        XSPARQLRewriter.attributeDeclaration_return retval = new XSPARQLRewriter.attributeDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.attributeName_return attributeName504 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2007:3: ( attributeName )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2007:5: attributeName
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_attributeName_in_attributeDeclaration9087);
            attributeName504=attributeName();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, attributeName504.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "attributeDeclaration"

    public static class elementTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2010:1: elementTest : ELEMENT LPAR ( elementNameOrWildcard ( COMMA typeName ( QUESTIONMARK )? )? )? RPAR ;
    public final XSPARQLRewriter.elementTest_return elementTest() throws RecognitionException {
        XSPARQLRewriter.elementTest_return retval = new XSPARQLRewriter.elementTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ELEMENT505=null;
        CommonTree LPAR506=null;
        CommonTree COMMA508=null;
        CommonTree QUESTIONMARK510=null;
        CommonTree RPAR511=null;
        XSPARQLRewriter.elementNameOrWildcard_return elementNameOrWildcard507 = null;

        XSPARQLRewriter.typeName_return typeName509 = null;


        CommonTree ELEMENT505_tree=null;
        CommonTree LPAR506_tree=null;
        CommonTree COMMA508_tree=null;
        CommonTree QUESTIONMARK510_tree=null;
        CommonTree RPAR511_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2011:3: ( ELEMENT LPAR ( elementNameOrWildcard ( COMMA typeName ( QUESTIONMARK )? )? )? RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2011:5: ELEMENT LPAR ( elementNameOrWildcard ( COMMA typeName ( QUESTIONMARK )? )? )? RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ELEMENT505=(CommonTree)match(input,ELEMENT,FOLLOW_ELEMENT_in_elementTest9100); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ELEMENT505_tree = (CommonTree)adaptor.dupNode(ELEMENT505);

            adaptor.addChild(root_0, ELEMENT505_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR506=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_elementTest9102); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR506_tree = (CommonTree)adaptor.dupNode(LPAR506);

            adaptor.addChild(root_0, LPAR506_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2011:18: ( elementNameOrWildcard ( COMMA typeName ( QUESTIONMARK )? )? )?
            int alt136=2;
            switch ( input.LA(1) ) {
                case NCNAME:
                case STAR:
                case PNAME_NS:
                case PNAME_LN:
                case A:
                case FROM:
                case TO:
                case ITEM:
                case NODE:
                case COMMENT:
                case ROW:
                    {
                    alt136=1;
                    }
                    break;
            }

            switch (alt136) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2011:19: elementNameOrWildcard ( COMMA typeName ( QUESTIONMARK )? )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_elementNameOrWildcard_in_elementTest9105);
                    elementNameOrWildcard507=elementNameOrWildcard();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, elementNameOrWildcard507.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2011:41: ( COMMA typeName ( QUESTIONMARK )? )?
                    int alt135=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt135=1;
                            }
                            break;
                    }

                    switch (alt135) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2011:42: COMMA typeName ( QUESTIONMARK )?
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA508=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_elementTest9108); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            COMMA508_tree = (CommonTree)adaptor.dupNode(COMMA508);

                            adaptor.addChild(root_0, COMMA508_tree);
                            }
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_typeName_in_elementTest9110);
                            typeName509=typeName();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, typeName509.getTree());
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2011:57: ( QUESTIONMARK )?
                            int alt134=2;
                            switch ( input.LA(1) ) {
                                case QUESTIONMARK:
                                    {
                                    alt134=1;
                                    }
                                    break;
                            }

                            switch (alt134) {
                                case 1 :
                                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: QUESTIONMARK
                                    {
                                    _last = (CommonTree)input.LT(1);
                                    QUESTIONMARK510=(CommonTree)match(input,QUESTIONMARK,FOLLOW_QUESTIONMARK_in_elementTest9112); if (state.failed) return retval;
                                    if ( state.backtracking==0 ) {
                                    QUESTIONMARK510_tree = (CommonTree)adaptor.dupNode(QUESTIONMARK510);

                                    adaptor.addChild(root_0, QUESTIONMARK510_tree);
                                    }

                                    if ( state.backtracking==0 ) {
                                    }
                                    }
                                    break;

                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RPAR511=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_elementTest9119); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR511_tree = (CommonTree)adaptor.dupNode(RPAR511);

            adaptor.addChild(root_0, RPAR511_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "elementTest"

    public static class elementNameOrWildcard_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementNameOrWildcard"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2014:1: elementNameOrWildcard : ( elementName | STAR );
    public final XSPARQLRewriter.elementNameOrWildcard_return elementNameOrWildcard() throws RecognitionException {
        XSPARQLRewriter.elementNameOrWildcard_return retval = new XSPARQLRewriter.elementNameOrWildcard_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree STAR513=null;
        XSPARQLRewriter.elementName_return elementName512 = null;


        CommonTree STAR513_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2015:3: ( elementName | STAR )
            int alt137=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt137=1;
                }
                break;
            case STAR:
                {
                alt137=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 137, 0, input);

                throw nvae;
            }

            switch (alt137) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2015:5: elementName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_elementName_in_elementNameOrWildcard9132);
                    elementName512=elementName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, elementName512.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2015:19: STAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    STAR513=(CommonTree)match(input,STAR,FOLLOW_STAR_in_elementNameOrWildcard9136); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    STAR513_tree = (CommonTree)adaptor.dupNode(STAR513);

                    adaptor.addChild(root_0, STAR513_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "elementNameOrWildcard"

    public static class schemaElementTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "schemaElementTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2018:1: schemaElementTest : SCHEMAELEMENT LPAR elementDeclaration RPAR ;
    public final XSPARQLRewriter.schemaElementTest_return schemaElementTest() throws RecognitionException {
        XSPARQLRewriter.schemaElementTest_return retval = new XSPARQLRewriter.schemaElementTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree SCHEMAELEMENT514=null;
        CommonTree LPAR515=null;
        CommonTree RPAR517=null;
        XSPARQLRewriter.elementDeclaration_return elementDeclaration516 = null;


        CommonTree SCHEMAELEMENT514_tree=null;
        CommonTree LPAR515_tree=null;
        CommonTree RPAR517_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2019:3: ( SCHEMAELEMENT LPAR elementDeclaration RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2019:5: SCHEMAELEMENT LPAR elementDeclaration RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            SCHEMAELEMENT514=(CommonTree)match(input,SCHEMAELEMENT,FOLLOW_SCHEMAELEMENT_in_schemaElementTest9149); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            SCHEMAELEMENT514_tree = (CommonTree)adaptor.dupNode(SCHEMAELEMENT514);

            adaptor.addChild(root_0, SCHEMAELEMENT514_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR515=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_schemaElementTest9151); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR515_tree = (CommonTree)adaptor.dupNode(LPAR515);

            adaptor.addChild(root_0, LPAR515_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_elementDeclaration_in_schemaElementTest9153);
            elementDeclaration516=elementDeclaration();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, elementDeclaration516.getTree());
            _last = (CommonTree)input.LT(1);
            RPAR517=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_schemaElementTest9155); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR517_tree = (CommonTree)adaptor.dupNode(RPAR517);

            adaptor.addChild(root_0, RPAR517_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "schemaElementTest"

    public static class elementDeclaration_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementDeclaration"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2022:1: elementDeclaration : elementName ;
    public final XSPARQLRewriter.elementDeclaration_return elementDeclaration() throws RecognitionException {
        XSPARQLRewriter.elementDeclaration_return retval = new XSPARQLRewriter.elementDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.elementName_return elementName518 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2023:3: ( elementName )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2023:5: elementName
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_elementName_in_elementDeclaration9168);
            elementName518=elementName();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, elementName518.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "elementDeclaration"

    public static class attributeName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "attributeName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2026:1: attributeName : qname ;
    public final XSPARQLRewriter.attributeName_return attributeName() throws RecognitionException {
        XSPARQLRewriter.attributeName_return retval = new XSPARQLRewriter.attributeName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname519 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2027:3: ( qname )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2027:5: qname
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_attributeName9181);
            qname519=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, qname519.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "attributeName"

    public static class elementName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2030:1: elementName : qname ;
    public final XSPARQLRewriter.elementName_return elementName() throws RecognitionException {
        XSPARQLRewriter.elementName_return retval = new XSPARQLRewriter.elementName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname520 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2031:3: ( qname )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2031:5: qname
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_elementName9194);
            qname520=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, qname520.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "elementName"

    public static class typeName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2034:1: typeName : qname ;
    public final XSPARQLRewriter.typeName_return typeName() throws RecognitionException {
        XSPARQLRewriter.typeName_return retval = new XSPARQLRewriter.typeName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname521 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2035:3: ( qname )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2035:5: qname
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_typeName9207);
            qname521=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, qname521.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "typeName"

    public static class uriliteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "uriliteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2038:1: uriliteral : stringliteral ;
    public final XSPARQLRewriter.uriliteral_return uriliteral() throws RecognitionException {
        XSPARQLRewriter.uriliteral_return retval = new XSPARQLRewriter.uriliteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.stringliteral_return stringliteral522 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2039:3: ( stringliteral )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2039:5: stringliteral
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_stringliteral_in_uriliteral9220);
            stringliteral522=stringliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, stringliteral522.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "uriliteral"

    public static class integerLiteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "integerLiteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2042:1: integerLiteral : INTEGER ;
    public final XSPARQLRewriter.integerLiteral_return integerLiteral() throws RecognitionException {
        XSPARQLRewriter.integerLiteral_return retval = new XSPARQLRewriter.integerLiteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree INTEGER523=null;

        CommonTree INTEGER523_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2043:3: ( INTEGER )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2043:5: INTEGER
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            INTEGER523=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_integerLiteral9233); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            INTEGER523_tree = (CommonTree)adaptor.dupNode(INTEGER523);

            adaptor.addChild(root_0, INTEGER523_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "integerLiteral"

    public static class decimalLiteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "decimalLiteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2046:1: decimalLiteral : DECIMAL ;
    public final XSPARQLRewriter.decimalLiteral_return decimalLiteral() throws RecognitionException {
        XSPARQLRewriter.decimalLiteral_return retval = new XSPARQLRewriter.decimalLiteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DECIMAL524=null;

        CommonTree DECIMAL524_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2047:3: ( DECIMAL )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2047:5: DECIMAL
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DECIMAL524=(CommonTree)match(input,DECIMAL,FOLLOW_DECIMAL_in_decimalLiteral9246); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DECIMAL524_tree = (CommonTree)adaptor.dupNode(DECIMAL524);

            adaptor.addChild(root_0, DECIMAL524_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "decimalLiteral"

    public static class stringliteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "stringliteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2050:1: stringliteral : QSTRING ;
    public final XSPARQLRewriter.stringliteral_return stringliteral() throws RecognitionException {
        XSPARQLRewriter.stringliteral_return retval = new XSPARQLRewriter.stringliteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree QSTRING525=null;

        CommonTree QSTRING525_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2051:3: ( QSTRING )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2051:5: QSTRING
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            QSTRING525=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_stringliteral9259); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            QSTRING525_tree = (CommonTree)adaptor.dupNode(QSTRING525);

            adaptor.addChild(root_0, QSTRING525_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "stringliteral"

    public static class baseDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "baseDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2070:1: baseDecl : ^( T_NAMESPACE DEFAULT irix= IRIREF ) ;
    public final XSPARQLRewriter.baseDecl_return baseDecl() throws RecognitionException {
        XSPARQLRewriter.baseDecl_return retval = new XSPARQLRewriter.baseDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree irix=null;
        CommonTree T_NAMESPACE526=null;
        CommonTree DEFAULT527=null;

        CommonTree irix_tree=null;
        CommonTree T_NAMESPACE526_tree=null;
        CommonTree DEFAULT527_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2071:3: ( ^( T_NAMESPACE DEFAULT irix= IRIREF ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2071:5: ^( T_NAMESPACE DEFAULT irix= IRIREF )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_NAMESPACE526=(CommonTree)match(input,T_NAMESPACE,FOLLOW_T_NAMESPACE_in_baseDecl9289); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_NAMESPACE526_tree = (CommonTree)adaptor.dupNode(T_NAMESPACE526);

            root_1 = (CommonTree)adaptor.becomeRoot(T_NAMESPACE526_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            DEFAULT527=(CommonTree)match(input,DEFAULT,FOLLOW_DEFAULT_in_baseDecl9291); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DEFAULT527_tree = (CommonTree)adaptor.dupNode(DEFAULT527);

            adaptor.addChild(root_1, DEFAULT527_tree);
            }
            _last = (CommonTree)input.LT(1);
            irix=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_baseDecl9295); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            irix_tree = (CommonTree)adaptor.dupNode(irix);

            adaptor.addChild(root_1, irix_tree);
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
              addNamespace(":", (irix!=null?irix.getText():null));
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "baseDecl"

    public static class prefixDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prefixDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2074:1: prefixDecl : ( ^( T_NAMESPACE DEFAULT irix= QSTRING ) -> | ^( T_NAMESPACE p= PNAME_NS irix= QSTRING ) -> ^( T_NAMESPACE NCNAME[$p.token, $p.text] QSTRING ) );
    public final XSPARQLRewriter.prefixDecl_return prefixDecl() throws RecognitionException {
        XSPARQLRewriter.prefixDecl_return retval = new XSPARQLRewriter.prefixDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree irix=null;
        CommonTree p=null;
        CommonTree T_NAMESPACE528=null;
        CommonTree DEFAULT529=null;
        CommonTree T_NAMESPACE530=null;

        CommonTree irix_tree=null;
        CommonTree p_tree=null;
        CommonTree T_NAMESPACE528_tree=null;
        CommonTree DEFAULT529_tree=null;
        CommonTree T_NAMESPACE530_tree=null;
        RewriteRuleNodeStream stream_PNAME_NS=new RewriteRuleNodeStream(adaptor,"token PNAME_NS");
        RewriteRuleNodeStream stream_T_NAMESPACE=new RewriteRuleNodeStream(adaptor,"token T_NAMESPACE");
        RewriteRuleNodeStream stream_QSTRING=new RewriteRuleNodeStream(adaptor,"token QSTRING");
        RewriteRuleNodeStream stream_DEFAULT=new RewriteRuleNodeStream(adaptor,"token DEFAULT");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2075:3: ( ^( T_NAMESPACE DEFAULT irix= QSTRING ) -> | ^( T_NAMESPACE p= PNAME_NS irix= QSTRING ) -> ^( T_NAMESPACE NCNAME[$p.token, $p.text] QSTRING ) )
            int alt138=2;
            switch ( input.LA(1) ) {
            case T_NAMESPACE:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case DEFAULT:
                        {
                        alt138=1;
                        }
                        break;
                    case PNAME_NS:
                        {
                        alt138=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 138, 2, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 138, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 138, 0, input);

                throw nvae;
            }

            switch (alt138) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2075:5: ^( T_NAMESPACE DEFAULT irix= QSTRING )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_NAMESPACE528=(CommonTree)match(input,T_NAMESPACE,FOLLOW_T_NAMESPACE_in_prefixDecl9312); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_NAMESPACE.add(T_NAMESPACE528);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    DEFAULT529=(CommonTree)match(input,DEFAULT,FOLLOW_DEFAULT_in_prefixDecl9314); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DEFAULT.add(DEFAULT529);

                    _last = (CommonTree)input.LT(1);
                    irix=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_prefixDecl9318); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(irix);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                      addNamespace(":", (irix!=null?irix.getText():null));
                    }


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2075:74: ->
                    {
                        root_0 = null;
                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2076:5: ^( T_NAMESPACE p= PNAME_NS irix= QSTRING )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_NAMESPACE530=(CommonTree)match(input,T_NAMESPACE,FOLLOW_T_NAMESPACE_in_prefixDecl9331); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_NAMESPACE.add(T_NAMESPACE530);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PNAME_NS,FOLLOW_PNAME_NS_in_prefixDecl9335); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_NS.add(p);

                    _last = (CommonTree)input.LT(1);
                    irix=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_prefixDecl9339); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(irix);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                      addNamespace((p!=null?p.getText():null), (irix!=null?irix.getText():null));
                    }


                    // AST REWRITE
                    // elements: QSTRING, T_NAMESPACE
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2077:3: -> ^( T_NAMESPACE NCNAME[$p.token, $p.text] QSTRING )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2077:6: ^( T_NAMESPACE NCNAME[$p.token, $p.text] QSTRING )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_T_NAMESPACE.nextNode(), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, p.token, (p!=null?p.getText():null)));
                        adaptor.addChild(root_1, stream_QSTRING.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prefixDecl"

    public static class datasetClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "datasetClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2080:1: datasetClause : ^(f= FROM (d= defaultGraphClause | e= namedGraphClause ) ) -> QSTRING[$f.token, \"\\n \" + $f.text + \" \"] ( $d)? ( $e)? ;
    public final XSPARQLRewriter.datasetClause_return datasetClause() throws RecognitionException {
        XSPARQLRewriter.datasetClause_return retval = new XSPARQLRewriter.datasetClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree f=null;
        XSPARQLRewriter.defaultGraphClause_return d = null;

        XSPARQLRewriter.namedGraphClause_return e = null;


        CommonTree f_tree=null;
        RewriteRuleNodeStream stream_FROM=new RewriteRuleNodeStream(adaptor,"token FROM");
        RewriteRuleSubtreeStream stream_defaultGraphClause=new RewriteRuleSubtreeStream(adaptor,"rule defaultGraphClause");
        RewriteRuleSubtreeStream stream_namedGraphClause=new RewriteRuleSubtreeStream(adaptor,"rule namedGraphClause");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2081:3: ( ^(f= FROM (d= defaultGraphClause | e= namedGraphClause ) ) -> QSTRING[$f.token, \"\\n \" + $f.text + \" \"] ( $d)? ( $e)? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2081:5: ^(f= FROM (d= defaultGraphClause | e= namedGraphClause ) )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            f=(CommonTree)match(input,FROM,FOLLOW_FROM_in_datasetClause9371); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_FROM.add(f);


            if ( state.backtracking==0 ) {
               ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset = false; 
            }

            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2081:57: (d= defaultGraphClause | e= namedGraphClause )
            int alt139=2;
            switch ( input.LA(1) ) {
            case VAR:
            case IRIREF:
                {
                alt139=1;
                }
                break;
            case NAMED:
                {
                alt139=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 139, 0, input);

                throw nvae;
            }

            switch (alt139) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2081:58: d= defaultGraphClause
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_defaultGraphClause_in_datasetClause9378);
                    d=defaultGraphClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_defaultGraphClause.add(d.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2081:81: e= namedGraphClause
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_namedGraphClause_in_datasetClause9384);
                    e=namedGraphClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_namedGraphClause.add(e.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: d, e
            // token labels: 
            // rule labels: retval, d, e
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_d=new RewriteRuleSubtreeStream(adaptor,"rule d",d!=null?d.tree:null);
            RewriteRuleSubtreeStream stream_e=new RewriteRuleSubtreeStream(adaptor,"rule e",e!=null?e.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2082:3: -> QSTRING[$f.token, \"\\n \" + $f.text + \" \"] ( $d)? ( $e)?
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, f.token, "\n " + (f!=null?f.getText():null) + " "));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2082:47: ( $d)?
                if ( stream_d.hasNext() ) {
                    adaptor.addChild(root_0, stream_d.nextTree());

                }
                stream_d.reset();
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2082:51: ( $e)?
                if ( stream_e.hasNext() ) {
                    adaptor.addChild(root_0, stream_e.nextTree());

                }
                stream_e.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "datasetClause"

    public static class defaultGraphClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "defaultGraphClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2085:1: defaultGraphClause : sourceSelector ;
    public final XSPARQLRewriter.defaultGraphClause_return defaultGraphClause() throws RecognitionException {
        XSPARQLRewriter.defaultGraphClause_return retval = new XSPARQLRewriter.defaultGraphClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.sourceSelector_return sourceSelector531 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2086:3: ( sourceSelector )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2086:5: sourceSelector
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sourceSelector_in_defaultGraphClause9415);
            sourceSelector531=sourceSelector();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, sourceSelector531.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "defaultGraphClause"

    public static class namedGraphClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "namedGraphClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2089:1: namedGraphClause : n= NAMED sourceSelector -> QSTRING[$n.token, $n.text] sourceSelector ;
    public final XSPARQLRewriter.namedGraphClause_return namedGraphClause() throws RecognitionException {
        XSPARQLRewriter.namedGraphClause_return retval = new XSPARQLRewriter.namedGraphClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree n=null;
        XSPARQLRewriter.sourceSelector_return sourceSelector532 = null;


        CommonTree n_tree=null;
        RewriteRuleNodeStream stream_NAMED=new RewriteRuleNodeStream(adaptor,"token NAMED");
        RewriteRuleSubtreeStream stream_sourceSelector=new RewriteRuleSubtreeStream(adaptor,"rule sourceSelector");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2090:3: (n= NAMED sourceSelector -> QSTRING[$n.token, $n.text] sourceSelector )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2090:5: n= NAMED sourceSelector
            {
            _last = (CommonTree)input.LT(1);
            n=(CommonTree)match(input,NAMED,FOLLOW_NAMED_in_namedGraphClause9430); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_NAMED.add(n);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sourceSelector_in_namedGraphClause9432);
            sourceSelector532=sourceSelector();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_sourceSelector.add(sourceSelector532.getTree());


            // AST REWRITE
            // elements: sourceSelector
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2091:3: -> QSTRING[$n.token, $n.text] sourceSelector
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, n.token, (n!=null?n.getText():null)));
                adaptor.addChild(root_0, stream_sourceSelector.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "namedGraphClause"

    public static class sourceSelector_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sourceSelector"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2094:1: sourceSelector : (i= IRIREF -> QSTRING[$i.token, \"<\" + $i.text + \">\"] | v= VAR -> {isBound(\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\")}? QSTRING[$v.token, \"<\"] VAR[\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\"] QSTRING[$v.token, \">\"] -> ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) ) ) ) );
    public final XSPARQLRewriter.sourceSelector_return sourceSelector() throws RecognitionException {
        XSPARQLRewriter.sourceSelector_return retval = new XSPARQLRewriter.sourceSelector_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree i=null;
        CommonTree v=null;

        CommonTree i_tree=null;
        CommonTree v_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_IRIREF=new RewriteRuleNodeStream(adaptor,"token IRIREF");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2095:3: (i= IRIREF -> QSTRING[$i.token, \"<\" + $i.text + \">\"] | v= VAR -> {isBound(\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\")}? QSTRING[$v.token, \"<\"] VAR[\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\"] QSTRING[$v.token, \">\"] -> ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) ) ) ) )
            int alt140=2;
            switch ( input.LA(1) ) {
            case IRIREF:
                {
                alt140=1;
                }
                break;
            case VAR:
                {
                alt140=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 140, 0, input);

                throw nvae;
            }

            switch (alt140) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2095:5: i= IRIREF
                    {
                    _last = (CommonTree)input.LT(1);
                    i=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_sourceSelector9456); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IRIREF.add(i);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2096:3: -> QSTRING[$i.token, \"<\" + $i.text + \">\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, i.token, "<" + (i!=null?i.getText():null) + ">"));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2097:5: v= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sourceSelector9471); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);



                    // AST REWRITE
                    // elements: VAR, v
                    // token labels: v
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_v=new RewriteRuleNodeStream(adaptor,"token v",v);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2098:3: -> {isBound(\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\")}? QSTRING[$v.token, \"<\"] VAR[\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\"] QSTRING[$v.token, \">\"]
                    if (isBound("$_" + Helper.removeLeading((v!=null?v.getText():null),"$")+"_graph")) {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, v.token, "<"));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(VAR, "$_" + Helper.removeLeading((v!=null?v.getText():null),"$")+"_graph"));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, v.token, ">"));

                    }
                    else // 2099:3: -> ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2099:6: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2100:9: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2101:15: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2101:61: ^( T_PARAMS $v)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_v.nextNode());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sourceSelector"

    public static class sWhereClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sWhereClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2106:1: sWhereClause : ^(w= T_SPARQL_WHERE groupGraphPattern ) -> QSTRING[$w.token, \"\\n \" + $w.text + \" \"] groupGraphPattern ;
    public final XSPARQLRewriter.sWhereClause_return sWhereClause() throws RecognitionException {
        XSPARQLRewriter.sWhereClause_return retval = new XSPARQLRewriter.sWhereClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree w=null;
        XSPARQLRewriter.groupGraphPattern_return groupGraphPattern533 = null;


        CommonTree w_tree=null;
        RewriteRuleNodeStream stream_T_SPARQL_WHERE=new RewriteRuleNodeStream(adaptor,"token T_SPARQL_WHERE");
        RewriteRuleSubtreeStream stream_groupGraphPattern=new RewriteRuleSubtreeStream(adaptor,"rule groupGraphPattern");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2107:3: ( ^(w= T_SPARQL_WHERE groupGraphPattern ) -> QSTRING[$w.token, \"\\n \" + $w.text + \" \"] groupGraphPattern )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2107:5: ^(w= T_SPARQL_WHERE groupGraphPattern )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            w=(CommonTree)match(input,T_SPARQL_WHERE,FOLLOW_T_SPARQL_WHERE_in_sWhereClause9572); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_SPARQL_WHERE.add(w);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_groupGraphPattern_in_sWhereClause9574);
            groupGraphPattern533=groupGraphPattern();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_groupGraphPattern.add(groupGraphPattern533.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: groupGraphPattern
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2108:3: -> QSTRING[$w.token, \"\\n \" + $w.text + \" \"] groupGraphPattern
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, w.token, "\n " + (w!=null?w.getText():null) + " "));
                adaptor.addChild(root_0, stream_groupGraphPattern.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sWhereClause"

    public static class solutionmodifier_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "solutionmodifier"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2112:1: solutionmodifier : ( orderclause ( limitoffsetclauses )? | ( groupBy )? ( having )? ( limitoffsetclauses )? );
    public final XSPARQLRewriter.solutionmodifier_return solutionmodifier() throws RecognitionException {
        XSPARQLRewriter.solutionmodifier_return retval = new XSPARQLRewriter.solutionmodifier_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.orderclause_return orderclause534 = null;

        XSPARQLRewriter.limitoffsetclauses_return limitoffsetclauses535 = null;

        XSPARQLRewriter.groupBy_return groupBy536 = null;

        XSPARQLRewriter.having_return having537 = null;

        XSPARQLRewriter.limitoffsetclauses_return limitoffsetclauses538 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2113:3: ( orderclause ( limitoffsetclauses )? | ( groupBy )? ( having )? ( limitoffsetclauses )? )
            int alt145=2;
            switch ( input.LA(1) ) {
            case ORDER:
                {
                alt145=1;
                }
                break;
            case EOF:
            case UP:
            case LIMIT:
            case OFFSET:
            case T_CONSTRUCT:
            case T_RETURN:
            case T_GROUP_BY:
            case T_HAVING:
                {
                alt145=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 145, 0, input);

                throw nvae;
            }

            switch (alt145) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2113:5: orderclause ( limitoffsetclauses )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orderclause_in_solutionmodifier9602);
                    orderclause534=orderclause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, orderclause534.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2113:17: ( limitoffsetclauses )?
                    int alt141=2;
                    switch ( input.LA(1) ) {
                        case LIMIT:
                        case OFFSET:
                            {
                            alt141=1;
                            }
                            break;
                    }

                    switch (alt141) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: limitoffsetclauses
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_limitoffsetclauses_in_solutionmodifier9604);
                            limitoffsetclauses535=limitoffsetclauses();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, limitoffsetclauses535.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2114:5: ( groupBy )? ( having )? ( limitoffsetclauses )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2114:5: ( groupBy )?
                    int alt142=2;
                    switch ( input.LA(1) ) {
                        case T_GROUP_BY:
                            {
                            alt142=1;
                            }
                            break;
                    }

                    switch (alt142) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: groupBy
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_groupBy_in_solutionmodifier9611);
                            groupBy536=groupBy();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, groupBy536.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2114:14: ( having )?
                    int alt143=2;
                    switch ( input.LA(1) ) {
                        case T_HAVING:
                            {
                            alt143=1;
                            }
                            break;
                    }

                    switch (alt143) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: having
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_having_in_solutionmodifier9614);
                            having537=having();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, having537.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2114:22: ( limitoffsetclauses )?
                    int alt144=2;
                    switch ( input.LA(1) ) {
                        case LIMIT:
                        case OFFSET:
                            {
                            alt144=1;
                            }
                            break;
                    }

                    switch (alt144) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: limitoffsetclauses
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_limitoffsetclauses_in_solutionmodifier9617);
                            limitoffsetclauses538=limitoffsetclauses();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, limitoffsetclauses538.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "solutionmodifier"

    public static class groupBy_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "groupBy"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2117:1: groupBy : ^( T_GROUP_BY VAR ) ;
    public final XSPARQLRewriter.groupBy_return groupBy() throws RecognitionException {
        XSPARQLRewriter.groupBy_return retval = new XSPARQLRewriter.groupBy_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_GROUP_BY539=null;
        CommonTree VAR540=null;

        CommonTree T_GROUP_BY539_tree=null;
        CommonTree VAR540_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2118:3: ( ^( T_GROUP_BY VAR ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2118:5: ^( T_GROUP_BY VAR )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_GROUP_BY539=(CommonTree)match(input,T_GROUP_BY,FOLLOW_T_GROUP_BY_in_groupBy9633); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_GROUP_BY539_tree = (CommonTree)adaptor.dupNode(T_GROUP_BY539);

            root_1 = (CommonTree)adaptor.becomeRoot(T_GROUP_BY539_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            VAR540=(CommonTree)match(input,VAR,FOLLOW_VAR_in_groupBy9635); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            VAR540_tree = (CommonTree)adaptor.dupNode(VAR540);

            adaptor.addChild(root_1, VAR540_tree);
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "groupBy"

    public static class having_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "having"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2121:1: having : ^( T_HAVING exprSingle ) ;
    public final XSPARQLRewriter.having_return having() throws RecognitionException {
        XSPARQLRewriter.having_return retval = new XSPARQLRewriter.having_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_HAVING541=null;
        XSPARQLRewriter.exprSingle_return exprSingle542 = null;


        CommonTree T_HAVING541_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2122:3: ( ^( T_HAVING exprSingle ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2122:5: ^( T_HAVING exprSingle )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_HAVING541=(CommonTree)match(input,T_HAVING,FOLLOW_T_HAVING_in_having9650); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_HAVING541_tree = (CommonTree)adaptor.dupNode(T_HAVING541);

            root_1 = (CommonTree)adaptor.becomeRoot(T_HAVING541_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_having9652);
            exprSingle542=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, exprSingle542.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "having"

    public static class limitoffsetclauses_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "limitoffsetclauses"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2125:1: limitoffsetclauses : ( limitclause ( offsetclause )? | offsetclause ( limitclause )? );
    public final XSPARQLRewriter.limitoffsetclauses_return limitoffsetclauses() throws RecognitionException {
        XSPARQLRewriter.limitoffsetclauses_return retval = new XSPARQLRewriter.limitoffsetclauses_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.limitclause_return limitclause543 = null;

        XSPARQLRewriter.offsetclause_return offsetclause544 = null;

        XSPARQLRewriter.offsetclause_return offsetclause545 = null;

        XSPARQLRewriter.limitclause_return limitclause546 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2126:3: ( limitclause ( offsetclause )? | offsetclause ( limitclause )? )
            int alt148=2;
            switch ( input.LA(1) ) {
            case LIMIT:
                {
                alt148=1;
                }
                break;
            case OFFSET:
                {
                alt148=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 148, 0, input);

                throw nvae;
            }

            switch (alt148) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2126:5: limitclause ( offsetclause )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_limitclause_in_limitoffsetclauses9666);
                    limitclause543=limitclause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, limitclause543.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2126:17: ( offsetclause )?
                    int alt146=2;
                    switch ( input.LA(1) ) {
                        case OFFSET:
                            {
                            alt146=1;
                            }
                            break;
                    }

                    switch (alt146) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: offsetclause
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_offsetclause_in_limitoffsetclauses9668);
                            offsetclause544=offsetclause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, offsetclause544.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2127:5: offsetclause ( limitclause )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_offsetclause_in_limitoffsetclauses9675);
                    offsetclause545=offsetclause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, offsetclause545.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2127:18: ( limitclause )?
                    int alt147=2;
                    switch ( input.LA(1) ) {
                        case LIMIT:
                            {
                            alt147=1;
                            }
                            break;
                    }

                    switch (alt147) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: limitclause
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_limitclause_in_limitoffsetclauses9677);
                            limitclause546=limitclause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, limitclause546.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "limitoffsetclauses"

    public static class orderclause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderclause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2130:1: orderclause : ^(o= ORDER orderCondition ) -> QSTRING[$o.token, $o.text + \" by \"] orderCondition ;
    public final XSPARQLRewriter.orderclause_return orderclause() throws RecognitionException {
        XSPARQLRewriter.orderclause_return retval = new XSPARQLRewriter.orderclause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.orderCondition_return orderCondition547 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_ORDER=new RewriteRuleNodeStream(adaptor,"token ORDER");
        RewriteRuleSubtreeStream stream_orderCondition=new RewriteRuleSubtreeStream(adaptor,"rule orderCondition");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2131:3: ( ^(o= ORDER orderCondition ) -> QSTRING[$o.token, $o.text + \" by \"] orderCondition )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2131:5: ^(o= ORDER orderCondition )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            o=(CommonTree)match(input,ORDER,FOLLOW_ORDER_in_orderclause9694); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_ORDER.add(o);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_orderCondition_in_orderclause9696);
            orderCondition547=orderCondition();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_orderCondition.add(orderCondition547.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: orderCondition
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2132:3: -> QSTRING[$o.token, $o.text + \" by \"] orderCondition
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null) + " by "));
                adaptor.addChild(root_0, stream_orderCondition.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderclause"

    public static class orderCondition_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderCondition"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2135:1: orderCondition : ( ( ASC | DESC ) brackettedExpression | constraint | v= VAR -> QSTRING[$v.token, $v.text+ \" \"] );
    public final XSPARQLRewriter.orderCondition_return orderCondition() throws RecognitionException {
        XSPARQLRewriter.orderCondition_return retval = new XSPARQLRewriter.orderCondition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree v=null;
        CommonTree set548=null;
        XSPARQLRewriter.brackettedExpression_return brackettedExpression549 = null;

        XSPARQLRewriter.constraint_return constraint550 = null;


        CommonTree v_tree=null;
        CommonTree set548_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2136:3: ( ( ASC | DESC ) brackettedExpression | constraint | v= VAR -> QSTRING[$v.token, $v.text+ \" \"] )
            int alt149=3;
            switch ( input.LA(1) ) {
            case ASC:
            case DESC:
                {
                alt149=1;
                }
                break;
            case LPAR:
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
                {
                alt149=2;
                }
                break;
            case VAR:
                {
                alt149=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 149, 0, input);

                throw nvae;
            }

            switch (alt149) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2136:5: ( ASC | DESC ) brackettedExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    set548=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=ASC && input.LA(1)<=DESC) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set548_tree = (CommonTree)adaptor.dupNode(set548);

                        adaptor.addChild(root_0, set548_tree);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_orderCondition9727);
                    brackettedExpression549=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, brackettedExpression549.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2137:5: constraint
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constraint_in_orderCondition9733);
                    constraint550=constraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, constraint550.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2138:5: v= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_orderCondition9741); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2138:11: -> QSTRING[$v.token, $v.text+ \" \"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, v.token, (v!=null?v.getText():null)+ " "));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderCondition"

    public static class limitclause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "limitclause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2141:1: limitclause : ^(l= LIMIT i= INTEGER ) -> QSTRING[$l.token, $l.text + \" \" + $i.text + \" \"] ;
    public final XSPARQLRewriter.limitclause_return limitclause() throws RecognitionException {
        XSPARQLRewriter.limitclause_return retval = new XSPARQLRewriter.limitclause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree l=null;
        CommonTree i=null;

        CommonTree l_tree=null;
        CommonTree i_tree=null;
        RewriteRuleNodeStream stream_INTEGER=new RewriteRuleNodeStream(adaptor,"token INTEGER");
        RewriteRuleNodeStream stream_LIMIT=new RewriteRuleNodeStream(adaptor,"token LIMIT");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2142:3: ( ^(l= LIMIT i= INTEGER ) -> QSTRING[$l.token, $l.text + \" \" + $i.text + \" \"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2142:5: ^(l= LIMIT i= INTEGER )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            l=(CommonTree)match(input,LIMIT,FOLLOW_LIMIT_in_limitclause9762); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_LIMIT.add(l);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            i=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_limitclause9766); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_INTEGER.add(i);


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2143:3: -> QSTRING[$l.token, $l.text + \" \" + $i.text + \" \"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l.token, (l!=null?l.getText():null) + " " + (i!=null?i.getText():null) + " "));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "limitclause"

    public static class offsetclause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "offsetclause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2146:1: offsetclause : ^(o= OFFSET i= INTEGER ) -> QSTRING[$o.token, $o.text + \" \" + $i.text + \" \"] ;
    public final XSPARQLRewriter.offsetclause_return offsetclause() throws RecognitionException {
        XSPARQLRewriter.offsetclause_return retval = new XSPARQLRewriter.offsetclause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        CommonTree i=null;

        CommonTree o_tree=null;
        CommonTree i_tree=null;
        RewriteRuleNodeStream stream_INTEGER=new RewriteRuleNodeStream(adaptor,"token INTEGER");
        RewriteRuleNodeStream stream_OFFSET=new RewriteRuleNodeStream(adaptor,"token OFFSET");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2147:3: ( ^(o= OFFSET i= INTEGER ) -> QSTRING[$o.token, $o.text + \" \" + $i.text + \" \"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2147:5: ^(o= OFFSET i= INTEGER )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            o=(CommonTree)match(input,OFFSET,FOLLOW_OFFSET_in_offsetclause9790); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_OFFSET.add(o);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            i=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_offsetclause9794); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_INTEGER.add(i);


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2148:3: -> QSTRING[$o.token, $o.text + \" \" + $i.text + \" \"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null) + " " + (i!=null?i.getText():null) + " "));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "offsetclause"

    public static class groupGraphPattern_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "groupGraphPattern"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2151:1: groupGraphPattern options {backtrack=true; } : ( singleGroupGraphPattern )+ -> QSTRING[\" { \"] ( singleGroupGraphPattern )+ QSTRING[\" } \"] ;
    public final XSPARQLRewriter.groupGraphPattern_return groupGraphPattern() throws RecognitionException {
        XSPARQLRewriter.groupGraphPattern_return retval = new XSPARQLRewriter.groupGraphPattern_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.singleGroupGraphPattern_return singleGroupGraphPattern551 = null;


        RewriteRuleSubtreeStream stream_singleGroupGraphPattern=new RewriteRuleSubtreeStream(adaptor,"rule singleGroupGraphPattern");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2155:3: ( ( singleGroupGraphPattern )+ -> QSTRING[\" { \"] ( singleGroupGraphPattern )+ QSTRING[\" } \"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2155:5: ( singleGroupGraphPattern )+
            {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2155:5: ( singleGroupGraphPattern )+
            int cnt150=0;
            loop150:
            do {
                int alt150=2;
                switch ( input.LA(1) ) {
                case UNION:
                case OPTIONAL:
                case FILTER:
                case GRAPH:
                case T_SUBJECT:
                    {
                    alt150=1;
                    }
                    break;

                }

                switch (alt150) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: singleGroupGraphPattern
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_singleGroupGraphPattern_in_groupGraphPattern9824);
            	    singleGroupGraphPattern551=singleGroupGraphPattern();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_singleGroupGraphPattern.add(singleGroupGraphPattern551.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt150 >= 1 ) break loop150;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(150, input);
                        throw eee;
                }
                cnt150++;
            } while (true);



            // AST REWRITE
            // elements: singleGroupGraphPattern
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2156:3: -> QSTRING[\" { \"] ( singleGroupGraphPattern )+ QSTRING[\" } \"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " { "));
                if ( !(stream_singleGroupGraphPattern.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_singleGroupGraphPattern.hasNext() ) {
                    adaptor.addChild(root_0, stream_singleGroupGraphPattern.nextTree());

                }
                stream_singleGroupGraphPattern.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " } "));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "groupGraphPattern"

    public static class singleGroupGraphPattern_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleGroupGraphPattern"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2159:1: singleGroupGraphPattern options {backtrack=true; } : ( triplesBlock | graphPatternNotTriples | filter );
    public final XSPARQLRewriter.singleGroupGraphPattern_return singleGroupGraphPattern() throws RecognitionException {
        XSPARQLRewriter.singleGroupGraphPattern_return retval = new XSPARQLRewriter.singleGroupGraphPattern_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.triplesBlock_return triplesBlock552 = null;

        XSPARQLRewriter.graphPatternNotTriples_return graphPatternNotTriples553 = null;

        XSPARQLRewriter.filter_return filter554 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2163:3: ( triplesBlock | graphPatternNotTriples | filter )
            int alt151=3;
            switch ( input.LA(1) ) {
            case T_SUBJECT:
                {
                alt151=1;
                }
                break;
            case UNION:
            case OPTIONAL:
            case GRAPH:
                {
                alt151=2;
                }
                break;
            case FILTER:
                {
                alt151=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 151, 0, input);

                throw nvae;
            }

            switch (alt151) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2163:5: triplesBlock
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_triplesBlock_in_singleGroupGraphPattern9860);
                    triplesBlock552=triplesBlock();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, triplesBlock552.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2164:5: graphPatternNotTriples
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_graphPatternNotTriples_in_singleGroupGraphPattern9866);
                    graphPatternNotTriples553=graphPatternNotTriples();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, graphPatternNotTriples553.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2165:5: filter
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_filter_in_singleGroupGraphPattern9872);
                    filter554=filter();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, filter554.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleGroupGraphPattern"

    public static class triplesBlock_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "triplesBlock"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2168:1: triplesBlock : ( triplesSameSubject )+ ;
    public final XSPARQLRewriter.triplesBlock_return triplesBlock() throws RecognitionException {
        XSPARQLRewriter.triplesBlock_return retval = new XSPARQLRewriter.triplesBlock_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.triplesSameSubject_return triplesSameSubject555 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2169:3: ( ( triplesSameSubject )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2169:5: ( triplesSameSubject )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2169:5: ( triplesSameSubject )+
            int cnt152=0;
            loop152:
            do {
                int alt152=2;
                switch ( input.LA(1) ) {
                case T_SUBJECT:
                    {
                    int LA152_2 = input.LA(2);

                    if ( (synpred253_XSPARQLRewriter()) ) {
                        alt152=1;
                    }


                    }
                    break;

                }

                switch (alt152) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: triplesSameSubject
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_triplesSameSubject_in_triplesBlock9887);
            	    triplesSameSubject555=triplesSameSubject();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, triplesSameSubject555.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt152 >= 1 ) break loop152;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(152, input);
                        throw eee;
                }
                cnt152++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "triplesBlock"

    public static class graphPatternNotTriples_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "graphPatternNotTriples"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2172:1: graphPatternNotTriples : ( optionalGraphPattern | groupOrUnionGraphPattern | graphGraphPattern );
    public final XSPARQLRewriter.graphPatternNotTriples_return graphPatternNotTriples() throws RecognitionException {
        XSPARQLRewriter.graphPatternNotTriples_return retval = new XSPARQLRewriter.graphPatternNotTriples_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.optionalGraphPattern_return optionalGraphPattern556 = null;

        XSPARQLRewriter.groupOrUnionGraphPattern_return groupOrUnionGraphPattern557 = null;

        XSPARQLRewriter.graphGraphPattern_return graphGraphPattern558 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2173:3: ( optionalGraphPattern | groupOrUnionGraphPattern | graphGraphPattern )
            int alt153=3;
            switch ( input.LA(1) ) {
            case OPTIONAL:
                {
                alt153=1;
                }
                break;
            case UNION:
                {
                alt153=2;
                }
                break;
            case GRAPH:
                {
                alt153=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 153, 0, input);

                throw nvae;
            }

            switch (alt153) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2173:5: optionalGraphPattern
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_optionalGraphPattern_in_graphPatternNotTriples9901);
                    optionalGraphPattern556=optionalGraphPattern();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, optionalGraphPattern556.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2174:5: groupOrUnionGraphPattern
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_groupOrUnionGraphPattern_in_graphPatternNotTriples9907);
                    groupOrUnionGraphPattern557=groupOrUnionGraphPattern();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, groupOrUnionGraphPattern557.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2175:5: graphGraphPattern
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_graphGraphPattern_in_graphPatternNotTriples9913);
                    graphGraphPattern558=graphGraphPattern();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, graphGraphPattern558.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "graphPatternNotTriples"

    public static class optionalGraphPattern_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "optionalGraphPattern"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2178:1: optionalGraphPattern : ^(o= OPTIONAL groupGraphPattern ) -> QSTRING[$o.token, \"\\n \" + $o.text +\" \"] groupGraphPattern ;
    public final XSPARQLRewriter.optionalGraphPattern_return optionalGraphPattern() throws RecognitionException {
        XSPARQLRewriter.optionalGraphPattern_return retval = new XSPARQLRewriter.optionalGraphPattern_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.groupGraphPattern_return groupGraphPattern559 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_OPTIONAL=new RewriteRuleNodeStream(adaptor,"token OPTIONAL");
        RewriteRuleSubtreeStream stream_groupGraphPattern=new RewriteRuleSubtreeStream(adaptor,"rule groupGraphPattern");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2179:3: ( ^(o= OPTIONAL groupGraphPattern ) -> QSTRING[$o.token, \"\\n \" + $o.text +\" \"] groupGraphPattern )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2179:5: ^(o= OPTIONAL groupGraphPattern )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            o=(CommonTree)match(input,OPTIONAL,FOLLOW_OPTIONAL_in_optionalGraphPattern9929); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_OPTIONAL.add(o);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_groupGraphPattern_in_optionalGraphPattern9931);
            groupGraphPattern559=groupGraphPattern();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_groupGraphPattern.add(groupGraphPattern559.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: groupGraphPattern
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2180:3: -> QSTRING[$o.token, \"\\n \" + $o.text +\" \"] groupGraphPattern
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, "\n " + (o!=null?o.getText():null) +" "));
                adaptor.addChild(root_0, stream_groupGraphPattern.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "optionalGraphPattern"

    public static class graphGraphPattern_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "graphGraphPattern"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2183:1: graphGraphPattern : ^(g= GRAPH varOrIRIref groupGraphPattern ) -> QSTRING[$g.token,\"\\n \" + $g.text + \" \"] varOrIRIref groupGraphPattern ;
    public final XSPARQLRewriter.graphGraphPattern_return graphGraphPattern() throws RecognitionException {
        XSPARQLRewriter.graphGraphPattern_return retval = new XSPARQLRewriter.graphGraphPattern_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree g=null;
        XSPARQLRewriter.varOrIRIref_return varOrIRIref560 = null;

        XSPARQLRewriter.groupGraphPattern_return groupGraphPattern561 = null;


        CommonTree g_tree=null;
        RewriteRuleNodeStream stream_GRAPH=new RewriteRuleNodeStream(adaptor,"token GRAPH");
        RewriteRuleSubtreeStream stream_varOrIRIref=new RewriteRuleSubtreeStream(adaptor,"rule varOrIRIref");
        RewriteRuleSubtreeStream stream_groupGraphPattern=new RewriteRuleSubtreeStream(adaptor,"rule groupGraphPattern");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2184:3: ( ^(g= GRAPH varOrIRIref groupGraphPattern ) -> QSTRING[$g.token,\"\\n \" + $g.text + \" \"] varOrIRIref groupGraphPattern )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2184:5: ^(g= GRAPH varOrIRIref groupGraphPattern )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            g=(CommonTree)match(input,GRAPH,FOLLOW_GRAPH_in_graphGraphPattern9957); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_GRAPH.add(g);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_varOrIRIref_in_graphGraphPattern9959);
            varOrIRIref560=varOrIRIref();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_varOrIRIref.add(varOrIRIref560.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_groupGraphPattern_in_graphGraphPattern9961);
            groupGraphPattern561=groupGraphPattern();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_groupGraphPattern.add(groupGraphPattern561.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: varOrIRIref, groupGraphPattern
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2185:3: -> QSTRING[$g.token,\"\\n \" + $g.text + \" \"] varOrIRIref groupGraphPattern
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, g.token, "\n " + (g!=null?g.getText():null) + " "));
                adaptor.addChild(root_0, stream_varOrIRIref.nextTree());
                adaptor.addChild(root_0, stream_groupGraphPattern.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "graphGraphPattern"

    public static class groupOrUnionGraphPattern_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "groupOrUnionGraphPattern"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2188:1: groupOrUnionGraphPattern : ^(u= UNION ^( T_UNION g1= groupGraphPattern ) ( ^( T_UNION g2+= groupGraphPattern ) )+ ) -> QSTRING[\" { \"] $g1 ( QSTRING[$u.token,\" } \\n\" + $u.text + \" { \"] $g2)+ QSTRING[\" } \"] ;
    public final XSPARQLRewriter.groupOrUnionGraphPattern_return groupOrUnionGraphPattern() throws RecognitionException {
        XSPARQLRewriter.groupOrUnionGraphPattern_return retval = new XSPARQLRewriter.groupOrUnionGraphPattern_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree u=null;
        CommonTree T_UNION562=null;
        CommonTree T_UNION563=null;
        List list_g2=null;
        XSPARQLRewriter.groupGraphPattern_return g1 = null;

        RuleReturnScope g2 = null;
        CommonTree u_tree=null;
        CommonTree T_UNION562_tree=null;
        CommonTree T_UNION563_tree=null;
        RewriteRuleNodeStream stream_T_UNION=new RewriteRuleNodeStream(adaptor,"token T_UNION");
        RewriteRuleNodeStream stream_UNION=new RewriteRuleNodeStream(adaptor,"token UNION");
        RewriteRuleSubtreeStream stream_groupGraphPattern=new RewriteRuleSubtreeStream(adaptor,"rule groupGraphPattern");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2189:3: ( ^(u= UNION ^( T_UNION g1= groupGraphPattern ) ( ^( T_UNION g2+= groupGraphPattern ) )+ ) -> QSTRING[\" { \"] $g1 ( QSTRING[$u.token,\" } \\n\" + $u.text + \" { \"] $g2)+ QSTRING[\" } \"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2189:5: ^(u= UNION ^( T_UNION g1= groupGraphPattern ) ( ^( T_UNION g2+= groupGraphPattern ) )+ )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            u=(CommonTree)match(input,UNION,FOLLOW_UNION_in_groupOrUnionGraphPattern9989); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_UNION.add(u);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_UNION562=(CommonTree)match(input,T_UNION,FOLLOW_T_UNION_in_groupOrUnionGraphPattern9992); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_UNION.add(T_UNION562);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_groupGraphPattern_in_groupOrUnionGraphPattern9996);
            g1=groupGraphPattern();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_groupGraphPattern.add(g1.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2189:47: ( ^( T_UNION g2+= groupGraphPattern ) )+
            int cnt154=0;
            loop154:
            do {
                int alt154=2;
                switch ( input.LA(1) ) {
                case T_UNION:
                    {
                    alt154=1;
                    }
                    break;

                }

                switch (alt154) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2189:48: ^( T_UNION g2+= groupGraphPattern )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_2 = _last;
            	    CommonTree _first_2 = null;
            	    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_UNION563=(CommonTree)match(input,T_UNION,FOLLOW_T_UNION_in_groupOrUnionGraphPattern10001); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_T_UNION.add(T_UNION563);



            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_groupGraphPattern_in_groupOrUnionGraphPattern10005);
            	    g2=groupGraphPattern();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_groupGraphPattern.add(g2.getTree());
            	    if (list_g2==null) list_g2=new ArrayList();
            	    list_g2.add(g2.getTree());


            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt154 >= 1 ) break loop154;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(154, input);
                        throw eee;
                }
                cnt154++;
            } while (true);


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: g1, g2
            // token labels: 
            // rule labels: retval, g1
            // token list labels: 
            // rule list labels: g2
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_g1=new RewriteRuleSubtreeStream(adaptor,"rule g1",g1!=null?g1.tree:null);
            RewriteRuleSubtreeStream stream_g2=new RewriteRuleSubtreeStream(adaptor,"token g2",list_g2);
            root_0 = (CommonTree)adaptor.nil();
            // 2190:3: -> QSTRING[\" { \"] $g1 ( QSTRING[$u.token,\" } \\n\" + $u.text + \" { \"] $g2)+ QSTRING[\" } \"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " { "));
                adaptor.addChild(root_0, stream_g1.nextTree());
                if ( !(stream_g2.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_g2.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, u.token, " } \n" + (u!=null?u.getText():null) + " { "));
                    adaptor.addChild(root_0, stream_g2.nextTree());

                }
                stream_g2.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " } "));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "groupOrUnionGraphPattern"

    public static class filter_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "filter"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2193:1: filter : ^(f= FILTER constraint ) -> QSTRING[$f.token, \"\\n \"+$f.text] constraint ;
    public final XSPARQLRewriter.filter_return filter() throws RecognitionException {
        XSPARQLRewriter.filter_return retval = new XSPARQLRewriter.filter_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree f=null;
        XSPARQLRewriter.constraint_return constraint564 = null;


        CommonTree f_tree=null;
        RewriteRuleNodeStream stream_FILTER=new RewriteRuleNodeStream(adaptor,"token FILTER");
        RewriteRuleSubtreeStream stream_constraint=new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2194:3: ( ^(f= FILTER constraint ) -> QSTRING[$f.token, \"\\n \"+$f.text] constraint )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2194:5: ^(f= FILTER constraint )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            f=(CommonTree)match(input,FILTER,FOLLOW_FILTER_in_filter10047); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_FILTER.add(f);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_constraint_in_filter10049);
            constraint564=constraint();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_constraint.add(constraint564.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: constraint
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2195:3: -> QSTRING[$f.token, \"\\n \"+$f.text] constraint
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, f.token, "\n "+(f!=null?f.getText():null)));
                adaptor.addChild(root_0, stream_constraint.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "filter"

    public static class constraint_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constraint"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2198:1: constraint : ( brackettedExpression | builtInCall | sFunctionCall );
    public final XSPARQLRewriter.constraint_return constraint() throws RecognitionException {
        XSPARQLRewriter.constraint_return retval = new XSPARQLRewriter.constraint_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression565 = null;

        XSPARQLRewriter.builtInCall_return builtInCall566 = null;

        XSPARQLRewriter.sFunctionCall_return sFunctionCall567 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2199:3: ( brackettedExpression | builtInCall | sFunctionCall )
            int alt155=3;
            switch ( input.LA(1) ) {
            case LPAR:
                {
                alt155=1;
                }
                break;
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
                {
                alt155=2;
                }
                break;
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
                {
                alt155=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 155, 0, input);

                throw nvae;
            }

            switch (alt155) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2199:5: brackettedExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_constraint10072);
                    brackettedExpression565=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, brackettedExpression565.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2200:5: builtInCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_builtInCall_in_constraint10078);
                    builtInCall566=builtInCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, builtInCall566.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2201:5: sFunctionCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sFunctionCall_in_constraint10084);
                    sFunctionCall567=sFunctionCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sFunctionCall567.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constraint"

    public static class sFunctionCall_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sFunctionCall"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2204:1: sFunctionCall : iRIref ( arglist )? ;
    public final XSPARQLRewriter.sFunctionCall_return sFunctionCall() throws RecognitionException {
        XSPARQLRewriter.sFunctionCall_return retval = new XSPARQLRewriter.sFunctionCall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.iRIref_return iRIref568 = null;

        XSPARQLRewriter.arglist_return arglist569 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2205:3: ( iRIref ( arglist )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2205:5: iRIref ( arglist )?
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_iRIref_in_sFunctionCall10097);
            iRIref568=iRIref();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, iRIref568.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2205:12: ( arglist )?
            int alt156=2;
            switch ( input.LA(1) ) {
                case VAR:
                case INTEGER:
                case QSTRING:
                case SLASH:
                case LPAR:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case ORSYMBOL:
                case ANDSYMBOL:
                case NOT:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case T_FUNCTION_CALL:
                    {
                    alt156=1;
                    }
                    break;
            }

            switch (alt156) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: arglist
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_arglist_in_sFunctionCall10099);
                    arglist569=arglist();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, arglist569.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sFunctionCall"

    public static class arglist_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "arglist"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2208:1: arglist options {backtrack=true; } : e1= expression (e2+= expression )* -> $e1 ( QSTRING[\",\"] $e2)* ;
    public final XSPARQLRewriter.arglist_return arglist() throws RecognitionException {
        XSPARQLRewriter.arglist_return retval = new XSPARQLRewriter.arglist_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        List list_e2=null;
        XSPARQLRewriter.expression_return e1 = null;

        RuleReturnScope e2 = null;
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2210:3: (e1= expression (e2+= expression )* -> $e1 ( QSTRING[\",\"] $e2)* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2210:6: e1= expression (e2+= expression )*
            {
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expression_in_arglist10123);
            e1=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_expression.add(e1.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2210:22: (e2+= expression )*
            loop157:
            do {
                int alt157=2;
                switch ( input.LA(1) ) {
                case VAR:
                case INTEGER:
                case QSTRING:
                case SLASH:
                case LPAR:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case ORSYMBOL:
                case ANDSYMBOL:
                case NOT:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case T_FUNCTION_CALL:
                    {
                    alt157=1;
                    }
                    break;

                }

                switch (alt157) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: e2+= expression
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_expression_in_arglist10127);
            	    e2=expression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_expression.add(e2.getTree());
            	    if (list_e2==null) list_e2=new ArrayList();
            	    list_e2.add(e2.getTree());


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop157;
                }
            } while (true);



            // AST REWRITE
            // elements: e2, e1
            // token labels: 
            // rule labels: retval, e1
            // token list labels: 
            // rule list labels: e2
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_e1=new RewriteRuleSubtreeStream(adaptor,"rule e1",e1!=null?e1.tree:null);
            RewriteRuleSubtreeStream stream_e2=new RewriteRuleSubtreeStream(adaptor,"token e2",list_e2);
            root_0 = (CommonTree)adaptor.nil();
            // 2210:36: -> $e1 ( QSTRING[\",\"] $e2)*
            {
                adaptor.addChild(root_0, stream_e1.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2210:43: ( QSTRING[\",\"] $e2)*
                while ( stream_e2.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, ","));
                    adaptor.addChild(root_0, stream_e2.nextTree());

                }
                stream_e2.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "arglist"

    public static class constructTemplate_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructTemplate"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2213:1: constructTemplate : ( constructTriples )? ;
    public final XSPARQLRewriter.constructTemplate_return constructTemplate() throws RecognitionException {
        XSPARQLRewriter.constructTemplate_return retval = new XSPARQLRewriter.constructTemplate_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.constructTriples_return constructTriples570 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2214:3: ( ( constructTriples )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2214:5: ( constructTriples )?
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2214:5: ( constructTriples )?
            int alt158=2;
            switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_SUBJECT:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt158=1;
                    }
                    break;
            }

            switch (alt158) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: constructTriples
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructTriples_in_constructTemplate10155);
                    constructTriples570=constructTriples();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, constructTriples570.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constructTemplate"

    public static class constructTriples_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructTriples"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2217:1: constructTriples : ( triplesSameSubject_ | enclosedExpr )+ ;
    public final XSPARQLRewriter.constructTriples_return constructTriples() throws RecognitionException {
        XSPARQLRewriter.constructTriples_return retval = new XSPARQLRewriter.constructTriples_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.triplesSameSubject__return triplesSameSubject_571 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr572 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2218:3: ( ( triplesSameSubject_ | enclosedExpr )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2218:5: ( triplesSameSubject_ | enclosedExpr )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2218:5: ( triplesSameSubject_ | enclosedExpr )+
            int cnt159=0;
            loop159:
            do {
                int alt159=3;
                switch ( input.LA(1) ) {
                case T_SUBJECT:
                    {
                    alt159=1;
                    }
                    break;
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt159=2;
                    }
                    break;

                }

                switch (alt159) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2218:6: triplesSameSubject_
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_triplesSameSubject__in_constructTriples10170);
            	    triplesSameSubject_571=triplesSameSubject_();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, triplesSameSubject_571.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;
            	case 2 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2218:28: enclosedExpr
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_enclosedExpr_in_constructTriples10174);
            	    enclosedExpr572=enclosedExpr();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, enclosedExpr572.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt159 >= 1 ) break loop159;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(159, input);
                        throw eee;
                }
                cnt159++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constructTriples"

    public static class triplesSameSubject_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "triplesSameSubject"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2221:1: triplesSameSubject : ( ^( T_SUBJECT subject propertyListNotEmpty ) -> subject QSTRING[\" \"] propertyListNotEmpty QSTRING[\" . \\n\"] | ^( T_SUBJECT triplesNode ( propertyListNotEmpty )? ) -> triplesNode ( propertyListNotEmpty )? QSTRING[\" . \\n\"] );
    public final XSPARQLRewriter.triplesSameSubject_return triplesSameSubject() throws RecognitionException {
        XSPARQLRewriter.triplesSameSubject_return retval = new XSPARQLRewriter.triplesSameSubject_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_SUBJECT573=null;
        CommonTree T_SUBJECT576=null;
        XSPARQLRewriter.subject_return subject574 = null;

        XSPARQLRewriter.propertyListNotEmpty_return propertyListNotEmpty575 = null;

        XSPARQLRewriter.triplesNode_return triplesNode577 = null;

        XSPARQLRewriter.propertyListNotEmpty_return propertyListNotEmpty578 = null;


        CommonTree T_SUBJECT573_tree=null;
        CommonTree T_SUBJECT576_tree=null;
        RewriteRuleNodeStream stream_T_SUBJECT=new RewriteRuleNodeStream(adaptor,"token T_SUBJECT");
        RewriteRuleSubtreeStream stream_propertyListNotEmpty=new RewriteRuleSubtreeStream(adaptor,"rule propertyListNotEmpty");
        RewriteRuleSubtreeStream stream_subject=new RewriteRuleSubtreeStream(adaptor,"rule subject");
        RewriteRuleSubtreeStream stream_triplesNode=new RewriteRuleSubtreeStream(adaptor,"rule triplesNode");
        logger.info("triplesSameSubject");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2223:3: ( ^( T_SUBJECT subject propertyListNotEmpty ) -> subject QSTRING[\" \"] propertyListNotEmpty QSTRING[\" . \\n\"] | ^( T_SUBJECT triplesNode ( propertyListNotEmpty )? ) -> triplesNode ( propertyListNotEmpty )? QSTRING[\" . \\n\"] )
            int alt161=2;
            switch ( input.LA(1) ) {
            case T_SUBJECT:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case VAR:
                    case BLANK_NODE_LABEL:
                    case PNAME_NS:
                    case PNAME_LN:
                    case IRIREF:
                    case T_EMPTY_ANON_BLANK:
                        {
                        alt161=1;
                        }
                        break;
                    case LPAR:
                    case T_ANON_BLANK:
                        {
                        alt161=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 161, 2, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 161, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 161, 0, input);

                throw nvae;
            }

            switch (alt161) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2223:5: ^( T_SUBJECT subject propertyListNotEmpty )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_SUBJECT573=(CommonTree)match(input,T_SUBJECT,FOLLOW_T_SUBJECT_in_triplesSameSubject10194); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SUBJECT.add(T_SUBJECT573);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_subject_in_triplesSameSubject10196);
                    subject574=subject();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_subject.add(subject574.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty_in_triplesSameSubject10198);
                    propertyListNotEmpty575=propertyListNotEmpty();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty.add(propertyListNotEmpty575.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: propertyListNotEmpty, subject
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2224:3: -> subject QSTRING[\" \"] propertyListNotEmpty QSTRING[\" . \\n\"]
                    {
                        adaptor.addChild(root_0, stream_subject.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_0, stream_propertyListNotEmpty.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " . \n"));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2225:5: ^( T_SUBJECT triplesNode ( propertyListNotEmpty )? )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_SUBJECT576=(CommonTree)match(input,T_SUBJECT,FOLLOW_T_SUBJECT_in_triplesSameSubject10221); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SUBJECT.add(T_SUBJECT576);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_triplesNode_in_triplesSameSubject10223);
                    triplesNode577=triplesNode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_triplesNode.add(triplesNode577.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2225:29: ( propertyListNotEmpty )?
                    int alt160=2;
                    switch ( input.LA(1) ) {
                        case T_VERB:
                            {
                            alt160=1;
                            }
                            break;
                    }

                    switch (alt160) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: propertyListNotEmpty
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_propertyListNotEmpty_in_triplesSameSubject10225);
                            propertyListNotEmpty578=propertyListNotEmpty();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_propertyListNotEmpty.add(propertyListNotEmpty578.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: propertyListNotEmpty, triplesNode
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2226:3: -> triplesNode ( propertyListNotEmpty )? QSTRING[\" . \\n\"]
                    {
                        adaptor.addChild(root_0, stream_triplesNode.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2226:18: ( propertyListNotEmpty )?
                        if ( stream_propertyListNotEmpty.hasNext() ) {
                            adaptor.addChild(root_0, stream_propertyListNotEmpty.nextTree());

                        }
                        stream_propertyListNotEmpty.reset();
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " . \n"));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "triplesSameSubject"

    protected static class triplesSameSubject__scope {
        CommonTree subject;
        String separator;
    }
    protected Stack triplesSameSubject__stack = new Stack();

    public static class triplesSameSubject__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "triplesSameSubject_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2229:1: triplesSameSubject_ options {backtrack=true; } : ^( T_SUBJECT (a= subject_ propertyListNotEmpty_ -> propertyListNotEmpty_ | b= bnode propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | bc= blankConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | cvar= constructVar propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | f= enclosedExpr propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | c= iriConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | g= collection propertyListNotEmpty_ | (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK ) propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) ) ) ) ;
    public final XSPARQLRewriter.triplesSameSubject__return triplesSameSubject_() throws RecognitionException {
        triplesSameSubject__stack.push(new triplesSameSubject__scope());
        XSPARQLRewriter.triplesSameSubject__return retval = new XSPARQLRewriter.triplesSameSubject__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree h=null;
        CommonTree T_SUBJECT579=null;
        XSPARQLRewriter.subject__return a = null;

        XSPARQLRewriter.bnode_return b = null;

        XSPARQLRewriter.blankConstruct_return bc = null;

        XSPARQLRewriter.constructVar_return cvar = null;

        XSPARQLRewriter.enclosedExpr_return f = null;

        XSPARQLRewriter.iriConstruct_return c = null;

        XSPARQLRewriter.collection_return g = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_580 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_581 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_582 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_583 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_584 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_585 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_586 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_587 = null;


        CommonTree h_tree=null;
        CommonTree T_SUBJECT579_tree=null;
        RewriteRuleNodeStream stream_T_EMPTY_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_EMPTY_ANON_BLANK");
        RewriteRuleNodeStream stream_T_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_ANON_BLANK");
        RewriteRuleNodeStream stream_T_SUBJECT=new RewriteRuleNodeStream(adaptor,"token T_SUBJECT");
        RewriteRuleSubtreeStream stream_constructVar=new RewriteRuleSubtreeStream(adaptor,"rule constructVar");
        RewriteRuleSubtreeStream stream_bnode=new RewriteRuleSubtreeStream(adaptor,"rule bnode");
        RewriteRuleSubtreeStream stream_blankConstruct=new RewriteRuleSubtreeStream(adaptor,"rule blankConstruct");
        RewriteRuleSubtreeStream stream_subject_=new RewriteRuleSubtreeStream(adaptor,"rule subject_");
        RewriteRuleSubtreeStream stream_propertyListNotEmpty_=new RewriteRuleSubtreeStream(adaptor,"rule propertyListNotEmpty_");
        RewriteRuleSubtreeStream stream_iriConstruct=new RewriteRuleSubtreeStream(adaptor,"rule iriConstruct");
        RewriteRuleSubtreeStream stream_collection=new RewriteRuleSubtreeStream(adaptor,"rule collection");
        RewriteRuleSubtreeStream stream_enclosedExpr=new RewriteRuleSubtreeStream(adaptor,"rule enclosedExpr");

          String rdfTermVar = getNewTempRdfTermVariable();

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2240:3: ( ^( T_SUBJECT (a= subject_ propertyListNotEmpty_ -> propertyListNotEmpty_ | b= bnode propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | bc= blankConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | cvar= constructVar propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | f= enclosedExpr propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | c= iriConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | g= collection propertyListNotEmpty_ | (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK ) propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) ) ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2240:5: ^( T_SUBJECT (a= subject_ propertyListNotEmpty_ -> propertyListNotEmpty_ | b= bnode propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | bc= blankConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | cvar= constructVar propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | f= enclosedExpr propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | c= iriConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | g= collection propertyListNotEmpty_ | (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK ) propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) ) ) )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_SUBJECT579=(CommonTree)match(input,T_SUBJECT,FOLLOW_T_SUBJECT_in_triplesSameSubject_10271); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_SUBJECT.add(T_SUBJECT579);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2241:7: (a= subject_ propertyListNotEmpty_ -> propertyListNotEmpty_ | b= bnode propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | bc= blankConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | cvar= constructVar propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | f= enclosedExpr propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | c= iriConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | g= collection propertyListNotEmpty_ | (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK ) propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) ) )
            int alt163=8;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
            case A:
                {
                alt163=1;
                }
                break;
            case BLANK_NODE_LABEL:
                {
                alt163=2;
                }
                break;
            case BNODE_CONSTRUCT:
                {
                alt163=3;
                }
                break;
            case VAR:
                {
                alt163=4;
                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt163=5;
                }
                break;
            case T_IRI_CONSTRUCT:
                {
                alt163=6;
                }
                break;
            case LPAR:
                {
                alt163=7;
                }
                break;
            case T_ANON_BLANK:
            case T_EMPTY_ANON_BLANK:
                {
                alt163=8;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 163, 0, input);

                throw nvae;
            }

            switch (alt163) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2241:9: a= subject_ propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_subject__in_triplesSameSubject_10283);
                    a=subject_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_subject_.add(a.getTree());
                    if ( state.backtracking==0 ) {
                      ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = (a!=null?((CommonTree)a.tree):null); ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10291);
                    propertyListNotEmpty_580=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_580.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2242:7: -> propertyListNotEmpty_
                    {
                        adaptor.addChild(root_0, stream_propertyListNotEmpty_.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2243:9: b= bnode propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_bnode_in_triplesSameSubject_10313);
                    b=bnode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_bnode.add(b.getTree());
                    if ( state.backtracking==0 ) {
                      ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(VAR, rdfTermVar));  ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10321);
                    propertyListNotEmpty_581=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_581.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2244:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2244:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2245:12: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2247:14: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2249:16: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2250:18: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2252:20: ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) )
                        {
                        CommonTree root_7 = (CommonTree)adaptor.nil();
                        root_7 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_7);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2253:22: ^( T_PAR QSTRING[$b.text] )
                        {
                        CommonTree root_8 = (CommonTree)adaptor.nil();
                        root_8 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_8);

                        adaptor.addChild(root_8, (CommonTree)adaptor.create(QSTRING, (b!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(b.start),
                          input.getTreeAdaptor().getTokenStopIndex(b.start))):null)));
                        adaptor.addChild(root_8, getPositionVarList());

                        adaptor.addChild(root_7, root_8);
                        }

                        adaptor.addChild(root_6, root_7);
                        }

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2262:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2263:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2264:16: ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, validSubjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2264:63: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2265:16: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2270:9: bc= blankConstruct propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blankConstruct_in_triplesSameSubject_10828);
                    bc=blankConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_blankConstruct.add(bc.getTree());
                    if ( state.backtracking==0 ) {
                      ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(VAR, rdfTermVar));  ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10834);
                    propertyListNotEmpty_582=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_582.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_, bc
                    // token labels: 
                    // rule labels: retval, bc
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_bc=new RewriteRuleSubtreeStream(adaptor,"rule bc",bc!=null?bc.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2271:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2271:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2272:12: ^( T_LET VAR[rdfTermVar] $bc)
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_3, stream_bc.nextTree());

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2276:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2277:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2278:16: ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, validSubjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2278:63: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2279:16: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2284:9: cvar= constructVar propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructVar_in_triplesSameSubject_11062);
                    cvar=constructVar();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_constructVar.add(cvar.getTree());
                    if ( state.backtracking==0 ) {
                       ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(VAR, rdfTermVar));  
                                                  ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11075);
                    propertyListNotEmpty_583=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_583.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_, cvar
                    // token labels: 
                    // rule labels: cvar, retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_cvar=new RewriteRuleSubtreeStream(adaptor,"rule cvar",cvar!=null?cvar.tree:null);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2287:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2287:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2288:12: ^( T_LET VAR[rdfTermVar] $cvar)
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_3, stream_cvar.nextTree());

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2292:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2293:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2294:16: ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, validSubjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2294:63: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2295:16: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2300:9: f= enclosedExpr propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_triplesSameSubject_11301);
                    f=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(f.getTree());
                    if ( state.backtracking==0 ) {
                       ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(VAR, rdfTermVar));  
                                ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;"; 
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11323);
                    propertyListNotEmpty_584=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_584.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_, f
                    // token labels: 
                    // rule labels: f, retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_f=new RewriteRuleSubtreeStream(adaptor,"rule f",f!=null?f.tree:null);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2304:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2304:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2305:12: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2307:15: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2309:12: ^( T_PARAMS $f)
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, stream_f.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2314:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2315:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2316:16: ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, validSubjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2316:63: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2317:16: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2322:9: c= iriConstruct propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_triplesSameSubject_11622);
                    c=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iriConstruct.add(c.getTree());
                    if ( state.backtracking==0 ) {
                       ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(VAR, rdfTermVar));  
                                ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;"; 
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11644);
                    propertyListNotEmpty_585=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_585.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_, c
                    // token labels: 
                    // rule labels: retval, c
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_c=new RewriteRuleSubtreeStream(adaptor,"rule c",c!=null?c.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2326:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2326:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2327:12: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2329:15: ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "xsparql:createURI"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2331:17: ^( T_PARAMS $c)
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, stream_c.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2336:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2337:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2338:16: ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, validSubjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2338:63: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2339:16: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2344:9: g= collection propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_collection_in_triplesSameSubject_11968);
                    g=collection();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_collection.add(g.getTree());
                    if ( state.backtracking==0 ) {
                      ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = (g!=null?((CommonTree)g.tree):null);  ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11984);
                    propertyListNotEmpty_586=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_586.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2347:9: (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK ) propertyListNotEmpty_
                    {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2347:9: (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK )
                    int alt162=2;
                    switch ( input.LA(1) ) {
                    case T_ANON_BLANK:
                        {
                        alt162=1;
                        }
                        break;
                    case T_EMPTY_ANON_BLANK:
                        {
                        alt162=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 162, 0, input);

                        throw nvae;
                    }

                    switch (alt162) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2347:10: h= T_ANON_BLANK
                            {
                            _last = (CommonTree)input.LT(1);
                            h=(CommonTree)match(input,T_ANON_BLANK,FOLLOW_T_ANON_BLANK_in_triplesSameSubject_11999); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_T_ANON_BLANK.add(h);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2347:25: h= T_EMPTY_ANON_BLANK
                            {
                            _last = (CommonTree)input.LT(1);
                            h=(CommonTree)match(input,T_EMPTY_ANON_BLANK,FOLLOW_T_EMPTY_ANON_BLANK_in_triplesSameSubject_12003); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_T_EMPTY_ANON_BLANK.add(h);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(QSTRING, ""));  ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " ; ";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_12008);
                    propertyListNotEmpty_587=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_587.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2348:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2348:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2349:12: ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2351:15: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2353:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2354:14: ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2355:16: ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, "fn:not"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2355:51: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2355:62: ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_7 = (CommonTree)adaptor.nil();
                        root_7 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_7);

                        adaptor.addChild(root_7, (CommonTree)adaptor.create(NCNAME, "fn:empty"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2355:99: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_8 = (CommonTree)adaptor.nil();
                        root_8 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_8);

                        adaptor.addChild(root_8, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_7, root_8);
                        }

                        adaptor.addChild(root_6, root_7);
                        }

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2356:17: ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, "["));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2356:38: ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(XPATH, "XPATH"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_6, (CommonTree)adaptor.create(LBRACKET, "["));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2356:76: ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) )
                        {
                        CommonTree root_7 = (CommonTree)adaptor.nil();
                        root_7 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(LT, "lt"), root_7);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2356:87: ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) )
                        {
                        CommonTree root_8 = (CommonTree)adaptor.nil();
                        root_8 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_8);

                        adaptor.addChild(root_8, (CommonTree)adaptor.create(NCNAME, "fn:position"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2356:127: ^( T_PARAMS )
                        {
                        CommonTree root_9 = (CommonTree)adaptor.nil();
                        root_9 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_9);

                        adaptor.addChild(root_8, root_9);
                        }

                        adaptor.addChild(root_7, root_8);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2356:141: ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) )
                        {
                        CommonTree root_8 = (CommonTree)adaptor.nil();
                        root_8 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_8);

                        adaptor.addChild(root_8, (CommonTree)adaptor.create(NCNAME, "fn:last"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2356:177: ^( T_PARAMS )
                        {
                        CommonTree root_9 = (CommonTree)adaptor.nil();
                        root_9 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_9);

                        adaptor.addChild(root_8, root_9);
                        }

                        adaptor.addChild(root_7, root_8);
                        }

                        adaptor.addChild(root_6, root_7);
                        }
                        adaptor.addChild(root_6, (CommonTree)adaptor.create(RBRACKET, "]"));

                        adaptor.addChild(root_5, root_6);
                        }
                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " ] .&#xA;"));

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            triplesSameSubject__stack.pop();
        }
        return retval;
    }
    // $ANTLR end "triplesSameSubject_"

    public static class constructVar_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructVar"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2365:1: constructVar : var= VAR -> {isBound(rdftermvar, Types.SPARQL)}? VAR[$var.token, rdftermvar] -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ;
    public final XSPARQLRewriter.constructVar_return constructVar() throws RecognitionException {
        XSPARQLRewriter.constructVar_return retval = new XSPARQLRewriter.constructVar_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;

        CommonTree var_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");


          String rdftermvar = "";

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2369:3: (var= VAR -> {isBound(rdftermvar, Types.SPARQL)}? VAR[$var.token, rdftermvar] -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2369:5: var= VAR
            {
            _last = (CommonTree)input.LT(1);
            var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_constructVar12317); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_VAR.add(var);

            if ( state.backtracking==0 ) {
               rdftermvar = (var!=null?var.getText():null); 
            }


            // AST REWRITE
            // elements: var, VAR
            // token labels: var
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleNodeStream stream_var=new RewriteRuleNodeStream(adaptor,"token var",var);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2370:3: -> {isBound(rdftermvar, Types.SPARQL)}? VAR[$var.token, rdftermvar]
            if (isBound(rdftermvar, Types.SPARQL)) {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(VAR, var.token, rdftermvar));

            }
            else // 2371:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) )
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2371:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2372:8: ^( T_PARAMS $var)
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                adaptor.addChild(root_2, stream_var.nextNode());

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constructVar"

    public static class propertyListNotEmpty__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "propertyListNotEmpty_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2378:1: propertyListNotEmpty_ : (v+= verbObjectList_ )+ -> ( $v)+ ;
    public final XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_() throws RecognitionException {
        XSPARQLRewriter.propertyListNotEmpty__return retval = new XSPARQLRewriter.propertyListNotEmpty__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        List list_v=null;
        RuleReturnScope v = null;
        RewriteRuleSubtreeStream stream_verbObjectList_=new RewriteRuleSubtreeStream(adaptor,"rule verbObjectList_");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2379:3: ( (v+= verbObjectList_ )+ -> ( $v)+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2379:5: (v+= verbObjectList_ )+
            {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2379:6: (v+= verbObjectList_ )+
            int cnt164=0;
            loop164:
            do {
                int alt164=2;
                switch ( input.LA(1) ) {
                case T_VERB:
                    {
                    alt164=1;
                    }
                    break;

                }

                switch (alt164) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: v+= verbObjectList_
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_verbObjectList__in_propertyListNotEmpty_12395);
            	    v=verbObjectList_();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_verbObjectList_.add(v.getTree());
            	    if (list_v==null) list_v=new ArrayList();
            	    list_v.add(v.getTree());


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt164 >= 1 ) break loop164;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(164, input);
                        throw eee;
                }
                cnt164++;
            } while (true);



            // AST REWRITE
            // elements: v
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: v
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_v=new RewriteRuleSubtreeStream(adaptor,"token v",list_v);
            root_0 = (CommonTree)adaptor.nil();
            // 2380:3: -> ( $v)+
            {
                if ( !(stream_v.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_v.hasNext() ) {
                    adaptor.addChild(root_0, stream_v.nextTree());

                }
                stream_v.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "propertyListNotEmpty_"

    protected static class verbObjectList__scope {
        CommonTree verb;
    }
    protected Stack verbObjectList__stack = new Stack();

    public static class verbObjectList__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "verbObjectList_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2383:1: verbObjectList_ : ( ^( T_VERB ve= verb_ objectList_ ) -> objectList_ | ^( T_VERB irix= iriConstruct objectList_ ) -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) ) | ^( T_VERB v= constructVar objectList_ ) -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $v) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) ) );
    public final XSPARQLRewriter.verbObjectList__return verbObjectList_() throws RecognitionException {
        verbObjectList__stack.push(new verbObjectList__scope());
        XSPARQLRewriter.verbObjectList__return retval = new XSPARQLRewriter.verbObjectList__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_VERB588=null;
        CommonTree T_VERB590=null;
        CommonTree T_VERB592=null;
        XSPARQLRewriter.verb__return ve = null;

        XSPARQLRewriter.iriConstruct_return irix = null;

        XSPARQLRewriter.constructVar_return v = null;

        XSPARQLRewriter.objectList__return objectList_589 = null;

        XSPARQLRewriter.objectList__return objectList_591 = null;

        XSPARQLRewriter.objectList__return objectList_593 = null;


        CommonTree T_VERB588_tree=null;
        CommonTree T_VERB590_tree=null;
        CommonTree T_VERB592_tree=null;
        RewriteRuleNodeStream stream_T_VERB=new RewriteRuleNodeStream(adaptor,"token T_VERB");
        RewriteRuleSubtreeStream stream_constructVar=new RewriteRuleSubtreeStream(adaptor,"rule constructVar");
        RewriteRuleSubtreeStream stream_objectList_=new RewriteRuleSubtreeStream(adaptor,"rule objectList_");
        RewriteRuleSubtreeStream stream_iriConstruct=new RewriteRuleSubtreeStream(adaptor,"rule iriConstruct");
        RewriteRuleSubtreeStream stream_verb_=new RewriteRuleSubtreeStream(adaptor,"rule verb_");

          String rdfTermVar = getNewTempRdfTermVariable();

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2390:3: ( ^( T_VERB ve= verb_ objectList_ ) -> objectList_ | ^( T_VERB irix= iriConstruct objectList_ ) -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) ) | ^( T_VERB v= constructVar objectList_ ) -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $v) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) ) )
            int alt165=3;
            switch ( input.LA(1) ) {
            case T_VERB:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case PNAME_NS:
                    case PNAME_LN:
                    case IRIREF:
                    case A:
                        {
                        alt165=1;
                        }
                        break;
                    case T_IRI_CONSTRUCT:
                        {
                        alt165=2;
                        }
                        break;
                    case VAR:
                        {
                        alt165=3;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 165, 2, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 165, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 165, 0, input);

                throw nvae;
            }

            switch (alt165) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2390:5: ^( T_VERB ve= verb_ objectList_ )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VERB588=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_verbObjectList_12427); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_VERB.add(T_VERB588);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_verb__in_verbObjectList_12431);
                    ve=verb_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_verb_.add(ve.getTree());
                    if ( state.backtracking==0 ) {
                      ((verbObjectList__scope)verbObjectList__stack.peek()).verb = (ve!=null?((CommonTree)ve.tree):null);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_objectList__in_verbObjectList_12435);
                    objectList_589=objectList_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_objectList_.add(objectList_589.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: objectList_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2391:3: -> objectList_
                    {
                        adaptor.addChild(root_0, stream_objectList_.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2392:5: ^( T_VERB irix= iriConstruct objectList_ )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VERB590=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_verbObjectList_12450); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_VERB.add(T_VERB590);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_verbObjectList_12454);
                    irix=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iriConstruct.add(irix.getTree());
                    if ( state.backtracking==0 ) {
                      ((verbObjectList__scope)verbObjectList__stack.peek()).verb = new CommonTree(new CommonToken(VAR, rdfTermVar));
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_objectList__in_verbObjectList_12458);
                    objectList_591=objectList_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_objectList_.add(objectList_591.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: objectList_, irix
                    // token labels: 
                    // rule labels: retval, irix
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_irix=new RewriteRuleSubtreeStream(adaptor,"rule irix",irix!=null?irix.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2393:3: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2393:6: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2394:8: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2396:11: ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, "xsparql:createURI"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2398:12: ^( T_PARAMS $irix)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_irix.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2403:8: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2404:10: ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2405:12: ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validPredicateFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2405:61: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2406:12: ^( T_PAR objectList_ )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, stream_objectList_.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2412:5: ^( T_VERB v= constructVar objectList_ )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VERB592=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_verbObjectList_12703); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_VERB.add(T_VERB592);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructVar_in_verbObjectList_12707);
                    v=constructVar();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_constructVar.add(v.getTree());
                    if ( state.backtracking==0 ) {
                      ((verbObjectList__scope)verbObjectList__stack.peek()).verb = new CommonTree(new CommonToken(VAR, rdfTermVar));
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_objectList__in_verbObjectList_12711);
                    objectList_593=objectList_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_objectList_.add(objectList_593.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: v, objectList_
                    // token labels: 
                    // rule labels: v, retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_v=new RewriteRuleSubtreeStream(adaptor,"rule v",v!=null?v.tree:null);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2413:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $v) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2413:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $v) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2414:12: ^( T_LET VAR[rdfTermVar] $v)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_2, stream_v.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2418:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2419:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2420:16: ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validPredicateFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2420:65: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2421:16: ^( T_PAR objectList_ )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, stream_objectList_.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            verbObjectList__stack.pop();
        }
        return retval;
    }
    // $ANTLR end "verbObjectList_"

    public static class propertyListNotEmpty_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "propertyListNotEmpty"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2428:1: propertyListNotEmpty options {backtrack=true; } : ^( T_VERB v1= verb o1= objectList ) ( ^( T_VERB v+= verb o+= objectList ) )* -> $v1 QSTRING[\" \"] $o1 ( QSTRING[\" ; \\n\"] $v QSTRING[\" \"] $o)* ;
    public final XSPARQLRewriter.propertyListNotEmpty_return propertyListNotEmpty() throws RecognitionException {
        XSPARQLRewriter.propertyListNotEmpty_return retval = new XSPARQLRewriter.propertyListNotEmpty_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_VERB594=null;
        CommonTree T_VERB595=null;
        List list_v=null;
        List list_o=null;
        XSPARQLRewriter.verb_return v1 = null;

        XSPARQLRewriter.objectList_return o1 = null;

        RuleReturnScope v = null;
        RuleReturnScope o = null;
        CommonTree T_VERB594_tree=null;
        CommonTree T_VERB595_tree=null;
        RewriteRuleNodeStream stream_T_VERB=new RewriteRuleNodeStream(adaptor,"token T_VERB");
        RewriteRuleSubtreeStream stream_verb=new RewriteRuleSubtreeStream(adaptor,"rule verb");
        RewriteRuleSubtreeStream stream_objectList=new RewriteRuleSubtreeStream(adaptor,"rule objectList");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2432:3: ( ^( T_VERB v1= verb o1= objectList ) ( ^( T_VERB v+= verb o+= objectList ) )* -> $v1 QSTRING[\" \"] $o1 ( QSTRING[\" ; \\n\"] $v QSTRING[\" \"] $o)* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2432:5: ^( T_VERB v1= verb o1= objectList ) ( ^( T_VERB v+= verb o+= objectList ) )*
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_VERB594=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_propertyListNotEmpty12950); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_VERB.add(T_VERB594);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_verb_in_propertyListNotEmpty12954);
            v1=verb();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_verb.add(v1.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_objectList_in_propertyListNotEmpty12958);
            o1=objectList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_objectList.add(o1.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2432:37: ( ^( T_VERB v+= verb o+= objectList ) )*
            loop166:
            do {
                int alt166=2;
                alt166 = dfa166.predict(input);
                switch (alt166) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2432:38: ^( T_VERB v+= verb o+= objectList )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_1 = _last;
            	    CommonTree _first_1 = null;
            	    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_VERB595=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_propertyListNotEmpty12963); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_T_VERB.add(T_VERB595);



            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_verb_in_propertyListNotEmpty12967);
            	    v=verb();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_verb.add(v.getTree());
            	    if (list_v==null) list_v=new ArrayList();
            	    list_v.add(v.getTree());

            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_objectList_in_propertyListNotEmpty12971);
            	    o=objectList();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_objectList.add(o.getTree());
            	    if (list_o==null) list_o=new ArrayList();
            	    list_o.add(o.getTree());


            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop166;
                }
            } while (true);



            // AST REWRITE
            // elements: o1, o, v1, v
            // token labels: 
            // rule labels: v1, retval, o1
            // token list labels: 
            // rule list labels: v, o
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_v1=new RewriteRuleSubtreeStream(adaptor,"rule v1",v1!=null?v1.tree:null);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_o1=new RewriteRuleSubtreeStream(adaptor,"rule o1",o1!=null?o1.tree:null);
            RewriteRuleSubtreeStream stream_v=new RewriteRuleSubtreeStream(adaptor,"token v",list_v);
            RewriteRuleSubtreeStream stream_o=new RewriteRuleSubtreeStream(adaptor,"token o",list_o);
            root_0 = (CommonTree)adaptor.nil();
            // 2433:3: -> $v1 QSTRING[\" \"] $o1 ( QSTRING[\" ; \\n\"] $v QSTRING[\" \"] $o)*
            {
                adaptor.addChild(root_0, stream_v1.nextTree());
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                adaptor.addChild(root_0, stream_o1.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2433:28: ( QSTRING[\" ; \\n\"] $v QSTRING[\" \"] $o)*
                while ( stream_o.hasNext()||stream_v.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " ; \n"));
                    adaptor.addChild(root_0, stream_v.nextTree());
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                    adaptor.addChild(root_0, stream_o.nextTree());

                }
                stream_o.reset();
                stream_v.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "propertyListNotEmpty"

    public static class propertyList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "propertyList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2436:1: propertyList : ( propertyListNotEmpty )? ;
    public final XSPARQLRewriter.propertyList_return propertyList() throws RecognitionException {
        XSPARQLRewriter.propertyList_return retval = new XSPARQLRewriter.propertyList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.propertyListNotEmpty_return propertyListNotEmpty596 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2437:3: ( ( propertyListNotEmpty )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2437:5: ( propertyListNotEmpty )?
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2437:5: ( propertyListNotEmpty )?
            int alt167=2;
            switch ( input.LA(1) ) {
                case T_VERB:
                    {
                    alt167=1;
                    }
                    break;
            }

            switch (alt167) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: propertyListNotEmpty
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty_in_propertyList13017);
                    propertyListNotEmpty596=propertyListNotEmpty();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, propertyListNotEmpty596.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "propertyList"

    public static class propertyList__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "propertyList_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2440:1: propertyList_ : ( propertyListNotEmpty_ )? ;
    public final XSPARQLRewriter.propertyList__return propertyList_() throws RecognitionException {
        XSPARQLRewriter.propertyList__return retval = new XSPARQLRewriter.propertyList__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_597 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2441:3: ( ( propertyListNotEmpty_ )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2441:5: ( propertyListNotEmpty_ )?
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2441:5: ( propertyListNotEmpty_ )?
            int alt168=2;
            switch ( input.LA(1) ) {
                case T_VERB:
                    {
                    alt168=1;
                    }
                    break;
            }

            switch (alt168) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_propertyList_13031);
                    propertyListNotEmpty_597=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, propertyListNotEmpty_597.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "propertyList_"

    public static class objectList__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "objectList_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2444:1: objectList_ : ^( T_OBJECT o1= object_ ) ( ^( T_OBJECT o+= object_ ) )* -> $o1 ( $o)* ;
    public final XSPARQLRewriter.objectList__return objectList_() throws RecognitionException {
        XSPARQLRewriter.objectList__return retval = new XSPARQLRewriter.objectList__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_OBJECT598=null;
        CommonTree T_OBJECT599=null;
        List list_o=null;
        XSPARQLRewriter.object__return o1 = null;

        RuleReturnScope o = null;
        CommonTree T_OBJECT598_tree=null;
        CommonTree T_OBJECT599_tree=null;
        RewriteRuleNodeStream stream_T_OBJECT=new RewriteRuleNodeStream(adaptor,"token T_OBJECT");
        RewriteRuleSubtreeStream stream_object_=new RewriteRuleSubtreeStream(adaptor,"rule object_");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2445:3: ( ^( T_OBJECT o1= object_ ) ( ^( T_OBJECT o+= object_ ) )* -> $o1 ( $o)* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2445:5: ^( T_OBJECT o1= object_ ) ( ^( T_OBJECT o+= object_ ) )*
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_OBJECT598=(CommonTree)match(input,T_OBJECT,FOLLOW_T_OBJECT_in_objectList_13046); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_OBJECT.add(T_OBJECT598);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_object__in_objectList_13050);
            o1=object_();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_object_.add(o1.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2445:28: ( ^( T_OBJECT o+= object_ ) )*
            loop169:
            do {
                int alt169=2;
                switch ( input.LA(1) ) {
                case T_OBJECT:
                    {
                    alt169=1;
                    }
                    break;

                }

                switch (alt169) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2445:29: ^( T_OBJECT o+= object_ )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_1 = _last;
            	    CommonTree _first_1 = null;
            	    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_OBJECT599=(CommonTree)match(input,T_OBJECT,FOLLOW_T_OBJECT_in_objectList_13055); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_T_OBJECT.add(T_OBJECT599);



            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_object__in_objectList_13059);
            	    o=object_();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_object_.add(o.getTree());
            	    if (list_o==null) list_o=new ArrayList();
            	    list_o.add(o.getTree());


            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop169;
                }
            } while (true);



            // AST REWRITE
            // elements: o, o1
            // token labels: 
            // rule labels: retval, o1
            // token list labels: 
            // rule list labels: o
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_o1=new RewriteRuleSubtreeStream(adaptor,"rule o1",o1!=null?o1.tree:null);
            RewriteRuleSubtreeStream stream_o=new RewriteRuleSubtreeStream(adaptor,"token o",list_o);
            root_0 = (CommonTree)adaptor.nil();
            // 2446:3: -> $o1 ( $o)*
            {
                adaptor.addChild(root_0, stream_o1.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2446:10: ( $o)*
                while ( stream_o.hasNext() ) {
                    adaptor.addChild(root_0, stream_o.nextTree());

                }
                stream_o.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "objectList_"

    public static class objectList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "objectList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2449:1: objectList : ^( T_OBJECT o1= object ) ( ^( T_OBJECT o+= object ) )* -> $o1 ( QSTRING[\" , \"] $o)* ;
    public final XSPARQLRewriter.objectList_return objectList() throws RecognitionException {
        XSPARQLRewriter.objectList_return retval = new XSPARQLRewriter.objectList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_OBJECT600=null;
        CommonTree T_OBJECT601=null;
        List list_o=null;
        XSPARQLRewriter.object_return o1 = null;

        RuleReturnScope o = null;
        CommonTree T_OBJECT600_tree=null;
        CommonTree T_OBJECT601_tree=null;
        RewriteRuleNodeStream stream_T_OBJECT=new RewriteRuleNodeStream(adaptor,"token T_OBJECT");
        RewriteRuleSubtreeStream stream_object=new RewriteRuleSubtreeStream(adaptor,"rule object");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2450:3: ( ^( T_OBJECT o1= object ) ( ^( T_OBJECT o+= object ) )* -> $o1 ( QSTRING[\" , \"] $o)* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2450:5: ^( T_OBJECT o1= object ) ( ^( T_OBJECT o+= object ) )*
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_OBJECT600=(CommonTree)match(input,T_OBJECT,FOLLOW_T_OBJECT_in_objectList13089); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_OBJECT.add(T_OBJECT600);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_object_in_objectList13093);
            o1=object();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_object.add(o1.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2450:27: ( ^( T_OBJECT o+= object ) )*
            loop170:
            do {
                int alt170=2;
                switch ( input.LA(1) ) {
                case T_OBJECT:
                    {
                    alt170=1;
                    }
                    break;

                }

                switch (alt170) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2450:28: ^( T_OBJECT o+= object )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_1 = _last;
            	    CommonTree _first_1 = null;
            	    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_OBJECT601=(CommonTree)match(input,T_OBJECT,FOLLOW_T_OBJECT_in_objectList13098); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_T_OBJECT.add(T_OBJECT601);



            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_object_in_objectList13102);
            	    o=object();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_object.add(o.getTree());
            	    if (list_o==null) list_o=new ArrayList();
            	    list_o.add(o.getTree());


            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop170;
                }
            } while (true);



            // AST REWRITE
            // elements: o, o1
            // token labels: 
            // rule labels: retval, o1
            // token list labels: 
            // rule list labels: o
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_o1=new RewriteRuleSubtreeStream(adaptor,"rule o1",o1!=null?o1.tree:null);
            RewriteRuleSubtreeStream stream_o=new RewriteRuleSubtreeStream(adaptor,"token o",list_o);
            root_0 = (CommonTree)adaptor.nil();
            // 2451:3: -> $o1 ( QSTRING[\" , \"] $o)*
            {
                adaptor.addChild(root_0, stream_o1.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2451:10: ( QSTRING[\" , \"] $o)*
                while ( stream_o.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " , "));
                    adaptor.addChild(root_0, stream_o.nextTree());

                }
                stream_o.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "objectList"

    public static class subject__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "subject_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2454:1: subject_ : verb_ ;
    public final XSPARQLRewriter.subject__return subject_() throws RecognitionException {
        XSPARQLRewriter.subject__return retval = new XSPARQLRewriter.subject__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.verb__return verb_602 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2455:3: ( verb_ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2458:4: verb_
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_verb__in_subject_13144);
            verb_602=verb_();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, verb_602.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "subject_"

    public static class subject_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "subject"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2464:1: subject : ( resource | i= IRIREF -> QSTRING[$i.token, $i.text] | blank -> QSTRING[\"[]\"] );
    public final XSPARQLRewriter.subject_return subject() throws RecognitionException {
        XSPARQLRewriter.subject_return retval = new XSPARQLRewriter.subject_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree i=null;
        XSPARQLRewriter.resource_return resource603 = null;

        XSPARQLRewriter.blank_return blank604 = null;


        CommonTree i_tree=null;
        RewriteRuleNodeStream stream_IRIREF=new RewriteRuleNodeStream(adaptor,"token IRIREF");
        RewriteRuleSubtreeStream stream_blank=new RewriteRuleSubtreeStream(adaptor,"rule blank");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2465:3: ( resource | i= IRIREF -> QSTRING[$i.token, $i.text] | blank -> QSTRING[\"[]\"] )
            int alt171=3;
            switch ( input.LA(1) ) {
            case VAR:
            case PNAME_NS:
            case PNAME_LN:
                {
                alt171=1;
                }
                break;
            case IRIREF:
                {
                alt171=2;
                }
                break;
            case BLANK_NODE_LABEL:
            case T_EMPTY_ANON_BLANK:
                {
                alt171=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 171, 0, input);

                throw nvae;
            }

            switch (alt171) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2465:5: resource
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_resource_in_subject13162);
                    resource603=resource();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, resource603.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2466:5: i= IRIREF
                    {
                    _last = (CommonTree)input.LT(1);
                    i=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_subject13170); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IRIREF.add(i);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2467:3: -> QSTRING[$i.token, $i.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, i.token, (i!=null?i.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2468:5: blank
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blank_in_subject13183);
                    blank604=blank();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_blank.add(blank604.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2469:3: -> QSTRING[\"[]\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "[]"));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "subject"

    public static class resource_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "resource"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2472:1: resource : (p= PNAME_LN -> QSTRING[$p.token, $p.text] | s= PNAME_NS -> QSTRING[$s.token, $s.text] | var= VAR -> {isBoundEarlier($var.text, Types.SPARQL) && $VariableScope::scopedDataset}? -> {isBoundEarlier($var.text, Types.XQUERY) && $VariableScope::scopedDataset}? -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) ) -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) ) -> QSTRING[$var.token, $var.text ] );
    public final XSPARQLRewriter.resource_return resource() throws RecognitionException {
        XSPARQLRewriter.resource_return retval = new XSPARQLRewriter.resource_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree p=null;
        CommonTree s=null;
        CommonTree var=null;

        CommonTree p_tree=null;
        CommonTree s_tree=null;
        CommonTree var_tree=null;
        RewriteRuleNodeStream stream_PNAME_NS=new RewriteRuleNodeStream(adaptor,"token PNAME_NS");
        RewriteRuleNodeStream stream_PNAME_LN=new RewriteRuleNodeStream(adaptor,"token PNAME_LN");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");


          String rdftermvar = "";
          logger.info("resource");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2477:3: (p= PNAME_LN -> QSTRING[$p.token, $p.text] | s= PNAME_NS -> QSTRING[$s.token, $s.text] | var= VAR -> {isBoundEarlier($var.text, Types.SPARQL) && $VariableScope::scopedDataset}? -> {isBoundEarlier($var.text, Types.XQUERY) && $VariableScope::scopedDataset}? -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) ) -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) ) -> QSTRING[$var.token, $var.text ] )
            int alt172=3;
            switch ( input.LA(1) ) {
            case PNAME_LN:
                {
                alt172=1;
                }
                break;
            case PNAME_NS:
                {
                alt172=2;
                }
                break;
            case VAR:
                {
                alt172=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 172, 0, input);

                throw nvae;
            }

            switch (alt172) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2477:5: p= PNAME_LN
                    {
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PNAME_LN,FOLLOW_PNAME_LN_in_resource13210); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_LN.add(p);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2478:3: -> QSTRING[$p.token, $p.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, p.token, (p!=null?p.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2479:5: s= PNAME_NS
                    {
                    _last = (CommonTree)input.LT(1);
                    s=(CommonTree)match(input,PNAME_NS,FOLLOW_PNAME_NS_in_resource13225); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_NS.add(s);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2480:3: -> QSTRING[$s.token, $s.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, s.token, (s!=null?s.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2481:5: var= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_resource13240); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(var);



                    // AST REWRITE
                    // elements: var, var
                    // token labels: var
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_var=new RewriteRuleNodeStream(adaptor,"token var",var);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2482:3: -> {isBoundEarlier($var.text, Types.SPARQL) && $VariableScope::scopedDataset}?
                    if (isBoundEarlier((var!=null?var.getText():null), Types.SPARQL) && ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset) {
                        adaptor.addChild(root_0,  addJoinVar(QSTRING, (var!=null?var.getText():null)) );

                    }
                    else // 2483:3: -> {isBoundEarlier($var.text, Types.XQUERY) && $VariableScope::scopedDataset}?
                    if (isBoundEarlier((var!=null?var.getText():null), Types.XQUERY) && ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset) {
                        adaptor.addChild(root_0,  addJoinVar(QSTRING, (var!=null?var.getText():null)) );

                    }
                    else // 2484:3: -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) )
                    if (isBoundEarlier((var!=null?var.getText():null), Types.SPARQL)) {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2484:49: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2484:91: ^( T_PARAMS $var)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, stream_var.nextNode());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }
                    else // 2485:3: -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) )
                    if (isBoundEarlier((var!=null?var.getText():null))) {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2485:35: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2485:77: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2485:88: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2485:134: ^( T_PARAMS $var)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_var.nextNode());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }
                    else // 2486:3: -> QSTRING[$var.token, $var.text ]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, var.token, (var!=null?var.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "resource"

    public static class verb_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "verb"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2489:1: verb : ( resource | a= A -> QSTRING[$a.token, \" \" + $a.text + \" \"] );
    public final XSPARQLRewriter.verb_return verb() throws RecognitionException {
        XSPARQLRewriter.verb_return retval = new XSPARQLRewriter.verb_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree a=null;
        XSPARQLRewriter.resource_return resource605 = null;


        CommonTree a_tree=null;
        RewriteRuleNodeStream stream_A=new RewriteRuleNodeStream(adaptor,"token A");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2490:3: ( resource | a= A -> QSTRING[$a.token, \" \" + $a.text + \" \"] )
            int alt173=2;
            switch ( input.LA(1) ) {
            case VAR:
            case PNAME_NS:
            case PNAME_LN:
                {
                alt173=1;
                }
                break;
            case A:
                {
                alt173=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 173, 0, input);

                throw nvae;
            }

            switch (alt173) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2490:5: resource
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_resource_in_verb13328);
                    resource605=resource();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, resource605.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2491:5: a= A
                    {
                    _last = (CommonTree)input.LT(1);
                    a=(CommonTree)match(input,A,FOLLOW_A_in_verb13336); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_A.add(a);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2491:9: -> QSTRING[$a.token, \" \" + $a.text + \" \"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, a.token, " " + (a!=null?a.getText():null) + " "));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "verb"

    public static class verb__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "verb_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2494:1: verb_ : ( sparqlPrefixedName | i= IRIREF -> QSTRING[$i.token, $i.text] | a= A -> QSTRING[$a.token, $a.text] );
    public final XSPARQLRewriter.verb__return verb_() throws RecognitionException {
        XSPARQLRewriter.verb__return retval = new XSPARQLRewriter.verb__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree i=null;
        CommonTree a=null;
        XSPARQLRewriter.sparqlPrefixedName_return sparqlPrefixedName606 = null;


        CommonTree i_tree=null;
        CommonTree a_tree=null;
        RewriteRuleNodeStream stream_A=new RewriteRuleNodeStream(adaptor,"token A");
        RewriteRuleNodeStream stream_IRIREF=new RewriteRuleNodeStream(adaptor,"token IRIREF");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2495:3: ( sparqlPrefixedName | i= IRIREF -> QSTRING[$i.token, $i.text] | a= A -> QSTRING[$a.token, $a.text] )
            int alt174=3;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
                {
                alt174=1;
                }
                break;
            case IRIREF:
                {
                alt174=2;
                }
                break;
            case A:
                {
                alt174=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 174, 0, input);

                throw nvae;
            }

            switch (alt174) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2495:5: sparqlPrefixedName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sparqlPrefixedName_in_verb_13354);
                    sparqlPrefixedName606=sparqlPrefixedName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sparqlPrefixedName606.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2496:5: i= IRIREF
                    {
                    _last = (CommonTree)input.LT(1);
                    i=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_verb_13362); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IRIREF.add(i);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2496:14: -> QSTRING[$i.token, $i.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, i.token, (i!=null?i.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2497:5: a= A
                    {
                    _last = (CommonTree)input.LT(1);
                    a=(CommonTree)match(input,A,FOLLOW_A_in_verb_13375); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_A.add(a);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2497:9: -> QSTRING[$a.token, $a.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, a.token, (a!=null?a.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "verb_"

    public static class object__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "object_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2501:1: object_ : (s= verb_ (n= nquad )? -> QSTRING[\" \"] QSTRING[\" \"] $s ( $n)? QSTRING[$triplesSameSubject_::separator] | cvar= constructVar (n= nquad )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | bb= bnode (n= nquad )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | rdfLiteral (n= nquad )? -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] rdfLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] ) | sNumericLiteral (n= nquad )? -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] sNumericLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] ) | b= blankConstruct (n= nquad )? -> ^( T_FLWOR ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) | literalConstruct (n= nquad )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] literalConstruct ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | irix= iriConstruct (n= nquad )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | collection -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] collection ) | T_ANON_BLANK propertyListNotEmpty_ -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ \"] ^( XPATH ^( T_PAR propertyListNotEmpty_ ) LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] \"] QSTRING[$triplesSameSubject_::separator] ) | T_EMPTY_ANON_BLANK propertyListNotEmpty_ -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ ]\"] propertyListNotEmpty_ QSTRING[$triplesSameSubject_::separator] ) );
    public final XSPARQLRewriter.object__return object_() throws RecognitionException {
        XSPARQLRewriter.object__return retval = new XSPARQLRewriter.object__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_ANON_BLANK611=null;
        CommonTree T_EMPTY_ANON_BLANK613=null;
        XSPARQLRewriter.verb__return s = null;

        XSPARQLRewriter.nquad_return n = null;

        XSPARQLRewriter.constructVar_return cvar = null;

        XSPARQLRewriter.bnode_return bb = null;

        XSPARQLRewriter.blankConstruct_return b = null;

        XSPARQLRewriter.iriConstruct_return irix = null;

        XSPARQLRewriter.rdfLiteral_return rdfLiteral607 = null;

        XSPARQLRewriter.sNumericLiteral_return sNumericLiteral608 = null;

        XSPARQLRewriter.literalConstruct_return literalConstruct609 = null;

        XSPARQLRewriter.collection_return collection610 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_612 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_614 = null;


        CommonTree T_ANON_BLANK611_tree=null;
        CommonTree T_EMPTY_ANON_BLANK613_tree=null;
        RewriteRuleNodeStream stream_T_EMPTY_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_EMPTY_ANON_BLANK");
        RewriteRuleNodeStream stream_T_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_ANON_BLANK");
        RewriteRuleSubtreeStream stream_constructVar=new RewriteRuleSubtreeStream(adaptor,"rule constructVar");
        RewriteRuleSubtreeStream stream_nquad=new RewriteRuleSubtreeStream(adaptor,"rule nquad");
        RewriteRuleSubtreeStream stream_blankConstruct=new RewriteRuleSubtreeStream(adaptor,"rule blankConstruct");
        RewriteRuleSubtreeStream stream_rdfLiteral=new RewriteRuleSubtreeStream(adaptor,"rule rdfLiteral");
        RewriteRuleSubtreeStream stream_bnode=new RewriteRuleSubtreeStream(adaptor,"rule bnode");
        RewriteRuleSubtreeStream stream_propertyListNotEmpty_=new RewriteRuleSubtreeStream(adaptor,"rule propertyListNotEmpty_");
        RewriteRuleSubtreeStream stream_collection=new RewriteRuleSubtreeStream(adaptor,"rule collection");
        RewriteRuleSubtreeStream stream_iriConstruct=new RewriteRuleSubtreeStream(adaptor,"rule iriConstruct");
        RewriteRuleSubtreeStream stream_sNumericLiteral=new RewriteRuleSubtreeStream(adaptor,"rule sNumericLiteral");
        RewriteRuleSubtreeStream stream_literalConstruct=new RewriteRuleSubtreeStream(adaptor,"rule literalConstruct");
        RewriteRuleSubtreeStream stream_verb_=new RewriteRuleSubtreeStream(adaptor,"rule verb_");

          String rdfTermVar = getNewTempRdfTermVariable();

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2505:3: (s= verb_ (n= nquad )? -> QSTRING[\" \"] QSTRING[\" \"] $s ( $n)? QSTRING[$triplesSameSubject_::separator] | cvar= constructVar (n= nquad )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | bb= bnode (n= nquad )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | rdfLiteral (n= nquad )? -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] rdfLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] ) | sNumericLiteral (n= nquad )? -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] sNumericLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] ) | b= blankConstruct (n= nquad )? -> ^( T_FLWOR ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) | literalConstruct (n= nquad )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] literalConstruct ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | irix= iriConstruct (n= nquad )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | collection -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] collection ) | T_ANON_BLANK propertyListNotEmpty_ -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ \"] ^( XPATH ^( T_PAR propertyListNotEmpty_ ) LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] \"] QSTRING[$triplesSameSubject_::separator] ) | T_EMPTY_ANON_BLANK propertyListNotEmpty_ -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ ]\"] propertyListNotEmpty_ QSTRING[$triplesSameSubject_::separator] ) )
            int alt183=11;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
            case A:
                {
                alt183=1;
                }
                break;
            case VAR:
                {
                alt183=2;
                }
                break;
            case BLANK_NODE_LABEL:
                {
                alt183=3;
                }
                break;
            case QSTRING:
                {
                alt183=4;
                }
                break;
            case INTEGER:
                {
                alt183=5;
                }
                break;
            case BNODE_CONSTRUCT:
                {
                alt183=6;
                }
                break;
            case T_LITERAL_CONSTRUCT:
                {
                alt183=7;
                }
                break;
            case T_IRI_CONSTRUCT:
                {
                alt183=8;
                }
                break;
            case LPAR:
                {
                alt183=9;
                }
                break;
            case T_ANON_BLANK:
                {
                alt183=10;
                }
                break;
            case T_EMPTY_ANON_BLANK:
                {
                alt183=11;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 183, 0, input);

                throw nvae;
            }

            switch (alt183) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2505:5: s= verb_ (n= nquad )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_verb__in_object_13403);
                    s=verb_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_verb_.add(s.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2505:14: (n= nquad )?
                    int alt175=2;
                    switch ( input.LA(1) ) {
                        case QSTRING:
                        case PNAME_LN:
                        case IRIREF:
                        case T_LITERAL_CONSTRUCT:
                        case T_IRI_CONSTRUCT:
                            {
                            alt175=1;
                            }
                            break;
                    }

                    switch (alt175) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= nquad
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_nquad_in_object_13407);
                            n=nquad();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nquad.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: s, n
                    // token labels: 
                    // rule labels: retval, s, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_s=new RewriteRuleSubtreeStream(adaptor,"rule s",s!=null?s.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2506:5: -> QSTRING[\" \"] QSTRING[\" \"] $s ( $n)? QSTRING[$triplesSameSubject_::separator]
                    {
                        adaptor.addChild(root_0, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_0, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_0, stream_s.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2506:126: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_0, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2508:5: cvar= constructVar (n= nquad )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructVar_in_object_13443);
                    cvar=constructVar();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_constructVar.add(cvar.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2508:24: (n= nquad )?
                    int alt176=2;
                    switch ( input.LA(1) ) {
                        case QSTRING:
                        case PNAME_LN:
                        case IRIREF:
                        case T_LITERAL_CONSTRUCT:
                        case T_IRI_CONSTRUCT:
                            {
                            alt176=1;
                            }
                            break;
                    }

                    switch (alt176) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= nquad
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_nquad_in_object_13447);
                            n=nquad();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nquad.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: cvar, n
                    // token labels: 
                    // rule labels: cvar, retval, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_cvar=new RewriteRuleSubtreeStream(adaptor,"rule cvar",cvar!=null?cvar.tree:null);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2509:5: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2509:8: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2510:7: ^( T_LET VAR[rdfTermVar] $cvar)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_2, stream_cvar.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2514:7: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2515:9: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2516:11: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2516:57: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2517:11: ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2517:19: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2518:21: ^( T_PARAMS )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2521:19: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2522:21: ^( T_PARAMS )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2525:19: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2525:61: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2526:19: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_4, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2533:5: bb= bnode (n= nquad )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_bnode_in_object_13858);
                    bb=bnode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_bnode.add(bb.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2533:15: (n= nquad )?
                    int alt177=2;
                    switch ( input.LA(1) ) {
                        case QSTRING:
                        case PNAME_LN:
                        case IRIREF:
                        case T_LITERAL_CONSTRUCT:
                        case T_IRI_CONSTRUCT:
                            {
                            alt177=1;
                            }
                            break;
                    }

                    switch (alt177) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= nquad
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_nquad_in_object_13862);
                            n=nquad();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nquad.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: n
                    // token labels: 
                    // rule labels: retval, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2534:3: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2534:7: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2535:9: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2537:11: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2539:13: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2540:15: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2542:17: ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2543:19: ^( T_PAR QSTRING[$bb.text] )
                        {
                        CommonTree root_7 = (CommonTree)adaptor.nil();
                        root_7 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_7);

                        adaptor.addChild(root_7, (CommonTree)adaptor.create(QSTRING, (bb!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(bb.start),
                          input.getTreeAdaptor().getTokenStopIndex(bb.start))):null)));
                        adaptor.addChild(root_7, getPositionVarList());

                        adaptor.addChild(root_6, root_7);
                        }

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2552:10: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2553:12: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2554:14: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2554:60: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2555:14: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_4, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2555:153: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_4, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2560:5: rdfLiteral (n= nquad )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rdfLiteral_in_object_14312);
                    rdfLiteral607=rdfLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_rdfLiteral.add(rdfLiteral607.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2560:17: (n= nquad )?
                    int alt178=2;
                    switch ( input.LA(1) ) {
                        case QSTRING:
                        case PNAME_LN:
                        case IRIREF:
                        case T_LITERAL_CONSTRUCT:
                        case T_IRI_CONSTRUCT:
                            {
                            alt178=1;
                            }
                            break;
                    }

                    switch (alt178) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= nquad
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_nquad_in_object_14316);
                            n=nquad();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nquad.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: rdfLiteral, n
                    // token labels: 
                    // rule labels: retval, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2561:3: -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] rdfLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2561:6: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] rdfLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_1);

                        adaptor.addChild(root_1, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, stream_rdfLiteral.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2561:140: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_1, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2562:5: sNumericLiteral (n= nquad )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sNumericLiteral_in_object_14350);
                    sNumericLiteral608=sNumericLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_sNumericLiteral.add(sNumericLiteral608.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2562:22: (n= nquad )?
                    int alt179=2;
                    switch ( input.LA(1) ) {
                        case QSTRING:
                        case PNAME_LN:
                        case IRIREF:
                        case T_LITERAL_CONSTRUCT:
                        case T_IRI_CONSTRUCT:
                            {
                            alt179=1;
                            }
                            break;
                    }

                    switch (alt179) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= nquad
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_nquad_in_object_14354);
                            n=nquad();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nquad.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: n, sNumericLiteral
                    // token labels: 
                    // rule labels: retval, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2563:3: -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] sNumericLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2563:6: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] sNumericLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_1);

                        adaptor.addChild(root_1, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, stream_sNumericLiteral.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2563:145: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_1, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2564:5: b= blankConstruct (n= nquad )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blankConstruct_in_object_14390);
                    b=blankConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_blankConstruct.add(b.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2564:23: (n= nquad )?
                    int alt180=2;
                    switch ( input.LA(1) ) {
                        case QSTRING:
                        case PNAME_LN:
                        case IRIREF:
                        case T_LITERAL_CONSTRUCT:
                        case T_IRI_CONSTRUCT:
                            {
                            alt180=1;
                            }
                            break;
                    }

                    switch (alt180) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= nquad
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_nquad_in_object_14394);
                            n=nquad();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nquad.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: b, n, b
                    // token labels: 
                    // rule labels: retval, b, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_b=new RewriteRuleSubtreeStream(adaptor,"rule b",b!=null?b.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2565:3: -> ^( T_FLWOR ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2565:6: ^( T_FLWOR ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2566:10: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2567:12: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2567:58: ^( T_PARAMS $b)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_b.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2568:12: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_3);

                        adaptor.addChild(root_3, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_3, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, " "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2568:135: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2568:177: ^( T_PARAMS $b)
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, stream_b.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2568:193: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_3, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_2, root_3);
                        }
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2572:5: literalConstruct (n= nquad )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_literalConstruct_in_object_14526);
                    literalConstruct609=literalConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_literalConstruct.add(literalConstruct609.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2572:23: (n= nquad )?
                    int alt181=2;
                    switch ( input.LA(1) ) {
                        case QSTRING:
                        case PNAME_LN:
                        case IRIREF:
                        case T_LITERAL_CONSTRUCT:
                        case T_IRI_CONSTRUCT:
                            {
                            alt181=1;
                            }
                            break;
                    }

                    switch (alt181) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= nquad
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_nquad_in_object_14530);
                            n=nquad();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nquad.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: literalConstruct, n
                    // token labels: 
                    // rule labels: retval, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2573:3: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] literalConstruct ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2573:6: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] literalConstruct ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2574:8: ^( T_LET VAR[rdfTermVar] literalConstruct )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_2, stream_literalConstruct.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2578:8: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2579:10: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2580:12: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2580:58: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2581:12: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_4, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2581:135: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2581:177: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2581:206: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_4, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2586:5: irix= iriConstruct (n= nquad )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_object_14729);
                    irix=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iriConstruct.add(irix.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2586:24: (n= nquad )?
                    int alt182=2;
                    switch ( input.LA(1) ) {
                        case QSTRING:
                        case PNAME_LN:
                        case IRIREF:
                        case T_LITERAL_CONSTRUCT:
                        case T_IRI_CONSTRUCT:
                            {
                            alt182=1;
                            }
                            break;
                    }

                    switch (alt182) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= nquad
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_nquad_in_object_14733);
                            n=nquad();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nquad.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: irix, n
                    // token labels: 
                    // rule labels: retval, irix, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_irix=new RewriteRuleSubtreeStream(adaptor,"rule irix",irix!=null?irix.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2587:3: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2587:6: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2588:8: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2590:11: ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, "xsparql:createURI"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2592:12: ^( T_PARAMS $irix)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_irix.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2597:8: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2598:10: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2599:12: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2599:58: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2600:12: ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2600:20: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2600:62: ^( T_PARAMS )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_4, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2600:190: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2600:232: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2600:261: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_4, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 9 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2605:5: collection
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_collection_in_object_15014);
                    collection610=collection();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_collection.add(collection610.getTree());


                    // AST REWRITE
                    // elements: collection
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2606:3: -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] collection )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2606:6: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] collection )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_1);

                        adaptor.addChild(root_1, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, stream_collection.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 10 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2607:5: T_ANON_BLANK propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    T_ANON_BLANK611=(CommonTree)match(input,T_ANON_BLANK,FOLLOW_T_ANON_BLANK_in_object_15040); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_ANON_BLANK.add(T_ANON_BLANK611);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_object_15042);
                    propertyListNotEmpty_612=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_612.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2608:3: -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ \"] ^( XPATH ^( T_PAR propertyListNotEmpty_ ) LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] \"] QSTRING[$triplesSameSubject_::separator] )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2608:6: ^( T_PAR QSTRING[\" \"] QSTRING[\" [ \"] ^( XPATH ^( T_PAR propertyListNotEmpty_ ) LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] \"] QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_1);

                        adaptor.addChild(root_1, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " [ "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2608:132: ^( XPATH ^( T_PAR propertyListNotEmpty_ ) LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(XPATH, "XPATH"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2608:140: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_3);

                        adaptor.addChild(root_3, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_2, root_3);
                        }
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(LBRACKET, "["));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2608:185: ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(LT, "lt"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2608:196: ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:position"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2608:236: ^( T_PARAMS )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2608:250: ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:last"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2608:286: ^( T_PARAMS )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(RBRACKET, "]"));

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " ] "));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 11 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2609:5: T_EMPTY_ANON_BLANK propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    T_EMPTY_ANON_BLANK613=(CommonTree)match(input,T_EMPTY_ANON_BLANK,FOLLOW_T_EMPTY_ANON_BLANK_in_object_15119); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_EMPTY_ANON_BLANK.add(T_EMPTY_ANON_BLANK613);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_object_15121);
                    propertyListNotEmpty_614=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_614.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2610:3: -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ ]\"] propertyListNotEmpty_ QSTRING[$triplesSameSubject_::separator] )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2610:6: ^( T_PAR QSTRING[\" \"] QSTRING[\" [ ]\"] propertyListNotEmpty_ QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_1);

                        adaptor.addChild(root_1, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " [ ]"));
                        adaptor.addChild(root_1, stream_propertyListNotEmpty_.nextTree());
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "object_"

    public static class nquad_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "nquad"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2614:1: nquad : (irix= iri | lit= literal_ ) -> ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) ) ^( T_PAR QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) ) ) QSTRING[\"\"] ) ;
    public final XSPARQLRewriter.nquad_return nquad() throws RecognitionException {
        XSPARQLRewriter.nquad_return retval = new XSPARQLRewriter.nquad_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.iri_return irix = null;

        XSPARQLRewriter.literal__return lit = null;


        RewriteRuleSubtreeStream stream_literal_=new RewriteRuleSubtreeStream(adaptor,"rule literal_");
        RewriteRuleSubtreeStream stream_iri=new RewriteRuleSubtreeStream(adaptor,"rule iri");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2615:3: ( (irix= iri | lit= literal_ ) -> ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) ) ^( T_PAR QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) ) ) QSTRING[\"\"] ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2616:4: (irix= iri | lit= literal_ )
            {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2616:4: (irix= iri | lit= literal_ )
            int alt184=2;
            switch ( input.LA(1) ) {
            case PNAME_LN:
            case IRIREF:
            case T_IRI_CONSTRUCT:
                {
                alt184=1;
                }
                break;
            case QSTRING:
            case T_LITERAL_CONSTRUCT:
                {
                alt184=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 184, 0, input);

                throw nvae;
            }

            switch (alt184) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2616:5: irix= iri
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iri_in_nquad15166);
                    irix=iri();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iri.add(irix.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2616:16: lit= literal_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_literal__in_nquad15172);
                    lit=literal_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_literal_.add(lit.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }



            // AST REWRITE
            // elements: lit, irix, irix, lit
            // token labels: 
            // rule labels: lit, retval, irix
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_lit=new RewriteRuleSubtreeStream(adaptor,"rule lit",lit!=null?lit.tree:null);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_irix=new RewriteRuleSubtreeStream(adaptor,"rule irix",irix!=null?irix.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2617:3: -> ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) ) ^( T_PAR QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) ) ) QSTRING[\"\"] )
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2618:10: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) ) ^( T_PAR QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) ) ) QSTRING[\"\"] )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2619:12: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2619:58: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2619:69: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2619:116: ^( T_PARAMS ( $irix)? ( $lit)? )
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2619:127: ( $irix)?
                if ( stream_irix.hasNext() ) {
                    adaptor.addChild(root_5, stream_irix.nextTree());

                }
                stream_irix.reset();
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2619:134: ( $lit)?
                if ( stream_lit.hasNext() ) {
                    adaptor.addChild(root_5, stream_lit.nextTree());

                }
                stream_lit.reset();

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2620:12: ^( T_PAR QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, " "));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2620:33: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2620:75: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) ) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2620:86: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ( $irix)? ( $lit)? ) )
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2620:133: ^( T_PARAMS ( $irix)? ( $lit)? )
                {
                CommonTree root_6 = (CommonTree)adaptor.nil();
                root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2620:144: ( $irix)?
                if ( stream_irix.hasNext() ) {
                    adaptor.addChild(root_6, stream_irix.nextTree());

                }
                stream_irix.reset();
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2620:151: ( $lit)?
                if ( stream_lit.hasNext() ) {
                    adaptor.addChild(root_6, stream_lit.nextTree());

                }
                stream_lit.reset();

                adaptor.addChild(root_5, root_6);
                }

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, ""));

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "nquad"

    public static class literal__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "literal_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2625:1: literal_ : ( literalConstruct | rdfLiteral );
    public final XSPARQLRewriter.literal__return literal_() throws RecognitionException {
        XSPARQLRewriter.literal__return retval = new XSPARQLRewriter.literal__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.literalConstruct_return literalConstruct615 = null;

        XSPARQLRewriter.rdfLiteral_return rdfLiteral616 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2626:3: ( literalConstruct | rdfLiteral )
            int alt185=2;
            switch ( input.LA(1) ) {
            case T_LITERAL_CONSTRUCT:
                {
                alt185=1;
                }
                break;
            case QSTRING:
                {
                alt185=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 185, 0, input);

                throw nvae;
            }

            switch (alt185) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2626:6: literalConstruct
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_literalConstruct_in_literal_15322);
                    literalConstruct615=literalConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, literalConstruct615.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2627:6: rdfLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rdfLiteral_in_literal_15329);
                    rdfLiteral616=rdfLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, rdfLiteral616.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "literal_"

    public static class object_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "object"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2630:1: object : ( resource | blank -> QSTRING[\"[]\"] | rdfLiteral | sNumericLiteral | triplesNode );
    public final XSPARQLRewriter.object_return object() throws RecognitionException {
        XSPARQLRewriter.object_return retval = new XSPARQLRewriter.object_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.resource_return resource617 = null;

        XSPARQLRewriter.blank_return blank618 = null;

        XSPARQLRewriter.rdfLiteral_return rdfLiteral619 = null;

        XSPARQLRewriter.sNumericLiteral_return sNumericLiteral620 = null;

        XSPARQLRewriter.triplesNode_return triplesNode621 = null;


        RewriteRuleSubtreeStream stream_blank=new RewriteRuleSubtreeStream(adaptor,"rule blank");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2631:3: ( resource | blank -> QSTRING[\"[]\"] | rdfLiteral | sNumericLiteral | triplesNode )
            int alt186=5;
            switch ( input.LA(1) ) {
            case VAR:
            case PNAME_NS:
            case PNAME_LN:
                {
                alt186=1;
                }
                break;
            case BLANK_NODE_LABEL:
            case T_EMPTY_ANON_BLANK:
                {
                alt186=2;
                }
                break;
            case QSTRING:
                {
                alt186=3;
                }
                break;
            case INTEGER:
                {
                alt186=4;
                }
                break;
            case LPAR:
            case T_ANON_BLANK:
                {
                alt186=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 186, 0, input);

                throw nvae;
            }

            switch (alt186) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2631:5: resource
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_resource_in_object15342);
                    resource617=resource();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, resource617.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2632:5: blank
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blank_in_object15348);
                    blank618=blank();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_blank.add(blank618.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2633:3: -> QSTRING[\"[]\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "[]"));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2634:5: rdfLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rdfLiteral_in_object15361);
                    rdfLiteral619=rdfLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, rdfLiteral619.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2635:5: sNumericLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sNumericLiteral_in_object15367);
                    sNumericLiteral620=sNumericLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sNumericLiteral620.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2636:5: triplesNode
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_triplesNode_in_object15373);
                    triplesNode621=triplesNode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, triplesNode621.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "object"

    public static class triplesNode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "triplesNode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2639:1: triplesNode : ( collection | blankNodePropertyList );
    public final XSPARQLRewriter.triplesNode_return triplesNode() throws RecognitionException {
        XSPARQLRewriter.triplesNode_return retval = new XSPARQLRewriter.triplesNode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.collection_return collection622 = null;

        XSPARQLRewriter.blankNodePropertyList_return blankNodePropertyList623 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2640:3: ( collection | blankNodePropertyList )
            int alt187=2;
            switch ( input.LA(1) ) {
            case LPAR:
                {
                alt187=1;
                }
                break;
            case T_ANON_BLANK:
                {
                alt187=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 187, 0, input);

                throw nvae;
            }

            switch (alt187) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2640:5: collection
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_collection_in_triplesNode15386);
                    collection622=collection();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, collection622.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2641:5: blankNodePropertyList
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blankNodePropertyList_in_triplesNode15392);
                    blankNodePropertyList623=blankNodePropertyList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, blankNodePropertyList623.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "triplesNode"

    public static class triplesNode__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "triplesNode_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2644:1: triplesNode_ : ( collection | blankNodePropertyList_ );
    public final XSPARQLRewriter.triplesNode__return triplesNode_() throws RecognitionException {
        XSPARQLRewriter.triplesNode__return retval = new XSPARQLRewriter.triplesNode__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.collection_return collection624 = null;

        XSPARQLRewriter.blankNodePropertyList__return blankNodePropertyList_625 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2645:3: ( collection | blankNodePropertyList_ )
            int alt188=2;
            switch ( input.LA(1) ) {
            case LPAR:
                {
                alt188=1;
                }
                break;
            case T_ANON_BLANK:
                {
                alt188=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 188, 0, input);

                throw nvae;
            }

            switch (alt188) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2645:5: collection
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_collection_in_triplesNode_15405);
                    collection624=collection();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, collection624.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2646:5: blankNodePropertyList_
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blankNodePropertyList__in_triplesNode_15411);
                    blankNodePropertyList_625=blankNodePropertyList_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, blankNodePropertyList_625.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "triplesNode_"

    public static class blankNodePropertyList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "blankNodePropertyList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2649:1: blankNodePropertyList : T_ANON_BLANK propertyListNotEmpty -> QSTRING[\"[\"] propertyListNotEmpty QSTRING[\"]\"] ;
    public final XSPARQLRewriter.blankNodePropertyList_return blankNodePropertyList() throws RecognitionException {
        XSPARQLRewriter.blankNodePropertyList_return retval = new XSPARQLRewriter.blankNodePropertyList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_ANON_BLANK626=null;
        XSPARQLRewriter.propertyListNotEmpty_return propertyListNotEmpty627 = null;


        CommonTree T_ANON_BLANK626_tree=null;
        RewriteRuleNodeStream stream_T_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_ANON_BLANK");
        RewriteRuleSubtreeStream stream_propertyListNotEmpty=new RewriteRuleSubtreeStream(adaptor,"rule propertyListNotEmpty");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2650:3: ( T_ANON_BLANK propertyListNotEmpty -> QSTRING[\"[\"] propertyListNotEmpty QSTRING[\"]\"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2650:5: T_ANON_BLANK propertyListNotEmpty
            {
            _last = (CommonTree)input.LT(1);
            T_ANON_BLANK626=(CommonTree)match(input,T_ANON_BLANK,FOLLOW_T_ANON_BLANK_in_blankNodePropertyList15424); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_ANON_BLANK.add(T_ANON_BLANK626);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_propertyListNotEmpty_in_blankNodePropertyList15426);
            propertyListNotEmpty627=propertyListNotEmpty();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_propertyListNotEmpty.add(propertyListNotEmpty627.getTree());


            // AST REWRITE
            // elements: propertyListNotEmpty
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2651:3: -> QSTRING[\"[\"] propertyListNotEmpty QSTRING[\"]\"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "["));
                adaptor.addChild(root_0, stream_propertyListNotEmpty.nextTree());
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "]"));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "blankNodePropertyList"

    public static class blankNodePropertyList__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "blankNodePropertyList_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2654:1: blankNodePropertyList_ : T_ANON_BLANK propertyListNotEmpty_ ;
    public final XSPARQLRewriter.blankNodePropertyList__return blankNodePropertyList_() throws RecognitionException {
        XSPARQLRewriter.blankNodePropertyList__return retval = new XSPARQLRewriter.blankNodePropertyList__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_ANON_BLANK628=null;
        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_629 = null;


        CommonTree T_ANON_BLANK628_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2655:3: ( T_ANON_BLANK propertyListNotEmpty_ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2655:5: T_ANON_BLANK propertyListNotEmpty_
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            T_ANON_BLANK628=(CommonTree)match(input,T_ANON_BLANK,FOLLOW_T_ANON_BLANK_in_blankNodePropertyList_15451); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_ANON_BLANK628_tree = (CommonTree)adaptor.dupNode(T_ANON_BLANK628);

            adaptor.addChild(root_0, T_ANON_BLANK628_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_propertyListNotEmpty__in_blankNodePropertyList_15453);
            propertyListNotEmpty_629=propertyListNotEmpty_();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, propertyListNotEmpty_629.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "blankNodePropertyList_"

    public static class collection_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "collection"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2658:1: collection : LPAR ( graphNode )+ RPAR ;
    public final XSPARQLRewriter.collection_return collection() throws RecognitionException {
        XSPARQLRewriter.collection_return retval = new XSPARQLRewriter.collection_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree LPAR630=null;
        CommonTree RPAR632=null;
        XSPARQLRewriter.graphNode_return graphNode631 = null;


        CommonTree LPAR630_tree=null;
        CommonTree RPAR632_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2659:3: ( LPAR ( graphNode )+ RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2659:5: LPAR ( graphNode )+ RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            LPAR630=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_collection15466); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR630_tree = (CommonTree)adaptor.dupNode(LPAR630);

            adaptor.addChild(root_0, LPAR630_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2659:10: ( graphNode )+
            int cnt189=0;
            loop189:
            do {
                int alt189=2;
                switch ( input.LA(1) ) {
                case VAR:
                case INTEGER:
                case QSTRING:
                case LPAR:
                case PNAME_NS:
                case PNAME_LN:
                case IRIREF:
                case TRUE:
                case FALSE:
                case T_ANON_BLANK:
                    {
                    alt189=1;
                    }
                    break;

                }

                switch (alt189) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: graphNode
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_graphNode_in_collection15468);
            	    graphNode631=graphNode();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, graphNode631.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt189 >= 1 ) break loop189;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(189, input);
                        throw eee;
                }
                cnt189++;
            } while (true);

            _last = (CommonTree)input.LT(1);
            RPAR632=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_collection15471); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR632_tree = (CommonTree)adaptor.dupNode(RPAR632);

            adaptor.addChild(root_0, RPAR632_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "collection"

    public static class graphNode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "graphNode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2662:1: graphNode : ( varOrTerm | triplesNode );
    public final XSPARQLRewriter.graphNode_return graphNode() throws RecognitionException {
        XSPARQLRewriter.graphNode_return retval = new XSPARQLRewriter.graphNode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.varOrTerm_return varOrTerm633 = null;

        XSPARQLRewriter.triplesNode_return triplesNode634 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2663:3: ( varOrTerm | triplesNode )
            int alt190=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
            case TRUE:
            case FALSE:
                {
                alt190=1;
                }
                break;
            case LPAR:
            case T_ANON_BLANK:
                {
                alt190=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 190, 0, input);

                throw nvae;
            }

            switch (alt190) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2663:5: varOrTerm
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_varOrTerm_in_graphNode15484);
                    varOrTerm633=varOrTerm();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, varOrTerm633.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2664:5: triplesNode
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_triplesNode_in_graphNode15490);
                    triplesNode634=triplesNode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, triplesNode634.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "graphNode"

    public static class varOrTerm_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varOrTerm"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2667:1: varOrTerm : ( VAR | graphTerm );
    public final XSPARQLRewriter.varOrTerm_return varOrTerm() throws RecognitionException {
        XSPARQLRewriter.varOrTerm_return retval = new XSPARQLRewriter.varOrTerm_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR635=null;
        XSPARQLRewriter.graphTerm_return graphTerm636 = null;


        CommonTree VAR635_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2668:3: ( VAR | graphTerm )
            int alt191=2;
            switch ( input.LA(1) ) {
            case VAR:
                {
                alt191=1;
                }
                break;
            case INTEGER:
            case QSTRING:
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
            case TRUE:
            case FALSE:
                {
                alt191=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 191, 0, input);

                throw nvae;
            }

            switch (alt191) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2668:5: VAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    VAR635=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varOrTerm15503); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR635_tree = (CommonTree)adaptor.dupNode(VAR635);

                    adaptor.addChild(root_0, VAR635_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2669:5: graphTerm
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_graphTerm_in_varOrTerm15509);
                    graphTerm636=graphTerm();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, graphTerm636.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varOrTerm"

    public static class literalConstruct_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "literalConstruct"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2672:1: literalConstruct : ( ^( T_LITERAL_CONSTRUCT e1= enclosedExpr at= AT e2= enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] $e1 $e2 QSTRING[\"\"] ) ) | ^( T_LITERAL_CONSTRUCT enclosedExpr c1= CARET c2= CARET iri ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] enclosedExpr QSTRING[\"\"] iri ) ) | ^( T_LITERAL_CONSTRUCT INTEGER AT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER enclosedExpr QSTRING[\"\\\"\\\"\"] ) ) | ^( T_LITERAL_CONSTRUCT INTEGER CARET CARET iriConstruct ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER QSTRING[\"\"] iriConstruct ) ) | ^( T_LITERAL_CONSTRUCT QSTRING AT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING enclosedExpr QSTRING[\"\"] ) ) | ^( T_LITERAL_CONSTRUCT QSTRING c1= CARET c2= CARET iriConstruct ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING QSTRING[\"\"] iriConstruct ) ) | ^( T_LITERAL_CONSTRUCT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS enclosedExpr ) ) );
    public final XSPARQLRewriter.literalConstruct_return literalConstruct() throws RecognitionException {
        XSPARQLRewriter.literalConstruct_return retval = new XSPARQLRewriter.literalConstruct_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree at=null;
        CommonTree c1=null;
        CommonTree c2=null;
        CommonTree T_LITERAL_CONSTRUCT637=null;
        CommonTree T_LITERAL_CONSTRUCT638=null;
        CommonTree T_LITERAL_CONSTRUCT641=null;
        CommonTree INTEGER642=null;
        CommonTree AT643=null;
        CommonTree T_LITERAL_CONSTRUCT645=null;
        CommonTree INTEGER646=null;
        CommonTree CARET647=null;
        CommonTree CARET648=null;
        CommonTree T_LITERAL_CONSTRUCT650=null;
        CommonTree QSTRING651=null;
        CommonTree AT652=null;
        CommonTree T_LITERAL_CONSTRUCT654=null;
        CommonTree QSTRING655=null;
        CommonTree T_LITERAL_CONSTRUCT657=null;
        XSPARQLRewriter.enclosedExpr_return e1 = null;

        XSPARQLRewriter.enclosedExpr_return e2 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr639 = null;

        XSPARQLRewriter.iri_return iri640 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr644 = null;

        XSPARQLRewriter.iriConstruct_return iriConstruct649 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr653 = null;

        XSPARQLRewriter.iriConstruct_return iriConstruct656 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr658 = null;


        CommonTree at_tree=null;
        CommonTree c1_tree=null;
        CommonTree c2_tree=null;
        CommonTree T_LITERAL_CONSTRUCT637_tree=null;
        CommonTree T_LITERAL_CONSTRUCT638_tree=null;
        CommonTree T_LITERAL_CONSTRUCT641_tree=null;
        CommonTree INTEGER642_tree=null;
        CommonTree AT643_tree=null;
        CommonTree T_LITERAL_CONSTRUCT645_tree=null;
        CommonTree INTEGER646_tree=null;
        CommonTree CARET647_tree=null;
        CommonTree CARET648_tree=null;
        CommonTree T_LITERAL_CONSTRUCT650_tree=null;
        CommonTree QSTRING651_tree=null;
        CommonTree AT652_tree=null;
        CommonTree T_LITERAL_CONSTRUCT654_tree=null;
        CommonTree QSTRING655_tree=null;
        CommonTree T_LITERAL_CONSTRUCT657_tree=null;
        RewriteRuleNodeStream stream_INTEGER=new RewriteRuleNodeStream(adaptor,"token INTEGER");
        RewriteRuleNodeStream stream_AT=new RewriteRuleNodeStream(adaptor,"token AT");
        RewriteRuleNodeStream stream_T_LITERAL_CONSTRUCT=new RewriteRuleNodeStream(adaptor,"token T_LITERAL_CONSTRUCT");
        RewriteRuleNodeStream stream_QSTRING=new RewriteRuleNodeStream(adaptor,"token QSTRING");
        RewriteRuleNodeStream stream_CARET=new RewriteRuleNodeStream(adaptor,"token CARET");
        RewriteRuleSubtreeStream stream_iriConstruct=new RewriteRuleSubtreeStream(adaptor,"rule iriConstruct");
        RewriteRuleSubtreeStream stream_enclosedExpr=new RewriteRuleSubtreeStream(adaptor,"rule enclosedExpr");
        RewriteRuleSubtreeStream stream_iri=new RewriteRuleSubtreeStream(adaptor,"rule iri");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2673:3: ( ^( T_LITERAL_CONSTRUCT e1= enclosedExpr at= AT e2= enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] $e1 $e2 QSTRING[\"\"] ) ) | ^( T_LITERAL_CONSTRUCT enclosedExpr c1= CARET c2= CARET iri ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] enclosedExpr QSTRING[\"\"] iri ) ) | ^( T_LITERAL_CONSTRUCT INTEGER AT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER enclosedExpr QSTRING[\"\\\"\\\"\"] ) ) | ^( T_LITERAL_CONSTRUCT INTEGER CARET CARET iriConstruct ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER QSTRING[\"\"] iriConstruct ) ) | ^( T_LITERAL_CONSTRUCT QSTRING AT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING enclosedExpr QSTRING[\"\"] ) ) | ^( T_LITERAL_CONSTRUCT QSTRING c1= CARET c2= CARET iriConstruct ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING QSTRING[\"\"] iriConstruct ) ) | ^( T_LITERAL_CONSTRUCT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS enclosedExpr ) ) )
            int alt192=7;
            switch ( input.LA(1) ) {
            case T_LITERAL_CONSTRUCT:
                {
                int LA192_1 = input.LA(2);

                if ( (synpred318_XSPARQLRewriter()) ) {
                    alt192=1;
                }
                else if ( (synpred319_XSPARQLRewriter()) ) {
                    alt192=2;
                }
                else if ( (synpred320_XSPARQLRewriter()) ) {
                    alt192=3;
                }
                else if ( (synpred321_XSPARQLRewriter()) ) {
                    alt192=4;
                }
                else if ( (synpred322_XSPARQLRewriter()) ) {
                    alt192=5;
                }
                else if ( (synpred323_XSPARQLRewriter()) ) {
                    alt192=6;
                }
                else if ( (true) ) {
                    alt192=7;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 192, 1, input);

                    throw nvae;
                }
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 192, 0, input);

                throw nvae;
            }

            switch (alt192) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2673:5: ^( T_LITERAL_CONSTRUCT e1= enclosedExpr at= AT e2= enclosedExpr )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT637=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15523); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT637);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct15527);
                    e1=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(e1.getTree());
                    _last = (CommonTree)input.LT(1);
                    at=(CommonTree)match(input,AT,FOLLOW_AT_in_literalConstruct15531); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT.add(at);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct15535);
                    e2=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(e2.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: e1, e2
                    // token labels: 
                    // rule labels: retval, e1, e2
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_e1=new RewriteRuleSubtreeStream(adaptor,"rule e1",e1!=null?e1.tree:null);
                    RewriteRuleSubtreeStream stream_e2=new RewriteRuleSubtreeStream(adaptor,"rule e2",e2!=null?e2.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2674:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] $e1 $e2 QSTRING[\"\"] ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2674:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] $e1 $e2 QSTRING[\"\"] ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2676:8: ^( T_PARAMS QSTRING[\"\"] $e1 $e2 QSTRING[\"\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_e1.nextTree());
                        adaptor.addChild(root_2, stream_e2.nextTree());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2683:5: ^( T_LITERAL_CONSTRUCT enclosedExpr c1= CARET c2= CARET iri )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT638=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15642); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT638);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct15644);
                    enclosedExpr639=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr639.getTree());
                    _last = (CommonTree)input.LT(1);
                    c1=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct15648); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c1);

                    _last = (CommonTree)input.LT(1);
                    c2=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct15652); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c2);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iri_in_literalConstruct15654);
                    iri640=iri();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iri.add(iri640.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: iri, enclosedExpr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2684:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] enclosedExpr QSTRING[\"\"] iri ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2684:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] enclosedExpr QSTRING[\"\"] iri ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2686:8: ^( T_PARAMS QSTRING[\"\"] enclosedExpr QSTRING[\"\"] iri )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_enclosedExpr.nextTree());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_iri.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2693:5: ^( T_LITERAL_CONSTRUCT INTEGER AT enclosedExpr )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT641=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15758); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT641);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    INTEGER642=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_literalConstruct15760); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_INTEGER.add(INTEGER642);

                    _last = (CommonTree)input.LT(1);
                    AT643=(CommonTree)match(input,AT,FOLLOW_AT_in_literalConstruct15762); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT.add(AT643);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct15764);
                    enclosedExpr644=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr644.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: INTEGER, enclosedExpr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2694:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER enclosedExpr QSTRING[\"\\\"\\\"\"] ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2694:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER enclosedExpr QSTRING[\"\\\"\\\"\"] ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2696:8: ^( T_PARAMS QSTRING[\"\"] INTEGER enclosedExpr QSTRING[\"\\\"\\\"\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_INTEGER.nextNode());
                        adaptor.addChild(root_2, stream_enclosedExpr.nextTree());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, "\"\""));

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2703:5: ^( T_LITERAL_CONSTRUCT INTEGER CARET CARET iriConstruct )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT645=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15870); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT645);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    INTEGER646=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_literalConstruct15872); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_INTEGER.add(INTEGER646);

                    _last = (CommonTree)input.LT(1);
                    CARET647=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct15874); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(CARET647);

                    _last = (CommonTree)input.LT(1);
                    CARET648=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct15876); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(CARET648);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_literalConstruct15878);
                    iriConstruct649=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iriConstruct.add(iriConstruct649.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: INTEGER, iriConstruct
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2704:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER QSTRING[\"\"] iriConstruct ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2704:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER QSTRING[\"\"] iriConstruct ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2706:8: ^( T_PARAMS QSTRING[\"\"] INTEGER QSTRING[\"\"] iriConstruct )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_INTEGER.nextNode());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_iriConstruct.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2714:5: ^( T_LITERAL_CONSTRUCT QSTRING AT enclosedExpr )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT650=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15983); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT650);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    QSTRING651=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_literalConstruct15985); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(QSTRING651);

                    _last = (CommonTree)input.LT(1);
                    AT652=(CommonTree)match(input,AT,FOLLOW_AT_in_literalConstruct15987); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT.add(AT652);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct15989);
                    enclosedExpr653=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr653.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: QSTRING, enclosedExpr, QSTRING, QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2715:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING enclosedExpr QSTRING[\"\"] ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2715:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING enclosedExpr QSTRING[\"\"] ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2717:8: ^( T_PARAMS QSTRING[\"\"] QSTRING enclosedExpr QSTRING[\"\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_QSTRING.nextNode());
                        adaptor.addChild(root_2, stream_enclosedExpr.nextTree());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2724:5: ^( T_LITERAL_CONSTRUCT QSTRING c1= CARET c2= CARET iriConstruct )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT654=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct16094); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT654);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    QSTRING655=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_literalConstruct16096); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(QSTRING655);

                    _last = (CommonTree)input.LT(1);
                    c1=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct16100); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c1);

                    _last = (CommonTree)input.LT(1);
                    c2=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct16104); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c2);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_literalConstruct16106);
                    iriConstruct656=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iriConstruct.add(iriConstruct656.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: QSTRING, QSTRING, iriConstruct, QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2725:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING QSTRING[\"\"] iriConstruct ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2725:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING QSTRING[\"\"] iriConstruct ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2727:8: ^( T_PARAMS QSTRING[\"\"] QSTRING QSTRING[\"\"] iriConstruct )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_QSTRING.nextNode());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_iriConstruct.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2734:5: ^( T_LITERAL_CONSTRUCT enclosedExpr )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT657=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct16212); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT657);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct16214);
                    enclosedExpr658=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr658.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: enclosedExpr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2735:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS enclosedExpr ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2735:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS enclosedExpr ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2737:8: ^( T_PARAMS enclosedExpr )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, stream_enclosedExpr.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "literalConstruct"

    public static class varOrIRIref_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varOrIRIref"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2743:1: varOrIRIref : ( VAR | iRIref );
    public final XSPARQLRewriter.varOrIRIref_return varOrIRIref() throws RecognitionException {
        XSPARQLRewriter.varOrIRIref_return retval = new XSPARQLRewriter.varOrIRIref_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR659=null;
        XSPARQLRewriter.iRIref_return iRIref660 = null;


        CommonTree VAR659_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2744:3: ( VAR | iRIref )
            int alt193=2;
            switch ( input.LA(1) ) {
            case VAR:
                {
                alt193=1;
                }
                break;
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
                {
                alt193=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 193, 0, input);

                throw nvae;
            }

            switch (alt193) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2744:5: VAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    VAR659=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varOrIRIref16288); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR659_tree = (CommonTree)adaptor.dupNode(VAR659);

                    adaptor.addChild(root_0, VAR659_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2745:5: iRIref
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iRIref_in_varOrIRIref16294);
                    iRIref660=iRIref();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, iRIref660.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varOrIRIref"

    public static class iriConstruct_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "iriConstruct"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2748:1: iriConstruct : ^( T_IRI_CONSTRUCT (l= LESSTHANLCURLY expr r= RCURLYGREATERTHAN -> expr | e1= enclosedExpr (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) ) | q= qname c= COLON enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) ) ) ) ;
    public final XSPARQLRewriter.iriConstruct_return iriConstruct() throws RecognitionException {
        XSPARQLRewriter.iriConstruct_return retval = new XSPARQLRewriter.iriConstruct_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree l=null;
        CommonTree r=null;
        CommonTree c=null;
        CommonTree T_IRI_CONSTRUCT661=null;
        XSPARQLRewriter.enclosedExpr_return e1 = null;

        XSPARQLRewriter.enclosedExpr_return e2 = null;

        XSPARQLRewriter.qname_return q = null;

        XSPARQLRewriter.expr_return expr662 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr663 = null;


        CommonTree l_tree=null;
        CommonTree r_tree=null;
        CommonTree c_tree=null;
        CommonTree T_IRI_CONSTRUCT661_tree=null;
        RewriteRuleNodeStream stream_COLON=new RewriteRuleNodeStream(adaptor,"token COLON");
        RewriteRuleNodeStream stream_RCURLYGREATERTHAN=new RewriteRuleNodeStream(adaptor,"token RCURLYGREATERTHAN");
        RewriteRuleNodeStream stream_T_IRI_CONSTRUCT=new RewriteRuleNodeStream(adaptor,"token T_IRI_CONSTRUCT");
        RewriteRuleNodeStream stream_LESSTHANLCURLY=new RewriteRuleNodeStream(adaptor,"token LESSTHANLCURLY");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        RewriteRuleSubtreeStream stream_enclosedExpr=new RewriteRuleSubtreeStream(adaptor,"rule enclosedExpr");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2749:3: ( ^( T_IRI_CONSTRUCT (l= LESSTHANLCURLY expr r= RCURLYGREATERTHAN -> expr | e1= enclosedExpr (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) ) | q= qname c= COLON enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) ) ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2749:5: ^( T_IRI_CONSTRUCT (l= LESSTHANLCURLY expr r= RCURLYGREATERTHAN -> expr | e1= enclosedExpr (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) ) | q= qname c= COLON enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) ) ) )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_IRI_CONSTRUCT661=(CommonTree)match(input,T_IRI_CONSTRUCT,FOLLOW_T_IRI_CONSTRUCT_in_iriConstruct16308); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_IRI_CONSTRUCT.add(T_IRI_CONSTRUCT661);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2750:7: (l= LESSTHANLCURLY expr r= RCURLYGREATERTHAN -> expr | e1= enclosedExpr (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) ) | q= qname c= COLON enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) ) )
            int alt195=3;
            switch ( input.LA(1) ) {
            case LESSTHANLCURLY:
                {
                alt195=1;
                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt195=2;
                }
                break;
            case TO:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt195=2;
                    }
                    break;
                case COLON:
                    {
                    alt195=3;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 195, 3, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt195=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 195, 0, input);

                throw nvae;
            }

            switch (alt195) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2750:8: l= LESSTHANLCURLY expr r= RCURLYGREATERTHAN
                    {
                    _last = (CommonTree)input.LT(1);
                    l=(CommonTree)match(input,LESSTHANLCURLY,FOLLOW_LESSTHANLCURLY_in_iriConstruct16319); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LESSTHANLCURLY.add(l);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expr_in_iriConstruct16321);
                    expr662=expr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expr.add(expr662.getTree());
                    _last = (CommonTree)input.LT(1);
                    r=(CommonTree)match(input,RCURLYGREATERTHAN,FOLLOW_RCURLYGREATERTHAN_in_iriConstruct16325); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RCURLYGREATERTHAN.add(r);



                    // AST REWRITE
                    // elements: expr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2751:7: -> expr
                    {
                        adaptor.addChild(root_0, stream_expr.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2752:9: e1= enclosedExpr (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) )
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_iriConstruct16352);
                    e1=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(e1.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2753:9: (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) )
                    int alt194=2;
                    switch ( input.LA(1) ) {
                    case COLON:
                        {
                        alt194=1;
                        }
                        break;
                    case NCNAME:
                    case PNAME_NS:
                    case PNAME_LN:
                    case A:
                    case FROM:
                    case TO:
                    case ITEM:
                    case NODE:
                    case COMMENT:
                    case ROW:
                        {
                        alt194=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 194, 0, input);

                        throw nvae;
                    }

                    switch (alt194) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2753:10: c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) )
                            {
                            _last = (CommonTree)input.LT(1);
                            c=(CommonTree)match(input,COLON,FOLLOW_COLON_in_iriConstruct16365); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_COLON.add(c);

                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2754:11: (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) )
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2754:12: e2= enclosedExpr
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_enclosedExpr_in_iriConstruct16380);
                            e2=enclosedExpr();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_enclosedExpr.add(e2.getTree());


                            // AST REWRITE
                            // elements: e1, e2
                            // token labels: 
                            // rule labels: retval, e1, e2
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                            RewriteRuleSubtreeStream stream_e1=new RewriteRuleSubtreeStream(adaptor,"rule e1",e1!=null?e1.tree:null);
                            RewriteRuleSubtreeStream stream_e2=new RewriteRuleSubtreeStream(adaptor,"rule e2",e2!=null?e2.tree:null);

                            root_0 = (CommonTree)adaptor.nil();
                            // 2755:13: -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) )
                            {
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2755:16: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) )
                                {
                                CommonTree root_2 = (CommonTree)adaptor.nil();
                                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2757:18: ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) )
                                {
                                CommonTree root_3 = (CommonTree)adaptor.nil();
                                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2757:29: ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2)
                                {
                                CommonTree root_4 = (CommonTree)adaptor.nil();
                                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                                adaptor.addChild(root_4, stream_e1.nextTree());
                                adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, c.token, (c!=null?c.getText():null)));
                                adaptor.addChild(root_4, stream_e2.nextTree());

                                adaptor.addChild(root_3, root_4);
                                }

                                adaptor.addChild(root_2, root_3);
                                }

                                adaptor.addChild(root_1, root_2);
                                }

                            }

                            retval.tree = root_0;}
                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2765:11: q= qname
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_qname_in_iriConstruct16500);
                            q=qname();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_qname.add(q.getTree());


                            // AST REWRITE
                            // elements: enclosedExpr
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (CommonTree)adaptor.nil();
                            // 2766:11: -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) )
                            {
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2766:14: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) )
                                {
                                CommonTree root_2 = (CommonTree)adaptor.nil();
                                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2768:16: ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) )
                                {
                                CommonTree root_3 = (CommonTree)adaptor.nil();
                                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2768:27: ^( T_PAR enclosedExpr QSTRING[$q.text] )
                                {
                                CommonTree root_4 = (CommonTree)adaptor.nil();
                                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                                adaptor.addChild(root_4, stream_enclosedExpr.nextTree());
                                adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, (q!=null?(input.getTokenStream().toString(
                                  input.getTreeAdaptor().getTokenStartIndex(q.start),
                                  input.getTreeAdaptor().getTokenStopIndex(q.start))):null)));

                                adaptor.addChild(root_3, root_4);
                                }

                                adaptor.addChild(root_2, root_3);
                                }

                                adaptor.addChild(root_1, root_2);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2771:9: q= qname c= COLON enclosedExpr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_iriConstruct16600);
                    q=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(q.getTree());
                    _last = (CommonTree)input.LT(1);
                    c=(CommonTree)match(input,COLON,FOLLOW_COLON_in_iriConstruct16604); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_COLON.add(c);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_iriConstruct16606);
                    enclosedExpr663=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr663.getTree());


                    // AST REWRITE
                    // elements: enclosedExpr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2772:7: -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2772:10: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2774:12: ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2774:23: ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, (q!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(q.start),
                          input.getTreeAdaptor().getTokenStopIndex(q.start))):null)));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, c.token, (c!=null?c.getText():null)));
                        adaptor.addChild(root_4, stream_enclosedExpr.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "iriConstruct"

    public static class graphTerm_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "graphTerm"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2780:1: graphTerm : ( iRIref | rdfLiteral | sNumericLiteral | booleanLiteral );
    public final XSPARQLRewriter.graphTerm_return graphTerm() throws RecognitionException {
        XSPARQLRewriter.graphTerm_return retval = new XSPARQLRewriter.graphTerm_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.iRIref_return iRIref664 = null;

        XSPARQLRewriter.rdfLiteral_return rdfLiteral665 = null;

        XSPARQLRewriter.sNumericLiteral_return sNumericLiteral666 = null;

        XSPARQLRewriter.booleanLiteral_return booleanLiteral667 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2781:3: ( iRIref | rdfLiteral | sNumericLiteral | booleanLiteral )
            int alt196=4;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
                {
                alt196=1;
                }
                break;
            case QSTRING:
                {
                alt196=2;
                }
                break;
            case INTEGER:
                {
                alt196=3;
                }
                break;
            case TRUE:
            case FALSE:
                {
                alt196=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 196, 0, input);

                throw nvae;
            }

            switch (alt196) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2781:5: iRIref
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iRIref_in_graphTerm16697);
                    iRIref664=iRIref();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, iRIref664.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2782:5: rdfLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rdfLiteral_in_graphTerm16703);
                    rdfLiteral665=rdfLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, rdfLiteral665.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2783:5: sNumericLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sNumericLiteral_in_graphTerm16709);
                    sNumericLiteral666=sNumericLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sNumericLiteral666.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2784:5: booleanLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_booleanLiteral_in_graphTerm16715);
                    booleanLiteral667=booleanLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, booleanLiteral667.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "graphTerm"

    public static class blankConstruct_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "blankConstruct"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2787:1: blankConstruct : b= BNODE_CONSTRUCT enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[$b.token, $b.text] enclosedExpr QSTRING[\"\"] QSTRING[\"\"] ) ) ;
    public final XSPARQLRewriter.blankConstruct_return blankConstruct() throws RecognitionException {
        XSPARQLRewriter.blankConstruct_return retval = new XSPARQLRewriter.blankConstruct_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree b=null;
        XSPARQLRewriter.enclosedExpr_return enclosedExpr668 = null;


        CommonTree b_tree=null;
        RewriteRuleNodeStream stream_BNODE_CONSTRUCT=new RewriteRuleNodeStream(adaptor,"token BNODE_CONSTRUCT");
        RewriteRuleSubtreeStream stream_enclosedExpr=new RewriteRuleSubtreeStream(adaptor,"rule enclosedExpr");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2788:3: (b= BNODE_CONSTRUCT enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[$b.token, $b.text] enclosedExpr QSTRING[\"\"] QSTRING[\"\"] ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2788:5: b= BNODE_CONSTRUCT enclosedExpr
            {
            _last = (CommonTree)input.LT(1);
            b=(CommonTree)match(input,BNODE_CONSTRUCT,FOLLOW_BNODE_CONSTRUCT_in_blankConstruct16730); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_BNODE_CONSTRUCT.add(b);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_enclosedExpr_in_blankConstruct16732);
            enclosedExpr668=enclosedExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr668.getTree());


            // AST REWRITE
            // elements: enclosedExpr
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2789:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[$b.token, $b.text] enclosedExpr QSTRING[\"\"] QSTRING[\"\"] ) )
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2789:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[$b.token, $b.text] enclosedExpr QSTRING[\"\"] QSTRING[\"\"] ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2791:8: ^( T_PARAMS QSTRING[$b.token, $b.text] enclosedExpr QSTRING[\"\"] QSTRING[\"\"] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, b.token, (b!=null?b.getText():null)));
                adaptor.addChild(root_2, stream_enclosedExpr.nextTree());
                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "blankConstruct"

    public static class expression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2800:1: expression : conditionalOrExpression ;
    public final XSPARQLRewriter.expression_return expression() throws RecognitionException {
        XSPARQLRewriter.expression_return retval = new XSPARQLRewriter.expression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.conditionalOrExpression_return conditionalOrExpression669 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2801:3: ( conditionalOrExpression )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2801:5: conditionalOrExpression
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_conditionalOrExpression_in_expression16845);
            conditionalOrExpression669=conditionalOrExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, conditionalOrExpression669.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "expression"

    public static class conditionalOrExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "conditionalOrExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2804:1: conditionalOrExpression : ( conditionalAndExpression | ^(o= ORSYMBOL conditionalOrExpression conditionalAndExpression ) -> conditionalOrExpression QSTRING[$o.token, \" \"+$o.text+\" \"] conditionalAndExpression );
    public final XSPARQLRewriter.conditionalOrExpression_return conditionalOrExpression() throws RecognitionException {
        XSPARQLRewriter.conditionalOrExpression_return retval = new XSPARQLRewriter.conditionalOrExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.conditionalAndExpression_return conditionalAndExpression670 = null;

        XSPARQLRewriter.conditionalOrExpression_return conditionalOrExpression671 = null;

        XSPARQLRewriter.conditionalAndExpression_return conditionalAndExpression672 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_ORSYMBOL=new RewriteRuleNodeStream(adaptor,"token ORSYMBOL");
        RewriteRuleSubtreeStream stream_conditionalAndExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalAndExpression");
        RewriteRuleSubtreeStream stream_conditionalOrExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalOrExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2805:3: ( conditionalAndExpression | ^(o= ORSYMBOL conditionalOrExpression conditionalAndExpression ) -> conditionalOrExpression QSTRING[$o.token, \" \"+$o.text+\" \"] conditionalAndExpression )
            int alt197=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case SLASH:
            case LPAR:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case ANDSYMBOL:
            case NOT:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt197=1;
                }
                break;
            case ORSYMBOL:
                {
                alt197=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 197, 0, input);

                throw nvae;
            }

            switch (alt197) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2805:5: conditionalAndExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_conditionalAndExpression_in_conditionalOrExpression16858);
                    conditionalAndExpression670=conditionalAndExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, conditionalAndExpression670.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2806:5: ^(o= ORSYMBOL conditionalOrExpression conditionalAndExpression )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    o=(CommonTree)match(input,ORSYMBOL,FOLLOW_ORSYMBOL_in_conditionalOrExpression16867); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ORSYMBOL.add(o);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_conditionalOrExpression_in_conditionalOrExpression16869);
                    conditionalOrExpression671=conditionalOrExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_conditionalOrExpression.add(conditionalOrExpression671.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_conditionalAndExpression_in_conditionalOrExpression16871);
                    conditionalAndExpression672=conditionalAndExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_conditionalAndExpression.add(conditionalAndExpression672.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: conditionalOrExpression, conditionalAndExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2807:3: -> conditionalOrExpression QSTRING[$o.token, \" \"+$o.text+\" \"] conditionalAndExpression
                    {
                        adaptor.addChild(root_0, stream_conditionalOrExpression.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, " "+(o!=null?o.getText():null)+" "));
                        adaptor.addChild(root_0, stream_conditionalAndExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "conditionalOrExpression"

    public static class conditionalAndExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "conditionalAndExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2810:1: conditionalAndExpression : ( valueLogical | ^(a= ANDSYMBOL conditionalAndExpression valueLogical ) -> conditionalAndExpression QSTRING[$a.token, \" &amp;&amp; \"] valueLogical );
    public final XSPARQLRewriter.conditionalAndExpression_return conditionalAndExpression() throws RecognitionException {
        XSPARQLRewriter.conditionalAndExpression_return retval = new XSPARQLRewriter.conditionalAndExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree a=null;
        XSPARQLRewriter.valueLogical_return valueLogical673 = null;

        XSPARQLRewriter.conditionalAndExpression_return conditionalAndExpression674 = null;

        XSPARQLRewriter.valueLogical_return valueLogical675 = null;


        CommonTree a_tree=null;
        RewriteRuleNodeStream stream_ANDSYMBOL=new RewriteRuleNodeStream(adaptor,"token ANDSYMBOL");
        RewriteRuleSubtreeStream stream_conditionalAndExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalAndExpression");
        RewriteRuleSubtreeStream stream_valueLogical=new RewriteRuleSubtreeStream(adaptor,"rule valueLogical");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2811:3: ( valueLogical | ^(a= ANDSYMBOL conditionalAndExpression valueLogical ) -> conditionalAndExpression QSTRING[$a.token, \" &amp;&amp; \"] valueLogical )
            int alt198=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case SLASH:
            case LPAR:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case NOT:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt198=1;
                }
                break;
            case ANDSYMBOL:
                {
                alt198=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 198, 0, input);

                throw nvae;
            }

            switch (alt198) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2811:5: valueLogical
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_valueLogical_in_conditionalAndExpression16896);
                    valueLogical673=valueLogical();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, valueLogical673.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2812:5: ^(a= ANDSYMBOL conditionalAndExpression valueLogical )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    a=(CommonTree)match(input,ANDSYMBOL,FOLLOW_ANDSYMBOL_in_conditionalAndExpression16905); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ANDSYMBOL.add(a);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_conditionalAndExpression_in_conditionalAndExpression16907);
                    conditionalAndExpression674=conditionalAndExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_conditionalAndExpression.add(conditionalAndExpression674.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_valueLogical_in_conditionalAndExpression16909);
                    valueLogical675=valueLogical();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_valueLogical.add(valueLogical675.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: conditionalAndExpression, valueLogical
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2813:3: -> conditionalAndExpression QSTRING[$a.token, \" &amp;&amp; \"] valueLogical
                    {
                        adaptor.addChild(root_0, stream_conditionalAndExpression.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, a.token, " &amp;&amp; "));
                        adaptor.addChild(root_0, stream_valueLogical.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "conditionalAndExpression"

    public static class valueLogical_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "valueLogical"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2816:1: valueLogical : relationalExpression ;
    public final XSPARQLRewriter.valueLogical_return valueLogical() throws RecognitionException {
        XSPARQLRewriter.valueLogical_return retval = new XSPARQLRewriter.valueLogical_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.relationalExpression_return relationalExpression676 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2817:3: ( relationalExpression )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2817:5: relationalExpression
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_relationalExpression_in_valueLogical16934);
            relationalExpression676=relationalExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, relationalExpression676.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "valueLogical"

    public static class relationalExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relationalExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2820:1: relationalExpression : ( numericExpression | ^( (o= EQUALS | o= HAFENEQUALS | o= LESSTHAN | o= GREATERTHAN | o= LESSTHANEQUALS | o= GREATERTHANEQUALS ) numericExpression numericExpression ) -> numericExpression QSTRING[$o.token, $o.text] numericExpression );
    public final XSPARQLRewriter.relationalExpression_return relationalExpression() throws RecognitionException {
        XSPARQLRewriter.relationalExpression_return retval = new XSPARQLRewriter.relationalExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.numericExpression_return numericExpression677 = null;

        XSPARQLRewriter.numericExpression_return numericExpression678 = null;

        XSPARQLRewriter.numericExpression_return numericExpression679 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_LESSTHAN=new RewriteRuleNodeStream(adaptor,"token LESSTHAN");
        RewriteRuleNodeStream stream_EQUALS=new RewriteRuleNodeStream(adaptor,"token EQUALS");
        RewriteRuleNodeStream stream_HAFENEQUALS=new RewriteRuleNodeStream(adaptor,"token HAFENEQUALS");
        RewriteRuleNodeStream stream_LESSTHANEQUALS=new RewriteRuleNodeStream(adaptor,"token LESSTHANEQUALS");
        RewriteRuleNodeStream stream_GREATERTHANEQUALS=new RewriteRuleNodeStream(adaptor,"token GREATERTHANEQUALS");
        RewriteRuleNodeStream stream_GREATERTHAN=new RewriteRuleNodeStream(adaptor,"token GREATERTHAN");
        RewriteRuleSubtreeStream stream_numericExpression=new RewriteRuleSubtreeStream(adaptor,"rule numericExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2821:3: ( numericExpression | ^( (o= EQUALS | o= HAFENEQUALS | o= LESSTHAN | o= GREATERTHAN | o= LESSTHANEQUALS | o= GREATERTHANEQUALS ) numericExpression numericExpression ) -> numericExpression QSTRING[$o.token, $o.text] numericExpression )
            int alt200=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case SLASH:
            case LPAR:
            case STAR:
            case PLUS:
            case MINUS:
            case NOT:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt200=1;
                }
                break;
            case LESSTHAN:
            case GREATERTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
                {
                alt200=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 200, 0, input);

                throw nvae;
            }

            switch (alt200) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2821:5: numericExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_numericExpression_in_relationalExpression16947);
                    numericExpression677=numericExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, numericExpression677.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2822:5: ^( (o= EQUALS | o= HAFENEQUALS | o= LESSTHAN | o= GREATERTHAN | o= LESSTHANEQUALS | o= GREATERTHANEQUALS ) numericExpression numericExpression )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();// org/deri/xsparql/rewriter/XSPARQLRewriter.g:2822:7: (o= EQUALS | o= HAFENEQUALS | o= LESSTHAN | o= GREATERTHAN | o= LESSTHANEQUALS | o= GREATERTHANEQUALS )
                    int alt199=6;
                    switch ( input.LA(1) ) {
                    case EQUALS:
                        {
                        alt199=1;
                        }
                        break;
                    case HAFENEQUALS:
                        {
                        alt199=2;
                        }
                        break;
                    case LESSTHAN:
                        {
                        alt199=3;
                        }
                        break;
                    case GREATERTHAN:
                        {
                        alt199=4;
                        }
                        break;
                    case LESSTHANEQUALS:
                        {
                        alt199=5;
                        }
                        break;
                    case GREATERTHANEQUALS:
                        {
                        alt199=6;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 199, 0, input);

                        throw nvae;
                    }

                    switch (alt199) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2822:8: o= EQUALS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,EQUALS,FOLLOW_EQUALS_in_relationalExpression16957); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_EQUALS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2822:19: o= HAFENEQUALS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,HAFENEQUALS,FOLLOW_HAFENEQUALS_in_relationalExpression16963); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_HAFENEQUALS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 3 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2822:35: o= LESSTHAN
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,LESSTHAN,FOLLOW_LESSTHAN_in_relationalExpression16969); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_LESSTHAN.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 4 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2822:47: o= GREATERTHAN
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,GREATERTHAN,FOLLOW_GREATERTHAN_in_relationalExpression16974); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_GREATERTHAN.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 5 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2822:63: o= LESSTHANEQUALS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,LESSTHANEQUALS,FOLLOW_LESSTHANEQUALS_in_relationalExpression16980); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_LESSTHANEQUALS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 6 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2822:82: o= GREATERTHANEQUALS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,GREATERTHANEQUALS,FOLLOW_GREATERTHANEQUALS_in_relationalExpression16986); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_GREATERTHANEQUALS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_numericExpression_in_relationalExpression16989);
                    numericExpression678=numericExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_numericExpression.add(numericExpression678.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_numericExpression_in_relationalExpression16991);
                    numericExpression679=numericExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_numericExpression.add(numericExpression679.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: numericExpression, numericExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2823:3: -> numericExpression QSTRING[$o.token, $o.text] numericExpression
                    {
                        adaptor.addChild(root_0, stream_numericExpression.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null)));
                        adaptor.addChild(root_0, stream_numericExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "relationalExpression"

    public static class numericExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "numericExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2826:1: numericExpression : additiveExpression ;
    public final XSPARQLRewriter.numericExpression_return numericExpression() throws RecognitionException {
        XSPARQLRewriter.numericExpression_return retval = new XSPARQLRewriter.numericExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.additiveExpression_return additiveExpression680 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2827:3: ( additiveExpression )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2827:5: additiveExpression
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_additiveExpression_in_numericExpression17016);
            additiveExpression680=additiveExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, additiveExpression680.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "numericExpression"

    public static class additiveExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "additiveExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2830:1: additiveExpression : ( multiplicativeExpression | ^( (o= PLUS | o= MINUS ) additiveExpression multiplicativeExpression ) -> additiveExpression QSTRING[$o.token, $o.text] multiplicativeExpression );
    public final XSPARQLRewriter.additiveExpression_return additiveExpression() throws RecognitionException {
        XSPARQLRewriter.additiveExpression_return retval = new XSPARQLRewriter.additiveExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.multiplicativeExpression_return multiplicativeExpression681 = null;

        XSPARQLRewriter.additiveExpression_return additiveExpression682 = null;

        XSPARQLRewriter.multiplicativeExpression_return multiplicativeExpression683 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_PLUS=new RewriteRuleNodeStream(adaptor,"token PLUS");
        RewriteRuleNodeStream stream_MINUS=new RewriteRuleNodeStream(adaptor,"token MINUS");
        RewriteRuleSubtreeStream stream_additiveExpression=new RewriteRuleSubtreeStream(adaptor,"rule additiveExpression");
        RewriteRuleSubtreeStream stream_multiplicativeExpression=new RewriteRuleSubtreeStream(adaptor,"rule multiplicativeExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2831:3: ( multiplicativeExpression | ^( (o= PLUS | o= MINUS ) additiveExpression multiplicativeExpression ) -> additiveExpression QSTRING[$o.token, $o.text] multiplicativeExpression )
            int alt202=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case SLASH:
            case LPAR:
            case STAR:
            case NOT:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt202=1;
                }
                break;
            case PLUS:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt202=2;
                    }
                    break;
                case VAR:
                case INTEGER:
                case QSTRING:
                case LPAR:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case T_FUNCTION_CALL:
                    {
                    alt202=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 202, 2, input);

                    throw nvae;
                }

                }
                break;
            case MINUS:
                {
                switch ( input.LA(2) ) {
                case VAR:
                case INTEGER:
                case QSTRING:
                case LPAR:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case T_FUNCTION_CALL:
                    {
                    alt202=1;
                    }
                    break;
                case DOWN:
                    {
                    alt202=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 202, 3, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 202, 0, input);

                throw nvae;
            }

            switch (alt202) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2831:5: multiplicativeExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression17029);
                    multiplicativeExpression681=multiplicativeExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, multiplicativeExpression681.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2832:5: ^( (o= PLUS | o= MINUS ) additiveExpression multiplicativeExpression )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();// org/deri/xsparql/rewriter/XSPARQLRewriter.g:2832:7: (o= PLUS | o= MINUS )
                    int alt201=2;
                    switch ( input.LA(1) ) {
                    case PLUS:
                        {
                        alt201=1;
                        }
                        break;
                    case MINUS:
                        {
                        alt201=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 201, 0, input);

                        throw nvae;
                    }

                    switch (alt201) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2832:8: o= PLUS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,PLUS,FOLLOW_PLUS_in_additiveExpression17039); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_PLUS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2832:17: o= MINUS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,MINUS,FOLLOW_MINUS_in_additiveExpression17045); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_MINUS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_additiveExpression_in_additiveExpression17048);
                    additiveExpression682=additiveExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_additiveExpression.add(additiveExpression682.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression17050);
                    multiplicativeExpression683=multiplicativeExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_multiplicativeExpression.add(multiplicativeExpression683.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: additiveExpression, multiplicativeExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2833:3: -> additiveExpression QSTRING[$o.token, $o.text] multiplicativeExpression
                    {
                        adaptor.addChild(root_0, stream_additiveExpression.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null)));
                        adaptor.addChild(root_0, stream_multiplicativeExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "additiveExpression"

    public static class multiplicativeExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multiplicativeExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2836:1: multiplicativeExpression : ( unaryExpression | ^( (o= STAR | o= SLASH ) multiplicativeExpression unaryExpression ) -> multiplicativeExpression QSTRING[$o.token, $o.text] unaryExpression );
    public final XSPARQLRewriter.multiplicativeExpression_return multiplicativeExpression() throws RecognitionException {
        XSPARQLRewriter.multiplicativeExpression_return retval = new XSPARQLRewriter.multiplicativeExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.unaryExpression_return unaryExpression684 = null;

        XSPARQLRewriter.multiplicativeExpression_return multiplicativeExpression685 = null;

        XSPARQLRewriter.unaryExpression_return unaryExpression686 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_STAR=new RewriteRuleNodeStream(adaptor,"token STAR");
        RewriteRuleNodeStream stream_SLASH=new RewriteRuleNodeStream(adaptor,"token SLASH");
        RewriteRuleSubtreeStream stream_unaryExpression=new RewriteRuleSubtreeStream(adaptor,"rule unaryExpression");
        RewriteRuleSubtreeStream stream_multiplicativeExpression=new RewriteRuleSubtreeStream(adaptor,"rule multiplicativeExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2837:3: ( unaryExpression | ^( (o= STAR | o= SLASH ) multiplicativeExpression unaryExpression ) -> multiplicativeExpression QSTRING[$o.token, $o.text] unaryExpression )
            int alt204=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case LPAR:
            case PLUS:
            case MINUS:
            case NOT:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt204=1;
                }
                break;
            case SLASH:
            case STAR:
                {
                alt204=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 204, 0, input);

                throw nvae;
            }

            switch (alt204) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2837:5: unaryExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unaryExpression_in_multiplicativeExpression17076);
                    unaryExpression684=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, unaryExpression684.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2838:5: ^( (o= STAR | o= SLASH ) multiplicativeExpression unaryExpression )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();// org/deri/xsparql/rewriter/XSPARQLRewriter.g:2838:7: (o= STAR | o= SLASH )
                    int alt203=2;
                    switch ( input.LA(1) ) {
                    case STAR:
                        {
                        alt203=1;
                        }
                        break;
                    case SLASH:
                        {
                        alt203=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 203, 0, input);

                        throw nvae;
                    }

                    switch (alt203) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2838:8: o= STAR
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,STAR,FOLLOW_STAR_in_multiplicativeExpression17086); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_STAR.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2838:17: o= SLASH
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_multiplicativeExpression17092); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_SLASH.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpression_in_multiplicativeExpression17095);
                    multiplicativeExpression685=multiplicativeExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_multiplicativeExpression.add(multiplicativeExpression685.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unaryExpression_in_multiplicativeExpression17097);
                    unaryExpression686=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression686.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: unaryExpression, multiplicativeExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2839:3: -> multiplicativeExpression QSTRING[$o.token, $o.text] unaryExpression
                    {
                        adaptor.addChild(root_0, stream_multiplicativeExpression.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null)));
                        adaptor.addChild(root_0, stream_unaryExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multiplicativeExpression"

    public static class unaryExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unaryExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2842:1: unaryExpression : (n= NOT primaryExpression -> QSTRING[$n.token, $n.text] primaryExpression | p= PLUS primaryExpression -> QSTRING[$p.token, $p.text] primaryExpression | m= MINUS primaryExpression -> QSTRING[$m.token, $m.text] primaryExpression | primaryExpression );
    public final XSPARQLRewriter.unaryExpression_return unaryExpression() throws RecognitionException {
        XSPARQLRewriter.unaryExpression_return retval = new XSPARQLRewriter.unaryExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree n=null;
        CommonTree p=null;
        CommonTree m=null;
        XSPARQLRewriter.primaryExpression_return primaryExpression687 = null;

        XSPARQLRewriter.primaryExpression_return primaryExpression688 = null;

        XSPARQLRewriter.primaryExpression_return primaryExpression689 = null;

        XSPARQLRewriter.primaryExpression_return primaryExpression690 = null;


        CommonTree n_tree=null;
        CommonTree p_tree=null;
        CommonTree m_tree=null;
        RewriteRuleNodeStream stream_PLUS=new RewriteRuleNodeStream(adaptor,"token PLUS");
        RewriteRuleNodeStream stream_NOT=new RewriteRuleNodeStream(adaptor,"token NOT");
        RewriteRuleNodeStream stream_MINUS=new RewriteRuleNodeStream(adaptor,"token MINUS");
        RewriteRuleSubtreeStream stream_primaryExpression=new RewriteRuleSubtreeStream(adaptor,"rule primaryExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2843:3: (n= NOT primaryExpression -> QSTRING[$n.token, $n.text] primaryExpression | p= PLUS primaryExpression -> QSTRING[$p.token, $p.text] primaryExpression | m= MINUS primaryExpression -> QSTRING[$m.token, $m.text] primaryExpression | primaryExpression )
            int alt205=4;
            switch ( input.LA(1) ) {
            case NOT:
                {
                alt205=1;
                }
                break;
            case PLUS:
                {
                alt205=2;
                }
                break;
            case MINUS:
                {
                alt205=3;
                }
                break;
            case VAR:
            case INTEGER:
            case QSTRING:
            case LPAR:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt205=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 205, 0, input);

                throw nvae;
            }

            switch (alt205) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2843:5: n= NOT primaryExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    n=(CommonTree)match(input,NOT,FOLLOW_NOT_in_unaryExpression17124); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_NOT.add(n);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_primaryExpression_in_unaryExpression17126);
                    primaryExpression687=primaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_primaryExpression.add(primaryExpression687.getTree());


                    // AST REWRITE
                    // elements: primaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2844:3: -> QSTRING[$n.token, $n.text] primaryExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, n.token, (n!=null?n.getText():null)));
                        adaptor.addChild(root_0, stream_primaryExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2845:5: p= PLUS primaryExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PLUS,FOLLOW_PLUS_in_unaryExpression17143); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PLUS.add(p);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_primaryExpression_in_unaryExpression17145);
                    primaryExpression688=primaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_primaryExpression.add(primaryExpression688.getTree());


                    // AST REWRITE
                    // elements: primaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2846:5: -> QSTRING[$p.token, $p.text] primaryExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, p.token, (p!=null?p.getText():null)));
                        adaptor.addChild(root_0, stream_primaryExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2847:5: m= MINUS primaryExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    m=(CommonTree)match(input,MINUS,FOLLOW_MINUS_in_unaryExpression17164); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_MINUS.add(m);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_primaryExpression_in_unaryExpression17166);
                    primaryExpression689=primaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_primaryExpression.add(primaryExpression689.getTree());


                    // AST REWRITE
                    // elements: primaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2848:5: -> QSTRING[$m.token, $m.text] primaryExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, m.token, (m!=null?m.getText():null)));
                        adaptor.addChild(root_0, stream_primaryExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2849:5: primaryExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_primaryExpression_in_unaryExpression17183);
                    primaryExpression690=primaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, primaryExpression690.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unaryExpression"

    public static class primaryExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "primaryExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2852:1: primaryExpression : ( brackettedExpression | builtInCall | iRIrefOrFunction | rdfLiteral | sNumericLiteral | booleanLiteral | var= VAR -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) ) -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) ) -> QSTRING[$var.token, $var.text ] );
    public final XSPARQLRewriter.primaryExpression_return primaryExpression() throws RecognitionException {
        XSPARQLRewriter.primaryExpression_return retval = new XSPARQLRewriter.primaryExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        XSPARQLRewriter.brackettedExpression_return brackettedExpression691 = null;

        XSPARQLRewriter.builtInCall_return builtInCall692 = null;

        XSPARQLRewriter.iRIrefOrFunction_return iRIrefOrFunction693 = null;

        XSPARQLRewriter.rdfLiteral_return rdfLiteral694 = null;

        XSPARQLRewriter.sNumericLiteral_return sNumericLiteral695 = null;

        XSPARQLRewriter.booleanLiteral_return booleanLiteral696 = null;


        CommonTree var_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");

         String rdftermvar = ""; 
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2854:3: ( brackettedExpression | builtInCall | iRIrefOrFunction | rdfLiteral | sNumericLiteral | booleanLiteral | var= VAR -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) ) -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) ) -> QSTRING[$var.token, $var.text ] )
            int alt206=7;
            switch ( input.LA(1) ) {
            case LPAR:
                {
                alt206=1;
                }
                break;
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
                {
                alt206=2;
                }
                break;
            case T_FUNCTION_CALL:
                {
                alt206=3;
                }
                break;
            case QSTRING:
                {
                alt206=4;
                }
                break;
            case INTEGER:
                {
                alt206=5;
                }
                break;
            case TRUE:
            case FALSE:
                {
                alt206=6;
                }
                break;
            case VAR:
                {
                alt206=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 206, 0, input);

                throw nvae;
            }

            switch (alt206) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2854:5: brackettedExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_primaryExpression17201);
                    brackettedExpression691=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, brackettedExpression691.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2855:5: builtInCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_builtInCall_in_primaryExpression17207);
                    builtInCall692=builtInCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, builtInCall692.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2856:5: iRIrefOrFunction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iRIrefOrFunction_in_primaryExpression17213);
                    iRIrefOrFunction693=iRIrefOrFunction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, iRIrefOrFunction693.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2857:5: rdfLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rdfLiteral_in_primaryExpression17219);
                    rdfLiteral694=rdfLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, rdfLiteral694.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2858:5: sNumericLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sNumericLiteral_in_primaryExpression17225);
                    sNumericLiteral695=sNumericLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sNumericLiteral695.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2859:5: booleanLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_booleanLiteral_in_primaryExpression17231);
                    booleanLiteral696=booleanLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, booleanLiteral696.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2862:5: var= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_primaryExpression17245); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(var);



                    // AST REWRITE
                    // elements: var, var
                    // token labels: var
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_var=new RewriteRuleNodeStream(adaptor,"token var",var);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2863:3: -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) )
                    if (isBoundEarlier((var!=null?var.getText():null), Types.SPARQL)) {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2863:49: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2863:91: ^( T_PARAMS $var)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, stream_var.nextNode());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }
                    else // 2864:3: -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) )
                    if (isBoundEarlier((var!=null?var.getText():null))) {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2864:35: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2864:77: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2864:88: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2864:134: ^( T_PARAMS $var)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_var.nextNode());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }
                    else // 2865:3: -> QSTRING[$var.token, $var.text ]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, var.token, (var!=null?var.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "primaryExpression"

    public static class brackettedExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "brackettedExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2868:1: brackettedExpression : l= LPAR expression r= RPAR -> QSTRING[$l.token, $l.text] expression QSTRING[$r.token, $r.text] ;
    public final XSPARQLRewriter.brackettedExpression_return brackettedExpression() throws RecognitionException {
        XSPARQLRewriter.brackettedExpression_return retval = new XSPARQLRewriter.brackettedExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree l=null;
        CommonTree r=null;
        XSPARQLRewriter.expression_return expression697 = null;


        CommonTree l_tree=null;
        CommonTree r_tree=null;
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2869:3: (l= LPAR expression r= RPAR -> QSTRING[$l.token, $l.text] expression QSTRING[$r.token, $r.text] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2869:5: l= LPAR expression r= RPAR
            {
            _last = (CommonTree)input.LT(1);
            l=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_brackettedExpression17319); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_LPAR.add(l);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expression_in_brackettedExpression17321);
            expression697=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_expression.add(expression697.getTree());
            _last = (CommonTree)input.LT(1);
            r=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_brackettedExpression17325); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_RPAR.add(r);



            // AST REWRITE
            // elements: expression
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2870:3: -> QSTRING[$l.token, $l.text] expression QSTRING[$r.token, $r.text]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l.token, (l!=null?l.getText():null)));
                adaptor.addChild(root_0, stream_expression.nextTree());
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, r.token, (r!=null?r.getText():null)));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "brackettedExpression"

    public static class builtInCall_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "builtInCall"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2873:1: builtInCall : (s= STR brackettedExpression -> QSTRING[$s.token, $s.text] brackettedExpression | l= LANG brackettedExpression -> QSTRING[$l.token, $l.text] brackettedExpression | lm= LANGMATCHES l1= LPAR e1= expression c= COMMA e2= expression r1= RPAR -> QSTRING[$lm.token, $lm.text] QSTRING[$l1.token, $l1.text] $e1 QSTRING[$c.token, $c.text] $e2 QSTRING[$r1.token, $r1.text] | d= DATATYPE brackettedExpression -> QSTRING[$d.token, $d.text] brackettedExpression | bo= BOUND l2= LPAR v= VAR r2= RPAR -> QSTRING[$bo.token, $bo.text] QSTRING[$l2.token, $l2.text] QSTRING[$v.token, $v.text] QSTRING[$r2.token, $r2.text] | i= ISIRI brackettedExpression -> QSTRING[$i.token, $i.text] brackettedExpression | u= ISURI brackettedExpression -> QSTRING[$u.token, $u.text] brackettedExpression | b= ISBLANK brackettedExpression -> QSTRING[$b.token, $b.text] brackettedExpression | lit= ISLITERAL brackettedExpression -> QSTRING[$lit.token, $lit.text] brackettedExpression | regexExpression );
    public final XSPARQLRewriter.builtInCall_return builtInCall() throws RecognitionException {
        XSPARQLRewriter.builtInCall_return retval = new XSPARQLRewriter.builtInCall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree s=null;
        CommonTree l=null;
        CommonTree lm=null;
        CommonTree l1=null;
        CommonTree c=null;
        CommonTree r1=null;
        CommonTree d=null;
        CommonTree bo=null;
        CommonTree l2=null;
        CommonTree v=null;
        CommonTree r2=null;
        CommonTree i=null;
        CommonTree u=null;
        CommonTree b=null;
        CommonTree lit=null;
        XSPARQLRewriter.expression_return e1 = null;

        XSPARQLRewriter.expression_return e2 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression698 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression699 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression700 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression701 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression702 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression703 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression704 = null;

        XSPARQLRewriter.regexExpression_return regexExpression705 = null;


        CommonTree s_tree=null;
        CommonTree l_tree=null;
        CommonTree lm_tree=null;
        CommonTree l1_tree=null;
        CommonTree c_tree=null;
        CommonTree r1_tree=null;
        CommonTree d_tree=null;
        CommonTree bo_tree=null;
        CommonTree l2_tree=null;
        CommonTree v_tree=null;
        CommonTree r2_tree=null;
        CommonTree i_tree=null;
        CommonTree u_tree=null;
        CommonTree b_tree=null;
        CommonTree lit_tree=null;
        RewriteRuleNodeStream stream_ISURI=new RewriteRuleNodeStream(adaptor,"token ISURI");
        RewriteRuleNodeStream stream_STR=new RewriteRuleNodeStream(adaptor,"token STR");
        RewriteRuleNodeStream stream_ISLITERAL=new RewriteRuleNodeStream(adaptor,"token ISLITERAL");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleNodeStream stream_COMMA=new RewriteRuleNodeStream(adaptor,"token COMMA");
        RewriteRuleNodeStream stream_LANGMATCHES=new RewriteRuleNodeStream(adaptor,"token LANGMATCHES");
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_DATATYPE=new RewriteRuleNodeStream(adaptor,"token DATATYPE");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_BOUND=new RewriteRuleNodeStream(adaptor,"token BOUND");
        RewriteRuleNodeStream stream_ISBLANK=new RewriteRuleNodeStream(adaptor,"token ISBLANK");
        RewriteRuleNodeStream stream_LANG=new RewriteRuleNodeStream(adaptor,"token LANG");
        RewriteRuleNodeStream stream_ISIRI=new RewriteRuleNodeStream(adaptor,"token ISIRI");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        RewriteRuleSubtreeStream stream_brackettedExpression=new RewriteRuleSubtreeStream(adaptor,"rule brackettedExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2874:3: (s= STR brackettedExpression -> QSTRING[$s.token, $s.text] brackettedExpression | l= LANG brackettedExpression -> QSTRING[$l.token, $l.text] brackettedExpression | lm= LANGMATCHES l1= LPAR e1= expression c= COMMA e2= expression r1= RPAR -> QSTRING[$lm.token, $lm.text] QSTRING[$l1.token, $l1.text] $e1 QSTRING[$c.token, $c.text] $e2 QSTRING[$r1.token, $r1.text] | d= DATATYPE brackettedExpression -> QSTRING[$d.token, $d.text] brackettedExpression | bo= BOUND l2= LPAR v= VAR r2= RPAR -> QSTRING[$bo.token, $bo.text] QSTRING[$l2.token, $l2.text] QSTRING[$v.token, $v.text] QSTRING[$r2.token, $r2.text] | i= ISIRI brackettedExpression -> QSTRING[$i.token, $i.text] brackettedExpression | u= ISURI brackettedExpression -> QSTRING[$u.token, $u.text] brackettedExpression | b= ISBLANK brackettedExpression -> QSTRING[$b.token, $b.text] brackettedExpression | lit= ISLITERAL brackettedExpression -> QSTRING[$lit.token, $lit.text] brackettedExpression | regexExpression )
            int alt207=10;
            switch ( input.LA(1) ) {
            case STR:
                {
                alt207=1;
                }
                break;
            case LANG:
                {
                alt207=2;
                }
                break;
            case LANGMATCHES:
                {
                alt207=3;
                }
                break;
            case DATATYPE:
                {
                alt207=4;
                }
                break;
            case BOUND:
                {
                alt207=5;
                }
                break;
            case ISIRI:
                {
                alt207=6;
                }
                break;
            case ISURI:
                {
                alt207=7;
                }
                break;
            case ISBLANK:
                {
                alt207=8;
                }
                break;
            case ISLITERAL:
                {
                alt207=9;
                }
                break;
            case REGEX:
                {
                alt207=10;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 207, 0, input);

                throw nvae;
            }

            switch (alt207) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2874:5: s= STR brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    s=(CommonTree)match(input,STR,FOLLOW_STR_in_builtInCall17352); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_STR.add(s);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17354);
                    brackettedExpression698=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression698.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2875:3: -> QSTRING[$s.token, $s.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, s.token, (s!=null?s.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2876:5: l= LANG brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    l=(CommonTree)match(input,LANG,FOLLOW_LANG_in_builtInCall17371); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LANG.add(l);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17373);
                    brackettedExpression699=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression699.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2877:3: -> QSTRING[$l.token, $l.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l.token, (l!=null?l.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2878:5: lm= LANGMATCHES l1= LPAR e1= expression c= COMMA e2= expression r1= RPAR
                    {
                    _last = (CommonTree)input.LT(1);
                    lm=(CommonTree)match(input,LANGMATCHES,FOLLOW_LANGMATCHES_in_builtInCall17390); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LANGMATCHES.add(lm);

                    _last = (CommonTree)input.LT(1);
                    l1=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_builtInCall17394); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LPAR.add(l1);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expression_in_builtInCall17398);
                    e1=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(e1.getTree());
                    _last = (CommonTree)input.LT(1);
                    c=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_builtInCall17402); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_COMMA.add(c);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expression_in_builtInCall17406);
                    e2=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(e2.getTree());
                    _last = (CommonTree)input.LT(1);
                    r1=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_builtInCall17410); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RPAR.add(r1);



                    // AST REWRITE
                    // elements: e1, e2
                    // token labels: 
                    // rule labels: retval, e1, e2
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_e1=new RewriteRuleSubtreeStream(adaptor,"rule e1",e1!=null?e1.tree:null);
                    RewriteRuleSubtreeStream stream_e2=new RewriteRuleSubtreeStream(adaptor,"rule e2",e2!=null?e2.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2879:3: -> QSTRING[$lm.token, $lm.text] QSTRING[$l1.token, $l1.text] $e1 QSTRING[$c.token, $c.text] $e2 QSTRING[$r1.token, $r1.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, lm.token, (lm!=null?lm.getText():null)));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l1.token, (l1!=null?l1.getText():null)));
                        adaptor.addChild(root_0, stream_e1.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, c.token, (c!=null?c.getText():null)));
                        adaptor.addChild(root_0, stream_e2.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, r1.token, (r1!=null?r1.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2880:5: d= DATATYPE brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    d=(CommonTree)match(input,DATATYPE,FOLLOW_DATATYPE_in_builtInCall17440); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DATATYPE.add(d);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17442);
                    brackettedExpression700=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression700.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2881:3: -> QSTRING[$d.token, $d.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, d.token, (d!=null?d.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2882:5: bo= BOUND l2= LPAR v= VAR r2= RPAR
                    {
                    _last = (CommonTree)input.LT(1);
                    bo=(CommonTree)match(input,BOUND,FOLLOW_BOUND_in_builtInCall17459); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_BOUND.add(bo);

                    _last = (CommonTree)input.LT(1);
                    l2=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_builtInCall17463); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LPAR.add(l2);

                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_builtInCall17467); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);

                    _last = (CommonTree)input.LT(1);
                    r2=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_builtInCall17471); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RPAR.add(r2);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2883:3: -> QSTRING[$bo.token, $bo.text] QSTRING[$l2.token, $l2.text] QSTRING[$v.token, $v.text] QSTRING[$r2.token, $r2.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, bo.token, (bo!=null?bo.getText():null)));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l2.token, (l2!=null?l2.getText():null)));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, v.token, (v!=null?v.getText():null)));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, r2.token, (r2!=null?r2.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2884:5: i= ISIRI brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    i=(CommonTree)match(input,ISIRI,FOLLOW_ISIRI_in_builtInCall17495); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ISIRI.add(i);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17497);
                    brackettedExpression701=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression701.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2885:3: -> QSTRING[$i.token, $i.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, i.token, (i!=null?i.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2886:5: u= ISURI brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    u=(CommonTree)match(input,ISURI,FOLLOW_ISURI_in_builtInCall17514); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ISURI.add(u);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17516);
                    brackettedExpression702=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression702.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2887:3: -> QSTRING[$u.token, $u.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, u.token, (u!=null?u.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2888:5: b= ISBLANK brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    b=(CommonTree)match(input,ISBLANK,FOLLOW_ISBLANK_in_builtInCall17533); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ISBLANK.add(b);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17535);
                    brackettedExpression703=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression703.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2889:3: -> QSTRING[$b.token, $b.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, b.token, (b!=null?b.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 9 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2890:5: lit= ISLITERAL brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    lit=(CommonTree)match(input,ISLITERAL,FOLLOW_ISLITERAL_in_builtInCall17552); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ISLITERAL.add(lit);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17554);
                    brackettedExpression704=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression704.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2891:3: -> QSTRING[$lit.token, $lit.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, lit.token, (lit!=null?lit.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 10 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2892:5: regexExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_regexExpression_in_builtInCall17569);
                    regexExpression705=regexExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, regexExpression705.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "builtInCall"

    public static class regexExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "regexExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2895:1: regexExpression : r= REGEX l= LPAR e1= expression c1= COMMA e2= expression (c2= COMMA e3= expression )? r1= RPAR -> QSTRING[$r.token, \" \" + $r.text] QSTRING[$l.token, $l.text] $e1 QSTRING[$c1.token, $c1.text] $e2 ( QSTRING[$c2.token, $c2.text] $e3)? QSTRING[$r1.token, $r1.text] ;
    public final XSPARQLRewriter.regexExpression_return regexExpression() throws RecognitionException {
        XSPARQLRewriter.regexExpression_return retval = new XSPARQLRewriter.regexExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree r=null;
        CommonTree l=null;
        CommonTree c1=null;
        CommonTree c2=null;
        CommonTree r1=null;
        XSPARQLRewriter.expression_return e1 = null;

        XSPARQLRewriter.expression_return e2 = null;

        XSPARQLRewriter.expression_return e3 = null;


        CommonTree r_tree=null;
        CommonTree l_tree=null;
        CommonTree c1_tree=null;
        CommonTree c2_tree=null;
        CommonTree r1_tree=null;
        RewriteRuleNodeStream stream_REGEX=new RewriteRuleNodeStream(adaptor,"token REGEX");
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleNodeStream stream_COMMA=new RewriteRuleNodeStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2896:3: (r= REGEX l= LPAR e1= expression c1= COMMA e2= expression (c2= COMMA e3= expression )? r1= RPAR -> QSTRING[$r.token, \" \" + $r.text] QSTRING[$l.token, $l.text] $e1 QSTRING[$c1.token, $c1.text] $e2 ( QSTRING[$c2.token, $c2.text] $e3)? QSTRING[$r1.token, $r1.text] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2896:5: r= REGEX l= LPAR e1= expression c1= COMMA e2= expression (c2= COMMA e3= expression )? r1= RPAR
            {
            _last = (CommonTree)input.LT(1);
            r=(CommonTree)match(input,REGEX,FOLLOW_REGEX_in_regexExpression17584); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_REGEX.add(r);

            _last = (CommonTree)input.LT(1);
            l=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_regexExpression17588); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_LPAR.add(l);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expression_in_regexExpression17592);
            e1=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_expression.add(e1.getTree());
            _last = (CommonTree)input.LT(1);
            c1=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_regexExpression17596); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_COMMA.add(c1);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expression_in_regexExpression17600);
            e2=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_expression.add(e2.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2896:57: (c2= COMMA e3= expression )?
            int alt208=2;
            switch ( input.LA(1) ) {
                case COMMA:
                    {
                    alt208=1;
                    }
                    break;
            }

            switch (alt208) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2896:58: c2= COMMA e3= expression
                    {
                    _last = (CommonTree)input.LT(1);
                    c2=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_regexExpression17605); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_COMMA.add(c2);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expression_in_regexExpression17610);
                    e3=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(e3.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            r1=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_regexExpression17616); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_RPAR.add(r1);



            // AST REWRITE
            // elements: e2, e3, e1
            // token labels: 
            // rule labels: e3, retval, e1, e2
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_e3=new RewriteRuleSubtreeStream(adaptor,"rule e3",e3!=null?e3.tree:null);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_e1=new RewriteRuleSubtreeStream(adaptor,"rule e1",e1!=null?e1.tree:null);
            RewriteRuleSubtreeStream stream_e2=new RewriteRuleSubtreeStream(adaptor,"rule e2",e2!=null?e2.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2897:3: -> QSTRING[$r.token, \" \" + $r.text] QSTRING[$l.token, $l.text] $e1 QSTRING[$c1.token, $c1.text] $e2 ( QSTRING[$c2.token, $c2.text] $e3)? QSTRING[$r1.token, $r1.text]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, r.token, " " + (r!=null?r.getText():null)));
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l.token, (l!=null?l.getText():null)));
                adaptor.addChild(root_0, stream_e1.nextTree());
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, c1.token, (c1!=null?c1.getText():null)));
                adaptor.addChild(root_0, stream_e2.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2897:103: ( QSTRING[$c2.token, $c2.text] $e3)?
                if ( stream_e3.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, c2.token, (c2!=null?c2.getText():null)));
                    adaptor.addChild(root_0, stream_e3.nextTree());

                }
                stream_e3.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, r1.token, (r1!=null?r1.getText():null)));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "regexExpression"

    public static class iRIrefOrFunction_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "iRIrefOrFunction"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2900:1: iRIrefOrFunction : ^( T_FUNCTION_CALL i= iRIref ^( T_PARAMS ( arglist )? ) ) -> QSTRING[$i.text] QSTRING[\"(\"] ( arglist )? QSTRING[\")\"] ;
    public final XSPARQLRewriter.iRIrefOrFunction_return iRIrefOrFunction() throws RecognitionException {
        XSPARQLRewriter.iRIrefOrFunction_return retval = new XSPARQLRewriter.iRIrefOrFunction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_FUNCTION_CALL706=null;
        CommonTree T_PARAMS707=null;
        XSPARQLRewriter.iRIref_return i = null;

        XSPARQLRewriter.arglist_return arglist708 = null;


        CommonTree T_FUNCTION_CALL706_tree=null;
        CommonTree T_PARAMS707_tree=null;
        RewriteRuleNodeStream stream_T_FUNCTION_CALL=new RewriteRuleNodeStream(adaptor,"token T_FUNCTION_CALL");
        RewriteRuleNodeStream stream_T_PARAMS=new RewriteRuleNodeStream(adaptor,"token T_PARAMS");
        RewriteRuleSubtreeStream stream_arglist=new RewriteRuleSubtreeStream(adaptor,"rule arglist");
        RewriteRuleSubtreeStream stream_iRIref=new RewriteRuleSubtreeStream(adaptor,"rule iRIref");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2901:3: ( ^( T_FUNCTION_CALL i= iRIref ^( T_PARAMS ( arglist )? ) ) -> QSTRING[$i.text] QSTRING[\"(\"] ( arglist )? QSTRING[\")\"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2901:5: ^( T_FUNCTION_CALL i= iRIref ^( T_PARAMS ( arglist )? ) )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_FUNCTION_CALL706=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_iRIrefOrFunction17663); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_FUNCTION_CALL.add(T_FUNCTION_CALL706);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_iRIref_in_iRIrefOrFunction17667);
            i=iRIref();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_iRIref.add(i.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_PARAMS707=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_iRIrefOrFunction17670); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_PARAMS.add(T_PARAMS707);



            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2901:43: ( arglist )?
                int alt209=2;
                switch ( input.LA(1) ) {
                    case VAR:
                    case INTEGER:
                    case QSTRING:
                    case SLASH:
                    case LPAR:
                    case STAR:
                    case LESSTHAN:
                    case GREATERTHAN:
                    case PLUS:
                    case MINUS:
                    case GREATERTHANEQUALS:
                    case LESSTHANEQUALS:
                    case HAFENEQUALS:
                    case EQUALS:
                    case ORSYMBOL:
                    case ANDSYMBOL:
                    case NOT:
                    case STR:
                    case LANG:
                    case LANGMATCHES:
                    case DATATYPE:
                    case BOUND:
                    case ISIRI:
                    case ISURI:
                    case ISBLANK:
                    case ISLITERAL:
                    case REGEX:
                    case TRUE:
                    case FALSE:
                    case T_FUNCTION_CALL:
                        {
                        alt209=1;
                        }
                        break;
                }

                switch (alt209) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: arglist
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_arglist_in_iRIrefOrFunction17672);
                        arglist708=arglist();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) stream_arglist.add(arglist708.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: arglist
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2901:54: -> QSTRING[$i.text] QSTRING[\"(\"] ( arglist )? QSTRING[\")\"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (i!=null?(input.getTokenStream().toString(
                  input.getTreeAdaptor().getTokenStartIndex(i.start),
                  input.getTreeAdaptor().getTokenStopIndex(i.start))):null)));
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "("));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2901:87: ( arglist )?
                if ( stream_arglist.hasNext() ) {
                    adaptor.addChild(root_0, stream_arglist.nextTree());

                }
                stream_arglist.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, ")"));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "iRIrefOrFunction"

    public static class rdfLiteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "rdfLiteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2904:1: rdfLiteral : (q= QSTRING -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] | q= QSTRING AT qname -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] AT qname | q= QSTRING c1= CARET c2= CARET (o= IRIREF | o= PNAME_LN ) -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] QSTRING[$c1.token, \"^^\"] QSTRING[$o.token, $o.text] );
    public final XSPARQLRewriter.rdfLiteral_return rdfLiteral() throws RecognitionException {
        XSPARQLRewriter.rdfLiteral_return retval = new XSPARQLRewriter.rdfLiteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree q=null;
        CommonTree c1=null;
        CommonTree c2=null;
        CommonTree o=null;
        CommonTree AT709=null;
        XSPARQLRewriter.qname_return qname710 = null;


        CommonTree q_tree=null;
        CommonTree c1_tree=null;
        CommonTree c2_tree=null;
        CommonTree o_tree=null;
        CommonTree AT709_tree=null;
        RewriteRuleNodeStream stream_AT=new RewriteRuleNodeStream(adaptor,"token AT");
        RewriteRuleNodeStream stream_PNAME_LN=new RewriteRuleNodeStream(adaptor,"token PNAME_LN");
        RewriteRuleNodeStream stream_QSTRING=new RewriteRuleNodeStream(adaptor,"token QSTRING");
        RewriteRuleNodeStream stream_IRIREF=new RewriteRuleNodeStream(adaptor,"token IRIREF");
        RewriteRuleNodeStream stream_CARET=new RewriteRuleNodeStream(adaptor,"token CARET");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2905:3: (q= QSTRING -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] | q= QSTRING AT qname -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] AT qname | q= QSTRING c1= CARET c2= CARET (o= IRIREF | o= PNAME_LN ) -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] QSTRING[$c1.token, \"^^\"] QSTRING[$o.token, $o.text] )
            int alt211=3;
            switch ( input.LA(1) ) {
            case QSTRING:
                {
                switch ( input.LA(2) ) {
                case AT:
                    {
                    alt211=2;
                    }
                    break;
                case CARET:
                    {
                    alt211=3;
                    }
                    break;
                case EOF:
                case UP:
                case VAR:
                case INTEGER:
                case QSTRING:
                case COMMA:
                case SLASH:
                case LPAR:
                case RPAR:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case PNAME_NS:
                case PNAME_LN:
                case ORSYMBOL:
                case ANDSYMBOL:
                case NOT:
                case IRIREF:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case T_ANON_BLANK:
                case T_FUNCTION_CALL:
                case T_LITERAL_CONSTRUCT:
                case T_IRI_CONSTRUCT:
                    {
                    alt211=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 211, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 211, 0, input);

                throw nvae;
            }

            switch (alt211) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2905:5: q= QSTRING
                    {
                    _last = (CommonTree)input.LT(1);
                    q=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_rdfLiteral17704); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(q);



                    // AST REWRITE
                    // elements: QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2905:15: -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, q.token, "\"\""+(q!=null?q.getText():null)+"\"\""));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2906:5: q= QSTRING AT qname
                    {
                    _last = (CommonTree)input.LT(1);
                    q=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_rdfLiteral17717); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(q);

                    _last = (CommonTree)input.LT(1);
                    AT709=(CommonTree)match(input,AT,FOLLOW_AT_in_rdfLiteral17719); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT.add(AT709);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_rdfLiteral17721);
                    qname710=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(qname710.getTree());


                    // AST REWRITE
                    // elements: qname, AT, QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2906:24: -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] AT qname
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, q.token, "\"\""+(q!=null?q.getText():null)+"\"\""));
                        adaptor.addChild(root_0, stream_AT.nextNode());
                        adaptor.addChild(root_0, stream_qname.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2907:5: q= QSTRING c1= CARET c2= CARET (o= IRIREF | o= PNAME_LN )
                    {
                    _last = (CommonTree)input.LT(1);
                    q=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_rdfLiteral17738); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(q);

                    _last = (CommonTree)input.LT(1);
                    c1=(CommonTree)match(input,CARET,FOLLOW_CARET_in_rdfLiteral17742); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c1);

                    _last = (CommonTree)input.LT(1);
                    c2=(CommonTree)match(input,CARET,FOLLOW_CARET_in_rdfLiteral17746); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c2);

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2907:33: (o= IRIREF | o= PNAME_LN )
                    int alt210=2;
                    switch ( input.LA(1) ) {
                    case IRIREF:
                        {
                        alt210=1;
                        }
                        break;
                    case PNAME_LN:
                        {
                        alt210=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 210, 0, input);

                        throw nvae;
                    }

                    switch (alt210) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2907:35: o= IRIREF
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_rdfLiteral17752); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_IRIREF.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2907:47: o= PNAME_LN
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,PNAME_LN,FOLLOW_PNAME_LN_in_rdfLiteral17759); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_PNAME_LN.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: QSTRING, QSTRING, QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2908:3: -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] QSTRING[$c1.token, \"^^\"] QSTRING[$o.token, $o.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, q.token, "\"\""+(q!=null?q.getText():null)+"\"\""));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, c1.token, "^^"));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "rdfLiteral"

    public static class sNumericLiteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sNumericLiteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2911:1: sNumericLiteral : INTEGER ;
    public final XSPARQLRewriter.sNumericLiteral_return sNumericLiteral() throws RecognitionException {
        XSPARQLRewriter.sNumericLiteral_return retval = new XSPARQLRewriter.sNumericLiteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree INTEGER711=null;

        CommonTree INTEGER711_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2912:3: ( INTEGER )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2912:5: INTEGER
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            INTEGER711=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_sNumericLiteral17788); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            INTEGER711_tree = (CommonTree)adaptor.dupNode(INTEGER711);

            adaptor.addChild(root_0, INTEGER711_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sNumericLiteral"

    public static class booleanLiteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "booleanLiteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2915:1: booleanLiteral : (t= TRUE -> QSTRING[$t.token, $t.text] | f= FALSE -> QSTRING[$f.token, $f.text] );
    public final XSPARQLRewriter.booleanLiteral_return booleanLiteral() throws RecognitionException {
        XSPARQLRewriter.booleanLiteral_return retval = new XSPARQLRewriter.booleanLiteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree t=null;
        CommonTree f=null;

        CommonTree t_tree=null;
        CommonTree f_tree=null;
        RewriteRuleNodeStream stream_FALSE=new RewriteRuleNodeStream(adaptor,"token FALSE");
        RewriteRuleNodeStream stream_TRUE=new RewriteRuleNodeStream(adaptor,"token TRUE");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2916:3: (t= TRUE -> QSTRING[$t.token, $t.text] | f= FALSE -> QSTRING[$f.token, $f.text] )
            int alt212=2;
            switch ( input.LA(1) ) {
            case TRUE:
                {
                alt212=1;
                }
                break;
            case FALSE:
                {
                alt212=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 212, 0, input);

                throw nvae;
            }

            switch (alt212) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2916:5: t= TRUE
                    {
                    _last = (CommonTree)input.LT(1);
                    t=(CommonTree)match(input,TRUE,FOLLOW_TRUE_in_booleanLiteral17803); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_TRUE.add(t);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2916:12: -> QSTRING[$t.token, $t.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, t.token, (t!=null?t.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2917:5: f= FALSE
                    {
                    _last = (CommonTree)input.LT(1);
                    f=(CommonTree)match(input,FALSE,FOLLOW_FALSE_in_booleanLiteral17816); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_FALSE.add(f);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2917:13: -> QSTRING[$f.token, $f.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, f.token, (f!=null?f.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "booleanLiteral"

    public static class string_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "string"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2926:1: string : QSTRING ;
    public final XSPARQLRewriter.string_return string() throws RecognitionException {
        XSPARQLRewriter.string_return retval = new XSPARQLRewriter.string_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree QSTRING712=null;

        CommonTree QSTRING712_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2927:3: ( QSTRING )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2927:5: QSTRING
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            QSTRING712=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_string17840); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            QSTRING712_tree = (CommonTree)adaptor.dupNode(QSTRING712);

            adaptor.addChild(root_0, QSTRING712_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "string"

    public static class iRIref_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "iRIref"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2931:1: iRIref : ( IRIREF | prefixedName );
    public final XSPARQLRewriter.iRIref_return iRIref() throws RecognitionException {
        XSPARQLRewriter.iRIref_return retval = new XSPARQLRewriter.iRIref_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree IRIREF713=null;
        XSPARQLRewriter.prefixedName_return prefixedName714 = null;


        CommonTree IRIREF713_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2932:3: ( IRIREF | prefixedName )
            int alt213=2;
            switch ( input.LA(1) ) {
            case IRIREF:
                {
                alt213=1;
                }
                break;
            case PNAME_NS:
            case PNAME_LN:
                {
                alt213=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 213, 0, input);

                throw nvae;
            }

            switch (alt213) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2932:5: IRIREF
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    IRIREF713=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_iRIref17855); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IRIREF713_tree = (CommonTree)adaptor.dupNode(IRIREF713);

                    adaptor.addChild(root_0, IRIREF713_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2933:5: prefixedName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_prefixedName_in_iRIref17861);
                    prefixedName714=prefixedName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, prefixedName714.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "iRIref"

    public static class prefixedName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prefixedName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2936:1: prefixedName : ( PNAME_LN | PNAME_NS );
    public final XSPARQLRewriter.prefixedName_return prefixedName() throws RecognitionException {
        XSPARQLRewriter.prefixedName_return retval = new XSPARQLRewriter.prefixedName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set715=null;

        CommonTree set715_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2937:3: ( PNAME_LN | PNAME_NS )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set715=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=PNAME_NS && input.LA(1)<=PNAME_LN) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set715_tree = (CommonTree)adaptor.dupNode(set715);

                adaptor.addChild(root_0, set715_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prefixedName"

    public static class blank_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "blank"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2941:1: blank : ( bnode | T_EMPTY_ANON_BLANK -> QSTRING[\"[]\"] );
    public final XSPARQLRewriter.blank_return blank() throws RecognitionException {
        XSPARQLRewriter.blank_return retval = new XSPARQLRewriter.blank_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_EMPTY_ANON_BLANK717=null;
        XSPARQLRewriter.bnode_return bnode716 = null;


        CommonTree T_EMPTY_ANON_BLANK717_tree=null;
        RewriteRuleNodeStream stream_T_EMPTY_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_EMPTY_ANON_BLANK");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2942:3: ( bnode | T_EMPTY_ANON_BLANK -> QSTRING[\"[]\"] )
            int alt214=2;
            switch ( input.LA(1) ) {
            case BLANK_NODE_LABEL:
                {
                alt214=1;
                }
                break;
            case T_EMPTY_ANON_BLANK:
                {
                alt214=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 214, 0, input);

                throw nvae;
            }

            switch (alt214) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2942:5: bnode
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_bnode_in_blank17893);
                    bnode716=bnode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, bnode716.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2943:5: T_EMPTY_ANON_BLANK
                    {
                    _last = (CommonTree)input.LT(1);
                    T_EMPTY_ANON_BLANK717=(CommonTree)match(input,T_EMPTY_ANON_BLANK,FOLLOW_T_EMPTY_ANON_BLANK_in_blank17899); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_EMPTY_ANON_BLANK.add(T_EMPTY_ANON_BLANK717);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2944:3: -> QSTRING[\"[]\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "[]"));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "blank"

    public static class predicateObjectList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "predicateObjectList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2960:1: predicateObjectList : ( ^( T_VERB verb objectList ) )+ ;
    public final XSPARQLRewriter.predicateObjectList_return predicateObjectList() throws RecognitionException {
        XSPARQLRewriter.predicateObjectList_return retval = new XSPARQLRewriter.predicateObjectList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_VERB718=null;
        XSPARQLRewriter.verb_return verb719 = null;

        XSPARQLRewriter.objectList_return objectList720 = null;


        CommonTree T_VERB718_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2961:3: ( ( ^( T_VERB verb objectList ) )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2961:5: ( ^( T_VERB verb objectList ) )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2961:5: ( ^( T_VERB verb objectList ) )+
            int cnt215=0;
            loop215:
            do {
                int alt215=2;
                switch ( input.LA(1) ) {
                case T_VERB:
                    {
                    alt215=1;
                    }
                    break;

                }

                switch (alt215) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2961:6: ^( T_VERB verb objectList )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_1 = _last;
            	    CommonTree _first_1 = null;
            	    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_VERB718=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_predicateObjectList17934); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    T_VERB718_tree = (CommonTree)adaptor.dupNode(T_VERB718);

            	    root_1 = (CommonTree)adaptor.becomeRoot(T_VERB718_tree, root_1);
            	    }


            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_verb_in_predicateObjectList17936);
            	    verb719=verb();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_1, verb719.getTree());
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_objectList_in_predicateObjectList17938);
            	    objectList720=objectList();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_1, objectList720.getTree());

            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt215 >= 1 ) break loop215;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(215, input);
                        throw eee;
                }
                cnt215++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "predicateObjectList"

    public static class iri_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "iri"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2964:1: iri : (p= PNAME_LN -> QSTRING[$p.text] | i= IRIREF -> QSTRING[$i.text] | iriConstruct );
    public final XSPARQLRewriter.iri_return iri() throws RecognitionException {
        XSPARQLRewriter.iri_return retval = new XSPARQLRewriter.iri_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree p=null;
        CommonTree i=null;
        XSPARQLRewriter.iriConstruct_return iriConstruct721 = null;


        CommonTree p_tree=null;
        CommonTree i_tree=null;
        RewriteRuleNodeStream stream_PNAME_LN=new RewriteRuleNodeStream(adaptor,"token PNAME_LN");
        RewriteRuleNodeStream stream_IRIREF=new RewriteRuleNodeStream(adaptor,"token IRIREF");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2965:3: (p= PNAME_LN -> QSTRING[$p.text] | i= IRIREF -> QSTRING[$i.text] | iriConstruct )
            int alt216=3;
            switch ( input.LA(1) ) {
            case PNAME_LN:
                {
                alt216=1;
                }
                break;
            case IRIREF:
                {
                alt216=2;
                }
                break;
            case T_IRI_CONSTRUCT:
                {
                alt216=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 216, 0, input);

                throw nvae;
            }

            switch (alt216) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2965:6: p= PNAME_LN
                    {
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PNAME_LN,FOLLOW_PNAME_LN_in_iri17957); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_LN.add(p);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2965:18: -> QSTRING[$p.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (p!=null?p.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2966:6: i= IRIREF
                    {
                    _last = (CommonTree)input.LT(1);
                    i=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_iri17972); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IRIREF.add(i);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2966:18: -> QSTRING[$i.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (i!=null?i.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2967:6: iriConstruct
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_iri17987);
                    iriConstruct721=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, iriConstruct721.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "iri"

    public static class resource__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "resource_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2970:1: resource_ : ( sparqlPrefixedName | VAR | IRIREF );
    public final XSPARQLRewriter.resource__return resource_() throws RecognitionException {
        XSPARQLRewriter.resource__return retval = new XSPARQLRewriter.resource__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR723=null;
        CommonTree IRIREF724=null;
        XSPARQLRewriter.sparqlPrefixedName_return sparqlPrefixedName722 = null;


        CommonTree VAR723_tree=null;
        CommonTree IRIREF724_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2971:3: ( sparqlPrefixedName | VAR | IRIREF )
            int alt217=3;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
                {
                alt217=1;
                }
                break;
            case VAR:
                {
                alt217=2;
                }
                break;
            case IRIREF:
                {
                alt217=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 217, 0, input);

                throw nvae;
            }

            switch (alt217) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2971:5: sparqlPrefixedName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sparqlPrefixedName_in_resource_18000);
                    sparqlPrefixedName722=sparqlPrefixedName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sparqlPrefixedName722.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2972:5: VAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    VAR723=(CommonTree)match(input,VAR,FOLLOW_VAR_in_resource_18006); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR723_tree = (CommonTree)adaptor.dupNode(VAR723);

                    adaptor.addChild(root_0, VAR723_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2973:5: IRIREF
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    IRIREF724=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_resource_18012); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IRIREF724_tree = (CommonTree)adaptor.dupNode(IRIREF724);

                    adaptor.addChild(root_0, IRIREF724_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "resource_"

    public static class rdfPredicate__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "rdfPredicate_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2976:1: rdfPredicate_ : resource_ ;
    public final XSPARQLRewriter.rdfPredicate__return rdfPredicate_() throws RecognitionException {
        XSPARQLRewriter.rdfPredicate__return retval = new XSPARQLRewriter.rdfPredicate__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.resource__return resource_725 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2977:3: ( resource_ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2977:5: resource_
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_resource__in_rdfPredicate_18025);
            resource_725=resource_();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, resource_725.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "rdfPredicate_"

    public static class bnode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "bnode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2980:1: bnode : BLANK_NODE_LABEL ;
    public final XSPARQLRewriter.bnode_return bnode() throws RecognitionException {
        XSPARQLRewriter.bnode_return retval = new XSPARQLRewriter.bnode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree BLANK_NODE_LABEL726=null;

        CommonTree BLANK_NODE_LABEL726_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2981:3: ( BLANK_NODE_LABEL )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2981:5: BLANK_NODE_LABEL
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            BLANK_NODE_LABEL726=(CommonTree)match(input,BLANK_NODE_LABEL,FOLLOW_BLANK_NODE_LABEL_in_bnode18038); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            BLANK_NODE_LABEL726_tree = (CommonTree)adaptor.dupNode(BLANK_NODE_LABEL726);

            adaptor.addChild(root_0, BLANK_NODE_LABEL726_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "bnode"

    public static class sparqlPrefixedName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sparqlPrefixedName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2984:1: sparqlPrefixedName : (p= PNAME_LN -> QSTRING[$p.token, $p.text] | p= PNAME_NS -> QSTRING[$p.token, $p.text] );
    public final XSPARQLRewriter.sparqlPrefixedName_return sparqlPrefixedName() throws RecognitionException {
        XSPARQLRewriter.sparqlPrefixedName_return retval = new XSPARQLRewriter.sparqlPrefixedName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree p=null;

        CommonTree p_tree=null;
        RewriteRuleNodeStream stream_PNAME_NS=new RewriteRuleNodeStream(adaptor,"token PNAME_NS");
        RewriteRuleNodeStream stream_PNAME_LN=new RewriteRuleNodeStream(adaptor,"token PNAME_LN");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2985:3: (p= PNAME_LN -> QSTRING[$p.token, $p.text] | p= PNAME_NS -> QSTRING[$p.token, $p.text] )
            int alt218=2;
            switch ( input.LA(1) ) {
            case PNAME_LN:
                {
                alt218=1;
                }
                break;
            case PNAME_NS:
                {
                alt218=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 218, 0, input);

                throw nvae;
            }

            switch (alt218) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2985:5: p= PNAME_LN
                    {
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PNAME_LN,FOLLOW_PNAME_LN_in_sparqlPrefixedName18053); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_LN.add(p);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2985:17: -> QSTRING[$p.token, $p.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, p.token, (p!=null?p.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2986:5: p= PNAME_NS
                    {
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PNAME_NS,FOLLOW_PNAME_NS_in_sparqlPrefixedName18067); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_NS.add(p);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2986:17: -> QSTRING[$p.token, $p.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, p.token, (p!=null?p.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sparqlPrefixedName"

    public static class qname_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "qname"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2990:1: qname : ( prefixedName | unprefixedName );
    public final XSPARQLRewriter.qname_return qname() throws RecognitionException {
        XSPARQLRewriter.qname_return retval = new XSPARQLRewriter.qname_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.prefixedName_return prefixedName727 = null;

        XSPARQLRewriter.unprefixedName_return unprefixedName728 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2991:3: ( prefixedName | unprefixedName )
            int alt219=2;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
                {
                alt219=1;
                }
                break;
            case NCNAME:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt219=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 219, 0, input);

                throw nvae;
            }

            switch (alt219) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2991:5: prefixedName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_prefixedName_in_qname18087);
                    prefixedName727=prefixedName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, prefixedName727.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2992:5: unprefixedName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unprefixedName_in_qname18093);
                    unprefixedName728=unprefixedName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, unprefixedName728.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "qname"

    public static class keyword_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "keyword"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2995:1: keyword : ( ITEM | t= TO -> NCNAME[$t.text] | f= FROM -> NCNAME[$f.text] | r= ROW -> NCNAME[$r.text] | c= COMMENT -> NCNAME[$c.text] | n= NODE -> NCNAME[$n.text] | A );
    public final XSPARQLRewriter.keyword_return keyword() throws RecognitionException {
        XSPARQLRewriter.keyword_return retval = new XSPARQLRewriter.keyword_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree t=null;
        CommonTree f=null;
        CommonTree r=null;
        CommonTree c=null;
        CommonTree n=null;
        CommonTree ITEM729=null;
        CommonTree A730=null;

        CommonTree t_tree=null;
        CommonTree f_tree=null;
        CommonTree r_tree=null;
        CommonTree c_tree=null;
        CommonTree n_tree=null;
        CommonTree ITEM729_tree=null;
        CommonTree A730_tree=null;
        RewriteRuleNodeStream stream_NODE=new RewriteRuleNodeStream(adaptor,"token NODE");
        RewriteRuleNodeStream stream_COMMENT=new RewriteRuleNodeStream(adaptor,"token COMMENT");
        RewriteRuleNodeStream stream_ROW=new RewriteRuleNodeStream(adaptor,"token ROW");
        RewriteRuleNodeStream stream_FROM=new RewriteRuleNodeStream(adaptor,"token FROM");
        RewriteRuleNodeStream stream_TO=new RewriteRuleNodeStream(adaptor,"token TO");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2996:3: ( ITEM | t= TO -> NCNAME[$t.text] | f= FROM -> NCNAME[$f.text] | r= ROW -> NCNAME[$r.text] | c= COMMENT -> NCNAME[$c.text] | n= NODE -> NCNAME[$n.text] | A )
            int alt220=7;
            switch ( input.LA(1) ) {
            case ITEM:
                {
                alt220=1;
                }
                break;
            case TO:
                {
                alt220=2;
                }
                break;
            case FROM:
                {
                alt220=3;
                }
                break;
            case ROW:
                {
                alt220=4;
                }
                break;
            case COMMENT:
                {
                alt220=5;
                }
                break;
            case NODE:
                {
                alt220=6;
                }
                break;
            case A:
                {
                alt220=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 220, 0, input);

                throw nvae;
            }

            switch (alt220) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2996:5: ITEM
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    ITEM729=(CommonTree)match(input,ITEM,FOLLOW_ITEM_in_keyword18106); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ITEM729_tree = (CommonTree)adaptor.dupNode(ITEM729);

                    adaptor.addChild(root_0, ITEM729_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2997:5: t= TO
                    {
                    _last = (CommonTree)input.LT(1);
                    t=(CommonTree)match(input,TO,FOLLOW_TO_in_keyword18114); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_TO.add(t);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2997:10: -> NCNAME[$t.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NCNAME, (t!=null?t.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2998:5: f= FROM
                    {
                    _last = (CommonTree)input.LT(1);
                    f=(CommonTree)match(input,FROM,FOLLOW_FROM_in_keyword18127); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_FROM.add(f);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2998:12: -> NCNAME[$f.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NCNAME, (f!=null?f.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2999:5: r= ROW
                    {
                    _last = (CommonTree)input.LT(1);
                    r=(CommonTree)match(input,ROW,FOLLOW_ROW_in_keyword18140); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ROW.add(r);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2999:11: -> NCNAME[$r.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NCNAME, (r!=null?r.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:3000:5: c= COMMENT
                    {
                    _last = (CommonTree)input.LT(1);
                    c=(CommonTree)match(input,COMMENT,FOLLOW_COMMENT_in_keyword18153); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_COMMENT.add(c);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 3000:15: -> NCNAME[$c.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NCNAME, (c!=null?c.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:3001:5: n= NODE
                    {
                    _last = (CommonTree)input.LT(1);
                    n=(CommonTree)match(input,NODE,FOLLOW_NODE_in_keyword18166); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_NODE.add(n);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 3001:12: -> NCNAME[$n.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NCNAME, (n!=null?n.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:3002:5: A
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    A730=(CommonTree)match(input,A,FOLLOW_A_in_keyword18177); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    A730_tree = (CommonTree)adaptor.dupNode(A730);

                    adaptor.addChild(root_0, A730_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "keyword"

    public static class unprefixedName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unprefixedName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:3004:1: unprefixedName : localPart ;
    public final XSPARQLRewriter.unprefixedName_return unprefixedName() throws RecognitionException {
        XSPARQLRewriter.unprefixedName_return retval = new XSPARQLRewriter.unprefixedName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.localPart_return localPart731 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:3005:3: ( localPart )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:3005:5: localPart
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_localPart_in_unprefixedName18188);
            localPart731=localPart();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, localPart731.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unprefixedName"

    public static class localPart_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "localPart"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:3008:1: localPart : ( NCNAME | keyword );
    public final XSPARQLRewriter.localPart_return localPart() throws RecognitionException {
        XSPARQLRewriter.localPart_return retval = new XSPARQLRewriter.localPart_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree NCNAME732=null;
        XSPARQLRewriter.keyword_return keyword733 = null;


        CommonTree NCNAME732_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:3009:3: ( NCNAME | keyword )
            int alt221=2;
            switch ( input.LA(1) ) {
            case NCNAME:
                {
                alt221=1;
                }
                break;
            case A:
            case FROM:
            case TO:
            case ITEM:
            case NODE:
            case COMMENT:
            case ROW:
                {
                alt221=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 221, 0, input);

                throw nvae;
            }

            switch (alt221) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:3009:5: NCNAME
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    NCNAME732=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_localPart18201); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAME732_tree = (CommonTree)adaptor.dupNode(NCNAME732);

                    adaptor.addChild(root_0, NCNAME732_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:3010:5: keyword
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_keyword_in_localPart18207);
                    keyword733=keyword();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, keyword733.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "localPart"

    // $ANTLR start synpred41_XSPARQLRewriter
    public final void synpred41_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1007:5: ( exprSingle )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1007:5: exprSingle
        {
        pushFollow(FOLLOW_exprSingle_in_synpred41_XSPARQLRewriter2109);
        exprSingle();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred41_XSPARQLRewriter

    // $ANTLR start synpred74_XSPARQLRewriter
    public final void synpred74_XSPARQLRewriter_fragment() throws RecognitionException {   
        XSPARQLRewriter.qname_return p1 = null;

        XSPARQLRewriter.qname_return q1 = null;


        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1281:5: (p1= qname DOT q1= qname )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1281:5: p1= qname DOT q1= qname
        {
        pushFollow(FOLLOW_qname_in_synpred74_XSPARQLRewriter4349);
        p1=qname();

        state._fsp--;
        if (state.failed) return ;
        match(input,DOT,FOLLOW_DOT_in_synpred74_XSPARQLRewriter4351); if (state.failed) return ;
        pushFollow(FOLLOW_qname_in_synpred74_XSPARQLRewriter4355);
        q1=qname();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred74_XSPARQLRewriter

    // $ANTLR start synpred77_XSPARQLRewriter
    public final void synpred77_XSPARQLRewriter_fragment() throws RecognitionException {   
        XSPARQLRewriter.sqlBooleanOp_return b = null;


        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1301:21: (b= sqlBooleanOp sqlWhereSpecList )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1301:21: b= sqlBooleanOp sqlWhereSpecList
        {
        pushFollow(FOLLOW_sqlBooleanOp_in_synpred77_XSPARQLRewriter4490);
        b=sqlBooleanOp();

        state._fsp--;
        if (state.failed) return ;
        pushFollow(FOLLOW_sqlWhereSpecList_in_synpred77_XSPARQLRewriter4492);
        sqlWhereSpecList();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred77_XSPARQLRewriter

    // $ANTLR start synpred93_XSPARQLRewriter
    public final void synpred93_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1386:54: ( solutionmodifier )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1386:54: solutionmodifier
        {
        pushFollow(FOLLOW_solutionmodifier_in_synpred93_XSPARQLRewriter4817);
        solutionmodifier();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred93_XSPARQLRewriter

    // $ANTLR start synpred253_XSPARQLRewriter
    public final void synpred253_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2169:5: ( triplesSameSubject )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2169:5: triplesSameSubject
        {
        pushFollow(FOLLOW_triplesSameSubject_in_synpred253_XSPARQLRewriter9887);
        triplesSameSubject();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred253_XSPARQLRewriter

    // $ANTLR start synpred277_XSPARQLRewriter
    public final void synpred277_XSPARQLRewriter_fragment() throws RecognitionException {   
        List list_v=null;
        List list_o=null;
        RuleReturnScope v = null;
        RuleReturnScope o = null;
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2432:38: ( ^( T_VERB v+= verb o+= objectList ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2432:38: ^( T_VERB v+= verb o+= objectList )
        {
        match(input,T_VERB,FOLLOW_T_VERB_in_synpred277_XSPARQLRewriter12963); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        pushFollow(FOLLOW_verb_in_synpred277_XSPARQLRewriter12967);
        v=verb();

        state._fsp--;
        if (state.failed) return ;
        if (list_v==null) list_v=new ArrayList();
        list_v.add(v);

        pushFollow(FOLLOW_objectList_in_synpred277_XSPARQLRewriter12971);
        o=objectList();

        state._fsp--;
        if (state.failed) return ;
        if (list_o==null) list_o=new ArrayList();
        list_o.add(o);


        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred277_XSPARQLRewriter

    // $ANTLR start synpred318_XSPARQLRewriter
    public final void synpred318_XSPARQLRewriter_fragment() throws RecognitionException {   
        CommonTree at=null;
        XSPARQLRewriter.enclosedExpr_return e1 = null;

        XSPARQLRewriter.enclosedExpr_return e2 = null;


        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2673:5: ( ^( T_LITERAL_CONSTRUCT e1= enclosedExpr at= AT e2= enclosedExpr ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2673:5: ^( T_LITERAL_CONSTRUCT e1= enclosedExpr at= AT e2= enclosedExpr )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred318_XSPARQLRewriter15523); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        pushFollow(FOLLOW_enclosedExpr_in_synpred318_XSPARQLRewriter15527);
        e1=enclosedExpr();

        state._fsp--;
        if (state.failed) return ;
        at=(CommonTree)match(input,AT,FOLLOW_AT_in_synpred318_XSPARQLRewriter15531); if (state.failed) return ;
        pushFollow(FOLLOW_enclosedExpr_in_synpred318_XSPARQLRewriter15535);
        e2=enclosedExpr();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred318_XSPARQLRewriter

    // $ANTLR start synpred319_XSPARQLRewriter
    public final void synpred319_XSPARQLRewriter_fragment() throws RecognitionException {   
        CommonTree c1=null;
        CommonTree c2=null;

        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2683:5: ( ^( T_LITERAL_CONSTRUCT enclosedExpr c1= CARET c2= CARET iri ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2683:5: ^( T_LITERAL_CONSTRUCT enclosedExpr c1= CARET c2= CARET iri )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred319_XSPARQLRewriter15642); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        pushFollow(FOLLOW_enclosedExpr_in_synpred319_XSPARQLRewriter15644);
        enclosedExpr();

        state._fsp--;
        if (state.failed) return ;
        c1=(CommonTree)match(input,CARET,FOLLOW_CARET_in_synpred319_XSPARQLRewriter15648); if (state.failed) return ;
        c2=(CommonTree)match(input,CARET,FOLLOW_CARET_in_synpred319_XSPARQLRewriter15652); if (state.failed) return ;
        pushFollow(FOLLOW_iri_in_synpred319_XSPARQLRewriter15654);
        iri();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred319_XSPARQLRewriter

    // $ANTLR start synpred320_XSPARQLRewriter
    public final void synpred320_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2693:5: ( ^( T_LITERAL_CONSTRUCT INTEGER AT enclosedExpr ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2693:5: ^( T_LITERAL_CONSTRUCT INTEGER AT enclosedExpr )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred320_XSPARQLRewriter15758); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        match(input,INTEGER,FOLLOW_INTEGER_in_synpred320_XSPARQLRewriter15760); if (state.failed) return ;
        match(input,AT,FOLLOW_AT_in_synpred320_XSPARQLRewriter15762); if (state.failed) return ;
        pushFollow(FOLLOW_enclosedExpr_in_synpred320_XSPARQLRewriter15764);
        enclosedExpr();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred320_XSPARQLRewriter

    // $ANTLR start synpred321_XSPARQLRewriter
    public final void synpred321_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2703:5: ( ^( T_LITERAL_CONSTRUCT INTEGER CARET CARET iriConstruct ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2703:5: ^( T_LITERAL_CONSTRUCT INTEGER CARET CARET iriConstruct )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred321_XSPARQLRewriter15870); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        match(input,INTEGER,FOLLOW_INTEGER_in_synpred321_XSPARQLRewriter15872); if (state.failed) return ;
        match(input,CARET,FOLLOW_CARET_in_synpred321_XSPARQLRewriter15874); if (state.failed) return ;
        match(input,CARET,FOLLOW_CARET_in_synpred321_XSPARQLRewriter15876); if (state.failed) return ;
        pushFollow(FOLLOW_iriConstruct_in_synpred321_XSPARQLRewriter15878);
        iriConstruct();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred321_XSPARQLRewriter

    // $ANTLR start synpred322_XSPARQLRewriter
    public final void synpred322_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2714:5: ( ^( T_LITERAL_CONSTRUCT QSTRING AT enclosedExpr ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2714:5: ^( T_LITERAL_CONSTRUCT QSTRING AT enclosedExpr )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred322_XSPARQLRewriter15983); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        match(input,QSTRING,FOLLOW_QSTRING_in_synpred322_XSPARQLRewriter15985); if (state.failed) return ;
        match(input,AT,FOLLOW_AT_in_synpred322_XSPARQLRewriter15987); if (state.failed) return ;
        pushFollow(FOLLOW_enclosedExpr_in_synpred322_XSPARQLRewriter15989);
        enclosedExpr();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred322_XSPARQLRewriter

    // $ANTLR start synpred323_XSPARQLRewriter
    public final void synpred323_XSPARQLRewriter_fragment() throws RecognitionException {   
        CommonTree c1=null;
        CommonTree c2=null;

        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2724:5: ( ^( T_LITERAL_CONSTRUCT QSTRING c1= CARET c2= CARET iriConstruct ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2724:5: ^( T_LITERAL_CONSTRUCT QSTRING c1= CARET c2= CARET iriConstruct )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred323_XSPARQLRewriter16094); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        match(input,QSTRING,FOLLOW_QSTRING_in_synpred323_XSPARQLRewriter16096); if (state.failed) return ;
        c1=(CommonTree)match(input,CARET,FOLLOW_CARET_in_synpred323_XSPARQLRewriter16100); if (state.failed) return ;
        c2=(CommonTree)match(input,CARET,FOLLOW_CARET_in_synpred323_XSPARQLRewriter16104); if (state.failed) return ;
        pushFollow(FOLLOW_iriConstruct_in_synpred323_XSPARQLRewriter16106);
        iriConstruct();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred323_XSPARQLRewriter

    // Delegated rules

    public final boolean synpred277_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred277_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred41_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred41_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred318_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred318_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred319_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred319_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred323_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred323_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred320_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred320_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred77_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred77_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred253_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred253_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred321_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred321_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred93_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred93_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred322_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred322_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred74_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred74_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA24 dfa24 = new DFA24(this);
    protected DFA41 dfa41 = new DFA41(this);
    protected DFA46 dfa46 = new DFA46(this);
    protected DFA49 dfa49 = new DFA49(this);
    protected DFA166 dfa166 = new DFA166(this);
    static final String DFA24_eotS =
        "\75\uffff";
    static final String DFA24_eofS =
        "\1\1\74\uffff";
    static final String DFA24_minS =
        "\1\3\1\uffff\2\0\4\uffff\1\0\1\uffff\21\0\42\uffff";
    static final String DFA24_maxS =
        "\1\u00f3\1\uffff\2\0\4\uffff\1\0\1\uffff\21\0\42\uffff";
    static final String DFA24_acceptS =
        "\1\uffff\1\2\72\uffff\1\1";
    static final String DFA24_specialS =
        "\2\uffff\1\0\1\1\4\uffff\1\2\1\uffff\1\3\1\4\1\5\1\6\1\7\1\10\1"+
        "\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\42\uffff}>";
    static final String[] DFA24_transitionS = {
            "\2\1\2\uffff\1\10\3\1\1\uffff\1\1\1\uffff\1\1\1\uffff\1\1\1"+
            "\uffff\3\1\1\uffff\1\1\1\uffff\1\26\2\uffff\2\2\2\15\1\25\1"+
            "\uffff\1\30\4\2\7\uffff\2\1\2\uffff\1\1\5\uffff\1\1\2\uffff"+
            "\1\1\7\30\1\uffff\1\1\10\uffff\2\1\1\uffff\1\32\7\uffff\1\1"+
            "\2\uffff\1\1\16\uffff\1\1\4\uffff\1\3\1\31\1\27\3\26\1\25\2"+
            "\24\5\uffff\11\1\21\uffff\1\30\4\uffff\1\1\4\uffff\1\12\24\uffff"+
            "\2\1\3\uffff\1\23\1\uffff\1\20\1\21\1\22\25\uffff\1\1\7\uffff"+
            "\1\1\1\13\1\14\1\uffff\1\17\1\13\17\uffff\1\16\2\1",
            "",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA24_eot = DFA.unpackEncodedString(DFA24_eotS);
    static final short[] DFA24_eof = DFA.unpackEncodedString(DFA24_eofS);
    static final char[] DFA24_min = DFA.unpackEncodedStringToUnsignedChars(DFA24_minS);
    static final char[] DFA24_max = DFA.unpackEncodedStringToUnsignedChars(DFA24_maxS);
    static final short[] DFA24_accept = DFA.unpackEncodedString(DFA24_acceptS);
    static final short[] DFA24_special = DFA.unpackEncodedString(DFA24_specialS);
    static final short[][] DFA24_transition;

    static {
        int numStates = DFA24_transitionS.length;
        DFA24_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA24_transition[i] = DFA.unpackEncodedString(DFA24_transitionS[i]);
        }
    }

    class DFA24 extends DFA {

        public DFA24(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 24;
            this.eot = DFA24_eot;
            this.eof = DFA24_eof;
            this.min = DFA24_min;
            this.max = DFA24_max;
            this.accept = DFA24_accept;
            this.special = DFA24_special;
            this.transition = DFA24_transition;
        }
        public String getDescription() {
            return "()+ loopback of 1007:5: ( exprSingle )+";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TreeNodeStream input = (TreeNodeStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA24_2 = input.LA(1);

                         
                        int index24_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_2);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA24_3 = input.LA(1);

                         
                        int index24_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_3);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA24_8 = input.LA(1);

                         
                        int index24_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_8);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA24_10 = input.LA(1);

                         
                        int index24_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_10);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA24_11 = input.LA(1);

                         
                        int index24_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_11);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA24_12 = input.LA(1);

                         
                        int index24_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_12);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA24_13 = input.LA(1);

                         
                        int index24_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_13);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA24_14 = input.LA(1);

                         
                        int index24_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_14);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA24_15 = input.LA(1);

                         
                        int index24_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_15);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA24_16 = input.LA(1);

                         
                        int index24_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_16);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA24_17 = input.LA(1);

                         
                        int index24_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_17);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA24_18 = input.LA(1);

                         
                        int index24_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_18);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA24_19 = input.LA(1);

                         
                        int index24_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_19);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA24_20 = input.LA(1);

                         
                        int index24_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_20);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA24_21 = input.LA(1);

                         
                        int index24_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_21);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA24_22 = input.LA(1);

                         
                        int index24_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_22);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA24_23 = input.LA(1);

                         
                        int index24_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_23);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA24_24 = input.LA(1);

                         
                        int index24_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_24);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA24_25 = input.LA(1);

                         
                        int index24_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_25);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA24_26 = input.LA(1);

                         
                        int index24_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 60;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_26);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 24, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA41_eotS =
        "\15\uffff";
    static final String DFA41_eofS =
        "\15\uffff";
    static final String DFA41_minS =
        "\1\u00ad\1\2\2\21\1\4\2\uffff\1\3\1\u00af\1\2\1\u00b1\2\uffff";
    static final String DFA41_maxS =
        "\1\u00ad\1\2\2\u00b0\1\4\2\uffff\1\3\1\u00af\1\2\1\u00c2\2\uffff";
    static final String DFA41_acceptS =
        "\5\uffff\1\2\1\1\4\uffff\1\3\1\4";
    static final String DFA41_specialS =
        "\15\uffff}>";
    static final String[] DFA41_transitionS = {
            "\1\1",
            "\1\2",
            "\1\6\3\uffff\1\6\2\uffff\1\5\176\uffff\1\3\3\uffff\1\4\24\uffff"+
            "\1\6",
            "\1\6\3\uffff\1\6\2\uffff\1\5\u0082\uffff\1\4\24\uffff\1\6",
            "\1\7",
            "",
            "",
            "\1\10",
            "\1\11",
            "\1\12",
            "\1\14\20\uffff\1\13",
            "",
            ""
    };

    static final short[] DFA41_eot = DFA.unpackEncodedString(DFA41_eotS);
    static final short[] DFA41_eof = DFA.unpackEncodedString(DFA41_eofS);
    static final char[] DFA41_min = DFA.unpackEncodedStringToUnsignedChars(DFA41_minS);
    static final char[] DFA41_max = DFA.unpackEncodedStringToUnsignedChars(DFA41_maxS);
    static final short[] DFA41_accept = DFA.unpackEncodedString(DFA41_acceptS);
    static final short[] DFA41_special = DFA.unpackEncodedString(DFA41_specialS);
    static final short[][] DFA41_transition;

    static {
        int numStates = DFA41_transitionS.length;
        DFA41_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA41_transition[i] = DFA.unpackEncodedString(DFA41_transitionS[i]);
        }
    }

    class DFA41 extends DFA {

        public DFA41(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 41;
            this.eot = DFA41_eot;
            this.eof = DFA41_eof;
            this.min = DFA41_min;
            this.max = DFA41_max;
            this.accept = DFA41_accept;
            this.special = DFA41_special;
            this.transition = DFA41_transition;
        }
        public String getDescription() {
            return "1078:1: sqlForClause : ( ^(fo= T_SQL_FOR ( distinct )? (var+= sqlVarOrFunction )+ ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ | ^(fo= T_SQL_FOR ( distinct )? s= STAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) ^( T_SQL_FROM ^( T_FUNCTION_CALL qname ^( T_PARAMS sqlVarOrString ) ) ) -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) );";
        }
    }
    static final String DFA46_eotS =
        "\20\uffff";
    static final String DFA46_eofS =
        "\20\uffff";
    static final String DFA46_minS =
        "\1\21\1\2\1\uffff\2\11\11\3\2\uffff";
    static final String DFA46_maxS =
        "\1\u00b0\1\2\1\uffff\2\u009b\11\4\2\uffff";
    static final String DFA46_acceptS =
        "\2\uffff\1\3\13\uffff\1\2\1\1";
    static final String DFA46_specialS =
        "\20\uffff}>";
    static final String[] DFA46_transitionS = {
            "\1\2\3\uffff\1\2\u009a\uffff\1\1",
            "\1\3",
            "",
            "\1\6\7\uffff\1\4\33\uffff\2\5\13\uffff\1\15\10\uffff\1\11\54"+
            "\uffff\1\10\14\uffff\1\7\1\14\2\uffff\1\13\31\uffff\1\12",
            "\1\6\43\uffff\2\5\13\uffff\1\15\10\uffff\1\11\54\uffff\1\10"+
            "\14\uffff\1\7\1\14\2\uffff\1\13\31\uffff\1\12",
            "\1\17\1\16",
            "\1\17\1\16",
            "\1\17\1\16",
            "\1\17\1\16",
            "\1\17\1\16",
            "\1\17\1\16",
            "\1\17\1\16",
            "\1\17\1\16",
            "\1\17\1\16",
            "",
            ""
    };

    static final short[] DFA46_eot = DFA.unpackEncodedString(DFA46_eotS);
    static final short[] DFA46_eof = DFA.unpackEncodedString(DFA46_eofS);
    static final char[] DFA46_min = DFA.unpackEncodedStringToUnsignedChars(DFA46_minS);
    static final char[] DFA46_max = DFA.unpackEncodedStringToUnsignedChars(DFA46_maxS);
    static final short[] DFA46_accept = DFA.unpackEncodedString(DFA46_acceptS);
    static final short[] DFA46_special = DFA.unpackEncodedString(DFA46_specialS);
    static final short[][] DFA46_transition;

    static {
        int numStates = DFA46_transitionS.length;
        DFA46_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA46_transition[i] = DFA.unpackEncodedString(DFA46_transitionS[i]);
        }
    }

    class DFA46 extends DFA {

        public DFA46(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 46;
            this.eot = DFA46_eot;
            this.eof = DFA46_eof;
            this.min = DFA46_min;
            this.max = DFA46_max;
            this.accept = DFA46_accept;
            this.special = DFA46_special;
            this.transition = DFA46_transition;
        }
        public String getDescription() {
            return "1258:1: sqlVarOrFunction : ( ^( T_VAR ( COMMA )? q= qname ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR[\"\\$\"+$q.text] ) | ^( T_VAR ( COMMA )? q= qname VAR ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR ) | ( COMMA )? LPAR functionCall AS v3= VAR RPAR );";
        }
    }
    static final String DFA49_eotS =
        "\30\uffff";
    static final String DFA49_eofS =
        "\30\uffff";
    static final String DFA49_minS =
        "\1\4\12\3\1\4\2\uffff\11\0\1\uffff";
    static final String DFA49_maxS =
        "\14\u009b\2\uffff\11\0\1\uffff";
    static final String DFA49_acceptS =
        "\14\uffff\1\2\1\3\11\uffff\1\1";
    static final String DFA49_specialS =
        "\16\uffff\1\4\1\10\1\5\1\7\1\0\1\2\1\3\1\6\1\1\1\uffff}>";
    static final String[] DFA49_transitionS = {
            "\1\12\4\uffff\1\2\43\uffff\2\1\13\uffff\1\11\10\uffff\1\5\54"+
            "\uffff\1\4\14\uffff\1\3\1\10\2\uffff\1\7\31\uffff\1\6",
            "\2\14\4\uffff\1\14\1\uffff\1\13\41\uffff\2\14\13\uffff\1\14"+
            "\10\uffff\1\14\54\uffff\1\14\14\uffff\2\14\2\uffff\1\14\31\uffff"+
            "\1\14",
            "\2\14\4\uffff\1\14\1\uffff\1\13\41\uffff\2\14\13\uffff\1\14"+
            "\10\uffff\1\14\54\uffff\1\14\14\uffff\2\14\2\uffff\1\14\31\uffff"+
            "\1\14",
            "\2\14\4\uffff\1\14\1\uffff\1\13\41\uffff\2\14\13\uffff\1\14"+
            "\10\uffff\1\14\54\uffff\1\14\14\uffff\2\14\2\uffff\1\14\31\uffff"+
            "\1\14",
            "\2\14\4\uffff\1\14\1\uffff\1\13\41\uffff\2\14\13\uffff\1\14"+
            "\10\uffff\1\14\54\uffff\1\14\14\uffff\2\14\2\uffff\1\14\31\uffff"+
            "\1\14",
            "\2\14\4\uffff\1\14\1\uffff\1\13\41\uffff\2\14\13\uffff\1\14"+
            "\10\uffff\1\14\54\uffff\1\14\14\uffff\2\14\2\uffff\1\14\31\uffff"+
            "\1\14",
            "\2\14\4\uffff\1\14\1\uffff\1\13\41\uffff\2\14\13\uffff\1\14"+
            "\10\uffff\1\14\54\uffff\1\14\14\uffff\2\14\2\uffff\1\14\31\uffff"+
            "\1\14",
            "\2\14\4\uffff\1\14\1\uffff\1\13\41\uffff\2\14\13\uffff\1\14"+
            "\10\uffff\1\14\54\uffff\1\14\14\uffff\2\14\2\uffff\1\14\31\uffff"+
            "\1\14",
            "\2\14\4\uffff\1\14\1\uffff\1\13\41\uffff\2\14\13\uffff\1\14"+
            "\10\uffff\1\14\54\uffff\1\14\14\uffff\2\14\2\uffff\1\14\31\uffff"+
            "\1\14",
            "\2\14\4\uffff\1\14\1\uffff\1\13\41\uffff\2\14\13\uffff\1\14"+
            "\10\uffff\1\14\54\uffff\1\14\14\uffff\2\14\2\uffff\1\14\31\uffff"+
            "\1\14",
            "\2\14\4\uffff\1\14\1\uffff\1\15\41\uffff\2\14\13\uffff\1\14"+
            "\10\uffff\1\14\54\uffff\1\14\14\uffff\2\14\2\uffff\1\14\31\uffff"+
            "\1\14",
            "\1\15\4\uffff\1\17\43\uffff\2\16\13\uffff\1\26\10\uffff\1\22"+
            "\54\uffff\1\21\14\uffff\1\20\1\25\2\uffff\1\24\31\uffff\1\23",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };

    static final short[] DFA49_eot = DFA.unpackEncodedString(DFA49_eotS);
    static final short[] DFA49_eof = DFA.unpackEncodedString(DFA49_eofS);
    static final char[] DFA49_min = DFA.unpackEncodedStringToUnsignedChars(DFA49_minS);
    static final char[] DFA49_max = DFA.unpackEncodedStringToUnsignedChars(DFA49_maxS);
    static final short[] DFA49_accept = DFA.unpackEncodedString(DFA49_acceptS);
    static final short[] DFA49_special = DFA.unpackEncodedString(DFA49_specialS);
    static final short[][] DFA49_transition;

    static {
        int numStates = DFA49_transitionS.length;
        DFA49_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA49_transition[i] = DFA.unpackEncodedString(DFA49_transitionS[i]);
        }
    }

    class DFA49 extends DFA {

        public DFA49(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 49;
            this.eot = DFA49_eot;
            this.eof = DFA49_eof;
            this.min = DFA49_min;
            this.max = DFA49_max;
            this.accept = DFA49_accept;
            this.special = DFA49_special;
            this.transition = DFA49_transition;
        }
        public String getDescription() {
            return "1279:1: relationSchemaName : (p1= qname DOT q1= qname -> QSTRING[\"\\\"\\\"\"+$p1.text+\"\\\"\\\".\\\"\\\"\"+$q1.text+\"\\\"\\\"\"] | relationAlias | p2= relationAlias DOT q2= relationAlias -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS $p2 QSTRING[\".\"] $q2) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TreeNodeStream input = (TreeNodeStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA49_18 = input.LA(1);

                         
                        int index49_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 23;}

                        else if ( (true) ) {s = 13;}

                         
                        input.seek(index49_18);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA49_22 = input.LA(1);

                         
                        int index49_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 23;}

                        else if ( (true) ) {s = 13;}

                         
                        input.seek(index49_22);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA49_19 = input.LA(1);

                         
                        int index49_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 23;}

                        else if ( (true) ) {s = 13;}

                         
                        input.seek(index49_19);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA49_20 = input.LA(1);

                         
                        int index49_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 23;}

                        else if ( (true) ) {s = 13;}

                         
                        input.seek(index49_20);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA49_14 = input.LA(1);

                         
                        int index49_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 23;}

                        else if ( (true) ) {s = 13;}

                         
                        input.seek(index49_14);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA49_16 = input.LA(1);

                         
                        int index49_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 23;}

                        else if ( (true) ) {s = 13;}

                         
                        input.seek(index49_16);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA49_21 = input.LA(1);

                         
                        int index49_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 23;}

                        else if ( (true) ) {s = 13;}

                         
                        input.seek(index49_21);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA49_17 = input.LA(1);

                         
                        int index49_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 23;}

                        else if ( (true) ) {s = 13;}

                         
                        input.seek(index49_17);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA49_15 = input.LA(1);

                         
                        int index49_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 23;}

                        else if ( (true) ) {s = 13;}

                         
                        input.seek(index49_15);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 49, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA166_eotS =
        "\17\uffff";
    static final String DFA166_eofS =
        "\1\1\16\uffff";
    static final String DFA166_minS =
        "\1\3\2\uffff\1\0\13\uffff";
    static final String DFA166_maxS =
        "\1\u00b6\2\uffff\1\0\13\uffff";
    static final String DFA166_acceptS =
        "\1\uffff\1\2\14\uffff\1\1";
    static final String DFA166_specialS =
        "\3\uffff\1\0\13\uffff}>";
    static final String[] DFA166_transitionS = {
            "\2\1\1\uffff\1\1\3\uffff\1\1\12\uffff\2\1\26\uffff\2\1\10\uffff"+
            "\1\1\133\uffff\2\1\36\uffff\1\1\2\uffff\1\3",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA166_eot = DFA.unpackEncodedString(DFA166_eotS);
    static final short[] DFA166_eof = DFA.unpackEncodedString(DFA166_eofS);
    static final char[] DFA166_min = DFA.unpackEncodedStringToUnsignedChars(DFA166_minS);
    static final char[] DFA166_max = DFA.unpackEncodedStringToUnsignedChars(DFA166_maxS);
    static final short[] DFA166_accept = DFA.unpackEncodedString(DFA166_acceptS);
    static final short[] DFA166_special = DFA.unpackEncodedString(DFA166_specialS);
    static final short[][] DFA166_transition;

    static {
        int numStates = DFA166_transitionS.length;
        DFA166_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA166_transition[i] = DFA.unpackEncodedString(DFA166_transitionS[i]);
        }
    }

    class DFA166 extends DFA {

        public DFA166(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 166;
            this.eot = DFA166_eot;
            this.eof = DFA166_eof;
            this.min = DFA166_min;
            this.max = DFA166_max;
            this.accept = DFA166_accept;
            this.special = DFA166_special;
            this.transition = DFA166_transition;
        }
        public String getDescription() {
            return "()* loopback of 2432:37: ( ^( T_VERB v+= verb o+= objectList ) )*";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TreeNodeStream input = (TreeNodeStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA166_3 = input.LA(1);

                         
                        int index166_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred277_XSPARQLRewriter()) ) {s = 14;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index166_3);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 166, _s, input);
            error(nvae);
            throw nvae;
        }
    }
 

    public static final BitSet FOLLOW_versionDecl_in_root962 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0100000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_libraryModule_in_root966 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_mainModule_in_root970 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_VERSION_in_versionDecl985 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_stringliteral_in_versionDecl987 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_ENCODING_in_versionDecl990 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_stringliteral_in_versionDecl992 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_MAIN_in_mainModule1020 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_prolog_in_mainModule1022 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000800000000000L});
    public static final BitSet FOLLOW_queryBody_in_mainModule1024 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_moduleDecl_in_libraryModule1039 = new BitSet(new long[]{0x0000000000000000L,0x0000004000000000L,0x8000000210000000L,0x00007F8000400003L});
    public static final BitSet FOLLOW_prolog_in_libraryModule1041 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_MODULE_DECL_in_moduleDecl1055 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_moduleDecl1057 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_uriliteral_in_moduleDecl1059 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_baseDecl_in_prolog1073 = new BitSet(new long[]{0x0000000000000002L,0x0000004000000000L,0x8000000210000000L,0x00007F8000400003L});
    public static final BitSet FOLLOW_prolog1_in_prolog1080 = new BitSet(new long[]{0x0000000000000002L,0x0000004000000000L,0x8000000210000000L,0x00007F8000400003L});
    public static final BitSet FOLLOW_prolog2_in_prolog1087 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x8000000200000000L,0x0000000000000003L});
    public static final BitSet FOLLOW_defaultNamespaceDecl_in_prolog11215 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_namespaceDecl_in_prolog11221 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_setter_in_prolog11227 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_importa_in_prolog11233 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prefixDecl_in_prolog11239 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_varDecl_in_prolog21252 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_functionDecl_in_prolog21258 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_optionDecl_in_prolog21264 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_boundarySpaceDecl_in_setter1277 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_defaultCollationDecl_in_setter1283 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_baseURIDecl_in_setter1289 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constructionDecl_in_setter1295 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_orderingModeDecl_in_setter1301 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_emptyOrderDecl_in_setter1307 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_copyNamespacesDecl_in_setter1313 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_schemaImport_in_importa1326 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_moduleImport_in_importa1330 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_NAMESPACE_in_namespaceDecl1344 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_namespaceDecl1348 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_namespaceDecl1352 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_BOUNDARYSPACE_DECL_in_boundarySpaceDecl1369 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_set_in_boundarySpaceDecl1371 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_DEFAULT_DECL_in_defaultNamespaceDecl1390 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_set_in_defaultNamespaceDecl1392 = new BitSet(new long[]{0x0000000000000000L,0x0000008000000000L});
    public static final BitSet FOLLOW_NAMESPACE_in_defaultNamespaceDecl1398 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_defaultNamespaceDecl1402 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_OPTION_DECL_in_optionDecl1419 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_optionDecl1421 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_stringliteral_in_optionDecl1423 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_ORDER_DECL_in_orderingModeDecl1438 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_set_in_orderingModeDecl1440 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_EMPTY_ORDER_DECL_in_emptyOrderDecl1459 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_set_in_emptyOrderDecl1461 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_COPYNAMESPACES_in_copyNamespacesDecl1480 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_preserveMode_in_copyNamespacesDecl1482 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000060000L});
    public static final BitSet FOLLOW_inheritMode_in_copyNamespacesDecl1484 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_set_in_preserveMode0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_inheritMode0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_DEFAULT_COLLATION_DECL_in_defaultCollationDecl1537 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_uriliteral_in_defaultCollationDecl1539 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_BASEURI_DECL_in_baseURIDecl1554 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_baseURIDecl1556 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_SCHEMA_IMPORT_in_schemaImport1571 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_SCHEMA_in_schemaImport1574 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_schemaPrefix_in_schemaImport1576 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_uriliteral_in_schemaImport1580 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_schemaImport1583 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_uriliteral_in_schemaImport1585 = new BitSet(new long[]{0x0000000000000408L});
    public static final BitSet FOLLOW_set_in_schemaPrefix0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_MODULE_IMPORT_in_moduleImport1621 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NAMESPACE_in_moduleImport1624 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_moduleImport1626 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_uriliteral_in_moduleImport1630 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_moduleImport1633 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_uriliteral_in_moduleImport1635 = new BitSet(new long[]{0x0000000000000408L});
    public static final BitSet FOLLOW_T_VARIABLE_DECL_in_varDecl1652 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_varDecl1656 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0800000000000000L});
    public static final BitSet FOLLOW_T_TYPE_in_varDecl1661 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_varDecl1663 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_exprSingle_in_varDecl1667 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_EXTERNAL_VARIABLE_DECL_in_varDecl1675 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_varDecl1679 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0800000000000000L});
    public static final BitSet FOLLOW_T_TYPE_in_varDecl1684 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_varDecl1686 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DECLARE_in_constructionDecl1702 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000008000L});
    public static final BitSet FOLLOW_CONSTRUCTION_in_constructionDecl1704 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000004200L});
    public static final BitSet FOLLOW_set_in_constructionDecl1706 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_FUNCTION_DECL_in_functionDecl1737 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_functionDecl1739 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_functionDecl1742 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_paramList_in_functionDecl1744 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_AS_in_functionDecl1750 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_sequenceType_in_functionDecl1752 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_enclosedExpr_in_functionDecl1758 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_EXTERNAL_in_functionDecl1762 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_param_in_paramList1777 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_T_PARAM_in_param1792 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_param1796 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0800000000000000L});
    public static final BitSet FOLLOW_T_TYPE_in_param1799 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_param1801 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_expr_in_enclosedExpr1819 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_enclosedExpr_1832 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_enclosedExpr_1834 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_enclosedExpr_1836 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_QUERY_BODY_in_queryBody1850 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_T_BODY_PART_in_queryBody1854 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_queryBody1856 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_epilogue_in_queryBody1861 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_EPILOGUE_in_epilogue2070 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_exprSingle_in_expr2109 = new BitSet(new long[]{0xF800003EF9000082L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_flworExpr_in_exprSingle2140 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_quantifiedExpr_in_exprSingle2146 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeSwitchExpr_in_exprSingle2152 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_orExpr_in_exprSingle2158 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ifExpr_in_exprSingle2164 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_FLWOR_in_flworExpr2188 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_forletClause_in_flworExpr2190 = new BitSet(new long[]{0x0000000000000008L,0x0000000000000000L,0x00000A0000000000L});
    public static final BitSet FOLLOW_returnClause_in_flworExpr2199 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_RETURN_in_returnClause2231 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_returnClause2233 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_CONSTRUCT_in_returnClause2253 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_constructTemplate_in_returnClause2256 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_forClause_in_forletClause2356 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000041000000000L});
    public static final BitSet FOLLOW_T_WHERE_in_forletClause2360 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_whereClause_in_forletClause2362 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_ORDER_in_forletClause2369 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderByClause_in_forletClause2371 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_sparqlForClause_in_forletClause2380 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sqlForClause_in_forletClause2386 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_letClause_in_forletClause2392 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000041000000000L});
    public static final BitSet FOLLOW_T_WHERE_in_forletClause2396 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_whereClause_in_forletClause2398 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_ORDER_in_forletClause2405 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderByClause_in_forletClause2407 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DISTINCT_in_distinct2423 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SQL_FOR_in_sqlForClause2460 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_distinct_in_sqlForClause2462 = new BitSet(new long[]{0x0000000000220000L,0x0000000000000000L,0x0001000000000000L});
    public static final BitSet FOLLOW_sqlVarOrFunction_in_sqlForClause2467 = new BitSet(new long[]{0x0000000000220008L,0x0000000000000000L,0x0001000000000000L});
    public static final BitSet FOLLOW_relationClause_in_sqlForClause2481 = new BitSet(new long[]{0x0000000000000002L,0x0000000000100000L});
    public static final BitSet FOLLOW_sqlWhereClause_in_sqlForClause2483 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SQL_FOR_in_sqlForClause2915 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_distinct_in_sqlForClause2917 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_STAR_in_sqlForClause2922 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_relationClause_in_sqlForClause2926 = new BitSet(new long[]{0x0000000000000002L,0x0000000000100000L});
    public static final BitSet FOLLOW_sqlWhereClause_in_sqlForClause2928 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SQL_FOR_in_sqlForClause3354 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_distinct_in_sqlForClause3356 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000008000000L});
    public static final BitSet FOLLOW_ROW_in_sqlForClause3359 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_sqlForClause3363 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_SQL_FROM_in_sqlForClause3377 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_sqlForClause3380 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_sqlForClause3382 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_sqlForClause3385 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_sqlVarOrString_in_sqlForClause3387 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_SQL_FOR_in_sqlForClause3648 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_distinct_in_sqlForClause3650 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000008000000L});
    public static final BitSet FOLLOW_ROW_in_sqlForClause3653 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_sqlForClause3657 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_relationClause_in_sqlForClause3672 = new BitSet(new long[]{0x0000000000000002L,0x0000000000100000L});
    public static final BitSet FOLLOW_sqlWhereClause_in_sqlForClause3674 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_TABLE_in_sqlVarOrString4090 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_sqlQuerySpec_in_sqlVarOrString4094 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_qname_in_sqlQuerySpec4120 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_sqlQuerySpec4131 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_VAR_in_sqlVarOrFunction4153 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_COMMA_in_sqlVarOrFunction4155 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_sqlVarOrFunction4160 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VAR_in_sqlVarOrFunction4188 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_COMMA_in_sqlVarOrFunction4190 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_sqlVarOrFunction4195 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_sqlVarOrFunction4197 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_COMMA_in_sqlVarOrFunction4223 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_sqlVarOrFunction4226 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_functionCall_in_sqlVarOrFunction4228 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_AS_in_sqlVarOrFunction4230 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_sqlVarOrFunction4234 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_sqlVarOrFunction4236 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SQL_FROM_in_relationClause4249 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_rdbSourceSelector_in_relationClause4251 = new BitSet(new long[]{0x0000000000020008L});
    public static final BitSet FOLLOW_COMMA_in_relationClause4254 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0002000000000000L});
    public static final BitSet FOLLOW_rdbSourceSelector_in_relationClause4256 = new BitSet(new long[]{0x0000000000020008L});
    public static final BitSet FOLLOW_T_TABLE_in_rdbSourceSelector4293 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_relationSchemaName_in_rdbSourceSelector4297 = new BitSet(new long[]{0x0400600000000218L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_relationAlias_in_rdbSourceSelector4301 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_qname_in_relationSchemaName4349 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_DOT_in_relationSchemaName4351 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_relationSchemaName4355 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_relationAlias_in_relationSchemaName4366 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_relationAlias_in_relationSchemaName4377 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_DOT_in_relationSchemaName4379 = new BitSet(new long[]{0x0400600000000210L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_relationAlias_in_relationSchemaName4383 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_relationAlias4429 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_relationAlias4442 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WHERE_in_sqlWhereClause4458 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_sqlWhereSpecList_in_sqlWhereClause4460 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_sqlAttrSpecList_in_sqlWhereSpecList4485 = new BitSet(new long[]{0x0000000000000002L,0x0000C00000000000L});
    public static final BitSet FOLLOW_sqlBooleanOp_in_sqlWhereSpecList4490 = new BitSet(new long[]{0xFC00603EF92006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_sqlWhereSpecList_in_sqlWhereSpecList4492 = new BitSet(new long[]{0x0000000000000002L,0x0000C00000000000L});
    public static final BitSet FOLLOW_sqlAttrSpec_in_sqlAttrSpecList4530 = new BitSet(new long[]{0x0000003C18000000L});
    public static final BitSet FOLLOW_generalComp_in_sqlAttrSpecList4534 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_sqlAttrSpec_in_sqlAttrSpecList4536 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_sqlAttrSpecList4561 = new BitSet(new long[]{0xFC00603EF92006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_sqlWhereSpecList_in_sqlAttrSpecList4563 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_sqlAttrSpecList4567 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_sqlBooleanOp0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_sqlAttrSpec4612 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_sqlAttrSpec4623 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numericliteral_in_sqlAttrSpec4688 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringliteral_in_sqlAttrSpec4701 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enclosedExpr_in_sqlAttrSpec4712 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_generalComp0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SPARQL_FOR_in_sparqlForClause4788 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_distinct_in_sparqlForClause4790 = new BitSet(new long[]{0x0000000000200010L});
    public static final BitSet FOLLOW_varOrFunction_in_sparqlForClause4795 = new BitSet(new long[]{0x0000000000200018L});
    public static final BitSet FOLLOW_datasetClause_in_sparqlForClause4807 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L,0x0000004004000000L});
    public static final BitSet FOLLOW_endpointClause_in_sparqlForClause4812 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000004004000000L});
    public static final BitSet FOLLOW_sWhereClause_in_sparqlForClause4815 = new BitSet(new long[]{0x0000000000000000L,0x00000000000000B0L,0x0000000000000000L,0x00000000000000C0L});
    public static final BitSet FOLLOW_solutionmodifier_in_sparqlForClause4817 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ENDPOINT_in_endpointClause6467 = new BitSet(new long[]{0x0080000000000010L});
    public static final BitSet FOLLOW_sourceSelector_in_endpointClause6471 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_varOrFunction6488 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_varOrFunction6511 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_functionCall_in_varOrFunction6513 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_AS_in_varOrFunction6515 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_varOrFunction6519 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_varOrFunction6521 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_singleForClause_in_forClause6547 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000008000000000L});
    public static final BitSet FOLLOW_T_FOR_in_singleForClause6562 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_singleForClause6566 = new BitSet(new long[]{0x0000000000001000L,0x0000000000000400L,0x0800000000000000L});
    public static final BitSet FOLLOW_T_TYPE_in_singleForClause6570 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_singleForClause6572 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_optionalPosClause_in_singleForClause6577 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_IN_in_optionalPosClause6596 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_optionalPosClause6598 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_AT_in_optionalPosClause6627 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_positionalVar_in_optionalPosClause6631 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_IN_in_optionalPosClause6635 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_optionalPosClause6637 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_VAR_in_positionalVar6671 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_singleLetClause_in_letClause6685 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000010000000000L});
    public static final BitSet FOLLOW_T_LET_in_singleLetClause6701 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_singleLetClause6713 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_singleLetClause6715 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_exprSingle_in_singleLetClause6725 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_WHERE_in_whereClause6829 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_whereClause6831 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_ORDER_BY_in_orderByClause6850 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderSpecList_in_orderByClause6852 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_STABLE_ORDER_BY_in_orderByClause6860 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderSpecList_in_orderByClause6862 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_orderSpec_in_orderSpecList6876 = new BitSet(new long[]{0xF800003EF9000082L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_exprSingle_in_orderSpec6891 = new BitSet(new long[]{0x0000000000000000L,0x0000000000803000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_orderModifier_in_orderSpec6893 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_orderModifier6906 = new BitSet(new long[]{0x0000000000000002L,0x0000000000800000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_EMPTY_in_orderModifier6916 = new BitSet(new long[]{0x0000000000000000L,0x0000000000600000L});
    public static final BitSet FOLLOW_set_in_orderModifier6918 = new BitSet(new long[]{0x0000000000000002L,0x0000000000800000L});
    public static final BitSet FOLLOW_COLLATION_in_orderModifier6929 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_uriliteral_in_orderModifier6931 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_quantifiedExpr6947 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_T_VAR_in_quantifiedExpr6955 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_quantifiedExpr6957 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000400L,0x0800000000000000L});
    public static final BitSet FOLLOW_T_TYPE_in_quantifiedExpr6961 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_quantifiedExpr6963 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_IN_in_quantifiedExpr6969 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_quantifiedExpr6971 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_SATISFIES_in_quantifiedExpr6978 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_quantifiedExpr6980 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_TYPESWITCH_in_typeSwitchExpr6996 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_typeSwitchExpr6998 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000010000000L});
    public static final BitSet FOLLOW_caseClause_in_typeSwitchExpr7000 = new BitSet(new long[]{0xF800003EF9000090L,0x007FC00000008003L,0x7400000100400000L,0x0002000370000000L});
    public static final BitSet FOLLOW_VAR_in_typeSwitchExpr7003 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_exprSingle_in_typeSwitchExpr7006 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_CASE_in_caseClause7020 = new BitSet(new long[]{0x0400600000000210L,0xF001020004000008L,0x000000000800001FL});
    public static final BitSet FOLLOW_VAR_in_caseClause7023 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_AS_in_caseClause7025 = new BitSet(new long[]{0x0400600000000210L,0xF001020004000008L,0x000000000800001FL});
    public static final BitSet FOLLOW_sequenceType_in_caseClause7029 = new BitSet(new long[]{0x0000000000000000L,0x0000000000040000L});
    public static final BitSet FOLLOW_RETURN_in_caseClause7031 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_exprSingle_in_caseClause7033 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IF_in_ifExpr7048 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_ifExpr7050 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_exprSingle_in_ifExpr7052 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_exprSingle_in_ifExpr7054 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_andExpr_in_orExpr7068 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OR_in_orExpr7075 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orExpr_in_orExpr7077 = new BitSet(new long[]{0xF800003EF9000080L,0x007F400000000003L,0x7400000000400000L,0x0002000100000000L});
    public static final BitSet FOLLOW_andExpr_in_orExpr7079 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_comparisonExpr_in_andExpr7093 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_AND_in_andExpr7100 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_andExpr_in_andExpr7102 = new BitSet(new long[]{0xF800003EF9000080L,0x007F000000000003L,0x7400000000400000L,0x0002000100000000L});
    public static final BitSet FOLLOW_comparisonExpr_in_andExpr7104 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_rangeExpr_in_comparisonExpr7118 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_comparisonExpr7132 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_rangeExpr_in_comparisonExpr7290 = new BitSet(new long[]{0x00000000E1000080L,0x007F000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_rangeExpr_in_comparisonExpr7292 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_additiveExpr_in_rangeExpr7311 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TO_in_rangeExpr7318 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_rangeExpr_in_rangeExpr7320 = new BitSet(new long[]{0x00000000E1000080L,0x007E000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_additiveExpr_in_rangeExpr7322 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_multiplicativeExpr_in_additiveExpr7336 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_additiveExpr7343 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_additiveExpr_in_additiveExpr7349 = new BitSet(new long[]{0x00000000E1000080L,0x007E000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_multiplicativeExpr_in_additiveExpr7351 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_unionExpr_in_multiplicativeExpr7362 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_multiplicativeExpr7369 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_multiplicativeExpr_in_multiplicativeExpr7385 = new BitSet(new long[]{0x00000000E0000080L,0x0070000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_unionExpr_in_multiplicativeExpr7387 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_intersectExceptExpr_in_unionExpr7401 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_unionExpr7408 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_unionExpr_in_unionExpr7416 = new BitSet(new long[]{0x0000000060000080L,0x0060000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_intersectExceptExpr_in_unionExpr7418 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_instanceOfExpr_in_intersectExceptExpr7432 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_intersectExceptExpr7439 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_intersectExceptExpr_in_intersectExceptExpr7447 = new BitSet(new long[]{0x0000000060000080L,0x0000000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_instanceOfExpr_in_intersectExceptExpr7449 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_treatExpr_in_instanceOfExpr7463 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_INSTANCEOF_in_instanceOfExpr7470 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_instanceOfExpr_in_instanceOfExpr7472 = new BitSet(new long[]{0x0400600000000210L,0xF001020004000008L,0x000000000800001FL});
    public static final BitSet FOLLOW_sequenceType_in_instanceOfExpr7474 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_castableExpr_in_treatExpr7488 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_TREATAS_in_treatExpr7495 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_treatExpr_in_treatExpr7497 = new BitSet(new long[]{0x0400600000000210L,0xF001020004000008L,0x000000000800001FL});
    public static final BitSet FOLLOW_sequenceType_in_treatExpr7499 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_castExpr_in_castableExpr7513 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_CASTABLEAS_in_castableExpr7520 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_castableExpr_in_castableExpr7522 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_singleType_in_castableExpr7524 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_unaryExpr_in_castExpr7538 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_CASTAS_in_castExpr7545 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_castExpr_in_castExpr7547 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_singleType_in_castExpr7549 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_set_in_unaryExpr7563 = new BitSet(new long[]{0x0000000060000080L,0x0000000000000000L,0x0000000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_valueExpr_in_unaryExpr7572 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_pathExpr_in_valueExpr7585 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_validateExpr_in_valueExpr7591 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_extensionExpr_in_valueExpr7597 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VALIDATE_in_validateExpr7610 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000768000000L});
    public static final BitSet FOLLOW_validationMode_in_validateExpr7612 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_validateExpr7615 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_validationMode0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_extensionExpr7652 = new BitSet(new long[]{0xF800003EF9000180L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_extensionExpr7654 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_extensionExpr7657 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_XPATH_in_pathExpr7671 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_SLASH_in_pathExpr7673 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_SLASH_in_pathExpr7675 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_relativePathExpr_in_pathExpr7677 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_XPATH_in_pathExpr7685 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_SLASH_in_pathExpr7687 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_relativePathExpr_in_pathExpr7689 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_XPATH_in_pathExpr7697 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_SLASH_in_pathExpr7699 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_XPATH_in_pathExpr7707 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_relativePathExpr_in_pathExpr7709 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_stepExpr_in_relativePathExpr7732 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_SLASH_in_relativePathExpr7735 = new BitSet(new long[]{0x0400600003041E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_SLASH_in_relativePathExpr7737 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_stepExpr_in_relativePathExpr7740 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_filterExpr_in_stepExpr7758 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_axisStep_in_stepExpr7764 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_reverseStep_in_axisStep7778 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_forwardStep_in_axisStep7782 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_predicateList_in_axisStep7785 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forwardAxis_in_forwardStep7798 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_nodeTest_in_forwardStep7800 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_abbrevForwardStep_in_forwardStep7806 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CHILD_in_forwardAxis7819 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7821 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DESCENDANT_in_forwardAxis7827 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7829 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ATTRIBUTE_in_forwardAxis7835 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7837 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SELF_in_forwardAxis7843 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7845 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DESCENDANTORSELF_in_forwardAxis7851 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7853 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FOLLOWINGSIBLING_in_forwardAxis7859 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7861 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FOLLOWING_in_forwardAxis7867 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7869 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_AT_in_abbrevForwardStep7882 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_nodeTest_in_abbrevForwardStep7885 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_reverseAxis_in_reverseStep7898 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_nodeTest_in_reverseStep7900 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_abbrevReverseStep_in_reverseStep7906 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PARENT_in_reverseAxis7919 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_reverseAxis7921 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANCESTOR_in_reverseAxis7927 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_reverseAxis7929 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PRECEDINGSIBLING_in_reverseAxis7935 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_reverseAxis7937 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PRECEDING_in_reverseAxis7943 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_reverseAxis7945 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANCESTORORSELF_in_reverseAxis7951 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_reverseAxis7953 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOTDOT_in_abbrevReverseStep7966 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_kindTest_in_nodeTest7979 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_nameTest_in_nodeTest7985 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_nameTest7998 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_wildCard_in_nameTest8004 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_wildCard8017 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_wildCard8023 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_COLON_in_wildCard8025 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_NCNAME_in_wildCard8027 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NCNAME_in_wildCard8033 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_COLON_in_wildCard8035 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_STAR_in_wildCard8037 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_primaryExpr_in_filterExpr8050 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_predicateList_in_filterExpr8052 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_predicate_in_predicateList8065 = new BitSet(new long[]{0x0000000000080002L});
    public static final BitSet FOLLOW_LBRACKET_in_predicate8079 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_predicate8081 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_RBRACKET_in_predicate8083 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_varRef_in_primaryExpr8096 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literal_in_primaryExpr8102 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_parenthesizedExpr_in_primaryExpr8108 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_contextItemExpr_in_primaryExpr8114 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_functionCall_in_primaryExpr8120 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_orderedExpr_in_primaryExpr8126 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_unorderedExpr_in_primaryExpr8132 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constructor_in_primaryExpr8138 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numericliteral_in_literal8151 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringliteral_in_literal8157 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_integerLiteral_in_numericliteral8170 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_decimalLiteral_in_numericliteral8176 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_varRef8195 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_varName8242 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_PAR_in_parenthesizedExpr8256 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_parenthesizedExpr8258 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DOT_in_contextItemExpr8273 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ORDERED_in_orderedExpr8286 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_orderedExpr8288 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_UNORDERED_in_unorderedExpr8301 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_unorderedExpr8303 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_functionCall8318 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_functionCall8320 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_functionCall8323 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_functionCall8325 = new BitSet(new long[]{0xF800003EF9000088L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_directConstructor_in_constructor8341 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_computedConstructor_in_constructor8347 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_dirElemConstructor_in_directConstructor8360 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_XML_ELEMENT_in_dirElemConstructor8376 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_dirElemConstructor8378 = new BitSet(new long[]{0x0000000000000008L,0x0000000000000000L,0x00000000C0000000L});
    public static final BitSet FOLLOW_dirAttributeList_in_dirElemConstructor8380 = new BitSet(new long[]{0x0000000000000008L,0x0000000000000000L,0x0000000040000000L});
    public static final BitSet FOLLOW_T_XML_CONTENT_in_dirElemConstructor8385 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_dirElemContent_in_dirElemConstructor8387 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_dirAttribute_in_dirAttributeList8406 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000080000000L});
    public static final BitSet FOLLOW_T_XML_ATTRIBUTE_in_dirAttribute8421 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_dirAttribute8423 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_dirAttributeValue_in_dirAttribute8425 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_enclosedExpr_in_dirAttributeValue8439 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QSTRING_in_dirAttributeValue8445 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_directConstructor_in_dirElemContent8458 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_commonContent_in_dirElemContent8464 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WHITESPACE_in_dirElemContent8470 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NCNAMEELM_in_dirElemContent8477 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_cDataSection_in_dirElemContent8484 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_commonContent8497 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_commonContent8499 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_commonContent8501 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_commonContent8515 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_LCURLY_in_commonContent8517 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RCURLY_in_commonContent8523 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_commonContent8525 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CDATASTART_in_cDataSection8538 = new BitSet(new long[]{0x0001000000000000L});
    public static final BitSet FOLLOW_CDATAELMEND_in_cDataSection8540 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compDocConstructor_in_computedConstructor8553 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compElemConstructor_in_computedConstructor8559 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compAttrConstructor_in_computedConstructor8565 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compTextConstructor_in_computedConstructor8571 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compCommentConstructor_in_computedConstructor8577 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compPIConstructor_in_computedConstructor8583 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOCUMENT_in_compDocConstructor8596 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_compDocConstructor8598 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ELEMENT_in_compElemConstructor8611 = new BitSet(new long[]{0x0400600000000280L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_compElemConstructor8615 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_enclosedExpr__in_compElemConstructor8619 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_LCURLY_in_compElemConstructor8622 = new BitSet(new long[]{0xF800003EF9000180L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_contentExpr_in_compElemConstructor8624 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_compElemConstructor8627 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expr_in_contentExpr8640 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ATTRIBUTE_in_compAttrConstructor8653 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_qname_in_compAttrConstructor8656 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_enclosedExpr_in_compAttrConstructor8660 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_LCURLY_in_compAttrConstructor8663 = new BitSet(new long[]{0xF800003EF9000180L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_compAttrConstructor8665 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_compAttrConstructor8668 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TEXT_in_compTextConstructor8681 = new BitSet(new long[]{0x0400600000000280L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_enclosedExpr__in_compTextConstructor8683 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COMMENT_in_compCommentConstructor8696 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_compCommentConstructor8698 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PROCESSINGINSTRUCTION_in_compPIConstructor8711 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_NCNAME_in_compPIConstructor8715 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_enclosedExpr_in_compPIConstructor8719 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_LCURLY_in_compPIConstructor8722 = new BitSet(new long[]{0xF800003EF9000180L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_compPIConstructor8724 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_compPIConstructor8727 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_atomicType_in_singleType8740 = new BitSet(new long[]{0x0000000100000002L});
    public static final BitSet FOLLOW_QUESTIONMARK_in_singleType8742 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sequenceType_in_typeDeclaration8756 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EMPTYSEQUENCE_in_sequenceType8769 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_sequenceType8771 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_sequenceType8773 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_itemType_in_sequenceType8779 = new BitSet(new long[]{0x0000000121000002L});
    public static final BitSet FOLLOW_occurrenceIndicator_in_sequenceType8781 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_occurrenceIndicator0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ITEM_in_itemType8816 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_itemType8818 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_itemType8820 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_atomicType_in_itemType8826 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_kindTest_in_itemType8832 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_atomicType8845 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_documentTest_in_kindTest8858 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_elementTest_in_kindTest8864 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_attributeTest_in_kindTest8870 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_schemaElementTest_in_kindTest8876 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_schemaAttributeTest_in_kindTest8882 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_piTest_in_kindTest8888 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_commentTest_in_kindTest8894 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_textTest_in_kindTest8900 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_anyKindTest_in_kindTest8906 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NODE_in_anyKindTest8919 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_anyKindTest8921 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_anyKindTest8923 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOCUMENTNODE_in_documentTest8936 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_documentTest8938 = new BitSet(new long[]{0x0000000000400000L,0x0000020000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_elementTest_in_documentTest8941 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_schemaElementTest_in_documentTest8945 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_documentTest8949 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TEXT_in_textTest8962 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_textTest8964 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_textTest8966 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COMMENT_in_commentTest8979 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_commentTest8981 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_commentTest8983 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PROCESSINGINSTRUCTION_in_piTest8996 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_piTest8998 = new BitSet(new long[]{0x0000000000400600L});
    public static final BitSet FOLLOW_NCNAME_in_piTest9001 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_stringliteral_in_piTest9005 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_piTest9009 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ATTRIBUTE_in_attributeTest9022 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_attributeTest9024 = new BitSet(new long[]{0x0400600001400200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_attributeNameOrWildcard_in_attributeTest9027 = new BitSet(new long[]{0x0000000000420000L});
    public static final BitSet FOLLOW_COMMA_in_attributeTest9030 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_typeName_in_attributeTest9032 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_attributeTest9038 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_attributeName_in_attributeNameOrWildcard9051 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_attributeNameOrWildcard9055 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SCHEMAATTRIBUTE_in_schemaAttributeTest9068 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_schemaAttributeTest9070 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_attributeDeclaration_in_schemaAttributeTest9072 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_schemaAttributeTest9074 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_attributeName_in_attributeDeclaration9087 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ELEMENT_in_elementTest9100 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_elementTest9102 = new BitSet(new long[]{0x0400600001400200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_elementNameOrWildcard_in_elementTest9105 = new BitSet(new long[]{0x0000000000420000L});
    public static final BitSet FOLLOW_COMMA_in_elementTest9108 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_typeName_in_elementTest9110 = new BitSet(new long[]{0x0000000100400000L});
    public static final BitSet FOLLOW_QUESTIONMARK_in_elementTest9112 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_elementTest9119 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_elementName_in_elementNameOrWildcard9132 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_elementNameOrWildcard9136 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SCHEMAELEMENT_in_schemaElementTest9149 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_schemaElementTest9151 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_elementDeclaration_in_schemaElementTest9153 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_schemaElementTest9155 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_elementName_in_elementDeclaration9168 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_attributeName9181 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_elementName9194 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_typeName9207 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringliteral_in_uriliteral9220 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTEGER_in_integerLiteral9233 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DECIMAL_in_decimalLiteral9246 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QSTRING_in_stringliteral9259 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_NAMESPACE_in_baseDecl9289 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_DEFAULT_in_baseDecl9291 = new BitSet(new long[]{0x0080000000000000L});
    public static final BitSet FOLLOW_IRIREF_in_baseDecl9295 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_NAMESPACE_in_prefixDecl9312 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_DEFAULT_in_prefixDecl9314 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_prefixDecl9318 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_NAMESPACE_in_prefixDecl9331 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_PNAME_NS_in_prefixDecl9335 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_prefixDecl9339 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_FROM_in_datasetClause9371 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_defaultGraphClause_in_datasetClause9378 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_namedGraphClause_in_datasetClause9384 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_sourceSelector_in_defaultGraphClause9415 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NAMED_in_namedGraphClause9430 = new BitSet(new long[]{0x0080000000000010L});
    public static final BitSet FOLLOW_sourceSelector_in_namedGraphClause9432 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_sourceSelector9456 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_sourceSelector9471 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SPARQL_WHERE_in_sWhereClause9572 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_groupGraphPattern_in_sWhereClause9574 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_orderclause_in_solutionmodifier9602 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000030L});
    public static final BitSet FOLLOW_limitoffsetclauses_in_solutionmodifier9604 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_groupBy_in_solutionmodifier9611 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000030L,0x0000000000000000L,0x0000000000000080L});
    public static final BitSet FOLLOW_having_in_solutionmodifier9614 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000030L});
    public static final BitSet FOLLOW_limitoffsetclauses_in_solutionmodifier9617 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_GROUP_BY_in_groupBy9633 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_groupBy9635 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_HAVING_in_having9650 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_having9652 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_limitclause_in_limitoffsetclauses9666 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000030L});
    public static final BitSet FOLLOW_offsetclause_in_limitoffsetclauses9668 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_offsetclause_in_limitoffsetclauses9675 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000010L});
    public static final BitSet FOLLOW_limitclause_in_limitoffsetclauses9677 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ORDER_in_orderclause9694 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderCondition_in_orderclause9696 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_set_in_orderCondition9719 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_orderCondition9727 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constraint_in_orderCondition9733 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_orderCondition9741 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LIMIT_in_limitclause9762 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_limitclause9766 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_OFFSET_in_offsetclause9790 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_offsetclause9794 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_singleGroupGraphPattern_in_groupGraphPattern9824 = new BitSet(new long[]{0x0000000000000002L,0x0010000000000000L,0x0020000000200180L});
    public static final BitSet FOLLOW_triplesBlock_in_singleGroupGraphPattern9860 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_graphPatternNotTriples_in_singleGroupGraphPattern9866 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_filter_in_singleGroupGraphPattern9872 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_triplesSameSubject_in_triplesBlock9887 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0020000000000000L});
    public static final BitSet FOLLOW_optionalGraphPattern_in_graphPatternNotTriples9901 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_groupOrUnionGraphPattern_in_graphPatternNotTriples9907 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_graphGraphPattern_in_graphPatternNotTriples9913 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OPTIONAL_in_optionalGraphPattern9929 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_groupGraphPattern_in_optionalGraphPattern9931 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_GRAPH_in_graphGraphPattern9957 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_varOrIRIref_in_graphGraphPattern9959 = new BitSet(new long[]{0x0000000000000000L,0x0010000000000000L,0x0020000000200180L});
    public static final BitSet FOLLOW_groupGraphPattern_in_graphGraphPattern9961 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_UNION_in_groupOrUnionGraphPattern9989 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_T_UNION_in_groupOrUnionGraphPattern9992 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_groupGraphPattern_in_groupOrUnionGraphPattern9996 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_UNION_in_groupOrUnionGraphPattern10001 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_groupGraphPattern_in_groupOrUnionGraphPattern10005 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_FILTER_in_filter10047 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_constraint_in_filter10049 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_brackettedExpression_in_constraint10072 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_builtInCall_in_constraint10078 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sFunctionCall_in_constraint10084 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iRIref_in_sFunctionCall10097 = new BitSet(new long[]{0x0038003C79240452L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_arglist_in_sFunctionCall10099 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_arglist10123 = new BitSet(new long[]{0x0038003C79240452L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_arglist10127 = new BitSet(new long[]{0x0038003C79240452L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_constructTriples_in_constructTemplate10155 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_triplesSameSubject__in_constructTriples10170 = new BitSet(new long[]{0xFC00603EF90006D2L,0x607FC0000000800BL,0x7420000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_constructTriples10174 = new BitSet(new long[]{0xFC00603EF90006D2L,0x607FC0000000800BL,0x7420000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_T_SUBJECT_in_triplesSameSubject10194 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_subject_in_triplesSameSubject10196 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty_in_triplesSameSubject10198 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_SUBJECT_in_triplesSameSubject10221 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_triplesNode_in_triplesSameSubject10223 = new BitSet(new long[]{0x0000000000000008L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty_in_triplesSameSubject10225 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_SUBJECT_in_triplesSameSubject_10271 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_subject__in_triplesSameSubject_10283 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10291 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_bnode_in_triplesSameSubject_10313 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10321 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_blankConstruct_in_triplesSameSubject_10828 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10834 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_constructVar_in_triplesSameSubject_11062 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11075 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_enclosedExpr_in_triplesSameSubject_11301 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11323 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_iriConstruct_in_triplesSameSubject_11622 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11644 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_collection_in_triplesSameSubject_11968 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11984 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_ANON_BLANK_in_triplesSameSubject_11999 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_T_EMPTY_ANON_BLANK_in_triplesSameSubject_12003 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_12008 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_VAR_in_constructVar12317 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_verbObjectList__in_propertyListNotEmpty_12395 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_T_VERB_in_verbObjectList_12427 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_verb__in_verbObjectList_12431 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList__in_verbObjectList_12435 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VERB_in_verbObjectList_12450 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_iriConstruct_in_verbObjectList_12454 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList__in_verbObjectList_12458 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VERB_in_verbObjectList_12703 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_constructVar_in_verbObjectList_12707 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList__in_verbObjectList_12711 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VERB_in_propertyListNotEmpty12950 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_verb_in_propertyListNotEmpty12954 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList_in_propertyListNotEmpty12958 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VERB_in_propertyListNotEmpty12963 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_verb_in_propertyListNotEmpty12967 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList_in_propertyListNotEmpty12971 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_propertyListNotEmpty_in_propertyList13017 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_propertyList_13031 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_OBJECT_in_objectList_13046 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_object__in_objectList_13050 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_OBJECT_in_objectList_13055 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_object__in_objectList_13059 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_OBJECT_in_objectList13089 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_object_in_objectList13093 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_OBJECT_in_objectList13098 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_object_in_objectList13102 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_verb__in_subject_13144 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_resource_in_subject13162 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_subject13170 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blank_in_subject13183 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PNAME_LN_in_resource13210 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PNAME_NS_in_resource13225 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_resource13240 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_resource_in_verb13328 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_A_in_verb13336 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sparqlPrefixedName_in_verb_13354 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_verb_13362 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_A_in_verb_13375 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_verb__in_object_13403 = new BitSet(new long[]{0x0080400000000402L,0x0000000000000000L,0x0000000000000000L,0x000C000000000000L});
    public static final BitSet FOLLOW_nquad_in_object_13407 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constructVar_in_object_13443 = new BitSet(new long[]{0x0080400000000402L,0x0000000000000000L,0x0000000000000000L,0x000C000000000000L});
    public static final BitSet FOLLOW_nquad_in_object_13447 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_bnode_in_object_13858 = new BitSet(new long[]{0x0080400000000402L,0x0000000000000000L,0x0000000000000000L,0x000C000000000000L});
    public static final BitSet FOLLOW_nquad_in_object_13862 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rdfLiteral_in_object_14312 = new BitSet(new long[]{0x0080400000000402L,0x0000000000000000L,0x0000000000000000L,0x000C000000000000L});
    public static final BitSet FOLLOW_nquad_in_object_14316 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sNumericLiteral_in_object_14350 = new BitSet(new long[]{0x0080400000000402L,0x0000000000000000L,0x0000000000000000L,0x000C000000000000L});
    public static final BitSet FOLLOW_nquad_in_object_14354 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blankConstruct_in_object_14390 = new BitSet(new long[]{0x0080400000000402L,0x0000000000000000L,0x0000000000000000L,0x000C000000000000L});
    public static final BitSet FOLLOW_nquad_in_object_14394 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literalConstruct_in_object_14526 = new BitSet(new long[]{0x0080400000000402L,0x0000000000000000L,0x0000000000000000L,0x000C000000000000L});
    public static final BitSet FOLLOW_nquad_in_object_14530 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iriConstruct_in_object_14729 = new BitSet(new long[]{0x0080400000000402L,0x0000000000000000L,0x0000000000000000L,0x000C000000000000L});
    public static final BitSet FOLLOW_nquad_in_object_14733 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_collection_in_object_15014 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_ANON_BLANK_in_object_15040 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_object_15042 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_EMPTY_ANON_BLANK_in_object_15119 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_object_15121 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iri_in_nquad15166 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literal__in_nquad15172 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literalConstruct_in_literal_15322 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rdfLiteral_in_literal_15329 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_resource_in_object15342 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blank_in_object15348 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rdfLiteral_in_object15361 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sNumericLiteral_in_object15367 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_triplesNode_in_object15373 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_collection_in_triplesNode15386 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blankNodePropertyList_in_triplesNode15392 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_collection_in_triplesNode_15405 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blankNodePropertyList__in_triplesNode_15411 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_ANON_BLANK_in_blankNodePropertyList15424 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty_in_blankNodePropertyList15426 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_ANON_BLANK_in_blankNodePropertyList_15451 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_blankNodePropertyList_15453 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_collection15466 = new BitSet(new long[]{0x0080600000200450L,0x0000000000000000L,0x0008000000180000L});
    public static final BitSet FOLLOW_graphNode_in_collection15468 = new BitSet(new long[]{0x0080600000600450L,0x0000000000000000L,0x0008000000180000L});
    public static final BitSet FOLLOW_RPAR_in_collection15471 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_varOrTerm_in_graphNode15484 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_triplesNode_in_graphNode15490 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_varOrTerm15503 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_graphTerm_in_varOrTerm15509 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15523 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct15527 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_literalConstruct15531 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct15535 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15642 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct15644 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct15648 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct15652 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iri_in_literalConstruct15654 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15758 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_literalConstruct15760 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_literalConstruct15762 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct15764 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15870 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_literalConstruct15872 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct15874 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct15876 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iriConstruct_in_literalConstruct15878 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15983 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_literalConstruct15985 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_literalConstruct15987 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct15989 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct16094 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_literalConstruct16096 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct16100 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct16104 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iriConstruct_in_literalConstruct16106 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct16212 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct16214 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_VAR_in_varOrIRIref16288 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iRIref_in_varOrIRIref16294 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_IRI_CONSTRUCT_in_iriConstruct16308 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_LESSTHANLCURLY_in_iriConstruct16319 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_iriConstruct16321 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_RCURLYGREATERTHAN_in_iriConstruct16325 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_enclosedExpr_in_iriConstruct16352 = new BitSet(new long[]{0x0400600000010200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_COLON_in_iriConstruct16365 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_iriConstruct16380 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_qname_in_iriConstruct16500 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_qname_in_iriConstruct16600 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_COLON_in_iriConstruct16604 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_iriConstruct16606 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_iRIref_in_graphTerm16697 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rdfLiteral_in_graphTerm16703 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sNumericLiteral_in_graphTerm16709 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanLiteral_in_graphTerm16715 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BNODE_CONSTRUCT_in_blankConstruct16730 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_blankConstruct16732 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalOrExpression_in_expression16845 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalAndExpression_in_conditionalOrExpression16858 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ORSYMBOL_in_conditionalOrExpression16867 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_conditionalOrExpression_in_conditionalOrExpression16869 = new BitSet(new long[]{0x0030003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_conditionalAndExpression_in_conditionalOrExpression16871 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_valueLogical_in_conditionalAndExpression16896 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANDSYMBOL_in_conditionalAndExpression16905 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_conditionalAndExpression_in_conditionalAndExpression16907 = new BitSet(new long[]{0x0020003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_valueLogical_in_conditionalAndExpression16909 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_relationalExpression_in_valueLogical16934 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numericExpression_in_relationalExpression16947 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EQUALS_in_relationalExpression16957 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_HAFENEQUALS_in_relationalExpression16963 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_LESSTHAN_in_relationalExpression16969 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_GREATERTHAN_in_relationalExpression16974 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_LESSTHANEQUALS_in_relationalExpression16980 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_GREATERTHANEQUALS_in_relationalExpression16986 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_numericExpression_in_relationalExpression16989 = new BitSet(new long[]{0x0020000061240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_numericExpression_in_relationalExpression16991 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_additiveExpression_in_numericExpression17016 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression17029 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_additiveExpression17039 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_MINUS_in_additiveExpression17045 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_additiveExpression_in_additiveExpression17048 = new BitSet(new long[]{0x0020000061240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression17050 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_unaryExpression_in_multiplicativeExpression17076 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_multiplicativeExpression17086 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_SLASH_in_multiplicativeExpression17092 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_multiplicativeExpression17095 = new BitSet(new long[]{0x0020000060200450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_unaryExpression_in_multiplicativeExpression17097 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_NOT_in_unaryExpression17124 = new BitSet(new long[]{0x0020000060200450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_primaryExpression_in_unaryExpression17126 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_unaryExpression17143 = new BitSet(new long[]{0x0020000060200450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_primaryExpression_in_unaryExpression17145 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_unaryExpression17164 = new BitSet(new long[]{0x0020000060200450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_primaryExpression_in_unaryExpression17166 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_primaryExpression_in_unaryExpression17183 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_brackettedExpression_in_primaryExpression17201 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_builtInCall_in_primaryExpression17207 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iRIrefOrFunction_in_primaryExpression17213 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rdfLiteral_in_primaryExpression17219 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sNumericLiteral_in_primaryExpression17225 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanLiteral_in_primaryExpression17231 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_primaryExpression17245 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_brackettedExpression17319 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_brackettedExpression17321 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_brackettedExpression17325 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STR_in_builtInCall17352 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17354 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LANG_in_builtInCall17371 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17373 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LANGMATCHES_in_builtInCall17390 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_builtInCall17394 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_builtInCall17398 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_COMMA_in_builtInCall17402 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_builtInCall17406 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_builtInCall17410 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATATYPE_in_builtInCall17440 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17442 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BOUND_in_builtInCall17459 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_builtInCall17463 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_builtInCall17467 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_builtInCall17471 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ISIRI_in_builtInCall17495 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17497 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ISURI_in_builtInCall17514 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17516 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ISBLANK_in_builtInCall17533 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17535 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ISLITERAL_in_builtInCall17552 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17554 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_regexExpression_in_builtInCall17569 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REGEX_in_regexExpression17584 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_regexExpression17588 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_regexExpression17592 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_COMMA_in_regexExpression17596 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_regexExpression17600 = new BitSet(new long[]{0x0000000000420000L});
    public static final BitSet FOLLOW_COMMA_in_regexExpression17605 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_regexExpression17610 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_regexExpression17616 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_iRIrefOrFunction17663 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_iRIref_in_iRIrefOrFunction17667 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_iRIrefOrFunction17670 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_arglist_in_iRIrefOrFunction17672 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_QSTRING_in_rdfLiteral17704 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QSTRING_in_rdfLiteral17717 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_rdfLiteral17719 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_rdfLiteral17721 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QSTRING_in_rdfLiteral17738 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_rdfLiteral17742 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_rdfLiteral17746 = new BitSet(new long[]{0x0080400000000000L});
    public static final BitSet FOLLOW_IRIREF_in_rdfLiteral17752 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PNAME_LN_in_rdfLiteral17759 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTEGER_in_sNumericLiteral17788 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_booleanLiteral17803 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_booleanLiteral17816 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QSTRING_in_string17840 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_iRIref17855 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prefixedName_in_iRIref17861 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_prefixedName0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_bnode_in_blank17893 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_EMPTY_ANON_BLANK_in_blank17899 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_VERB_in_predicateObjectList17934 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_verb_in_predicateObjectList17936 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList_in_predicateObjectList17938 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PNAME_LN_in_iri17957 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_iri17972 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iriConstruct_in_iri17987 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sparqlPrefixedName_in_resource_18000 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_resource_18006 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_resource_18012 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_resource__in_rdfPredicate_18025 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BLANK_NODE_LABEL_in_bnode18038 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PNAME_LN_in_sparqlPrefixedName18053 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PNAME_NS_in_sparqlPrefixedName18067 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prefixedName_in_qname18087 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_unprefixedName_in_qname18093 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ITEM_in_keyword18106 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TO_in_keyword18114 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FROM_in_keyword18127 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ROW_in_keyword18140 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COMMENT_in_keyword18153 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NODE_in_keyword18166 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_A_in_keyword18177 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_localPart_in_unprefixedName18188 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NCNAME_in_localPart18201 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_keyword_in_localPart18207 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_exprSingle_in_synpred41_XSPARQLRewriter2109 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_synpred74_XSPARQLRewriter4349 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_DOT_in_synpred74_XSPARQLRewriter4351 = new BitSet(new long[]{0x0400600000000200L,0x6001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_synpred74_XSPARQLRewriter4355 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sqlBooleanOp_in_synpred77_XSPARQLRewriter4490 = new BitSet(new long[]{0xFC00603EF92006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_sqlWhereSpecList_in_synpred77_XSPARQLRewriter4492 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_solutionmodifier_in_synpred93_XSPARQLRewriter4817 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_triplesSameSubject_in_synpred253_XSPARQLRewriter9887 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_VERB_in_synpred277_XSPARQLRewriter12963 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_verb_in_synpred277_XSPARQLRewriter12967 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList_in_synpred277_XSPARQLRewriter12971 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred318_XSPARQLRewriter15523 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_enclosedExpr_in_synpred318_XSPARQLRewriter15527 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_synpred318_XSPARQLRewriter15531 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_synpred318_XSPARQLRewriter15535 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred319_XSPARQLRewriter15642 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_enclosedExpr_in_synpred319_XSPARQLRewriter15644 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred319_XSPARQLRewriter15648 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred319_XSPARQLRewriter15652 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iri_in_synpred319_XSPARQLRewriter15654 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred320_XSPARQLRewriter15758 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_synpred320_XSPARQLRewriter15760 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_synpred320_XSPARQLRewriter15762 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_synpred320_XSPARQLRewriter15764 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred321_XSPARQLRewriter15870 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_synpred321_XSPARQLRewriter15872 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred321_XSPARQLRewriter15874 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred321_XSPARQLRewriter15876 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iriConstruct_in_synpred321_XSPARQLRewriter15878 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred322_XSPARQLRewriter15983 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_synpred322_XSPARQLRewriter15985 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_synpred322_XSPARQLRewriter15987 = new BitSet(new long[]{0xFC00603EF90006D0L,0x607FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_synpred322_XSPARQLRewriter15989 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred323_XSPARQLRewriter16094 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_synpred323_XSPARQLRewriter16096 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred323_XSPARQLRewriter16100 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred323_XSPARQLRewriter16104 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iriConstruct_in_synpred323_XSPARQLRewriter16106 = new BitSet(new long[]{0x0000000000000008L});

}